; PIO compatible header file STC11-STC10.asm 20210829.
; For use with all STC11xx STC10xx series.
; 适用于 STC11xx STC10xx 系列的芯片。

;.ifndef STC11_STC10_ASM
;.define STC11_STC10_ASM

;SFR DEFINITION | NOTE | POR RESET VALUE  |  DESCRIPTION

P0 .EQU 0x80                  ;1111,1111 Port 0
   P00 .EQU 0x80+0 ;Port 0 Bit 0
   P01 .EQU 0x80+1 ;Port 0 Bit 1
   P02 .EQU 0x80+2 ;Port 0 Bit 2
   P03 .EQU 0x80+3 ;Port 0 Bit 3
   P04 .EQU 0x80+4 ;Port 0 Bit 4
   P05 .EQU 0x80+5 ;Port 0 Bit 5
   P06 .EQU 0x80+6 ;Port 0 Bit 6
   P07 .EQU 0x80+7 ;Port 0 Bit 7
   P0_0 .EQU 0x80+0 ;Port 0 Bit 0
   P0_1 .EQU 0x80+1 ;Port 0 Bit 1
   P0_2 .EQU 0x80+2 ;Port 0 Bit 2
   P0_3 .EQU 0x80+3 ;Port 0 Bit 3
   P0_4 .EQU 0x80+4 ;Port 0 Bit 4
   P0_5 .EQU 0x80+5 ;Port 0 Bit 5
   P0_6 .EQU 0x80+6 ;Port 0 Bit 6
   P0_7 .EQU 0x80+7 ;Port 0 Bit 7

SP .EQU 0x81                  ;0000,0111 Stack Pointer

;DPTR .EQU 0x82                ;0000,0000 Data Pointer
DPL .EQU 0x82                ;0000,0000 Data Pointer Low

DPH .EQU 0x83                 ;0000,0000 Data Pointer High

PCON .EQU 0x87                ;0011,0000|0001,0000 Power Control
   IDL   = 0x01 ;Idle
   PD    = 0x02 ;Power Down
   STOP  = 0x02 ;Stop
   GF0   = 0x04 ;General Flag 0
   GF1   = 0x08 ;General Flag 1
   POF   = 0x10 ;Power On Flag
   LVDF  = 0x10 ;Low Voltage Detect Flag
   SMOD0 = 0x40 ;Serial Mode 0
   SMOD  = 0x80 ;Serial Mode

TCON .EQU 0x88                ;0000,0000 Timer Control
   IT0 .EQU 0x88+0 ;Interrupt 0 Type
   IE0 .EQU 0x88+1 ;Interrupt 0 Edge
   IT1 .EQU 0x88+2 ;Interrupt 1 Type
   IE1 .EQU 0x88+3 ;Interrupt 1 Edge
   TR0 .EQU 0x88+4 ;Timer 0 Run
   TF0 .EQU 0x88+5 ;Timer 0 Flag
   TR1 .EQU 0x88+6 ;Timer 1 Run
   TF1 .EQU 0x88+7 ;Timer 1 Flag

TMOD .EQU 0x89                ;0000,0000 Timer Mode
   T0_M0   = 0x01 ;Timer 0 Mode 0
   T0_M1   = 0x02 ;Timer 0 Mode 1
   T0_M    = 0x03 ;Timer 0 Mode
   T0_CT   = 0x04 ;Timer 0 Counter Timer
   T0_GATE = 0x08 ;Timer 0 Gate
   T1_M0   = 0x10 ;Timer 1 Mode 0
   T1_M1   = 0x20 ;Timer 1 Mode 1
   T1_M    = 0x30 ;Timer 1 Mode
   T1_CT   = 0x40 ;Timer 1 Counter Timer
   T1_GATE = 0x80 ;Timer 1 Gate
   M00   = 0x01 ;Mode 0 Timer 0
   M10   = 0x02 ;Mode 1 Timer 0
   M0    = 0x03 ;Timer 0 Mode
   CT0   = 0x04 ;Counter Timer 0
   GATE0 = 0x08 ;Gate 0
   M01   = 0x10 ;Mode 1 Timer 1
   M11   = 0x20 ;Mode 1 Timer 1
   M1    = 0x30 ;Timer 1 Mode
   CT1   = 0x40 ;Counter Timer 1
   GATE1 = 0x80 ;Gate 1

TL0 .EQU 0x8A                 ;0000,0000 Timer 0 Low

TL1 .EQU 0x8B                 ;0000,0000 Timer 1 Low

TH0 .EQU 0x8C                 ;0000,0000 Timer 0 High

TH1 .EQU 0x8D                 ;000x,0000 Timer 1 High

AUXR .EQU 0x8E                ;0000,0000|0000,x000 Auxiliary Register
   S1BRS     = 0x01 ;Serial 1 Baud Rate Select
   XRAM    = 0x02 ;External RAM (what were they thinking!)
   EXTRAM    = 0x02 ;External RAM
   BRTx12    = 0x04 ;Baud Rate Times 12
   BRTR      = 0x10 ;Baud Rate Timer Run
   UART_M0x6 = 0x20 ;Universal Asynchronous Receiver Transmitter Baud Rate Mode 0 Times 6
   T1x12     = 0x40 ;Timer 1 Times 12
   T0x12     = 0x80 ;Timer 0 Times 12

WAKE_CLKO .EQU 0x8F           ;0000,0000|x000,x000 Wakeup Clock Output
   T0CLKO     = 0x01 ;Timer 0 Clock Overflow Output
   T1CLKO     = 0x02 ;Timer 1 Clock Overflow Output
   BRTCLKO    = 0x04 ;Baud Rate Timer Clock Overflow
   T0_PIN_IE  = 0x10 ;Timer 0 Pin Interrupt Enable
   T1_PIN_IE  = 0x20 ;Timer 1 Pin Interrupt Enable
   RXD_PIN_IE = 0x40 ;RXD Pin Interrupt Enable

; b6 - RXD_PIN_IE : 当 P3.0(RXD) 下降沿置位 RI 时可唤醒 powerdown(必须打开相应中断)。
; b5 - T1_PIN_IE : 当 T1 脚下降沿置位 T1 中断标志时可唤醒 powerdown(必须打开相应中断)。
; b4 - T0_PIN_IE : 当 T0 脚下降沿置位 T0 中断标志时可唤醒 powerdown(必须打开相应中断)。
; b2 -
; b1 - T1CLKO : 允许 T1CKO(P3.5) 脚输出 T1 溢出脉冲，Fck1, 1/2 T1 溢出率
; b0 - T0CLKO : 允许 T0CKO(P3.4) 脚输出 T0 溢出脉冲，Fck0, 1/2 T1 溢出率

; b6 - RXD_PIN_IE: When the P3.0 (RXD) falling edge, PowerDown can be woken up (the corresponding interrupt must be opened).
; b5 - T1_PIN_IE: Wake PowerDown when the T1 pin falls along the T1 interrupt flag (must open the corresponding interrupt).
; b4 - T0_PIN_IE: Wake up PowerDown when the T0 foot falls along the T0 interrupt flag (must open the corresponding interrupt).
; b2 - BRTCLKO : Allow P1.0 foot output clock of Baud-Rate Timer (BRT). The clock rate is BRT overflow rate divided by 2.
; b1 - T1CLKO: Allow T1CKO (P3.5) foot output T1 overflow pulse, FCK1, 1/2 T1 overflow rate
; b0 - T0CLKO: Allow T0CKO (P3.4) foot output T0 overflow pulse, FCK0, 1/2 T1 overflow rate

P1 .EQU 0x90                  ;1111,1111 Port 1
   CLKOUT2 .EQU 0x90+0 ;Clock Out 2
   RXD_P1  .EQU 0x90+6 ;Receive Data
   TXD_P1  .EQU 0x90+7 ;Transmit Data
   P10 .EQU 0x90+0 ;Port 1 Bit 0
   P11 .EQU 0x90+1 ;Port 1 Bit 1
   P12 .EQU 0x90+2 ;Port 1 Bit 2
   P13 .EQU 0x90+3 ;Port 1 Bit 3
   P14 .EQU 0x90+4 ;Port 1 Bit 4
   P15 .EQU 0x90+5 ;Port 1 Bit 5
   P16 .EQU 0x90+6 ;Port 1 Bit 6
   P17 .EQU 0x90+7 ;Port 1 Bit 7
   P1_0 .EQU 0x90+0 ;Port 1 Bit 0
   P1_1 .EQU 0x90+1 ;Port 1 Bit 1
   P1_2 .EQU 0x90+2 ;Port 1 Bit 2
   P1_3 .EQU 0x90+3 ;Port 1 Bit 3
   P1_4 .EQU 0x90+4 ;Port 1 Bit 4
   P1_5 .EQU 0x90+5 ;Port 1 Bit 5
   P1_6 .EQU 0x90+6 ;Port 1 Bit 6
   P1_7 .EQU 0x90+7 ;Port 1 Bit 7

P1M1 .EQU 0x91                ;0000,0000 Port 1 Mode 1
   P10M1 = 0x01 ;Port 1 bit 0 Mode 1
   P11M1 = 0x02 ;Port 1 bit 1 Mode 1
   P12M1 = 0x04 ;Port 1 bit 2 Mode 1
   P13M1 = 0x08 ;Port 1 bit 3 Mode 1
   P14M1 = 0x10 ;Port 1 bit 4 Mode 1
   P15M1 = 0x20 ;Port 1 bit 5 Mode 1
   P16M1 = 0x40 ;Port 1 bit 6 Mode 1
   P17M1 = 0x80 ;Port 1 bit 7 Mode 1

P1M0 .EQU 0x92                ;0000,0000 Port 1 Mode 0
   P10M0 = 0x01 ;Port 1 bit 0 Mode 0
   P11M0 = 0x02 ;Port 1 bit 1 Mode 0
   P12M0 = 0x04 ;Port 1 bit 2 Mode 0
   P13M0 = 0x08 ;Port 1 bit 3 Mode 0
   P14M0 = 0x10 ;Port 1 bit 4 Mode 0
   P15M0 = 0x20 ;Port 1 bit 5 Mode 0
   P16M0 = 0x40 ;Port 1 bit 6 Mode 0
   P17M0 = 0x80 ;Port 1 bit 7 Mode 0

P0M1 .EQU 0x93                ;0000,0000 Port 0 Mode 1
   P00M1 = 0x01 ;Port 0 bit 0 Mode 1
   P01M1 = 0x02 ;Port 0 bit 1 Mode 1
   P02M1 = 0x04 ;Port 0 bit 2 Mode 1
   P03M1 = 0x08 ;Port 0 bit 3 Mode 1
   P04M1 = 0x10 ;Port 0 bit 4 Mode 1
   P05M1 = 0x20 ;Port 0 bit 5 Mode 1
   P06M1 = 0x40 ;Port 0 bit 6 Mode 1
   P07M1 = 0x80 ;Port 0 bit 7 Mode 1

P0M0 .EQU 0x94                ;0000,0000 Port 0 Mode 0
   P00M0 = 0x01 ;Port 0 bit 0 Mode 0
   P01M0 = 0x02 ;Port 0 bit 1 Mode 0
   P02M0 = 0x04 ;Port 0 bit 2 Mode 0
   P03M0 = 0x08 ;Port 0 bit 3 Mode 0
   P04M0 = 0x10 ;Port 0 bit 4 Mode 0
   P05M0 = 0x20 ;Port 0 bit 5 Mode 0
   P06M0 = 0x40 ;Port 0 bit 6 Mode 0
   P07M0 = 0x80 ;Port 0 bit 7 Mode 0

P2M1 .EQU 0x95                ;0000,0000 Port 2 Mode 1
   P20M1 = 0x01 ;Port 2 bit 0 Mode 1
   P21M1 = 0x02 ;Port 2 bit 1 Mode 1
   P22M1 = 0x04 ;Port 2 bit 2 Mode 1
   P23M1 = 0x08 ;Port 2 bit 3 Mode 1
   P24M1 = 0x10 ;Port 2 bit 4 Mode 1
   P25M1 = 0x20 ;Port 2 bit 5 Mode 1
   P26M1 = 0x40 ;Port 2 bit 6 Mode 1
   P27M1 = 0x80 ;Port 2 bit 7 Mode 1

P2M0 .EQU 0x96                ;0000,0000 Port 2 Mode 0
   P20M0 = 0x01 ;Port 2 bit 0 Mode 0
   P21M0 = 0x02 ;Port 2 bit 1 Mode 0
   P22M0 = 0x04 ;Port 2 bit 2 Mode 0
   P23M0 = 0x08 ;Port 2 bit 3 Mode 0
   P24M0 = 0x10 ;Port 2 bit 4 Mode 0
   P25M0 = 0x20 ;Port 2 bit 5 Mode 0
   P26M0 = 0x40 ;Port 2 bit 6 Mode 0
   P27M0 = 0x80 ;Port 2 bit 7 Mode 0

CLK_DIV .EQU 0x97             ;xxxx,x000 Clock Divider
   CLKS0 = 0x01 ;Clock Select 0
   CLKS1 = 0x02 ;Clock Select 1
   CLKS2 = 0x04 ;Clock Select 2
   CLKS  = 0x07 ;Clock Select

SCON .EQU 0x98                ;0000,0000 Serial Control
   RI  .EQU 0x98+0 ;Receive Interrupt
   TI  .EQU 0x98+1 ;Transmit Interrupt
   RB8 .EQU 0x98+2 ;Receive Bit 8
   TB8 .EQU 0x98+3 ;Transmit Bit 8
   REN .EQU 0x98+4 ;Receive Enable
   SM2 .EQU 0x98+5 ;Serial Mode 2
   SM1 .EQU 0x98+6 ;Serial Mode 1
   SM0 .EQU 0x98+7 ;Serial Mode 0
   FE  .EQU 0x98+7 ;Framing Error

SBUF .EQU 0x99                ;xxxx,xxxx Serial Buffer

BRT .EQU 0x9C                 ;0000,0000 Serial 2 Baud Rate Timer

P2 .EQU 0xA0                  ;1111,1111 Port 2
   P20 .EQU 0xA0+0 ;Port 2 Bit 0
   P21 .EQU 0xA0+1 ;Port 2 Bit 1
   P22 .EQU 0xA0+2 ;Port 2 Bit 2
   P23 .EQU 0xA0+3 ;Port 2 Bit 3
   P24 .EQU 0xA0+4 ;Port 2 Bit 4
   P25 .EQU 0xA0+5 ;Port 2 Bit 5
   P26 .EQU 0xA0+6 ;Port 2 Bit 6
   P27 .EQU 0xA0+7 ;Port 2 Bit 7
   P2_0 .EQU 0xA0+0 ;Port 2 Bit 0
   P2_1 .EQU 0xA0+1 ;Port 2 Bit 1
   P2_2 .EQU 0xA0+2 ;Port 2 Bit 2
   P2_3 .EQU 0xA0+3 ;Port 2 Bit 3
   P2_4 .EQU 0xA0+4 ;Port 2 Bit 4
   P2_5 .EQU 0xA0+5 ;Port 2 Bit 5
   P2_6 .EQU 0xA0+6 ;Port 2 Bit 6
   P2_7 .EQU 0xA0+7 ;Port 2 Bit 7

BUS_SPEED .EQU 0xA1           ;xx10,x011 Bus Speed
   RWS0  = 0x01 ;Read Write Stretch 0
   RWS1  = 0x02 ;Read Write Stretch 1
   RWS2  = 0x03 ;Read Write Stretch 2
   RWS   = 0x07 ;Read Write Stretch
   ALES0 = 0x10 ;ALE Stretch 0
   ALES1 = 0x20 ;ALE Stretch 1
   ALES  = 0x30 ;ALE Stretch

; ALES1 and ALES0:
; 00 : The P0 address setup time and hold time to ALE negative edge is one clock cycle.
; 01 : The P0 address setup time and hold time to ALE negative edge is two clock cycles.
; 10 : The P0 address setup time and hold time to ALE negative edge is three clock cycles (default).
; 11 : The P0 address setup time and hold time to ALE negative edge is four clock cycles.

; RWS2,RWS1,RWS0:
;   000 : The MOVX read/write pulse is 1 clock cycle.
;   001 : The MOVX read/write pulse is 2 clock cycles.
;   010 : The MOVX read/write pulse is 3 clock cycles.
;   011 : The MOVX read/write pulse is 4 clock cycles (default).
;   100 : The MOVX read/write pulse is 5 clock cycles.
;   101 : The MOVX read/write pulse is 6 clock cycles.
;   110 : The MOVX read/write pulse is 7 clock cycles.
;   111 : The MOVX read/write pulse is 8 clock cycles.

AUXR1 .EQU 0xA2               ;xxxx,0xx0 Auxiliary Register 1
   DPS     = 0x01 ;Data Pointer Select
   GF2     = 0x08 ;General Flag 2
   UART_P1 = 0x80 ;Universal Asynchronous Transmitter Receiver Port 1

; UART_P1:
;     0, 缺省UART 在P3 口
;     1，UART 从P3 口切换到P1 口: TxD 从P3.1 切换到P1.7 口
;                                  RxD 从P3.0 切换到P1.6 口
; GF2: 通用标志位

; DPS: 0, 使用缺省数据指针DPTR0
;      1，使用另一个数据指针DPTR1

; UART_P1:
;     0, the default UART in P3
;     1, UART Switch from P3 to P1 port: TXD Switch from P3.1 to P1.7
;                                  RXD switches from P3.0 to P1.6
; GF2: Universal Sign

; DPS: 0, use default data pointer DPTR0
;      1, use another data pointer DPTR1

TEST_WDT .EQU 0xA7            ;xxxx,xxxx Test Watchdog Timer (do not use)

IE .EQU 0xA8                  ;0x00,0000 Interrupt Enable
   EX0  .EQU 0xA8+0 ;Enable External 0
   ET0  .EQU 0xA8+1 ;Enable Timer 0
   EX1  .EQU 0xA8+2 ;Enable External 1
   ET1  .EQU 0xA8+3 ;Enable Timer 1
   ES   .EQU 0xA8+4 ;Enable Serial
   ELVD .EQU 0xA8+6 ;Enable Low Voltage Detect
   EA   .EQU 0xA8+7 ;Enable All

SADDR .EQU 0xA9               ;0000,0000 Slave Address

; SFR(WKTCL, 0xAA); //Datasheet Error?
; SFR(WKTCH, 0xAB); //Datasheet Error?

P3 .EQU 0xB0                  ;1111,1111 Port 3
   RXD     .EQU 0xB0+0 ;Receive Data
   TXD     .EQU 0xB0+1 ;Transmit Data
   INT0    .EQU 0xB0+2 ;Interrupt 0
   INT1    .EQU 0xB0+3 ;Interrupt 1
   T0      .EQU 0xB0+4 ;Timer 0
   CLKOUT0 .EQU 0xB0+4 ;Clock Out 0
   T1      .EQU 0xB0+5 ;Timer 1
   CLKOUT1 .EQU 0xB0+5 ;Clock Out 1
   WR      .EQU 0xB0+6 ;Write
   RD      .EQU 0xB0+7 ;Read
   P30 .EQU 0xB0+0 ;Port 3 Bit 0
   P31 .EQU 0xB0+1 ;Port 3 Bit 1
   P32 .EQU 0xB0+2 ;Port 3 Bit 2
   P33 .EQU 0xB0+3 ;Port 3 Bit 3
   P34 .EQU 0xB0+4 ;Port 3 Bit 4
   P35 .EQU 0xB0+5 ;Port 3 Bit 5
   P37 .EQU 0xB0+7 ;Port 3 Bit 7
   P3_0 .EQU 0xB0+0 ;Port 3 Bit 0
   P3_1 .EQU 0xB0+1 ;Port 3 Bit 1
   P3_2 .EQU 0xB0+2 ;Port 3 Bit 2
   P3_3 .EQU 0xB0+3 ;Port 3 Bit 3
   P3_4 .EQU 0xB0+4 ;Port 3 Bit 4
   P3_5 .EQU 0xB0+5 ;Port 3 Bit 5
   P3_7 .EQU 0xB0+7 ;Port 3 Bit 7

P3M1 .EQU 0xB1                ;0000,0000 Port 3 Mode 1
   P30M1 = 0x01 ;Port 3 bit 0 Mode 1
   P31M1 = 0x02 ;Port 3 bit 1 Mode 1
   P32M1 = 0x04 ;Port 3 bit 2 Mode 1
   P33M1 = 0x08 ;Port 3 bit 3 Mode 1
   P34M1 = 0x10 ;Port 3 bit 4 Mode 1
   P35M1 = 0x20 ;Port 3 bit 5 Mode 1
   P36M1 = 0x40 ;Port 3 bit 6 Mode 1
   P37M1 = 0x80 ;Port 3 bit 7 Mode 1

P3M0 .EQU 0xB2                ;0000,0000 Port 3 Mode 0
   P30M0 = 0x01 ;Port 3 bit 0 Mode 0
   P31M0 = 0x02 ;Port 3 bit 1 Mode 0
   P32M0 = 0x04 ;Port 3 bit 2 Mode 0
   P33M0 = 0x08 ;Port 3 bit 3 Mode 0
   P34M0 = 0x10 ;Port 3 bit 4 Mode 0
   P35M0 = 0x20 ;Port 3 bit 5 Mode 0
   P36M0 = 0x40 ;Port 3 bit 6 Mode 0
   P37M0 = 0x80 ;Port 3 bit 7 Mode 0

P4M1 .EQU 0xB3                ;0000,0000 Port 4 Mode 1
   P40M1 = 0x01 ;Port 4 bit 0 Mode 1
   P41M1 = 0x02 ;Port 4 bit 1 Mode 1
   P42M1 = 0x04 ;Port 4 bit 2 Mode 1
   P43M1 = 0x08 ;Port 4 bit 3 Mode 1
   P44M1 = 0x10 ;Port 4 bit 4 Mode 1
   P45M1 = 0x20 ;Port 4 bit 5 Mode 1
   P46M1 = 0x40 ;Port 4 bit 6 Mode 1
   P47M1 = 0x80 ;Port 4 bit 7 Mode 1

P4M0 .EQU 0xB4                ;0000,0000 Port 4 Mode 0
   P40M0 = 0x01 ;Port 4 bit 0 Mode 0
   P41M0 = 0x02 ;Port 4 bit 1 Mode 0
   P42M0 = 0x04 ;Port 4 bit 2 Mode 0
   P43M0 = 0x08 ;Port 4 bit 3 Mode 0
   P44M0 = 0x10 ;Port 4 bit 4 Mode 0
   P45M0 = 0x20 ;Port 4 bit 5 Mode 0
   P46M0 = 0x40 ;Port 4 bit 6 Mode 0
   P47M0 = 0x80 ;Port 4 bit 7 Mode 0

IP .EQU 0xB8                  ;0000,0000|x0x0,0000 Interrupt Priority
   PX0  .EQU 0xB8+0 ;Priority External 0
   PT0  .EQU 0xB8+1 ;Priority Timer 0
   PX1  .EQU 0xB8+2 ;Priority External 1
   PT1  .EQU 0xB8+3 ;Priority Timer 1
   PS   .EQU 0xB8+4 ;Priority Serial
   PLVD .EQU 0xB8+6 ;Priority Low Voltage Detect

SADEN .EQU 0xB9               ;0000,0000 Slave Address Enable

P4SW .EQU 0xBB                ;x000,xxxx Port 4 Switch
   NA_P44  = 0x10 ;Not Applicable Port 4 bit 4 (PSEN not implemented)
   ALE_P45 = 0x20 ;Address Latch Enable Port 4 bit 5
   NA_P46  = 0x40 ;Not Applicable External Access (EA not implemented)

P4 .EQU 0xC0                  ;1111,1111 Port 4
   NA    .EQU 0xC0+4 ;Not Applicable (PSEN not implemented)
   ALE   .EQU 0xC0+5 ;Address Latch Enable
   P46NA .EQU 0xC0+6 ;Port 4 but 6 Not Applicable (EA not implemented)
   RST   .EQU 0xC0+7 ;Reset
   P40 .EQU 0xC0+0 ;Port 4 Bit 0
   P41 .EQU 0xC0+1 ;Port 4 Bit 1
   P42 .EQU 0xC0+2 ;Port 4 Bit 2
   P43 .EQU 0xC0+3 ;Port 4 Bit 3
   P44 .EQU 0xC0+4 ;Port 4 Bit 4
   P45 .EQU 0xC0+5 ;Port 4 Bit 5
   P46 .EQU 0xC0+6 ;Port 4 Bit 6
   P47 .EQU 0xC0+7 ;Port 4 Bit 6
   P4_0 .EQU 0xC0+0 ;Port 4 Bit 0
   P4_1 .EQU 0xC0+1 ;Port 4 Bit 1
   P4_2 .EQU 0xC0+2 ;Port 4 Bit 2
   P4_3 .EQU 0xC0+3 ;Port 4 Bit 3
   P4_4 .EQU 0xC0+4 ;Port 4 Bit 4
   P4_5 .EQU 0xC0+5 ;Port 4 Bit 5
   P4_6 .EQU 0xC0+6 ;Port 4 Bit 6
   P4_7 .EQU 0xC0+7 ;Port 4 Bit 7

WDT_CONTR .EQU 0xC1           ;xx00,0000 Watchdog Timer Control
   PS0      = 0x01 ;Prescale 0
   PS1      = 0x02 ;Prescale 1
   PS2      = 0x04 ;Prescale 2
   IDLE_WDT = 0x08 ;Idle Watchdog Timer
   CLR_WDT  = 0x10 ;Clear Watchdog Timer
   EN_WDT   = 0x20 ;Enable Watchdog Timer
   WDT_FLAG = 0x80 ;Watchdog Timer Flag

IAP_DATA .EQU 0xC2            ;1111,1111 In Application Programming Data
ISP_DATA .EQU 0xC2            ;In System Programming Data

IAP_ADDRH .EQU 0xC3           ;0000,0000 In Application Programming Address High
ISP_ADDRH .EQU 0xC3           ;In System Programming Address High

IAP_ADDRL .EQU 0xC4           ;0000,0000 In Application Programming Address Low
ISP_ADDRL .EQU 0xC4           ;In System Programming Address Low

IAP_CMD .EQU 0xC5             ;xxxx,x000|xxxx,xx00 In Application Programming Command
ISP_CMD .EQU 0xC5             ;In System Programming Command
   MS0    = 0x01 ;Mode Select 0
   MS1    = 0x02 ;Mode Select 1
   IAPCMD = 0x03 ;In Application Programming Command
; Valid commands follow
   IAP_IDL   = 0x00
   IAP_READ  = 0x01
   IAP_WRITE = 0x02
   IAP_ERASE = 0x03
; End of valid commands

IAP_TRIG .EQU 0xC6            ;xxxx,xxxx In Application Programming Trigger
ISP_TRIG .EQU 0xC6            ;In System Programming Trigger

IAP_CONTR .EQU 0xC7           ;0000,x000|0000,0000 In Application Programming Control
ISP_CONTR .EQU 0xC7           ;In System Programming Control
   WT0      = 0x01 ;Wait 0
   WT1      = 0x02 ;Wait 1
   WT2      = 0x04 ;Wait 2
   IAP_WT   = 0x07 ;In Application Programming Wait
   CMD_FAIL = 0x10 ;Command Fail
   SWRST    = 0x20 ;Software Reset Trigger
   SWBS     = 0x40 ;Software Boot Selection
   IAPEN    = 0x80 ;In Application Programming Enable

PSW .EQU 0xD0                 ;0000,0000 Program status word
   P   .EQU 0xD0+0 ;Parity
   F1  .EQU 0xD0+1 ;Flag 1
   OV  .EQU 0xD0+2 ;Overflow
   RS0 .EQU 0xD0+3 ;Register Select 0
   RS1 .EQU 0xD0+4 ;Register Select 1
   F0  .EQU 0xD0+5 ;Flag 0
   AC  .EQU 0xD0+6 ;Auxiliary Carry
   CY  .EQU 0xD0+7 ;Carry

ACC .EQU 0xE0                 ;0000,0000 Accumulator
   ACC0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC7 .EQU 0xE0+7 ;Accumulator Bit 7
   ACC_0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC_1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC_2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC_3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC_4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC_5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC_6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC_7 .EQU 0xE0+7 ;Accumulator Bit 7

B .EQU 0xF0                   ;0000,0000 B
   B0 .EQU 0xF0+0 ;B Bit 0
   B1 .EQU 0xF0+1 ;B Bit 1
   B2 .EQU 0xF0+2 ;B Bit 2
   B3 .EQU 0xF0+3 ;B Bit 3
   B4 .EQU 0xF0+4 ;B Bit 4
   B5 .EQU 0xF0+5 ;B Bit 5
   B6 .EQU 0xF0+6 ;B Bit 6
   B7 .EQU 0xF0+7 ;B Bit 7
   B_0 .EQU 0xF0+0 ;B Bit 0
   B_1 .EQU 0xF0+1 ;B Bit 1
   B_2 .EQU 0xF0+2 ;B Bit 2
   B_3 .EQU 0xF0+3 ;B Bit 3
   B_4 .EQU 0xF0+4 ;B Bit 4
   B_5 .EQU 0xF0+5 ;B Bit 5
   B_6 .EQU 0xF0+6 ;B Bit 6
   B_7 .EQU 0xF0+7 ;B Bit 7

;Interrupt numbers: Address = ( Number * 8 ) + 3
;Vectors are named after their corresponding interrupt
;enable register bit, so that we don't have to make up
;names and can be consisten across different 8051 MCUs
   X0_VECTOR  = 0 ; 0x0003 External Interrupt 0
   T0_VECTOR  = 1 ; 0x000B Timer 0
   X1_VECTOR  = 2 ; 0x0013 External Interrupt 1
   T1_VECTOR  = 3 ; 0x001B Timer 1
   S_VECTOR   = 4 ; 0x0023 Serial Port
   ;    -     = 5 ; 0x002B       -
   LVD_VECTOR = 6 ; 0x0033 Low Voltage Detect

;.endif