; PIO compatible header file STC12x5A.asm 20210829.
; For use with all STC12C5Axx STC12LE5Axx series.
; 适用于 STC12C5Axx STC12LE5Axx 系列的芯片。

;.ifndef STC12x5A_ASM
;.define STC12x5A_ASM

;SFR DEFINITION | NOTE | POR RESET VALUE  |  DESCRIPTION

P0 .EQU 0x80                  ;1111,1111 Port 0
   P00 .EQU 0x80+0 ;Port 0 Bit 0
   P01 .EQU 0x80+1 ;Port 0 Bit 1
   P02 .EQU 0x80+2 ;Port 0 Bit 2
   P03 .EQU 0x80+3 ;Port 0 Bit 3
   P04 .EQU 0x80+4 ;Port 0 Bit 4
   P05 .EQU 0x80+5 ;Port 0 Bit 5
   P06 .EQU 0x80+6 ;Port 0 Bit 6
   P07 .EQU 0x80+7 ;Port 0 Bit 7
   P0_0 .EQU 0x80+0 ;Port 0 Bit 0
   P0_1 .EQU 0x80+1 ;Port 0 Bit 1
   P0_2 .EQU 0x80+2 ;Port 0 Bit 2
   P0_3 .EQU 0x80+3 ;Port 0 Bit 3
   P0_4 .EQU 0x80+4 ;Port 0 Bit 4
   P0_5 .EQU 0x80+5 ;Port 0 Bit 5
   P0_6 .EQU 0x80+6 ;Port 0 Bit 6
   P0_7 .EQU 0x80+7 ;Port 0 Bit 7

SP .EQU 0x81                  ;0000,0111 Stack Pointer

;DPTR .EQU 0x82                ;0000,0000 Data Pointer
DPL .EQU 0x82                ;0000,0000 Data Pointer Low

DPH .EQU 0x83                 ;0000,0000 Data Pointer High

PCON .EQU 0x87                ;0011,0000|0001,0000 Power Control
   IDL   = 0x01 ;Idle
   PD    = 0x02 ;Power Down
   STOP  = 0x02 ;Stop
   GF0   = 0x04 ;General Flag 0
   GF1   = 0x08 ;General Flag 1
   POF   = 0x10 ;Power On Flag
   LVDF  = 0x10 ;Low Voltage Detect Flag
   SMOD0 = 0x40 ;Serial Mode 0
   SMOD  = 0x80 ;Serial Mode

TCON .EQU 0x88                ;0000,0000 Timer Control
   IT0 .EQU 0x88+0 ;Interrupt 0 Type
   IE0 .EQU 0x88+1 ;Interrupt 0 Edge
   IT1 .EQU 0x88+2 ;Interrupt 1 Type
   IE1 .EQU 0x88+3 ;Interrupt 1 Edge
   TR0 .EQU 0x88+4 ;Timer 0 Run
   TF0 .EQU 0x88+5 ;Timer 0 Flag
   TR1 .EQU 0x88+6 ;Timer 1 Run
   TF1 .EQU 0x88+7 ;Timer 1 Flag

TMOD .EQU 0x89                ;0000,0000 Timer Mode
   T0_M0   = 0x01 ;Timer 0 Mode 0
   T0_M1   = 0x02 ;Timer 0 Mode 1
   T0_M    = 0x03 ;Timer 0 Mode
   T0_CT   = 0x04 ;Timer 0 Counter Timer
   T0_GATE = 0x08 ;Timer 0 Gate
   T1_M0   = 0x10 ;Timer 1 Mode 0
   T1_M1   = 0x20 ;Timer 1 Mode 1
   T1_M    = 0x30 ;Timer 1 Mode
   T1_CT   = 0x40 ;Timer 1 Counter Timer
   T1_GATE = 0x80 ;Timer 1 Gate
   M00   = 0x01 ;Mode 0 Timer 0
   M10   = 0x02 ;Mode 1 Timer 0
   M0    = 0x03 ;Timer 0 Mode
   CT0   = 0x04 ;Counter Timer 0
   GATE0 = 0x08 ;Gate 0
   M01   = 0x10 ;Mode 1 Timer 1
   M11   = 0x20 ;Mode 1 Timer 1
   M1    = 0x30 ;Timer 1 Mode
   CT1   = 0x40 ;Counter Timer 1
   GATE1 = 0x80 ;Gate 1

TL0 .EQU 0x8A                 ;0000,0000 Timer 0 Low

TL1 .EQU 0x8B                 ;0000,0000 Timer 1 Low

TH0 .EQU 0x8C                 ;0000,0000 Timer 0 High

TH1 .EQU 0x8D                 ;0000,0000 Timer 1 High

AUXR .EQU 0x8E                ;0000,0000 Auxiliary Register
   S1BRS     = 0x01 ;Serial 1 Baud Rate Select
   EXTRAM    = 0x02 ;External RAM
   BRTx12    = 0x04 ;Baud Rate Times 12
   S2SMOD    = 0x08 ;Serial 2 Serial baudrate Modify
   BRTR      = 0x10 ;Baud Rate Timer Run
   UART_M0x6 = 0x20 ;Universal Asynchronous Receiver Transmitter Baud Rate Mode 0 Times 6
   T1x12     = 0x40 ;Timer 1 Times 12
   T0x12     = 0x80 ;Timer 0 Times 12

WAKE_CLKO .EQU 0x8F           ;0000,0000|0000,0x00 Wakeup Clock Output
   T0CLKO     = 0x01 ;Timer 0 Clock Overflow Output
   T1CLKO     = 0x02 ;Timer 1 Clock Overflow Output
   BRTCLKO    = 0x04 ;Baud Rate Timer Clock Overflow
   LVD_WAKE   = 0x08 ;Low Voltage Detect Wakeup
   T0_PIN_IE  = 0x10 ;Timer 0 Pin Interrupt Enable
   T1_PIN_IE  = 0x20 ;Timer 1 Pin Interrupt Enable
   RXD_PIN_IE = 0x40 ;RXD Pin Interrupt Enable
   PCAWAKEUP  = 0x80 ;Programmable Counter Array Wakeup

; b7 - PCAWAKEUP : PCA 中断可唤醒 powerdown。
; b6 - RXD_PIN_IE : 当 P3.0(RXD) 下降沿置位 RI 时可唤醒 powerdown(必须打开相应中断)。
; b5 - T1_PIN_IE : 当 T1 脚下降沿置位 T1 中断标志时可唤醒 powerdown(必须打开相应中断)。
; b4 - T0_PIN_IE : 当 T0 脚下降沿置位 T0 中断标志时可唤醒 powerdown(必须打开相应中断)。
; b3 - LVD_WAKE : 当 CMPIN 脚低电平置位 LVD 中断标志时可唤醒 powerdown(必须打开相应中断)。
; b2 -
; b1 - T1CLKO : 允许 T1CKO(P3.5) 脚输出 T1 溢出脉冲，Fck1, 1/2 T1 溢出率
; b0 - T0CLKO : 允许 T0CKO(P3.4) 脚输出 T0 溢出脉冲，Fck0, 1/2 T1 溢出率

; b7 - PCAWAKEUP: PCA interrupts can wake up PowerDown.
; b6 - RXD_PIN_IE: When the P3.0 (RXD) falling edge, PowerDown can be woken up (the corresponding interrupt must be opened).
; b5 - T1_PIN_IE: Wake PowerDown when the T1 pin falls along the T1 interrupt flag (must open the corresponding interrupt).
; b4 - T0_PIN_IE: Wake up PowerDown when the T0 foot falls along the T0 interrupt flag (must open the corresponding interrupt).
; b3 - LVD_WAKE: Wake up PowerDown when the Cmpin foot is set to the LVD interrupt flag (must open the corresponding interrupt).
; b2 -
; b1 - T1CLKO: Allow T1CKO (P3.5) foot output T1 overflow pulse, FCK1, 1/2 T1 overflow rate
; b0 - T0CLKO: Allow T0CKO (P3.4) foot output T0 overflow pulse, FCK0, 1/2 T1 overflow rate

P1 .EQU 0x90                  ;1111,1111 Port 1
   CLKOUT2 .EQU 0x90+0 ;Clock Out 2
   RxD2    .EQU 0x90+2 ;Receive Data 2
   ECI     .EQU 0x90+2 ;External Clock Input
   TxD2    .EQU 0x90+3 ;Transmit Data 2
   CCP0    .EQU 0x90+3 ;Compare Capture PWM 0
   SS      .EQU 0x90+4 ;Slave Select
   CCP1    .EQU 0x90+4 ;Compare Capture PWM 1
   MOSI    .EQU 0x90+5 ;Master Out Slave In
   MISO    .EQU 0x90+6 ;Master In Slave Out
   SCLK    .EQU 0x90+7 ;Serial Clock
   ACH0 .EQU 0x90+0 ;ADC Channel 0
   ACH1 .EQU 0x90+1 ;ADC Channel 1
   ACH2 .EQU 0x90+2 ;ADC Channel 2
   ACH3 .EQU 0x90+3 ;ADC Channel 3
   ACH4 .EQU 0x90+4 ;ADC Channel 4
   ACH5 .EQU 0x90+5 ;ADC Channel 5
   ACH6 .EQU 0x90+6 ;ADC Channel 6
   ACH7 .EQU 0x90+7 ;ADC Channel 7
   ADC0 .EQU 0x90+0 ;AtoD Channel 0
   ADC1 .EQU 0x90+1 ;AtoD Channel 1
   ADC2 .EQU 0x90+2 ;AtoD Channel 2
   ADC3 .EQU 0x90+3 ;AtoD Channel 3
   ADC4 .EQU 0x90+4 ;AtoD Channel 4
   ADC5 .EQU 0x90+5 ;AtoD Channel 5
   ADC6 .EQU 0x90+6 ;AtoD Channel 6
   ADC7 .EQU 0x90+7 ;AtoD Channel 7
   AIN0 .EQU 0x90+0 ;Analog Input 0
   AIN1 .EQU 0x90+1 ;Analog Input 1
   AIN2 .EQU 0x90+2 ;Analog Input 2
   AIN3 .EQU 0x90+3 ;Analog Input 3
   AIN4 .EQU 0x90+4 ;Analog Input 4
   AIN5 .EQU 0x90+5 ;Analog Input 5
   AIN6 .EQU 0x90+6 ;Analog Input 6
   AIN7 .EQU 0x90+7 ;Analog Input 7
   P10 .EQU 0x90+0 ;Port 1 Bit 0
   P11 .EQU 0x90+1 ;Port 1 Bit 1
   P12 .EQU 0x90+2 ;Port 1 Bit 2
   P13 .EQU 0x90+3 ;Port 1 Bit 3
   P14 .EQU 0x90+4 ;Port 1 Bit 4
   P15 .EQU 0x90+5 ;Port 1 Bit 5
   P16 .EQU 0x90+6 ;Port 1 Bit 6
   P17 .EQU 0x90+7 ;Port 1 Bit 7
   P1_0 .EQU 0x90+0 ;Port 1 Bit 0
   P1_1 .EQU 0x90+1 ;Port 1 Bit 1
   P1_2 .EQU 0x90+2 ;Port 1 Bit 2
   P1_3 .EQU 0x90+3 ;Port 1 Bit 3
   P1_4 .EQU 0x90+4 ;Port 1 Bit 4
   P1_5 .EQU 0x90+5 ;Port 1 Bit 5
   P1_6 .EQU 0x90+6 ;Port 1 Bit 6
   P1_7 .EQU 0x90+7 ;Port 1 Bit 7

P1M1 .EQU 0x91                ;0000,0000 Port 1 Mode 1
   P10M1 = 0x01 ;Port 1 bit 0 Mode 1
   P11M1 = 0x02 ;Port 1 bit 1 Mode 1
   P12M1 = 0x04 ;Port 1 bit 2 Mode 1
   P13M1 = 0x08 ;Port 1 bit 3 Mode 1
   P14M1 = 0x10 ;Port 1 bit 4 Mode 1
   P15M1 = 0x20 ;Port 1 bit 5 Mode 1
   P16M1 = 0x40 ;Port 1 bit 6 Mode 1
   P17M1 = 0x80 ;Port 1 bit 7 Mode 1

P1M0 .EQU 0x92                ;0000,0000 Port 1 Mode 0
   P10M0 = 0x01 ;Port 1 bit 0 Mode 0
   P11M0 = 0x02 ;Port 1 bit 1 Mode 0
   P12M0 = 0x04 ;Port 1 bit 2 Mode 0
   P13M0 = 0x08 ;Port 1 bit 3 Mode 0
   P14M0 = 0x10 ;Port 1 bit 4 Mode 0
   P15M0 = 0x20 ;Port 1 bit 5 Mode 0
   P16M0 = 0x40 ;Port 1 bit 6 Mode 0
   P17M0 = 0x80 ;Port 1 bit 7 Mode 0

P0M1 .EQU 0x93                ;0000,0000 Port 0 Mode 1
   P00M1 = 0x01 ;Port 0 bit 0 Mode 1
   P01M1 = 0x02 ;Port 0 bit 1 Mode 1
   P02M1 = 0x04 ;Port 0 bit 2 Mode 1
   P03M1 = 0x08 ;Port 0 bit 3 Mode 1
   P04M1 = 0x10 ;Port 0 bit 4 Mode 1
   P05M1 = 0x20 ;Port 0 bit 5 Mode 1
   P06M1 = 0x40 ;Port 0 bit 6 Mode 1
   P07M1 = 0x80 ;Port 0 bit 7 Mode 1

P0M0 .EQU 0x94                ;0000,0000 Port 0 Mode 0
   P00M0 = 0x01 ;Port 0 bit 0 Mode 0
   P01M0 = 0x02 ;Port 0 bit 1 Mode 0
   P02M0 = 0x04 ;Port 0 bit 2 Mode 0
   P03M0 = 0x08 ;Port 0 bit 3 Mode 0
   P04M0 = 0x10 ;Port 0 bit 4 Mode 0
   P05M0 = 0x20 ;Port 0 bit 5 Mode 0
   P06M0 = 0x40 ;Port 0 bit 6 Mode 0
   P07M0 = 0x80 ;Port 0 bit 7 Mode 0

P2M1 .EQU 0x95                ;0000,0000 Port 2 Mode 1
   P20M1 = 0x01 ;Port 2 bit 0 Mode 1
   P21M1 = 0x02 ;Port 2 bit 1 Mode 1
   P22M1 = 0x04 ;Port 2 bit 2 Mode 1
   P23M1 = 0x08 ;Port 2 bit 3 Mode 1
   P24M1 = 0x10 ;Port 2 bit 4 Mode 1
   P25M1 = 0x20 ;Port 2 bit 5 Mode 1
   P26M1 = 0x40 ;Port 2 bit 6 Mode 1
   P27M1 = 0x80 ;Port 2 bit 7 Mode 1

P2M0 .EQU 0x96                ;0000,0000 Port 2 Mode 0
   P20M0 = 0x01 ;Port 2 bit 0 Mode 0
   P21M0 = 0x02 ;Port 2 bit 1 Mode 0
   P22M0 = 0x04 ;Port 2 bit 2 Mode 0
   P23M0 = 0x08 ;Port 2 bit 3 Mode 0
   P24M0 = 0x10 ;Port 2 bit 4 Mode 0
   P25M0 = 0x20 ;Port 2 bit 5 Mode 0
   P26M0 = 0x40 ;Port 2 bit 6 Mode 0
   P27M0 = 0x80 ;Port 2 bit 7 Mode 0

CLK_DIV .EQU 0x97             ;xxxx,x000 Clock Divider
   CLKS0 = 0x01 ;Clock Select 0
   CLKS1 = 0x02 ;Clock Select 1
   CLKS2 = 0x04 ;Clock Select 2
   CLKS  = 0x07 ;Clock Select

SCON .EQU 0x98                ;0000,0000 Serial Control
   RI  .EQU 0x98+0 ;Receive Interrupt
   TI  .EQU 0x98+1 ;Transmit Interrupt
   RB8 .EQU 0x98+2 ;Receive Bit 8
   TB8 .EQU 0x98+3 ;Transmit Bit 8
   REN .EQU 0x98+4 ;Receive Enable
   SM2 .EQU 0x98+5 ;Serial Mode 2
   SM1 .EQU 0x98+6 ;Serial Mode 1
   SM0 .EQU 0x98+7 ;Serial Mode 0
   FE  .EQU 0x98+7 ;Framing Error

SBUF .EQU 0x99                ;xxxx,xxxx Serial Buffer

S2CON .EQU 0x9A               ;0000,0000 Serial 2 Control
   S2RI  = 0x01 ;Serial 2 Receive Interrupt
   S2TI  = 0x02 ;Serial 2 Transmit Interrupt
   S2RB8 = 0x04 ;Serial 2 Receive Bit 8
   S2TB8 = 0x08 ;Serial 2 Transmit Bit 8
   S2REN = 0x10 ;Serial 2 Receive Enable
   S2SM2 = 0x20 ;Serial 2 Serial Mode 2
   S2SM1 = 0x40 ;Serial 2 Serial Mode 1
   S2SM0 = 0x80 ;Serial 2 Serial Mode 0

S2BUF .EQU 0x9B               ;xxxx,xxxx Serial 2 Buffer

BRT .EQU 0x9C                 ;0000,0000 Serial 2 Baud Rate Timer

P1ASF .EQU 0x9D               ;0000,0000 Port 1 Analog Special Function
   P10ASF = 0x01 ;Port 1 bit 0 Analdog Special Function
   P11ASF = 0x02 ;Port 1 bit 1 Analdog Special Function
   P12ASF = 0x04 ;Port 1 bit 2 Analdog Special Function
   P13ASF = 0x08 ;Port 1 bit 3 Analdog Special Function
   P14ASF = 0x10 ;Port 1 bit 4 Analdog Special Function
   P15ASF = 0x20 ;Port 1 bit 5 Analdog Special Function
   P16ASF = 0x40 ;Port 1 bit 6 Analdog Special Function
   P17ASF = 0x80 ;Port 1 bit 7 Analdog Special Function

P2 .EQU 0xA0                  ;1111,1111 Port 2
   P20 .EQU 0xA0+0 ;Port 2 Bit 0
   P21 .EQU 0xA0+1 ;Port 2 Bit 1
   P22 .EQU 0xA0+2 ;Port 2 Bit 2
   P23 .EQU 0xA0+3 ;Port 2 Bit 3
   P24 .EQU 0xA0+4 ;Port 2 Bit 4
   P25 .EQU 0xA0+5 ;Port 2 Bit 5
   P26 .EQU 0xA0+6 ;Port 2 Bit 6
   P27 .EQU 0xA0+7 ;Port 2 Bit 7
   P2_0 .EQU 0xA0+0 ;Port 2 Bit 0
   P2_1 .EQU 0xA0+1 ;Port 2 Bit 1
   P2_2 .EQU 0xA0+2 ;Port 2 Bit 2
   P2_3 .EQU 0xA0+3 ;Port 2 Bit 3
   P2_4 .EQU 0xA0+4 ;Port 2 Bit 4
   P2_5 .EQU 0xA0+5 ;Port 2 Bit 5
   P2_6 .EQU 0xA0+6 ;Port 2 Bit 6
   P2_7 .EQU 0xA0+7 ;Port 2 Bit 7

BUS_SPEED .EQU 0xA1           ;xx10,x011 Bus Speed
   RWS0  = 0x01 ;Read Write Stretch 0
   RWS1  = 0x02 ;Read Write Stretch 1
   RWS2  = 0x03 ;Read Write Stretch 2
   RWS   = 0x07 ;Read Write Stretch
   ALES0 = 0x10 ;ALE Stretch 0
   ALES1 = 0x20 ;ALE Stretch 1
   ALES  = 0x30 ;ALE Stretch

; ALES1 and ALES0:
; 00 : The P0 address setup time and hold time to ALE negative edge is one clock cycle.
; 01 : The P0 address setup time and hold time to ALE negative edge is two clock cycles.
; 10 : The P0 address setup time and hold time to ALE negative edge is three clock cycles (default).
; 11 : The P0 address setup time and hold time to ALE negative edge is four clock cycles.

; RWS2,RWS1,RWS0:
;   000 : The MOVX read/write pulse is 1 clock cycle.
;   001 : The MOVX read/write pulse is 2 clock cycles.
;   010 : The MOVX read/write pulse is 3 clock cycles.
;   011 : The MOVX read/write pulse is 4 clock cycles (default).
;   100 : The MOVX read/write pulse is 5 clock cycles.
;   101 : The MOVX read/write pulse is 6 clock cycles.
;   110 : The MOVX read/write pulse is 7 clock cycles.
;   111 : The MOVX read/write pulse is 8 clock cycles.

AUXR1 .EQU 0xA2               ;0000,0000|x000,00x0 Auxiliary Register 1
   DPS    = 0x01 ;Data Pointer Select
   ADRJ   = 0x04 ;Analog to Digital Result Juxtapose
   GF2    = 0x08 ;General Flag 2
   S2_P4  = 0x10 ;Serial Port 2 Port 4
   SPI_P4 = 0x20 ;Serial Peripheral Interface Port 4
   PCA_P4 = 0x40 ;Programmable Counter Array Port 4

; PCA_P4:
;     0, 缺省PCA 在P1 口
;     1，PCA/PWM 从P1 口切换到P4 口: ECI 从P1.2 切换到P4.1 口，
;                                    PCA0/PWM0 从P1.3 切换到P4.2 口
;                                    PCA1/PWM1 从P1.4 切换到P4.3 口
; SPI_P4:
;     0, 缺省SPI 在P1 口
;     1，SPI 从P1 口切换到P4 口: SPICLK 从P1.7 切换到P4.3 口
;                                MISO 从P1.6 切换到P4.2 口
;                                MOSI 从P1.5 切换到P4.1 口
;                                SS 从P1.4 切换到P4.0 口
; S2_P4:
;     0, 缺省UART2 在P1 口
;     1，UART2 从P1 口切换到P4 口: TxD2 从P1.3 切换到P4.3 口
;                                  RxD2 从P1.2 切换到P4.2 口
; GF2: 通用标志位

; ADRJ:
;     0, 10 位A/D 转换结果的高8 位放在ADC_RES 寄存器, 低2 位放在ADC_RESL 寄存器
;     1，10 位A/D 转换结果的最高2 位放在ADC_RES 寄存器的低2 位, 低8 位放在ADC_RESL 寄存器

; DPS: 0, 使用缺省数据指针DPTR0
;      1，使用另一个数据指针DPTR1

; PCA_P4:
;     0, default PCA in P1
;     1. PCA/PWM is switched from P1 to P4 port: ECI is switched from P1.2 to P4.1 port,
;                                    PCA0/PWM0 switches from P1.3 to P4.2
;                                    PCA1/PWM1 switches from P1.4 to P4.3
; SPI_P4:
;     0, default SPI in P1
;     1, SPI switches from P1 port to P4 port: SPICLK switches from P1.7 to P4.3
;                                MISO switches from P1.6 to P4.2
;                                MOSI switches from P1.5 to P4.1
;                                SS switches from P1.4 to P4.0
; S2_P4:
;     0, the default UART2 in P1
;     1, UART2 Switch from P1 to P4 port: TXD2 Switch from P1.3 to P4.3
;                                  RXD2 switches from P1.2 to P4.2
; GF2: Universal Sign

; Adrj:
;     0, 10-bit A/D conversion results high 8 bits placed on the ADC_RES register, low 2 bits in the ADC_RESL register
;     1,10-bit A/D conversion results are placed in the low 2 bits of the ADC_RES register, and the low 8 bits are placed in the ADC_RESL register.

; DPS: 0, use default data pointer DPTR0
;      1, use another data pointer DPTR1

TEST_WDT .EQU 0xA7            ;xxxx,xxxx Test Watchdog Timer (do not use)

IE .EQU 0xA8                  ;0000,0000|0x00,0000 Interrupt Enable
   EX0  .EQU 0xA8+0 ;Enable External 0
   ET0  .EQU 0xA8+1 ;Enable Timer 0
   EX1  .EQU 0xA8+2 ;Enable External 1
   ET1  .EQU 0xA8+3 ;Enable Timer 1
   ES   .EQU 0xA8+4 ;Enable Serial
   EADC .EQU 0xA8+5 ;Enable Analog to Digital Converter
   ELVD .EQU 0xA8+6 ;Enable Low Voltage Detect
   EA   .EQU 0xA8+7 ;Enable All

SADDR .EQU 0xA9               ;0000,0000 Slave Address

IE2 .EQU 0xAF                 ;xxxx,xx00 Interrupt Enable 2
   ES2  = 0x01 ;Enable Serial 2
   ESPI = 0x02 ;Enable Serial Peripheral Interface

P3 .EQU 0xB0                  ;1111,1111 Port 3
   RXD     .EQU 0xB0+0 ;Receive Data
   TXD     .EQU 0xB0+1 ;Transmit Data
   INT0    .EQU 0xB0+2 ;Interrupt 0
   INT1    .EQU 0xB0+3 ;Interrupt 1
   T0      .EQU 0xB0+4 ;Timer 0
   CLKOUT0 .EQU 0xB0+4 ;Clock Out 0
   T1      .EQU 0xB0+5 ;Timer 1
   CLKOUT1 .EQU 0xB0+5 ;Clock Out 1
   WR      .EQU 0xB0+6 ;Write
   RD      .EQU 0xB0+7 ;Read
   P30 .EQU 0xB0+0 ;Port 3 Bit 0
   P31 .EQU 0xB0+1 ;Port 3 Bit 1
   P32 .EQU 0xB0+2 ;Port 3 Bit 2
   P33 .EQU 0xB0+3 ;Port 3 Bit 3
   P34 .EQU 0xB0+4 ;Port 3 Bit 4
   P35 .EQU 0xB0+5 ;Port 3 Bit 5
   P36 .EQU 0xB0+6 ;Port 3 Bit 6
   P37 .EQU 0xB0+7 ;Port 3 Bit 7
   P3_0 .EQU 0xB0+0 ;Port 3 Bit 0
   P3_1 .EQU 0xB0+1 ;Port 3 Bit 1
   P3_2 .EQU 0xB0+2 ;Port 3 Bit 2
   P3_3 .EQU 0xB0+3 ;Port 3 Bit 3
   P3_4 .EQU 0xB0+4 ;Port 3 Bit 4
   P3_5 .EQU 0xB0+5 ;Port 3 Bit 5
   P3_6 .EQU 0xB0+6 ;Port 3 Bit 6
   P3_7 .EQU 0xB0+7 ;Port 3 Bit 7

P3M1 .EQU 0xB1                ;0000,0000 Port 3 Mode 1
   P30M1 = 0x01 ;Port 3 bit 0 Mode 1
   P31M1 = 0x02 ;Port 3 bit 1 Mode 1
   P32M1 = 0x04 ;Port 3 bit 2 Mode 1
   P33M1 = 0x08 ;Port 3 bit 3 Mode 1
   P34M1 = 0x10 ;Port 3 bit 4 Mode 1
   P35M1 = 0x20 ;Port 3 bit 5 Mode 1
   P36M1 = 0x40 ;Port 3 bit 6 Mode 1
   P37M1 = 0x80 ;Port 3 bit 7 Mode 1

P3M0 .EQU 0xB2                ;0000,0000 Port 3 Mode 0
   P30M0 = 0x01 ;Port 3 bit 0 Mode 0
   P31M0 = 0x02 ;Port 3 bit 1 Mode 0
   P32M0 = 0x04 ;Port 3 bit 2 Mode 0
   P33M0 = 0x08 ;Port 3 bit 3 Mode 0
   P34M0 = 0x10 ;Port 3 bit 4 Mode 0
   P35M0 = 0x20 ;Port 3 bit 5 Mode 0
   P36M0 = 0x40 ;Port 3 bit 6 Mode 0
   P37M0 = 0x80 ;Port 3 bit 7 Mode 0

P4M1 .EQU 0xB3                ;0000,0000 Port 4 Mode 1
   P40M1 = 0x01 ;Port 4 bit 0 Mode 1
   P41M1 = 0x02 ;Port 4 bit 1 Mode 1
   P42M1 = 0x04 ;Port 4 bit 2 Mode 1
   P43M1 = 0x08 ;Port 4 bit 3 Mode 1
   P44M1 = 0x10 ;Port 4 bit 4 Mode 1
   P45M1 = 0x20 ;Port 4 bit 5 Mode 1
   P46M1 = 0x40 ;Port 4 bit 6 Mode 1
   P47M1 = 0x80 ;Port 4 bit 7 Mode 1

P4M0 .EQU 0xB4                ;0000,0000 Port 4 Mode 0
   P40M0 = 0x01 ;Port 4 bit 0 Mode 0
   P41M0 = 0x02 ;Port 4 bit 1 Mode 0
   P42M0 = 0x04 ;Port 4 bit 2 Mode 0
   P43M0 = 0x08 ;Port 4 bit 3 Mode 0
   P44M0 = 0x10 ;Port 4 bit 4 Mode 0
   P45M0 = 0x20 ;Port 4 bit 5 Mode 0
   P46M0 = 0x40 ;Port 4 bit 6 Mode 0
   P47M0 = 0x80 ;Port 4 bit 7 Mode 0

IP2 .EQU 0xB5                 ;xxxx,xx00 Interrupt Priority 2
   PS2  = 0x01 ;Priority Serial
   PSPI = 0x02 ;Priority Serial Peripheral Interface

IPH2 .EQU 0xB6                ;xxxx,xx00 Interrupt Priority High 2
   PS2H  = 0x01 ;Priority Serial 2 High
   PSPIH = 0x02 ;Priority Serial Peripheral Interface High

IPH .EQU 0xB7                 ;0000,0000 Interrupt Priority High
   PX0H  = 0x01 ;Priority EXternal 0 High
   PT0H  = 0x02 ;Priority Timer 0 High
   PX1H  = 0x04 ;Priority External 1 High
   PT1H  = 0x08 ;Priority Timer 1 High
   PSH   = 0x10 ;Priority Serial High
   PADCH = 0x20 ;Priority Analog to Digital Converter High
   PLVDH = 0x40 ;Priority Low Voltage Detect High
   PPCAH = 0x80 ;Priority Programmable Counter Array High

IP .EQU 0xB8                  ;0000,0000 Interrupt Priority
   PX0  .EQU 0xB8+0 ;Priority External 0
   PT0  .EQU 0xB8+1 ;Priority Timer 0
   PX1  .EQU 0xB8+2 ;Priority External 1
   PT1  .EQU 0xB8+3 ;Priority Timer 1
   PS   .EQU 0xB8+4 ;Priority Serial
   PADC .EQU 0xB8+5 ;Priority Analog to Digital Converter
   PLVD .EQU 0xB8+6 ;Priority Low Voltage Detect
   PPCA .EQU 0xB8+7 ;Priority Programmable Counter Array

SADEN .EQU 0xB9               ;0000,0000 Slave Address Enable

P4SW .EQU 0xBB                ;x000,xxxx Port 4 Switch
   NA_P44  = 0x10 ;Not Applicable Port 4 bit 4 (PSEN not implemented)
   ALE_P45 = 0x20 ;Address Latch Enable Port 4 bit 5
   LVD_P46 = 0x40 ;Low Voltage Detect Port 4 bit 6

ADC_CONTR .EQU 0xBC           ;0000,0000 Analog to Digital Converter Control
   CHS0      = 0x01 ;Channel Select 0
   CHS1      = 0x02 ;Channel Select 1
   CHS2      = 0x04 ;Channel Select 2
   ADC_CHS   = 0x0F ;ADC Analog Channel Select
   ADC_START = 0x08 ;Analog to Digital Converter Start
   ADC_FLAG  = 0x10 ;Analog to Digital Converter Flag
   SPEED0    = 0x20 ;Speed 0
   SPEED1    = 0x40 ;Speed 1
   ADC_POWER = 0x40 ;Analog to Digital Converter Power

ADC_RES .EQU 0xBD             ;0000,0000 Analog to Digital Converter Result

ADC_RESL .EQU 0xBE            ;0000,0000 Analog to Digital Converter Result Low

P4 .EQU 0xC0                  ;1111,1111 Port 4
   SS_P4   .EQU 0xC0+0 ;Slave Select Port 4
   ECI_P4  .EQU 0xC0+1 ;External Clock Input Port 4
   MOSI_P4 .EQU 0xC0+1 ;Master Out Slave In Port 4
   CCP0_P4 .EQU 0xC0+2 ;Compare Capture PWM 0 Port 4
   MISO_P4 .EQU 0xC0+2 ;Master In Slave Out secondry
   CCP1_P4 .EQU 0xC0+3 ;Compare Capture PWM 1 Port 4
   SCLK_P4 .EQU 0xC0+3 ;Serial Clock Port 4
   NA      .EQU 0xC0+4 ;Not Applicable (PSEN not implemented)
   ALE     .EQU 0xC0+5 ;Address Latch Enable
   EX_LVD  .EQU 0xC0+6 ;External Low Voltage Detect
   RST2    .EQU 0xC0+6 ;Reset 2
   RST     .EQU 0xC0+7 ;Reset
   P40 .EQU 0xC0+0 ;Port 4 Bit 0
   P41 .EQU 0xC0+1 ;Port 4 Bit 1
   P42 .EQU 0xC0+2 ;Port 4 Bit 2
   P43 .EQU 0xC0+3 ;Port 4 Bit 3
   P44 .EQU 0xC0+4 ;Port 4 Bit 4
   P45 .EQU 0xC0+5 ;Port 4 Bit 5
   P46 .EQU 0xC0+6 ;Port 4 Bit 6
   P4_0 .EQU 0xC0+0 ;Port 4 Bit 0
   P4_1 .EQU 0xC0+1 ;Port 4 Bit 1
   P4_2 .EQU 0xC0+2 ;Port 4 Bit 2
   P4_3 .EQU 0xC0+3 ;Port 4 Bit 3
   P4_4 .EQU 0xC0+4 ;Port 4 Bit 4
   P4_5 .EQU 0xC0+5 ;Port 4 Bit 5
   P4_6 .EQU 0xC0+6 ;Port 4 Bit 6

WDT_CONTR .EQU 0xC1           ;0x00,0000|xx00,0000 Watchdog Timer Control
   WDTPS0   = 0x01 ;Prescale 0
   WDTPS1   = 0x02 ;Prescale 1
   WDTPS2   = 0x04 ;Prescale 2
   WDTPS    = 0x07 ;Prescale
   IDLE_WDT = 0x08 ;Idle Watchdog Timer
   CLR_WDT  = 0x10 ;Clear Watchdog Timer
   EN_WDT   = 0x20 ;Enable Watchdog Timer
   WDT_FLAG = 0x80 ;Watchdog Timer Flag

IAP_DATA .EQU 0xC2            ;1111,1111 In Application Programming Data
ISP_DATA .EQU 0xC2            ;In System Programming Data

IAP_ADDRH .EQU 0xC3           ;0000,0000 In Application Programming Address High
ISP_ADDRH .EQU 0xC3           ;In System Programming Address High

IAP_ADDRL .EQU 0xC4           ;0000,0000 In Application Programming Address Low
ISP_ADDRL .EQU 0xC4           ;In System Programming Address Low

IAP_CMD .EQU 0xC5             ;xxxx,x000|xxxx,xx00 In Application Programming Command
ISP_CMD .EQU 0xC5             ;In System Programming Command
   MS0    = 0x01 ;Mode Select 0
   MS1    = 0x02 ;Mode Select 1
   IAPCMD = 0x03 ;In Application Programming Command
; Valid commands follow
   IAP_IDL   = 0x00
   IAP_READ  = 0x01
   IAP_WRITE = 0x02
   IAP_ERASE = 0x03
; End of valid commands

IAP_TRIG .EQU 0xC6            ;xxxx,xxxx In Application Programming Trigger
ISP_TRIG .EQU 0xC6            ;In System Programming Trigger

IAP_CONTR .EQU 0xC7           ;0000,x000 In Application Programming Control
ISP_CONTR .EQU 0xC7           ;In System Programming Control
   WT0      = 0x01 ;Wait 0
   WT1      = 0x02 ;Wait 1
   WT2      = 0x04 ;Wait 2
   IAP_WT   = 0x07 ;In Application Programming Wait
   CMD_FAIL = 0x10 ;Command Fail
   SWRST    = 0x20 ;Software Reset Trigger
   SWBS     = 0x40 ;Software Boot Selection
   IAPEN    = 0x80 ;In Application Programming Enable

P5 .EQU 0xC8                  ;xxxx,1111 Port 5
   P50 .EQU 0xC8+0 ;Port 5 Bit 0
   P51 .EQU 0xC8+1 ;Port 5 Bit 1
   P52 .EQU 0xC8+2 ;Port 5 Bit 2
   P53 .EQU 0xC8+3 ;Port 5 Bit 3
   P5_0 .EQU 0xC8+0 ;Port 5 Bit 0
   P5_1 .EQU 0xC8+1 ;Port 5 Bit 1
   P5_2 .EQU 0xC8+2 ;Port 5 Bit 2
   P5_3 .EQU 0xC8+3 ;Port 5 Bit 3

P5M1 .EQU 0xC9                ;xxxx,0000|0000,0000 Port 5 Mode 1
   P50M1 = 0x01 ;Port 5 bit 0 Mode 1
   P51M1 = 0x02 ;Port 5 bit 1 Mode 1
   P52M1 = 0x04 ;Port 5 bit 2 Mode 1
   P53M1 = 0x08 ;Port 5 bit 3 Mode 1

P5M0 .EQU 0xCA                ;xxxx,0000|0000,0000 Port 5 Mode 0
   P50M0 = 0x01 ;Port 5 bit 0 Mode 0
   P51M0 = 0x02 ;Port 5 bit 1 Mode 0
   P52M0 = 0x04 ;Port 5 bit 2 Mode 0
   P53M0 = 0x08 ;Port 5 bit 3 Mode 0

SPSTAT .EQU 0xCD              ;00xx,xxxx Serial Peripheral Status Register
   WCOL = 0x40 ;Write Collision
   SPIF = 0x80 ;Serial Peripheral Interface Flag

SPCTL .EQU 0xCE               ;0000,0100 Serial Peripheral Control
   SPR0 = 0x00 ;Serial Peripheral Rate 0
   SPR1 = 0x01 ;Serial Peripheral Rate 1
   SPR  = 0x03 ;Serial Peripheral Rate
   CPHA = 0x04 ;Clock Phase
   CPOL = 0x08 ;Clock Polarity
   MSTR = 0x10 ;Master
   DORD = 0x20 ;Data Order
   SPEN = 0x40 ;Serial Peripheral Enable
   SSIG = 0x80 ;Slave Select Signal

SPDAT .EQU 0xCF               ;0000,0000 Serial Peripheral Data

PSW .EQU 0xD0                 ;0000,0000 Program status word
   P   .EQU 0xD0+0 ;Parity
   F1  .EQU 0xD0+1 ;Flag 1
   OV  .EQU 0xD0+2 ;Overflow
   RS0 .EQU 0xD0+3 ;Register Select 0
   RS1 .EQU 0xD0+4 ;Register Select 1
   F0  .EQU 0xD0+5 ;Flag 0
   AC  .EQU 0xD0+6 ;Auxiliary Carry
   CY  .EQU 0xD0+7 ;Carry

CCON .EQU 0xD8                ;00xx,xx00 PCA Control
   CCF0 .EQU 0xD8+0 ;Capture Compare Flag 0
   CCF1 .EQU 0xD8+1 ;Capture Compare Flag 1
   CR   .EQU 0xD8+6 ;PCA Run
   CF   .EQU 0xD8+7 ;PCA Flag

; CF: PCA计数器溢出标志,由硬件或软件置位,必须由软件清0。
; CR: 1:允许 PCA 计数器计数, 必须由软件清0。
; CCF1: PCA 模块1 中断标志, 由硬件置位, 必须由软件清0。
; CCF0: PCA 模块0 中断标志, 由硬件置位, 必须由软件清0。

; CF: PCA counter overflow flag, is set by hardware or software, must be cleared by software.
; CR: 1: Allows the PCA counter count, must be cleared by software.
; CCF1: PCA module 1 interrupt flag, is set by hardware, must be cleared by software.
; CCF0: PCA module 0 interrupt flag, is set by hardware, must be cleared by software.

CMOD .EQU 0xD9                ;0xxx,0000|00xx,0000 PCA Mode
   ECF  = 0x01 ;Enable PCA Flag
   CPS0 = 0x02 ;PCA Pulse Source 0
   CPS1 = 0x04 ;PCA Pulse Source 1
   CPS2 = 0x08 ;PCA Pulse Source 2
   CPS  = 0x0E ;PCA Pulse Source
   CIDL = 0x80 ;PCA Idle

; CIDL: idle 状态时 PCA 计数器是否继续计数, 0: 继续计数, 1: 停止计数。

; CPS2: PCA 计数器脉冲源选择位 2。
; CPS1: PCA 计数器脉冲源选择位 1。
; CPS0: PCA 计数器脉冲源选择位 0。
;    CPS2   CPS1   CPS0
;     0      0      0    系统时钟频率 fosc/12。
;     0      0      1    系统时钟频率 fosc/2。
;     0      1      0    Timer0 溢出。
;     0      1      1    由 ECI/P3.4 脚输入的外部时钟，最大 fosc/2。
;     1      0      0    系统时钟频率，  Fosc/1
;     1      0      1    系统时钟频率/4，Fosc/4
;     1      1      0    系统时钟频率/6，Fosc/6
;     1      1      1    系统时钟频率/8，Fosc/8

; ECF: PCA计数器溢出中断允许位, 1--允许 CF(CCON.7) 产生中断。

; CIDL: The PCA counter continues counts when the IDLE state, 0: Continue count, 1: Stop count.

; CPS2: PCA Counter Pulse Source Select Bits 2.
; CPS1: PCA Counter pulse source selection bit 1.
; CPS0: PCA Counter pulse source selection bit 0.
;     CPS2 CPS1 CPS0
;      0 0 0 System clock frequency FOSC / 12.
;      0 0 1 System clock frequency FOSC / 2.
;      0 1 0 TIMER0 overflow.
;      0 1 1 The external clock input by ECI / P3.4 is the maximum fosc / 2.
;      1 0 0 System Clock Frequency, FOSC / 1
;      1 0 1 System Clock Frequency / 4, FOSC / 4
;      1 1 0 System Clock Frequency / 6, FOSC / 6
;      1 1 1 System Clock Frequency / 8, FOSC / 8

; ECF: The PCA counter overflow interrupt allowed bit, 1 - Allow CF (CCON.7) to generate an interrupt.

CCAPM0 .EQU 0xDA              ;x000,0000 Compare Capture PWM Mode 0
   ECCF0  = 0x01 ;Enable PCA Capture Flag 0
   PWM0   = 0x02 ;Pulse Width Modulator 0
   TOG0   = 0x04 ;Toggle 0
   MAT0   = 0x08 ;Match 0
   CAPN0  = 0x10 ;Capture Negative-going 0
   CAPP0  = 0x20 ;Capture Positive-going 0
   ECOM0  = 0x40 ;Enable Comparator 0

CCAPM1 .EQU 0xDB              ;x000,0000 Compare Capture PWM Mode 1
   ECCF1  = 0x01 ;Enable PCA Capture Flag 1
   PWM1   = 0x02 ;Pulse Width Modulator 1
   TOG1   = 0x04 ;Toggle 1
   MAT1   = 0x08 ;Match 1
   CAPN1  = 0x10 ;Capture Negative-going 1
   CAPP1  = 0x20 ;Capture Positive-going 1
   ECOM1  = 0x40 ;Enable Comparator 1

; ECOMn, 1:允许比较功能。
; CAPPn, 1:允许上升沿触发捕捉功能。
; CAPNn, 1:允许下降沿触发捕捉功能。
; MATn, 1:当匹配情况发生时, 允许 CCON 中的 CCFn 置位。
; TOGn, 1:当匹配情况发生时, CEXn 将翻转。
; PWMn, 1:将 CEXn 设置为 PWM 输出。
; ECCFn, 1:允许 CCON 中的 CCFn 触发中断。

; ECOMn  CAPPn  CAPNn  MATn  TOGn  PWMn  ECCFn
;   0      0      0     0     0     0     0   0x00   未启用任何功能。
;   x      1      0     0     0     0     x   0x21   16位CEXn上升沿触发捕捉功能。
;   x      0      1     0     0     0     x   0x11   16位CEXn下降沿触发捕捉功能。
;   x      1      1     0     0     0     x   0x31   16位CEXn边沿(上、下沿)触发捕捉功能。
;   1      0      0     1     0     0     x   0x49   16位软件定时器。
;   1      0      0     1     1     0     x   0x4d   16位高速脉冲输出。
;   1      0      0     0     0     1     0   0x42   8位 PWM。

; ECOMn  CAPPn  CAPNn  MATn  TOGn  PWMn  ECCFn
;   0      0      0     0     0     0     0   0x00   无此操作
;   1      0      0     0     0     1     0   0x42   普通8位PWM, 无中断
;   1      1      0     0     0     1     1   0x63   PWM输出由低变高可产生中断
;   1      0      1     0     0     1     1   0x53   PWM输出由高变低可产生中断
;   1      1      1     0     0     1     1   0x73   PWM输出由低变高或由高变低都可产生中断

; ECOMN, 1: Allow comparison functions.
; CAPPN, 1: Allows the rising edge to trigger capture functions.
; CAPNN, 1: Allows the falling edge to trigger capture function.
; MATN, 1: When the match occurs, the CCFN in CCON is allowed.
; TOGN, 1: When the match occurs, Cexn will flip.
; PWMN, 1: Set CexN to PWM output.
; ECCFN, 1: Allows CCFN trigger interrupt in CCON.

; ECOMN CAPPN CAPNN MATN TOGN PWMN ECCFN
;   0 0 0 0 0 0 0 0x00 No function is not enabled.
;   X 1 0 0 0 0 x 0x21 16-bit CEXN rising edge trigger capture function.
;   X 0 1 0 0 0 x 0x11 16-bit CEXN falling edge trigger capture function.
;   X 1 1 0 0 0 x 0x31 16-bit CEXN edge (upper, down) trigger capture function.
;   1 0 0 1 0 0 x 0x49 16-bit software timer.
;   1 0 0 1 0 x 0x4D 16-bit high speed pulse output.
;   1 0 0 0 0 1 0 0 x 42 8-bit PWM.

; ECOMN CAPPN CAPNN MATN TOGN PWMN ECCFN
;   0 0 0 0 0 0 0 0x00 Non-this
;   1 0 0 0 0 1 0 0x42 Ordinary 8-bit PWM, no interrupt
;   1 1 0 0 0 1 1 0x63 PWM output from low change can be interrupted
;   1 0 1 0 0 1 1 0 x53 PWM output from high change low can generate interrupt
;   1 1 1 0 0 1 1 0x73 PWM output can be interrupted by low change or low high change

ACC .EQU 0xE0                 ;0000,0000 Accumulator
   ACC0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC7 .EQU 0xE0+7 ;Accumulator Bit 7
   ACC_0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC_1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC_2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC_3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC_4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC_5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC_6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC_7 .EQU 0xE0+7 ;Accumulator Bit 7

CL .EQU 0xE9                  ;0000,0000 PCA Low

CCAP0L .EQU 0xEA              ;0000,0000 PCA Capture 0 Low

CCAP1L .EQU 0xEB              ;0000,0000 PCA Capture 1 Low

B .EQU 0xF0                   ;0000,0000 B
   B0 .EQU 0xF0+0 ;B Bit 0
   B1 .EQU 0xF0+1 ;B Bit 1
   B2 .EQU 0xF0+2 ;B Bit 2
   B3 .EQU 0xF0+3 ;B Bit 3
   B4 .EQU 0xF0+4 ;B Bit 4
   B5 .EQU 0xF0+5 ;B Bit 5
   B6 .EQU 0xF0+6 ;B Bit 6
   B7 .EQU 0xF0+7 ;B Bit 7
   B_0 .EQU 0xF0+0 ;B Bit 0
   B_1 .EQU 0xF0+1 ;B Bit 1
   B_2 .EQU 0xF0+2 ;B Bit 2
   B_3 .EQU 0xF0+3 ;B Bit 3
   B_4 .EQU 0xF0+4 ;B Bit 4
   B_5 .EQU 0xF0+5 ;B Bit 5
   B_6 .EQU 0xF0+6 ;B Bit 6
   B_7 .EQU 0xF0+7 ;B Bit 7

PCA_PWM0 .EQU 0xF2            ;xxxx,xx00 Programmable Counter Array Pulse Width Modulator 0
   EPC0L = 0x01 ;PWM 0 Compare Value Low
   EPC0H = 0x02 ;PWM 0 Compare Value High

PCA_PWM1 .EQU 0xF3            ;xxxx,xx00 Programmable Counter Array Pulse Width Modulator 1
   EPC1L = 0x01 ;PWM 1 Compare Value Low
   EPC1H = 0x02 ;PWM 1 Compare Value High

; B7-B2: 保留
; B1(EPCnH): 在 PWM 模式下，与 CCAPnH 组成 9 位数。
; B0(EPCnL): 在 PWM 模式下，与 CCAPnL 组成 9 位数。

; B7-B2: Reserved
; B1 (EPCNH): In PWM mode, it consists of 9 digits with CCAPNH.
; B0 (EPCNL): In the PWM mode, it consists of 9 digits with CCAPNL.

CH .EQU 0xF9                  ;0000,0000 PCA High

CCAP0H .EQU 0xFA              ;0000,0000 PCA Capture 0 High

CCAP1H .EQU 0xFB              ;0000,0000 PCA Capture 1 High

;Interrupt numbers: Address = ( Number * 8 ) + 3
;Vectors are named after their corresponding interrupt
;enable register bit, so that we don't have to make up
;names and can be consisten across different 8051 MCUs
   X0_VECTOR  = 0 ; 0x0003 External Interrupt 0
   T0_VECTOR  = 1 ; 0x000B Timer 0
   X1_VECTOR  = 2 ; 0x0013 External Interrupt 1
   T1_VECTOR  = 3 ; 0x001B Timer 1
   S_VECTOR   = 4 ; 0x0023 Serial Port
   ADC_VECTOR = 5 ; 0x002B Analog to Digital Converter
   LVD_VECTOR = 6 ; 0x0033 Low Voltage Detect
   PCA_VECTOR = 7 ; 0x003B Programmable Counter Array
   S2_VECTOR  = 8 ; 0x0043 Serial Port 2
   SPI_VECTOR = 9 ; 0x004B Serial Peripheral Interface

;.endif
