; PIO compatible header file STC12xx052.asm 20210829.
; For use with STC12C1052 STC12C2052 STC12C3052 STC12C4052 STC12C5052
; STC12LE1052 STC12LE2052 STC12LE3052 STC12LE4052 STC12LE5052
; STC12C1052AD STC12C2052AD STC12C3052AD STC12C4052AD STC12C5052AD
; STC12LE1052AD STC12LE2052AD STC12LE3052AD STC12LE4052AD STC12LE5052AD

;.ifndef STC12xx052_ASM
;.define STC12xx052_ASM

SP .EQU 0x81
;DPTR .EQU 0x82
DPL .EQU 0x82
DPH .EQU 0x83
SPSTAT .EQU 0x84
SPCTL .EQU 0x85
SPDAT .EQU 0x86
PCON .EQU 0x87
TCON .EQU 0x88
   IT0 .EQU 0x88+0 ;Interrupt 0 Type
   IE0 .EQU 0x88+1 ;Interrupt 0 Edge
   IT1 .EQU 0x88+2 ;Interrupt 1 Type
   IE1 .EQU 0x88+3 ;Interrupt 1 Edge
   TR0 .EQU 0x88+4 ;Timer 0 Run
   TF0 .EQU 0x88+5 ;Timer 0 Flag
   TR1 .EQU 0x88+6 ;Timer 1 Run
   TF1 .EQU 0x88+7 ;Timer 1 Flag
TMOD .EQU 0x89
TL0 .EQU 0x8A
TL1 .EQU 0x8B
TH0 .EQU 0x8C
TH1 .EQU 0x8D
AUXR .EQU 0x8E
WAKE_CLKO .EQU 0x8F
P1 .EQU 0x90
   CLKOUT0 .EQU 0x90+0 ;Clock Out 0
   CLKOUT1 .EQU 0x90+1 ;Clock Out 1
   SS      .EQU 0x90+4 ;Slave Select
   MOSI    .EQU 0x90+5 ;Master Out Slave In
   MISO    .EQU 0x90+6 ;Master In Slave Out
   SCLK    .EQU 0x90+7 ;Serial Clock
   ACH0 .EQU 0x90+0 ;ADC Channel 0
   ACH1 .EQU 0x90+1 ;ADC Channel 1
   ACH2 .EQU 0x90+2 ;ADC Channel 2
   ACH3 .EQU 0x90+3 ;ADC Channel 3
   ACH4 .EQU 0x90+4 ;ADC Channel 4
   ACH5 .EQU 0x90+5 ;ADC Channel 5
   ACH6 .EQU 0x90+6 ;ADC Channel 6
   ACH7 .EQU 0x90+7 ;ADC Channel 7
   ADC0 .EQU 0x90+0 ;AtoD Channel 0
   ADC1 .EQU 0x90+1 ;AtoD Channel 1
   ADC2 .EQU 0x90+2 ;AtoD Channel 2
   ADC3 .EQU 0x90+3 ;AtoD Channel 3
   ADC4 .EQU 0x90+4 ;AtoD Channel 4
   ADC5 .EQU 0x90+5 ;AtoD Channel 5
   ADC6 .EQU 0x90+6 ;AtoD Channel 6
   ADC7 .EQU 0x90+7 ;AtoD Channel 7
   AIN0 .EQU 0x90+0 ;Analog Input 0
   AIN1 .EQU 0x90+1 ;Analog Input 1
   AIN2 .EQU 0x90+2 ;Analog Input 2
   AIN3 .EQU 0x90+3 ;Analog Input 3
   AIN4 .EQU 0x90+4 ;Analog Input 4
   AIN5 .EQU 0x90+5 ;Analog Input 5
   AIN6 .EQU 0x90+6 ;Analog Input 6
   AIN7 .EQU 0x90+7 ;Analog Input 7
   P10 .EQU 0x90+0 ;Port 1 Bit 0
   P11 .EQU 0x90+1 ;Port 1 Bit 1
   P12 .EQU 0x90+2 ;Port 1 Bit 2
   P13 .EQU 0x90+3 ;Port 1 Bit 3
   P14 .EQU 0x90+4 ;Port 1 Bit 4
   P15 .EQU 0x90+5 ;Port 1 Bit 5
   P16 .EQU 0x90+6 ;Port 1 Bit 6
   P17 .EQU 0x90+7 ;Port 1 Bit 7
   P1_0 .EQU 0x90+0 ;Port 1 Bit 0
   P1_1 .EQU 0x90+1 ;Port 1 Bit 1
   P1_2 .EQU 0x90+2 ;Port 1 Bit 2
   P1_3 .EQU 0x90+3 ;Port 1 Bit 3
   P1_4 .EQU 0x90+4 ;Port 1 Bit 4
   P1_5 .EQU 0x90+5 ;Port 1 Bit 5
   P1_6 .EQU 0x90+6 ;Port 1 Bit 6
   P1_7 .EQU 0x90+7 ;Port 1 Bit 7
P1M0 .EQU 0x91
P1M1 .EQU 0x92
SCON .EQU 0x98
   RI  .EQU 0x98+0 ;Receive Interrupt
   TI  .EQU 0x98+1 ;Transmit Interrupt
   RB8 .EQU 0x98+2 ;Receive Bit 8
   TB8 .EQU 0x98+3 ;Transmit Bit 8
   REN .EQU 0x98+4 ;Receive Enable
   SM2 .EQU 0x98+5 ;Serial Mode 2
   SM1 .EQU 0x98+6 ;Serial Mode 1
   SM0 .EQU 0x98+7 ;Serial Mode 0
   FE  .EQU 0x98+7 ;Framing Error
SBUF .EQU 0x99
IE .EQU 0xA8
   EX0      .EQU 0xA8+0 ;Enable External 0
   ET0      .EQU 0xA8+1 ;Enable Timer 0
   EX1      .EQU 0xA8+2 ;Enable External 1
   ET1      .EQU 0xA8+3 ;Enable Timer 1
   ES       .EQU 0xA8+4 ;Enable Serial
   EADC_SPI .EQU 0xA8+5 ;Enable Analog to Digital Converter Serial Peripheral Interface
   EPCA_LVD .EQU 0xA8+6 ;Enable Programmable Counter Array Low Voltage Detect
   EA       .EQU 0xA8+7 ;Enable All
SADDR .EQU 0xA9
P3 .EQU 0xB0
   RXD  .EQU 0xB0+0 ;Receive Data
   TXD  .EQU 0xB0+1 ;Transmit Data
   INT0 .EQU 0xB0+2 ;Interrupt 0
   INT1 .EQU 0xB0+3 ;Interrupt 1
   T0   .EQU 0xB0+4 ;Timer 0
   ECI  .EQU 0xB0+4 ;External Clock In
   T1   .EQU 0xB0+5 ;Timer 1
   PCA1 .EQU 0xB0+5 ;Programmable Counter Array 1
   PWM1 .EQU 0xB0+5 ;Pulse Width Modulator 1
   PCA0 .EQU 0xB0+7 ;Programmable Counter Array 0
   PWM0 .EQU 0xB0+7 ;Pulse Width Modulator 0
   P30 .EQU 0xB0+0 ;Port 3 Bit 0
   P31 .EQU 0xB0+1 ;Port 3 Bit 1
   P32 .EQU 0xB0+2 ;Port 3 Bit 2
   P33 .EQU 0xB0+3 ;Port 3 Bit 3
   P34 .EQU 0xB0+4 ;Port 3 Bit 4
   P35 .EQU 0xB0+5 ;Port 3 Bit 5
   P37 .EQU 0xB0+7 ;Port 3 Bit 7
   P3_0 .EQU 0xB0+0 ;Port 3 Bit 0
   P3_1 .EQU 0xB0+1 ;Port 3 Bit 1
   P3_2 .EQU 0xB0+2 ;Port 3 Bit 2
   P3_3 .EQU 0xB0+3 ;Port 3 Bit 3
   P3_4 .EQU 0xB0+4 ;Port 3 Bit 4
   P3_5 .EQU 0xB0+5 ;Port 3 Bit 5
   P3_7 .EQU 0xB0+7 ;Port 3 Bit 7
P3M0 .EQU 0xB1
P3M1 .EQU 0xB2
IPH .EQU 0xB7
IP .EQU 0xB8
   PX0      .EQU 0xB8+0 ;Priority External 0
   PT0      .EQU 0xB8+1 ;Priority Timer 0
   PX1      .EQU 0xB8+2 ;Priority External 1
   PT1      .EQU 0xB8+3 ;Priority Timer 1
   PS       .EQU 0xB8+4 ;Priority Serial
   PADC_SPI .EQU 0xB8+5 ;Priority Analog to Digital Converter Serial Peripheral Interface
   PPCA_LVD .EQU 0xB8+6 ;Priority Programmable Counter Array Low Voltage Detect
SADEN .EQU 0xB9
ADC_CONTR .EQU 0xC5
ADC_DATA .EQU 0xC6
CLK_DIV .EQU 0xC7
PSW .EQU 0xD0
   P   .EQU 0xD0+0 ;Parity
   F1  .EQU 0xD0+1 ;Flag 1
   OV  .EQU 0xD0+2 ;Overflow
   RS0 .EQU 0xD0+3 ;Register Select 0
   RS1 .EQU 0xD0+4 ;Register Select 1
   F0  .EQU 0xD0+5 ;Flag 0
   AC  .EQU 0xD0+6 ;Auxiliary Carry
   CY  .EQU 0xD0+7 ;Carry
CCON .EQU 0xD8
   CCF0 .EQU 0xD8+0 ;Capture Compare Flag 0
   CCF1 .EQU 0xD8+1 ;Capture Compare Flag 1
   CR   .EQU 0xD8+6 ;PCA Run
   CF   .EQU 0xD8+7 ;PCA Flag
CMOD .EQU 0xD9
CCAPM0 .EQU 0xDA
CCAPM1 .EQU 0xDB
ACC .EQU 0xE0
   ACC0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC7 .EQU 0xE0+7 ;Accumulator Bit 7
   ACC_0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC_1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC_2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC_3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC_4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC_5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC_6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC_7 .EQU 0xE0+7 ;Accumulator Bit 7
WDT_CONTR .EQU 0xE1
ISP_DATA .EQU 0xE2
ISP_ADDRH .EQU 0xE3
ISP_ADDRL .EQU 0xE4
ISP_CMD .EQU 0xE5
ISP_TRIG .EQU 0xE6
ISP_CONTR .EQU 0xE7
CL .EQU 0xE9
CCAP0L .EQU 0xEA
CCAP1L .EQU 0xEB
B .EQU 0xF0
   B0 .EQU 0xF0+0 ;B Bit 0
   B1 .EQU 0xF0+1 ;B Bit 1
   B2 .EQU 0xF0+2 ;B Bit 2
   B3 .EQU 0xF0+3 ;B Bit 3
   B4 .EQU 0xF0+4 ;B Bit 4
   B5 .EQU 0xF0+5 ;B Bit 5
   B6 .EQU 0xF0+6 ;B Bit 6
   B7 .EQU 0xF0+7 ;B Bit 7
   B_0 .EQU 0xF0+0 ;B Bit 0
   B_1 .EQU 0xF0+1 ;B Bit 1
   B_2 .EQU 0xF0+2 ;B Bit 2
   B_3 .EQU 0xF0+3 ;B Bit 3
   B_4 .EQU 0xF0+4 ;B Bit 4
   B_5 .EQU 0xF0+5 ;B Bit 5
   B_6 .EQU 0xF0+6 ;B Bit 6
   B_7 .EQU 0xF0+7 ;B Bit 7
PCA_PWM0 .EQU 0xF2
PCA_PWM1 .EQU 0xF3
CH .EQU 0xF9
CCAP0H .EQU 0xFA
CCAP1H .EQU 0xFB

;Interrupt_Address = ( Interrupt_Number * 8 ) + 3
;Vectors are named after their corresponding IE, IP or IR register bit so
;that we don't have to invent names and can be more consistent across MCUs.
   X0_VECTOR      = 0 ; 0x03 External Interrupt 0
   T0_VECTOR      = 1 ; 0x0B Timer 0
   X1_VECTOR      = 2 ; 0x13 External Interrupt 1
   T1_VECTOR      = 3 ; 0x1B Timer 1
   S_VECTOR       = 4 ; 0x23 Serial Port 1
   ADC_SPI_VECTOR = 5 ; 0x2B Analog to Digitak Converter & Serial Peripheral Interface
   PCA_LVD_VECTOR = 6 ; 0x33 Programmable Counter Array and Low Voltage Detect

;.endif
