; PIO compatible header file STC15-4K-PWM.asm 20210829.
; For use with series STC15W4KxxS4 IAP15W4KxxS4 IRC15W4KxxS4
; STC15W1KxxPWM IAP15W1KxxPWM IRC15W1KxxPWM only.
; This header is for newer STC15 MCU's with advanced
; PWM and has been checked against the datasheet.
; The following pins are confgured inputs at POR:
; P06 P07 P16 P17 P21 P22 P23 P27 P37 P42 P44 P45.

;.ifndef STC15_4K_PWM_ASM
;.define STC15_4K_PWM_ASM

; Special Function Register | POR Reset Value | Description

P0 .EQU 0x80                  ;1111,1111 Port 0
   P00 .EQU 0x80+0 ;Port 0 Bit 0
   P01 .EQU 0x80+1 ;Port 0 Bit 1
   P02 .EQU 0x80+2 ;Port 0 Bit 2
   P03 .EQU 0x80+3 ;Port 0 Bit 3
   P04 .EQU 0x80+4 ;Port 0 Bit 4
   P05 .EQU 0x80+5 ;Port 0 Bit 5
   P06 .EQU 0x80+6 ;Port 0 Bit 6
   P07 .EQU 0x80+7 ;Port 0 Bit 7
   P0_0 .EQU 0x80+0 ;Port 0 Bit 0
   P0_1 .EQU 0x80+1 ;Port 0 Bit 1
   P0_2 .EQU 0x80+2 ;Port 0 Bit 2
   P0_3 .EQU 0x80+3 ;Port 0 Bit 3
   P0_4 .EQU 0x80+4 ;Port 0 Bit 4
   P0_5 .EQU 0x80+5 ;Port 0 Bit 5
   P0_6 .EQU 0x80+6 ;Port 0 Bit 6
   P0_7 .EQU 0x80+7 ;Port 0 Bit 7
; See device specific data sheet for additional pin names.

SP .EQU 0x81                  ;0000,0111 Stack Pointer

;DPTR .EQU 0x82                ;0000,0000 Data Pointer Word
DPL .EQU 0x82                 ;0000,0000 Data Pointer Low Byte

DPH .EQU 0x83                 ;0000,0000 Data Pointer High Byte

S4CON .EQU 0x84               ;0000,0000 Serial Port 4 Control Register
   S4RI  = 0x01 ;Serial Port 4 Receive Interrupt Flag
   S4TI  = 0x02 ;Serial Port 4 Transmit Interrupt Flag
   S4RB8 = 0x04 ;Serial Port 4 Receive Bit 8 Data
   S4TB8 = 0x08 ;Serial Port 4 Transmit Bit 8 Data
   S4REN = 0x10 ;Serial Port 4 Receive Enable
   S4SM2 = 0x20 ;Serial Port 4 Select Mode Bit 2
   S4ST4 = 0x40 ;Serial Port 4 Select Timer 4
   S4SM0 = 0x80 ;Serial Port 4 Select Mode Bit 0

S4BUF .EQU 0x85               ;xxxx,xxxx Serial Port 4 Data Register

PCON .EQU 0x87                ;0011,0000 Power Control Register
   IDL   = 0x01 ;Idle Mode Control
   PD    = 0x02 ;Power Down Mode Control
   GF0   = 0x04 ;User Defined Gereral Purpose Flag 0
   GF1   = 0x08 ;User Defined General Purpose Flag 1
   POF   = 0x10 ;Power On Flag
   LVDF  = 0x20 ;Low Voltage Detect Flag
   SMOD0 = 0x40 ;Frame Error Detection Control
   SMOD  = 0x80 ;Double Baudrate of Serial Port 1

TCON .EQU 0x88                ;0000,0000 T0/T1 Control Register
   IT0 .EQU 0x88+0 ;Interrupt 0 Type
   IE0 .EQU 0x88+1 ;Interrupt 0 Edge
   IT1 .EQU 0x88+2 ;Interrupt 1 Type
   IE1 .EQU 0x88+3 ;Interrupt 1 Edge
   TR0 .EQU 0x88+4 ;Timer 0 Run
   TF0 .EQU 0x88+5 ;Timer 0 Flag
   TR1 .EQU 0x88+6 ;Timer 1 Run
   TF1 .EQU 0x88+7 ;Timer 1 Flag

TMOD .EQU 0x89                ;Timer Mode
   T0_M0   = 0x01 ;Timer 0 Mode 0
   T0_M1   = 0x02 ;Timer 0 Mode 1
   T0_M    = 0x03 ;Timer 0 Mode
   T0_CT   = 0x04 ;Timer 0 Counter Timer
   T0_GATE = 0x08 ;Timer 0 Gate
   T1_M0   = 0x10 ;Timer 1 Mode 0
   T1_M1   = 0x20 ;Timer 1 Mode 1
   T1_M    = 0x30 ;Timer 1 Mode
   T1_CT   = 0x40 ;Timer 1 Counter Timer
   T1_GATE = 0x80 ;Timer 1 Gate
   M00   = 0x01 ;Mode 0 Timer 0
   M10   = 0x02 ;Mode 1 Timer 0
   M0    = 0x03 ;Timer 0 Mode
   CT0   = 0x04 ;Counter Timer 0
   GATE0 = 0x08 ;Gate 0
   M01   = 0x10 ;Mode 1 Timer 1
   M11   = 0x20 ;Mode 1 Timer 1
   M1    = 0x30 ;Timer 1 Mode
   CT1   = 0x40 ;Counter Timer 1
   GATE1 = 0x80 ;Gate 1

TL0 .EQU 0x8A                 ;0000,0000 Timer 0 Low Byte
RL_TL0 .EQU 0x8A              ;0000,0000 Reload Timer 0 Low Byte

TL1 .EQU 0x8B                 ;0000,0000 Timer 1 Low Byte
RL_TL1 .EQU 0x8B              ;0000,0000 Reload Timer 1 Low Byte

TH0 .EQU 0x8C                 ;0000,0000 Timer 0 High Byte
RL_TH0 .EQU 0x8C              ;0000,0000 Reload Timer 0 High Byte

TH1 .EQU 0x8D                 ;0000,0000 Timer 1 High Byte
RL_TH1 .EQU 0x8D              ;0000,0000 Reload Timer 1 High Byte

AUXR .EQU 0x8E                ;0000,0001 Auxiliary Register
   S1ST2     = 0x01 ;Serial Port 1 Baud Rate Generator Select
   EXTRAM    = 0x02 ;Extended RAM Access Control
   T2x12     = 0x04 ;Timer 2 Clock x12 Prescaler Bypass
   T2_CT     = 0x08 ;Timer 2 Counter or Timer Mode Select
   T2R       = 0x10 ;Timer 2 Run Control
   UART_M0x6 = 0x20 ;UART 1 Mode 0 Baudrate Prescaler Select
   T1x12     = 0x40 ;Timer 1 Clock x12 Prescaler Bypass
   T0x12     = 0x80 ;Timer 0 Clock x12 Prescaler Bypass

INT_CLKO .EQU 0x8F            ;x000,0000|0000,0000 Interrupt and Clock Output Control Register
AUXR2 .EQU 0x8F               ;Auxiliary Register 2
   T0CLKO  = 0x01 ;Timer 0 Clock Output Control
   T1CLKO  = 0x02 ;Timer 1 Clock Output Control
   T2CLKO  = 0x04 ;Timer 2 Clock Output Control
   MCKO_S2 = 0x08 ;Master Clock Output Select 2 (see register 0x97)
   EX2     = 0x10 ;External Interrupt 3 Enable
   EX3     = 0x20 ;External Interrupt 2 Enable
   EX4     = 0x40 ;External Interrupt 4 Enable

P1 .EQU 0x90                  ;1111,1111 Port 1
   ACH0 .EQU 0x90+0 ;ADC Channel 0
   ACH1 .EQU 0x90+1 ;ADC Channel 1
   ACH2 .EQU 0x90+2 ;ADC Channel 2
   ACH3 .EQU 0x90+3 ;ADC Channel 3
   ACH4 .EQU 0x90+4 ;ADC Channel 4
   ACH5 .EQU 0x90+5 ;ADC Channel 5
   ACH6 .EQU 0x90+6 ;ADC Channel 6
   ACH7 .EQU 0x90+7 ;ADC Channel 7
   ADC0 .EQU 0x90+0 ;AtoD Channel 0
   ADC1 .EQU 0x90+1 ;AtoD Channel 1
   ADC2 .EQU 0x90+2 ;AtoD Channel 2
   ADC3 .EQU 0x90+3 ;AtoD Channel 3
   ADC4 .EQU 0x90+4 ;AtoD Channel 4
   ADC5 .EQU 0x90+5 ;AtoD Channel 5
   ADC6 .EQU 0x90+6 ;AtoD Channel 6
   ADC7 .EQU 0x90+7 ;AtoD Channel 7
   AIN0 .EQU 0x90+0 ;Analog Input 0
   AIN1 .EQU 0x90+1 ;Analog Input 1
   AIN2 .EQU 0x90+2 ;Analog Input 2
   AIN3 .EQU 0x90+3 ;Analog Input 3
   AIN4 .EQU 0x90+4 ;Analog Input 4
   AIN5 .EQU 0x90+5 ;Analog Input 5
   AIN6 .EQU 0x90+6 ;Analog Input 6
   AIN7 .EQU 0x90+7 ;Analog Input 7
   P10 .EQU 0x90+0 ;Port 1 Bit 0
   P11 .EQU 0x90+1 ;Port 1 Bit 1
   P12 .EQU 0x90+2 ;Port 1 Bit 2
   P13 .EQU 0x90+3 ;Port 1 Bit 3
   P14 .EQU 0x90+4 ;Port 1 Bit 4
   P15 .EQU 0x90+5 ;Port 1 Bit 5
   P16 .EQU 0x90+6 ;Port 1 Bit 6
   P17 .EQU 0x90+7 ;Port 1 Bit 7
   P1_0 .EQU 0x90+0 ;Port 1 Bit 0
   P1_1 .EQU 0x90+1 ;Port 1 Bit 1
   P1_2 .EQU 0x90+2 ;Port 1 Bit 2
   P1_3 .EQU 0x90+3 ;Port 1 Bit 3
   P1_4 .EQU 0x90+4 ;Port 1 Bit 4
   P1_5 .EQU 0x90+5 ;Port 1 Bit 5
   P1_6 .EQU 0x90+6 ;Port 1 Bit 6
   P1_7 .EQU 0x90+7 ;Port 1 Bit 7
; See device specific data sheet for additional pin names.

P1M1 .EQU 0x91                ;0000,0000 Port 1 Mode Register 1
   P10M1 = 0x01 ;Port 1 bit 0 Mode 1
   P11M1 = 0x02 ;Port 1 bit 1 Mode 1
   P12M1 = 0x04 ;Port 1 bit 2 Mode 1
   P13M1 = 0x08 ;Port 1 bit 3 Mode 1
   P14M1 = 0x10 ;Port 1 bit 4 Mode 1
   P15M1 = 0x20 ;Port 1 bit 5 Mode 1
   P16M1 = 0x40 ;Port 1 bit 6 Mode 1
   P17M1 = 0x80 ;Port 1 bit 7 Mode 1

P1M0 .EQU 0x92                ;0000,0000 Port 1 Mode Register 0
   P10M0 = 0x01 ;Port 1 bit 0 Mode 0
   P11M0 = 0x02 ;Port 1 bit 1 Mode 0
   P12M0 = 0x04 ;Port 1 bit 2 Mode 0
   P13M0 = 0x08 ;Port 1 bit 3 Mode 0
   P14M0 = 0x10 ;Port 1 bit 4 Mode 0
   P15M0 = 0x20 ;Port 1 bit 5 Mode 0
   P16M0 = 0x40 ;Port 1 bit 6 Mode 0
   P17M0 = 0x80 ;Port 1 bit 7 Mode 0

P0M1 .EQU 0x93                ;0000,0000 Port 0 Mode Register 1
   P00M1 = 0x01 ;Port 0 bit 0 Mode 1
   P01M1 = 0x02 ;Port 0 bit 1 Mode 1
   P02M1 = 0x04 ;Port 0 bit 2 Mode 1
   P03M1 = 0x08 ;Port 0 bit 3 Mode 1
   P04M1 = 0x10 ;Port 0 bit 4 Mode 1
   P05M1 = 0x20 ;Port 0 bit 5 Mode 1
   P06M1 = 0x40 ;Port 0 bit 6 Mode 1
   P07M1 = 0x80 ;Port 0 bit 7 Mode 1

P0M0 .EQU 0x94                ;0000,0000 Port 0 Mode Register 0
   P00M0 = 0x01 ;Port 0 bit 0 Mode 0
   P01M0 = 0x02 ;Port 0 bit 1 Mode 0
   P02M0 = 0x04 ;Port 0 bit 2 Mode 0
   P03M0 = 0x08 ;Port 0 bit 3 Mode 0
   P04M0 = 0x10 ;Port 0 bit 4 Mode 0
   P05M0 = 0x20 ;Port 0 bit 5 Mode 0
   P06M0 = 0x40 ;Port 0 bit 6 Mode 0
   P07M0 = 0x80 ;Port 0 bit 7 Mode 0

P2M1 .EQU 0x95                ;0000,0000 Port 2 Mode Register 1
   P20M1 = 0x01 ;Port 2 bit 0 Mode 1
   P21M1 = 0x02 ;Port 2 bit 1 Mode 1
   P22M1 = 0x04 ;Port 2 bit 2 Mode 1
   P23M1 = 0x08 ;Port 2 bit 3 Mode 1
   P24M1 = 0x10 ;Port 2 bit 4 Mode 1
   P25M1 = 0x20 ;Port 2 bit 5 Mode 1
   P26M1 = 0x40 ;Port 2 bit 6 Mode 1
   P27M1 = 0x80 ;Port 2 bit 7 Mode 1

P2M0 .EQU 0x96                ;0000,0000 Port 2 Mode Register 0
   P20M0 = 0x01 ;Port 2 bit 0 Mode 0
   P21M0 = 0x02 ;Port 2 bit 1 Mode 0
   P22M0 = 0x04 ;Port 2 bit 2 Mode 0
   P23M0 = 0x08 ;Port 2 bit 3 Mode 0
   P24M0 = 0x10 ;Port 2 bit 4 Mode 0
   P25M0 = 0x20 ;Port 2 bit 5 Mode 0
   P26M0 = 0x40 ;Port 2 bit 6 Mode 0
   P27M0 = 0x80 ;Port 2 bit 7 Mode 0

CLK_DIV .EQU 0x97             ;0000,0000 Clock Division Control Register
PCON2 .EQU 0x97               ;Power Control Register 2
   CLKS0 = 0x01 ;Clock Select 0
   CLKS1 = 0x02 ;Clock Select 1
   CLKS2 = 0x04 ;Clock Select 2
   CLKS  = 0x07 ;Clock Select
   MCLKO_2 = 0x08 ;Master Clock Output 2 Select
   Tx_Rx   = 0x10 ;Relay from Rx out to Tx
   ADRJ    = 0x20 ;Analog to Digital Result Juxtapose
   MCKO_S0 = 0x40 ;Master Clock Output Select 0 (see register 0x8F)
   MCKO_S1 = 0x80 ;Master Clock Output Select 1 (see register 0x8F)

SCON .EQU 0x98                ;0000,0000 Serial Port 1 Control Register
   RI  .EQU 0x98+0 ;Receive Interrupt
   TI  .EQU 0x98+1 ;Transmit Interrupt
   RB8 .EQU 0x98+2 ;Receive Bit 8
   TB8 .EQU 0x98+3 ;Transmit Bit 8
   REN .EQU 0x98+4 ;Receive Enable
   SM2 .EQU 0x98+5 ;Serial Mode 2
   SM1 .EQU 0x98+6 ;Serial Mode 1
   SM0 .EQU 0x98+7 ;Serial Mode 0
   FE  .EQU 0x98+7 ;Framing Error

SBUF .EQU 0x99                ;xxxx,xxxx Serial Port 1 Data Register

S2CON .EQU 0x9A               ;0100,0000|0000,0000 Serial Port 2 Control Register
   S2RI  = 0x01 ;Serial Port 2 Receive Interrupt Flag
   S2TI  = 0x02 ;Serial Port 2 Transmit Interrupt Flag
   S2RB8 = 0x04 ;Serial Port 2 Receive Bit 8 Data
   S2TB8 = 0x08 ;Serial Port 2 Transmit Bit 8 Data
   S2REN = 0x10 ;Serial Port 2 Receive Enable
   S2SM2 = 0x20 ;Serial Port 2 Select Mode Bit 2
   S2SM0 = 0x80 ;Serial Port 2 Select Mode Bit 0

S2BUF .EQU 0x9B               ;xxxx,xxxx Serial Port 2 Data Register

P1ASF .EQU 0x9D               ;0000,0000 Port 1 Analog Function Configuration Register
   P10ASF = 0x01 ;Port 1 bit 0 Analog Special Function
   P11ASF = 0x02 ;Port 1 bit 1 Analog Special Function
   P12ASF = 0x04 ;Port 1 bit 2 Analog Special Function
   P13ASF = 0x08 ;Port 1 bit 3 Analog Special Function
   P14ASF = 0x10 ;Port 1 bit 4 Analog Special Function
   P15ASF = 0x20 ;Port 1 bit 5 Analog Special Function
   P16ASF = 0x40 ;Port 1 bit 6 Analog Special Function
   P17ASF = 0x80 ;Port 1 bit 7 Analog Special Function

P2 .EQU 0xA0                  ;1111,1111 Port 2
   P20 .EQU 0xA0+0 ;Port 2 Bit 0
   P21 .EQU 0xA0+1 ;Port 2 Bit 1
   P22 .EQU 0xA0+2 ;Port 2 Bit 2
   P23 .EQU 0xA0+3 ;Port 2 Bit 3
   P24 .EQU 0xA0+4 ;Port 2 Bit 4
   P25 .EQU 0xA0+5 ;Port 2 Bit 5
   P26 .EQU 0xA0+6 ;Port 2 Bit 6
   P27 .EQU 0xA0+7 ;Port 2 Bit 7
   P2_0 .EQU 0xA0+0 ;Port 2 Bit 0
   P2_1 .EQU 0xA0+1 ;Port 2 Bit 1
   P2_2 .EQU 0xA0+2 ;Port 2 Bit 2
   P2_3 .EQU 0xA0+3 ;Port 2 Bit 3
   P2_4 .EQU 0xA0+4 ;Port 2 Bit 4
   P2_5 .EQU 0xA0+5 ;Port 2 Bit 5
   P2_6 .EQU 0xA0+6 ;Port 2 Bit 6
   P2_7 .EQU 0xA0+7 ;Port 2 Bit 7
; See device specific data sheet for additional pin names.

BUS_SPEED .EQU 0xA1           ;xxxx,xx10 Bus Speed Control Register
   SPEED = 0x07 ;Bus Read-Write Speed Control
   RW_S  = 0xC0 ;Read-Write Control Pin Select

P_SW1 .EQU 0xA2               ;0100,0000|0000,0000 Peripheral Port Switching Register 1
AUXR1 .EQU 0xA2               ;Auxiliary Register 1
   DPS    = 0x01 ;Data Pointer Select
   SPI_S0 = 0x04 ;Serial Peripheral Interface Select 0
   SPI_S1 = 0x08 ;Serial Peripheral Interface Select 1
   SPI_S  = 0x0C ;Serial Peripheral Interface Select
   CCP_S0 = 0x10 ;Compare Capture PWM Select 0
   CCP_S1 = 0x20 ;Compare Capture PWM Select 1
   CCP_S  = 0x30 ;Compare Capture PWM Select
   S1_S0  = 0x40 ;Serial Port 1 Select 0
   S1_S1  = 0x80 ;Serial Port 1 Select 1
   S1_S   = 0xC0 ;Serial Purt 1 Select

IE .EQU 0xA8                  ;0000,0000 Interrupt Control Register
   EX0  .EQU 0xA8+0 ;Enable External 0
   ET0  .EQU 0xA8+1 ;Enable Timer 0
   EX1  .EQU 0xA8+2 ;Enable External 1
   ET1  .EQU 0xA8+3 ;Enable Timer 1
   ES   .EQU 0xA8+4 ;Enable Serial
   EADC .EQU 0xA8+5 ;Enable ADC
   ELVD .EQU 0xA8+6 ;Enable Low Voltage Detect
   EA   .EQU 0xA8+7 ;Enable All

SADDR .EQU 0xA9               ;0000,0000 Slave Address Register

WKTCL .EQU 0xAA               ;0111,1111|1111,1111 Power Down Wakeup Timer Control Low Byte
WKTCL_CNT .EQU 0xAA           ;0111,1111|1111,1111 Power Down Wakeup Timer Control Count

WKTCH .EQU 0xAB               ;0111,1111 Power Down Wakeup Timer Control High Byte
   WKTEN = 0x80 ;Power Down Wakeup Timer Enable
WKTCH_CNT .EQU 0xAB           ;0111,1111|x111,1111 Power Down Wakeup Timer Control Count

S3CON .EQU 0xAC               ;0000,0000 Serial Port 3 Control Register
   S3RI  = 0x01 ;Serial Port 3 Receive Interrupt Flag
   S3TI  = 0x02 ;Serial Port 3 Transmit Interrupt Flag
   S3RB8 = 0x04 ;Serial Port 3 Receive Bit 8 Data
   S3TB8 = 0x08 ;Serial Port 3 Transmit Bit 8 Data
   S3REN = 0x10 ;Serial Port 3 Receive Enable
   S3SM2 = 0x20 ;Serial Port 3 Select Mode Bit 2
   S3ST3 = 0x40 ;Serial Port 3 Select Timer 3
   S3SM0 = 0x80 ;Serial Port 3 Select Mode Bit 0

S3BUF .EQU 0xAD               ;xxxx,xxxx Serial Port 3 Data Register

IE2 .EQU 0xAF                 ;x000,0000 Interrupt Enable Register 2
   ES2  = 0x01 ;Enable Serial Port 2 Interrupt
   ESPI = 0x02 ;Enable Serial Peripheral Interface Interrupt
   ET2  = 0x04 ;Enable Timer 2 Interrupt
   ES3  = 0x08 ;Enable Serial Port 3 Interrupt
   ES4  = 0x10 ;Enable Serial Port 4 Interrupt
   ET3  = 0x20 ;Enable Timer 3 Interrupt
   ET4  = 0x40 ;Enable Timer 4 Interrupt
   ECAN = 0x80 ;Enable CAN Interrupt

P3 .EQU 0xB0                  ;1111,1111 Port 3
   P30 .EQU 0xB0+0 ;Port 3 Bit 0
   P31 .EQU 0xB0+1 ;Port 3 Bit 1
   P32 .EQU 0xB0+2 ;Port 3 Bit 2
   P33 .EQU 0xB0+3 ;Port 3 Bit 3
   P34 .EQU 0xB0+4 ;Port 3 Bit 4
   P35 .EQU 0xB0+5 ;Port 3 Bit 5
   P36 .EQU 0xB0+6 ;Port 3 Bit 6
   P37 .EQU 0xB0+7 ;Port 3 Bit 7
   P3_0 .EQU 0xB0+0 ;Port 3 Bit 0
   P3_1 .EQU 0xB0+1 ;Port 3 Bit 1
   P3_2 .EQU 0xB0+2 ;Port 3 Bit 2
   P3_3 .EQU 0xB0+3 ;Port 3 Bit 3
   P3_4 .EQU 0xB0+4 ;Port 3 Bit 4
   P3_5 .EQU 0xB0+5 ;Port 3 Bit 5
   P3_6 .EQU 0xB0+6 ;Port 3 Bit 6
   P3_7 .EQU 0xB0+7 ;Port 3 Bit 7
; See device specific data sheet for additional pin names.

P3M1 .EQU 0xB1                ;0000,0000 Port 3 Mode Register 1
   P30M1 = 0x01 ;Port 3 bit 0 Mode 1
   P31M1 = 0x02 ;Port 3 bit 1 Mode 1
   P32M1 = 0x04 ;Port 3 bit 2 Mode 1
   P33M1 = 0x08 ;Port 3 bit 3 Mode 1
   P34M1 = 0x10 ;Port 3 bit 4 Mode 1
   P35M1 = 0x20 ;Port 3 bit 5 Mode 1
   P36M1 = 0x40 ;Port 3 bit 6 Mode 1
   P37M1 = 0x80 ;Port 3 bit 7 Mode 1

P3M0 .EQU 0xB2                ;0000,0000 Port 3 Mode Register 0
   P30M0 = 0x01 ;Port 3 bit 0 Mode 0
   P31M0 = 0x02 ;Port 3 bit 1 Mode 0
   P32M0 = 0x04 ;Port 3 bit 2 Mode 0
   P33M0 = 0x08 ;Port 3 bit 3 Mode 0
   P34M0 = 0x10 ;Port 3 bit 4 Mode 0
   P35M0 = 0x20 ;Port 3 bit 5 Mode 0
   P36M0 = 0x40 ;Port 3 bit 6 Mode 0
   P37M0 = 0x80 ;Port 3 bit 7 Mode 0

P4M1 .EQU 0xB3                ;0000,0000 Port 4 Mode Register 1
   P40M1 = 0x01 ;Port 4 bit 0 Mode 1
   P41M1 = 0x02 ;Port 4 bit 1 Mode 1
   P42M1 = 0x04 ;Port 4 bit 2 Mode 1
   P43M1 = 0x08 ;Port 4 bit 3 Mode 1
   P44M1 = 0x10 ;Port 4 bit 4 Mode 1
   P45M1 = 0x20 ;Port 4 bit 5 Mode 1
   P46M1 = 0x40 ;Port 4 bit 6 Mode 1
   P47M1 = 0x80 ;Port 4 bit 7 Mode 1

P4M0 .EQU 0xB4                ;0000,0000 Port 4 Mode Register 0
   P40M0 = 0x01 ;Port 4 bit 0 Mode 0
   P41M0 = 0x02 ;Port 4 bit 1 Mode 0
   P42M0 = 0x04 ;Port 4 bit 2 Mode 0
   P43M0 = 0x08 ;Port 4 bit 3 Mode 0
   P44M0 = 0x10 ;Port 4 bit 4 Mode 0
   P45M0 = 0x20 ;Port 4 bit 5 Mode 0
   P46M0 = 0x40 ;Port 4 bit 6 Mode 0
   P47M0 = 0x80 ;Port 4 bit 7 Mode 0

IP2 .EQU 0xB5                 ;xxx0,0000|xx00,0000|0000,0000 Interrupt Priority Register 2
   PS2    = 0x01 ;Serial Port 2 Interrupt Priority
   PSPI   = 0x02 ;Serial Peripheral Interface Interrupt Priority
   PPWM   = 0x04 ;PWM Interrupt Priority
   PPWMFD = 0x08 ;PWM Fault Detect Interrupt Priority
   PX4    = 0x10 ;External Interrupt 4 Priority
   PCMP   = 0x20 ;Comparator Interrupt Priority
   PI2C   = 0x40 ;I2C Interrupt Priority
   PCAN   = 0x80 ;CAN Interrupt Priority

; SFR(IP2H, 0xB6); //Datasheet Error?
; SFR(IPH, 0xB7); //Datasheet Error?

IP .EQU 0xB8                  ;0000,0000|x0x0,0000 Interrupt Priority Register
   PX0  .EQU 0xB8+0 ;Priority External 0
   PT0  .EQU 0xB8+1 ;Priority Timer 0
   PX1  .EQU 0xB8+2 ;Priority External 1
   PT1  .EQU 0xB8+3 ;Priority Timer 1
   PS   .EQU 0xB8+4 ;Priority Serial
   PADC .EQU 0xB8+5 ;Priority ADC
   PLVD .EQU 0xB8+6 ;Priority Low Voltage Detect
   PPCA .EQU 0xB8+7 ;Priority Programmable Counter Array

SADEN .EQU 0xB9               ;0000,0000 Slave Address Mask Register

P_SW2 .EQU 0xBA               ;0000,x000|xxxx,x000|0000,0000 Peripheral Port Switching Register 2
   S2_S   = 0x10 ;Serial Port 2 Pin Select
   S3_S   = 0x20 ;Serial Port 3 Pin Select
   S4_S   = 0x40 ;Serial Port 4 Pin Select
   CMPO_S = 0x80 ;Comparator Output Pin Select
   I2C_S  = 0x30 ;I2C Pin Select
   CAN_S  = 0x40 ;CAN Pin Select
   EAXFR  = 0x80 ;Extended RAM Area Transfer Enable

ADC_CONTR .EQU 0xBC           ;0000,0000 ADC Conversion Control Register
   CHS0      = 0x01 ;Channel Select 0
   CHS1      = 0x02 ;Channel Select 1
   CHS2      = 0x04 ;Channel Select 2
   ADC_CHS   = 0x0F ;ADC Analog Channel Select
   ADC_START = 0x08 ;Analog to Digital Converter Start
   ADC_FLAG  = 0x10 ;Analog to Digital Converter Flag
   SPEED0    = 0x20 ;Speed 0
   SPEED1    = 0x40 ;Speed 1
   ADC_POWER = 0x80 ;Analog to Digital Converter Power

ADC_RES .EQU 0xBD             ;0000,0000 ADC Conversion Result High 8 Bits

ADC_RESL .EQU 0xBE            ;0000,0000 ADC Conversion Result Low 2 Bits

P4 .EQU 0xC0                  ;1111,1111 Port 4
   P40  .EQU 0xC0+0 ;Port 4 Bit 0
   P41  .EQU 0xC0+1 ;Port 4 Bit 1
   P42  .EQU 0xC0+2 ;Port 4 Bit 2
   P43  .EQU 0xC0+3 ;Port 4 Bit 3
   P44  .EQU 0xC0+4 ;Port 4 Bit 4
   P45  .EQU 0xC0+5 ;Port 4 Bit 5
   P46  .EQU 0xC0+6 ;Port 4 Bit 6
   P47  .EQU 0xC0+7 ;Port 4 Bit 7
   P4_0  .EQU 0xC0+0 ;Port 4 Bit 0
   P4_1  .EQU 0xC0+1 ;Port 4 Bit 1
   P4_2  .EQU 0xC0+2 ;Port 4 Bit 2
   P4_3  .EQU 0xC0+3 ;Port 4 Bit 3
   P4_4  .EQU 0xC0+4 ;Port 4 Bit 4
   P4_5  .EQU 0xC0+5 ;Port 4 Bit 5
   P4_6  .EQU 0xC0+6 ;Port 4 Bit 6
   P4_7  .EQU 0xC0+7 ;Port 4 Bit 7
; See device specific data sheet for additional pin names.

WDT_CONTR .EQU 0xC1           ;xx00,0000|0x00,0000 Watchdog Control Register
   WDTPS0   = 0x01 ;Watchdog Timer Prescaler 0
   WDTPS1   = 0x02 ;Watchdog Timer Prescaler 1
   WDTPS2   = 0x04 ;Watchdog Timer Prescaler 2
   WDT_PS   = 0x07 ;Watchdog Timer Prescaler
   IDL_WDT  = 0x08 ;Watchdog Timer Idle Mode Behavior
   CLR_WDT  = 0x10 ;Clear Watchdog Timer
   EN_WDT   = 0x20 ;Enable Watchdog Timer
   WDT_FLAG = 0x80 ;Watchdog Timer Overflow Flag

IAP_DATA .EQU 0xC2            ;1111,1111 In Application Programming Data
ISP_DATA .EQU 0xC2            ;In System Programming Data

IAP_ADDRH .EQU 0xC3           ;0000,0000 In Application Programming Address High
ISP_ADDRH .EQU 0xC3           ;In System Programming Address High

IAP_ADDRL .EQU 0xC4           ;0000,0000 In Application Programming Address Low
ISP_ADDRL .EQU 0xC4           ;In System Programming Address Low

IAP_CMD .EQU 0xC5             ;xxxx,x000|xxxx,xx00 In Application Programming Command
ISP_CMD .EQU 0xC5             ;In System Programming Command
   MS0    = 0x01 ;Mode Select 0
   MS1    = 0x02 ;Mode Select 1
   IAPCMD = 0x03 ;In Application Programming Command
; Valid commands follow
   IAP_IDL   = 0x00
   IAP_READ  = 0x01
   IAP_WRITE = 0x02
   IAP_ERASE = 0x03
; End of valid commands

IAP_TRIG .EQU 0xC6            ;xxxx,xxxx In Application Programming Trigger
ISP_TRIG .EQU 0xC6            ;In System Programming Trigger

IAP_CONTR .EQU 0xC7           ;0000,x000|0000,0000 In Application Programming Control
ISP_CONTR .EQU 0xC7           ;In System Programming Control
   WT0      = 0x01 ;Wait 0
   WT1      = 0x02 ;Wait 1
   WT2      = 0x04 ;Wait 2
   IAP_WT   = 0x07 ;In Application Programming Wait
   CMD_FAIL = 0x10 ;Command Fail
   SWRST    = 0x20 ;Software Reset Trigger
   SWBS     = 0x40 ;Software Boot Selection
   IAPEN    = 0x80 ;In Application Programming Enable

P5 .EQU 0xC8                  ;xxxx,1111 Port 5
   P50  .EQU 0xC8+0 ;Port 5 Bit 0
   P51  .EQU 0xC8+1 ;Port 5 Bit 1
   P52  .EQU 0xC8+2 ;Port 5 Bit 2
   P53  .EQU 0xC8+3 ;Port 5 Bit 3
   P54  .EQU 0xC8+4 ;Port 5 Bit 4
   P55  .EQU 0xC8+5 ;Port 5 Bit 5
   P5_0  .EQU 0xC8+0 ;Port 5 Bit 0
   P5_1  .EQU 0xC8+1 ;Port 5 Bit 1
   P5_2  .EQU 0xC8+2 ;Port 5 Bit 2
   P5_3  .EQU 0xC8+3 ;Port 5 Bit 3
   P5_4  .EQU 0xC8+4 ;Port 5 Bit 4
   P5_5  .EQU 0xC8+5 ;Port 5 Bit 5
; See device specific data sheet for additional pin names.

P5M1 .EQU 0xC9                ;0000,0000|xxxx,1111 Port 5 Mode Register 1
   P50M1 = 0x01 ;Port 5 bit 0 Mode 1
   P51M1 = 0x02 ;Port 5 bit 1 Mode 1
   P52M1 = 0x04 ;Port 5 bit 2 Mode 1
   P53M1 = 0x08 ;Port 5 bit 3 Mode 1
   P54M1 = 0x10 ;Port 5 bit 4 Mode 1
   P55M1 = 0x20 ;Port 5 bit 5 Mode 1

P5M0 .EQU 0xCA                ;0000,0000|xxxx,1111 Port 5 Mode Register 0
   P50M0 = 0x01 ;Port 5 bit 0 Mode 0
   P51M0 = 0x02 ;Port 5 bit 1 Mode 0
   P52M0 = 0x04 ;Port 5 bit 2 Mode 0
   P53M0 = 0x08 ;Port 5 bit 3 Mode 0
   P54M0 = 0x10 ;Port 5 bit 4 Mode 0
   P55M0 = 0x20 ;Port 5 bit 5 Mode 0

P6M1 .EQU 0xCB                ;0000,0000 Port 6 Mode Register 1
   P60M1 = 0x01 ;Port 6 bit 0 Mode 1
   P61M1 = 0x02 ;Port 6 bit 1 Mode 1
   P62M1 = 0x04 ;Port 6 bit 2 Mode 1
   P63M1 = 0x08 ;Port 6 bit 3 Mode 1
   P64M1 = 0x10 ;Port 6 bit 4 Mode 1
   P65M1 = 0x20 ;Port 6 bit 5 Mode 1
   P66M1 = 0x40 ;Port 6 bit 6 Mode 1
   P67M1 = 0x80 ;Port 6 bit 7 Mode 1

P6M0 .EQU 0xCC                ;0000,0000 Port 6 Mode Register 0
   P60M0 = 0x01 ;Port 6 bit 0 Mode 0
   P61M0 = 0x02 ;Port 6 bit 1 Mode 0
   P62M0 = 0x04 ;Port 6 bit 2 Mode 0
   P63M0 = 0x08 ;Port 6 bit 3 Mode 0
   P64M0 = 0x10 ;Port 6 bit 4 Mode 0
   P65M0 = 0x20 ;Port 6 bit 5 Mode 0
   P66M0 = 0x40 ;Port 6 bit 6 Mode 0
   P67M0 = 0x80 ;Port 6 bit 7 Mode 0

SPSTAT .EQU 0xCD              ;00xx,xxxx Serial Peripheral Status Register
   WCOL = 0x40 ;Write Collision
   SPIF = 0x80 ;Serial Peripheral Interface Flag

SPCTL .EQU 0xCE               ;0000,0100 Serial Peripheral Control
   SPR0 = 0x00 ;Serial Peripheral Rate 0
   SPR1 = 0x01 ;Serial Peripheral Rate 1
   SPR  = 0x03 ;Serial Peripheral Rate
   CPHA = 0x04 ;Clock Phase
   CPOL = 0x08 ;Clock Polarity
   MSTR = 0x10 ;Master
   DORD = 0x20 ;Data Order
   SPEN = 0x40 ;Serial Peripheral Enable
   SSIG = 0x80 ;Slave Select Signal

SPDAT .EQU 0xCF               ;0000,0000 Serial Peripheral Data Register

PSW .EQU 0xD0                 ;0000,0000 Program status word
   P   .EQU 0xD0+0 ;Parity
   F1  .EQU 0xD0+1 ;Flag 1
   OV  .EQU 0xD0+2 ;Overflow
   RS0 .EQU 0xD0+3 ;Register Select 0
   RS1 .EQU 0xD0+4 ;Register Select 1
   F0  .EQU 0xD0+5 ;Flag 0
   AC  .EQU 0xD0+6 ;Auxiliary Carry
   CY  .EQU 0xD0+7 ;Carry

T4T3M .EQU 0xD1               ;0000,0000 T3/T4 Mode Register
   T3CLKO = 0x01 ;Timer 3 Clock Output Control
   T3x12  = 0x02 ;Timer 3 Clock x12 Prescaler Bypass
   T3_CT  = 0x04 ;Timer 3 Counter or Timer Mode Select
   T3R    = 0x08 ;Timer 3 Run Control
   T4CLKO = 0x10 ;Timer 4 Clock Output Control
   T4x12  = 0x20 ;Timer 4 Clock x12 Prescaler Bypass
   T4_CT  = 0x40 ;Timer 4 Counter or Timer Mode Select
   T4R    = 0x80 ;Timer 4 Run Control

T4H .EQU 0xD2                 ;0000,0000 Timer 4 High Byte
RL_TH4 .EQU 0xD2              ;0000,0000 Reload Timer 4 High Byte

T4L .EQU 0xD3                 ;0000,0000 Timer 4 Low Byte
RL_TL4 .EQU 0xD3              ;0000,0000 Reload Timer 4 Low Byte

T3H .EQU 0xD4                 ;0000,0000 Timer 3 High Byte
RL_TH3 .EQU 0xD4              ;0000,0000 Reload Timer 3 High Byte

T3L .EQU 0xD5                 ;0000,0000 Timer 3 Low Byte
RL_TL3 .EQU 0xD5              ;0000,0000 Reload Timer 3 Low Byte

T2H .EQU 0xD6                 ;0000,0000 Timer 2 High Byte
RL_TH2 .EQU 0xD6              ;0000,0000 Reload Timer 2 High Byte

T2L .EQU 0xD7                 ;0000,0000 Timer 2 Low Byte
RL_TL2 .EQU 0xD7              ;0000,0000 Reload Timer 2 Low Byte

CCON .EQU 0xD8                ;00xx,0000|00xx,xx00 PCA Control Register
   CCF0 .EQU 0xD8+0 ;Capture Compare Flag 0
   CCF1 .EQU 0xD8+1 ;Capture Compare Flag 1
   CCF2 .EQU 0xD8+2 ;Capture Compare Flag 2
   CCF3 .EQU 0xD8+3 ;Capture Compare Flag 3
   CR   .EQU 0xD8+6 ;PCA Run
   CF   .EQU 0xD8+7 ;PCA Flag

CMOD .EQU 0xD9                ;00xx,0000|0xxx,0000|0xxx,x000 PCA Working Mode Register
   ECF  = 0x01 ;PCA Counter Overflow Interrupt Enable
   CPS0 = 0x02 ;PCA Counter Pulse Source Select 0
   CPS1 = 0x04 ;PCA Counter Pulse Source Select 1
   CPS2 = 0x08 ;PCA Counter Pulse Source Select 2
   CPS  = 0x0E ;PCA Counter Pulse Source Select
   CIDL = 0x80 ;PCA Counter Idle Mode Control

CCAPM0 .EQU 0xDA              ;x000,0000 Compare Capture PWM 0 Mode
   ECCF0  = 0x01 ;Enable PCA Capture Flag 0
   PWM0   = 0x02 ;Pulse Width Modulator 0
   TOG0   = 0x04 ;Toggle 0
   MAT0   = 0x08 ;Match 0
   CCAPN0 = 0x10 ;PCA Capture Negative-going 0
   CCAPP0 = 0x20 ;PCA Capture Positive-going 0
   ECOM0  = 0x40 ;Enable Comparator 0

CCAPM1 .EQU 0xDB              ;x000,0000 Compare Capture PWM 1 Mode
   ECCF1  = 0x01 ;Enable PCA Capture Flag 1
   PWM1   = 0x02 ;Pulse Width Modulator 1
   TOG1   = 0x04 ;Toggle 1
   MAT1   = 0x08 ;Match 1
   CCAPN1 = 0x10 ;PCA Capture Negative-going 1
   CCAPP1 = 0x20 ;PCA Capture Positive-going 1
   ECOM1  = 0x40 ;Enable Comparator 1

ACC .EQU 0xE0                 ;0000,0000 Accumulator
   ACC0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC7 .EQU 0xE0+7 ;Accumulator Bit 7
   ACC_0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC_1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC_2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC_3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC_4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC_5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC_6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC_7 .EQU 0xE0+7 ;Accumulator Bit 7

P7M1 .EQU 0xE1                ;0000,0000 Port 7 Mode Register 1
   P70M1 = 0x01 ;Port 7 bit 0 Mode 1
   P71M1 = 0x02 ;Port 7 bit 1 Mode 1
   P72M1 = 0x04 ;Port 7 bit 2 Mode 1
   P73M1 = 0x08 ;Port 7 bit 3 Mode 1
   P74M1 = 0x10 ;Port 7 bit 4 Mode 1
   P75M1 = 0x20 ;Port 7 bit 5 Mode 1
   P76M1 = 0x40 ;Port 7 bit 6 Mode 1
   P77M1 = 0x80 ;Port 7 bit 7 Mode 1

P7M0 .EQU 0xE2                ;0000,0000 Port 7 Mode Register 0
   P70M0 = 0x01 ;Port 7 bit 0 Mode 0
   P71M0 = 0x02 ;Port 7 bit 1 Mode 0
   P72M0 = 0x04 ;Port 7 bit 2 Mode 0
   P73M0 = 0x08 ;Port 7 bit 3 Mode 0
   P74M0 = 0x10 ;Port 7 bit 4 Mode 0
   P75M0 = 0x20 ;Port 7 bit 5 Mode 0
   P76M0 = 0x40 ;Port 7 bit 6 Mode 0
   P77M0 = 0x80 ;Port 7 bit 7 Mode 0

CMPCR1 .EQU 0xE6              ;0000,0000 Comparator Control Register 1
   CMPRES = 0x01 ;Comparator Result
   CMPOE  = 0x02 ;Comparator Output Enable
   NIS    = 0x04 ;Negative Input Source Selection
   PIS    = 0x08 ;Positive Input Source Selection
   NIE    = 0x10 ;Falling Edge Interrupt Enable
   PIE    = 0x20 ;Rising Edge Interrupt Enable
   CMPIF  = 0x40 ;Comparator Interrupt Flag
   CMPEN  = 0x80 ;Comparator Enable

CMPCR2 .EQU 0xE7              ;0000,1001 Comparator Control Register 2
   LCDTY   = 0x3F ;Digital Filter Control
   DISFLT  = 0x40 ;Analog Filter Control
   INVCMPO = 0x80 ;Comparator Output Control

P6 .EQU 0xE8                  ;1111,1111 Port 6
   P60  .EQU 0xE8+0 ;Port 6 Bit 0
   P61  .EQU 0xE8+1 ;Port 6 Bit 1
   P62  .EQU 0xE8+2 ;Port 6 Bit 2
   P63  .EQU 0xE8+3 ;Port 6 Bit 3
   P64  .EQU 0xE8+4 ;Port 6 Bit 4
   P65  .EQU 0xE8+5 ;Port 6 Bit 5
   P66  .EQU 0xE8+6 ;Port 6 Bit 6
   P67  .EQU 0xE8+7 ;Port 6 Bit 7
   P6_0  .EQU 0xE8+0 ;Port 6 Bit 0
   P6_1  .EQU 0xE8+1 ;Port 6 Bit 1
   P6_2  .EQU 0xE8+2 ;Port 6 Bit 2
   P6_3  .EQU 0xE8+3 ;Port 6 Bit 3
   P6_4  .EQU 0xE8+4 ;Port 6 Bit 4
   P6_5  .EQU 0xE8+5 ;Port 6 Bit 5
   P6_6  .EQU 0xE8+6 ;Port 6 Bit 6
   P6_7  .EQU 0xE8+7 ;Port 6 Bit 7

CL .EQU 0xE9                  ;0000,0000 PCA Counter Low Byte

CCAP0L .EQU 0xEA              ;0000,0000 PCA Module 0 Capture/Compare Register Low Byte

CCAP1L .EQU 0xEB              ;0000,0000 PCA Module 1 Capture/Compare Register Low Byte

B .EQU 0xF0                   ;0000,0000 B Register
   B0 .EQU 0xF0+0 ;B Bit 0
   B1 .EQU 0xF0+1 ;B Bit 1
   B2 .EQU 0xF0+2 ;B Bit 2
   B3 .EQU 0xF0+3 ;B Bit 3
   B4 .EQU 0xF0+4 ;B Bit 4
   B5 .EQU 0xF0+5 ;B Bit 5
   B6 .EQU 0xF0+6 ;B Bit 6
   B7 .EQU 0xF0+7 ;B Bit 7
   B_0 .EQU 0xF0+0 ;B Bit 0
   B_1 .EQU 0xF0+1 ;B Bit 1
   B_2 .EQU 0xF0+2 ;B Bit 2
   B_3 .EQU 0xF0+3 ;B Bit 3
   B_4 .EQU 0xF0+4 ;B Bit 4
   B_5 .EQU 0xF0+5 ;B Bit 5
   B_6 .EQU 0xF0+6 ;B Bit 6
   B_7 .EQU 0xF0+7 ;B Bit 7

PWMCFG .EQU 0xF1              ;0000,0000 PCA Module 0 PWM Register
   C2INI  = 0x01 ;PWM 2 Initial Output Level
   C3INI  = 0x02 ;PWM 3 Initial Output Level
   C4INI  = 0x04 ;PWM 4 Initial Output Level
   C5INI  = 0x08 ;PWM 5 Initial Output Level
   C6INI  = 0x10 ;PWM 6 Initial Output Level
   C7INI  = 0x20 ;PWM 7 Initial Output Level
   CBTADC = 0x40 ;PWM Trigger ADC

PCA_PWM0 .EQU 0xF2            ;00xx,xx00|xxxx,xx00 Programmable Counter Array Module 0 PWM Register
   EPC0L   = 0x01 ;MSB of comparison vaule in PWM mode
   EPC0H   = 0x02 ;MSB of reload vaule in PWM mode
   XCCAP0L = 0x0C ;9th & 10th bit of comparison value in PWM mode
   XCCAP0H = 0x30 ;9th & 10th bit of reload value in PWM mode
   EBS0_0  = 0x40 ;Number of PCAn PWM Bits Control 0
   EBS0_1  = 0x80 ;Number of PCAn PWM Bits Control 1
   EBS0    = 0xC0 ;Number of PCAn PWM Bits Control

PCA_PWM1 .EQU 0xF3            ;00xx,xx00|xxxx,xx00 Programmable Counter Array Module 1 PWM Register
   EPC1L   = 0x01 ;MSB of comparison vaule in PWM mode
   EPC1H   = 0x02 ;MSB of reload vaule in PWM mode
   XCCAP1L = 0x0C ;9th & 10th bit of comparison value in PWM mode
   XCCAP1H = 0x30 ;9th & 10th bit of reload value in PWM mode
   EBS1_0  = 0x40 ;Number of PCAn PWM Bits Control 0
   EBS1_1  = 0x80 ;Number of PCAn PWM Bits Control 1
   EBS1    = 0xC0 ;Number of PCAn PWM Bits Control

PWMCR .EQU 0xF5               ;0000,0000 PWM Control Register
   ENC2O = 0x01 ;Enable PWM 2 Output
   ENC3O = 0x02 ;Enable PWM 3 Output
   ENC4O = 0x04 ;Enable PWM 4 Output
   ENC5O = 0x08 ;Enable PWM 5 Output
   ENC6O = 0x10 ;Enable PWM 6 Output
   ENC7O = 0x20 ;Enable PWM 7 Output
   ECBI  = 0x40 ;Enable PWM Interrupt
   ENPWM = 0x80 ;Enable PWM

PWMIF .EQU 0xF6               ;x000,0000|0000,0000 Interrupt Flag Register
   C2IF = 0x01 ;PWM 2 Interrupt Flag
   C3IF = 0x02 ;PWM 3 Interrupt Flag
   C4IF = 0x04 ;PWM 4 Interrupt Flag
   C5IF = 0x08 ;PWM 5 Interrupt Flag
   C6IF = 0x10 ;PWM 6 Interrupt Flag
   C7IF = 0x20 ;PWM 7 Interrupt Flag
   CBIF = 0x40 ;PWM Interrupt Flag

PWMFDCR .EQU 0xF7             ;xx00,0000|0000,0000 PWM Fault Detect Control Register
   FDIF    = 0x01 ;Fault Detect Interrupt Flag
   FDIO    = 0x02 ;Fault Detect Input Output
   FDCMP   = 0x04 ;Fault Detect Comparator
   EFDI    = 0x08 ;Enable Fault Detect Interrupt
   FLTFLIO = 0x10 ;Faut Flag Input Output
   ENFD    = 0x20 ;Enable Fault Detection

P7 .EQU 0xF8                  ;1111,1111 Port 7
   P70 .EQU 0xF8+0 ;Port 7 Bit 0
   P71 .EQU 0xF8+1 ;Port 7 Bit 1
   P72 .EQU 0xF8+2 ;Port 7 Bit 2
   P73 .EQU 0xF8+3 ;Port 7 Bit 3
   P74 .EQU 0xF8+4 ;Port 7 Bit 4
   P75 .EQU 0xF8+5 ;Port 7 Bit 5
   P76 .EQU 0xF8+6 ;Port 7 Bit 6
   P77 .EQU 0xF8+7 ;Port 7 Bit 7
   P7_0 .EQU 0xF8+0 ;Port 7 Bit 0
   P7_1 .EQU 0xF8+1 ;Port 7 Bit 1
   P7_2 .EQU 0xF8+2 ;Port 7 Bit 2
   P7_3 .EQU 0xF8+3 ;Port 7 Bit 3
   P7_4 .EQU 0xF8+4 ;Port 7 Bit 4
   P7_5 .EQU 0xF8+5 ;Port 7 Bit 5
   P7_6 .EQU 0xF8+6 ;Port 7 Bit 6
   P7_7 .EQU 0xF8+7 ;Port 7 Bit 7

CH .EQU 0xF9                  ;0000,0000 PCA Counter High Byte

CCAP0H .EQU 0xFA              ;0000,0000 PCA Module 0 Capture/Compare Register High Byte

CCAP1H .EQU 0xFB              ;0000,0000 PCA Module 1 Capture/Compare Register High Byte

; The following special function registers are in the extended RAM area.
; You need to set bit7 of P_SW2 EAXFR to 1 to read and write them normally.
PWM2T1      .EQU 0xff00 ;          PWM 2 Timer 1 Word
PWM2T1H     .EQU 0xff00 ;x000,0000 PWM 2 Timer 1 High Byte
PWM2T1L     .EQU 0xff01 ;0000,0000 PWM 2 Timer 1 Low Byte
PWM2T2      .EQU 0xff02 ;          PWM 2 Timer 2 Word
PWM2T2H     .EQU 0xff02 ;x000,0000 PWM 2 Timer 2 High Byte
PWM2T2L     .EQU 0xff03 ;0000,0000 PWM 2 Timer 2 Low Byte
PWM2CR      .EQU 0xff04 ;          PWM 2 Control register
   EC2T1SI = 0x01 ;Trigger Point 1 Interrupt Enable
   EC2T2SI = 0x02 ;Trigger Point 2 Interrupt Enable
   EPWM2I  = 0x04 ;Interrupt Enable
   PWM2_PS = 0x08 ;Output Pin Selection
PWM3T1      .EQU 0xff10 ;          PWM 3 Timer 1 Word
PWM3T1H     .EQU 0xff10 ;x000,0000 PWM 3 Timer 1 High Byte
PWM3T1L     .EQU 0xff11 ;0000,0000 PWM 3 Timer 1 Low Byte
PWM3T2      .EQU 0xff12 ;          PWM 3 Timer 2 Word
PWM3T2H     .EQU 0xff12 ;x000,0000 PWM 3 Timer 2 High Byte
PWM3T2L     .EQU 0xff13 ;0000,0000 PWM 3 Timer 2 Low Byte
PWM3CR      .EQU 0xff14 ;          PWM 3 Control register
   EC3T1SI = 0x01 ;Trigger Point 1 Interrupt Enable
   EC3T2SI = 0x02 ;Trigger Point 2 Interrupt Enable
   EPWM3I  = 0x04 ;Interrupt Enable
   PWM3_PS = 0x08 ;Output Pin Selection
PWM4T1      .EQU 0xff20 ;          PWM 4 Timer 1 Word
PWM4T1H     .EQU 0xff20 ;x000,0000 PWM 4 Timer 1 High Byte
PWM4T1L     .EQU 0xff21 ;0000,0000 PWM 4 Timer 1 Low Byte
PWM4T2      .EQU 0xff22 ;          PWM 4 Timer 2 Word
PWM4T2H     .EQU 0xff22 ;x000,0000 PWM 4 Timer 2 High Byte
PWM4T2L     .EQU 0xff23 ;0000,0000 PWM 4 Timer 2 Low Byte
PWM4CR      .EQU 0xff24 ;          PWM 4 Control register
   EC4T1SI = 0x01 ;Trigger Point 1 Interrupt Enable
   EC4T2SI = 0x02 ;Trigger Point 2 Interrupt Enable
   EPWM4I  = 0x04 ;Interrupt Enable
   PWM4_PS = 0x08 ;Output Pin Selection
PWM5T1      .EQU 0xff30 ;          PWM 5 Timer 1 Word
PWM5T1H     .EQU 0xff30 ;x000,0000 PWM 5 Timer 1 High Byte
PWM5T1L     .EQU 0xff31 ;0000,0000 PWM 5 Timer 1 Low Byte
PWM5T2      .EQU 0xff32 ;          PWM 5 Timer 2 Word
PWM5T2H     .EQU 0xff32 ;x000,0000 PWM 5 Timer 2 High Byte
PWM5T2L     .EQU 0xff33 ;0000,0000 PWM 5 Timer 2 Low Byte
PWM5CR      .EQU 0xff34 ;          PWM 5 Control register
   EC5T1SI = 0x01 ;Trigger Point 1 Interrupt Enable
   EC5T2SI = 0x02 ;Trigger Point 2 Interrupt Enable
   EPWM5I  = 0x04 ;Interrupt Enable
   PWM5_PS = 0x08 ;Output Pin Selection
PWM6T1      .EQU 0xff40 ;          PWM 6 Timer 1 Word
PWM6T1H     .EQU 0xff40 ;x000,0000 PWM 6 Timer 1 High Byte
PWM6T1L     .EQU 0xff41 ;0000,0000 PWM 6 Timer 1 Low Byte
PWM6T2      .EQU 0xff42 ;          PWM 6 Timer 2 Word
PWM6T2H     .EQU 0xff42 ;x000,0000 PWM 6 Timer 2 High Byte
PWM6T2L     .EQU 0xff43 ;0000,0000 PWM 6 Timer 2 Low Byte
PWM6CR      .EQU 0xff44 ;          PWM 6 Control register
   EC6T1SI = 0x01 ;Trigger Point 1 Interrupt Enable
   EC6T2SI = 0x02 ;Trigger Point 2 Interrupt Enable
   EPWM6I  = 0x04 ;Interrupt Enable
   PWM6_PS = 0x08 ;Output Pin Selection
PWM7T1      .EQU 0xff50 ;          PWM 7 Timer 1 Word
PWM7T1H     .EQU 0xff50 ;x000,0000 PWM 7 Timer 1 High Byte
PWM7T1L     .EQU 0xff51 ;0000,0000 PWM 7 Timer 1 Low Byte
PWM7T2      .EQU 0xff52 ;          PWM 7 Timer 2 Word
PWM7T2H     .EQU 0xff52 ;x000,0000 PWM 7 Timer 2 High Byte
PWM7T2L     .EQU 0xff53 ;0000,0000 PWM 7 Timer 2 Low Byte
PWM7CR      .EQU 0xff54 ;          PWM 7 Control register
   EC7T1SI = 0x01 ;Trigger Point 1 Interrupt Enable
   EC7T2SI = 0x02 ;Trigger Point 2 Interrupt Enable
   EPWM7I  = 0x04 ;Interrupt Enable
   PWM7_PS = 0x08 ;Output Pin Selection
PWMC        .EQU 0xfff0 ;          PWM Counter Word
PWMCH       .EQU 0xfff0 ;x000,0000 PWM Counter High Byte
PWMCL       .EQU 0xfff1 ;0000,0000 PWM Counter Low Byte
PWMCKS      .EQU 0xfff2 ;xxx0,0000 PWM Clock Selection
   PWM_PS = 0x0F ;PWM System Clock Prescaler
   SELT2  = 0x10 ;PWM Clock source selection

;Interrupt_Address = ( Interrupt_Number * 8 ) + 3
;Vectors are named after their corresponding IE, IP or IR register bit so
;that we don't have to invent names and can be more consistent across MCUs.
   X0_VECTOR  = 0  ; 0x03 External Interrupt 0
   T0_VECTOR  = 1  ; 0x0B Timer 0
   X1_VECTOR  = 2  ; 0x13 External Interrupt 1
   T1_VECTOR  = 3  ; 0x1B Timer 1
   S_VECTOR   = 4  ; 0x23 Serial Port 1
   ADC_VECTOR = 5  ; 0x2B Analog to Digital Converter
   LVD_VECTOR = 6  ; 0x33 Low Voltage Detect
   PCA_VECTOR = 7  ; 0x3B Programmable Counter Array (CCP)
   S2_VECTOR  = 8  ; 0x43 Serial Port 2
   SPI_VECTOR = 9  ; 0x4B Serial Peripheral Interface
   X2_VECTOR  = 10 ; 0x53 External Interrupt 2
   X3_VECTOR  = 11 ; 0x5B External Interrupt 3
   T2_VECTOR  = 12 ; 0x63 Timer 2
   ;    -     = 13 ; 0x6B        -
   ;    -     = 14 ; 0x73 System Reserved
   ;    -     = 15 ; 0x7B System Reserved
   X4_VECTOR  = 16 ; 0x83 External Interrupt 4
   S3_VECTOR  = 17 ; 0x8B Serial Port 3
   S4_VECTOR  = 18 ; 0x93 Serial Port 4
   T3_VECTOR  = 19 ; 0x9B Timer 3
   T4_VECTOR  = 20 ; 0xA3 Timer 4
   CMP_VECTOR = 21 ; 0xAB Comparator
   PWM_VECTOR = 22 ; 0xB3 Pulse Width Modulator
   PFD_VECTOR = 23 ; 0xBB PWM Fault Detect

;.endif
