; PIO compatible header file STC8-A-C-F.asm 20210829.
; For use with all STC8Axx STCCxx STCFxx series.

;.ifndef STC8_A_C_F_ASM
;.define STC8_A_C_F_ASM

; SFR Definition               Description

P0 .EQU 0x80                  ;Port 0
; SBIT(ACH0, 0x80, 0); //ADC Channel 8
; SBIT(ACH1, 0x80, 1); //ADC Channel 9
; SBIT(ACH2, 0x80, 2); //ADC Channel 10
; SBIT(ACH3, 0x80, 3); //ADC Channel 11
; SBIT(ACH4, 0x80, 4); //ADC Channel 12
; SBIT(ACH5, 0x80, 5); //ADC Channel 13
; SBIT(ACH6, 0x80, 6); //ADC Channel 14
; SBIT(ADC0, 0x80, 0); //AtoD Channel 8
; SBIT(ADC1, 0x80, 1); //AtoD Channel 9
; SBIT(ADC2, 0x80, 2); //AtoD Channel 10
; SBIT(ADC3, 0x80, 3); //AtoD Channel 11
; SBIT(ADC4, 0x80, 4); //AtoD Channel 12
; SBIT(ADC5, 0x80, 5); //AtoD Channel 13
; SBIT(ADC6, 0x80, 6); //AtoD Channel 14
; SBIT(AIN0, 0x80, 0); //Analog Input 8
; SBIT(AIN1, 0x80, 1); //Analog Input 9
; SBIT(AIN2, 0x80, 2); //Analog Input 10
; SBIT(AIN3, 0x80, 3); //Analog Input 11
; SBIT(AIN4, 0x80, 4); //Analog Input 12
; SBIT(AIN5, 0x80, 5); //Analog Input 13
; SBIT(AIN6, 0x80, 6); //Analog Input 14
   P00 .EQU 0x80+0 ;Port 0 Bit 0
   P01 .EQU 0x80+1 ;Port 0 Bit 1
   P02 .EQU 0x80+2 ;Port 0 Bit 2
   P03 .EQU 0x80+3 ;Port 0 Bit 3
   P04 .EQU 0x80+4 ;Port 0 Bit 4
   P05 .EQU 0x80+5 ;Port 0 Bit 5
   P06 .EQU 0x80+6 ;Port 0 Bit 6
   P07 .EQU 0x80+7 ;Port 0 Bit 7
   P0_0 .EQU 0x80+0 ;Port 0 Bit 0
   P0_1 .EQU 0x80+1 ;Port 0 Bit 1
   P0_2 .EQU 0x80+2 ;Port 0 Bit 2
   P0_3 .EQU 0x80+3 ;Port 0 Bit 3
   P0_4 .EQU 0x80+4 ;Port 0 Bit 4
   P0_5 .EQU 0x80+5 ;Port 0 Bit 5
   P0_6 .EQU 0x80+6 ;Port 0 Bit 6
   P0_7 .EQU 0x80+7 ;Port 0 Bit 7
; See device specific data sheet for additional pin names.

SP .EQU 0x81                  ;Stack Pointer

;DPTR .EQU 0x82                ;Date Pointer Word
DPL .EQU 0x82                 ;Data Pointer Low Byte

DPH .EQU 0x83                 ;Data Pointer High Byte

S4CON .EQU 0x84               ;Serial Port 4 Control Register
   S4RI  = 0x01 ;Serial Port 4 Receive Interrupt Flag
   S4TI  = 0x02 ;Serial Port 4 Transmit Interrupt Flag
   S4RB8 = 0x04 ;Serial Port 4 Receive Bit 8 Data
   S4TB8 = 0x08 ;Serial Port 4 Transmit Bit 8 Data
   S4REN = 0x10 ;Serial Port 4 Receive Enable
   S4SM2 = 0x20 ;Serial Port 4 Select Mode Bit 2
   S4ST4 = 0x40 ;Serial Port 4 Select Timer 4
   S4SM0 = 0x80 ;Serial Port 4 Select Mode Bit 0

S4BUF .EQU 0x85               ;Serial Port 4 Data Register

PCON .EQU 0x87                ;Power Control Register
   IDL   = 0x01 ;Idle Mode Control
   PD    = 0x02 ;Power Down Mode Control
   GF0   = 0x04 ;User Defined Gereral Purpose Flag 0
   GF1   = 0x08 ;User Defined General Purpose Flag 1
   POF   = 0x10 ;Power On Flag
   LVDF  = 0x20 ;Low Voltage Detect Flag
   SMOD0 = 0x40 ;Frame Error Detection Control
   SMOD  = 0x80 ;Double Baudrate of Serial Port 1

TCON .EQU 0x88                ;Timer Control
   IT0 .EQU 0x88+0 ;Interrupt 0 Type
   IE0 .EQU 0x88+1 ;Interrupt 0 Edge
   IT1 .EQU 0x88+2 ;Interrupt 1 Type
   IE1 .EQU 0x88+3 ;Interrupt 1 Edge
   TR0 .EQU 0x88+4 ;Timer 0 Run
   TF0 .EQU 0x88+5 ;Timer 0 Flag
   TR1 .EQU 0x88+6 ;Timer 1 Run
   TF1 .EQU 0x88+7 ;Timer 1 Flag

TMOD .EQU 0x89                ;Timer Mode
   T0_M0   = 0x01 ;Timer 0 Mode 0
   T0_M1   = 0x02 ;Timer 0 Mode 1
   T0_M    = 0x03 ;Timer 0 Mode
   T0_CT   = 0x04 ;Timer 0 Counter Timer
   T0_GATE = 0x08 ;Timer 0 Gate
   T1_M0   = 0x10 ;Timer 1 Mode 0
   T1_M1   = 0x20 ;Timer 1 Mode 1
   T1_M    = 0x30 ;Timer 1 Mode
   T1_CT   = 0x40 ;Timer 1 Counter Timer
   T1_GATE = 0x80 ;Timer 1 Gate
   M00   = 0x01 ;Mode 0 Timer 0
   M10   = 0x02 ;Mode 1 Timer 0
   M0    = 0x03 ;Timer 0 Mode
   CT0   = 0x04 ;Counter Timer 0
   GATE0 = 0x08 ;Gate 0
   M01   = 0x10 ;Mode 1 Timer 1
   M11   = 0x20 ;Mode 1 Timer 1
   M1    = 0x30 ;Timer 1 Mode
   CT1   = 0x40 ;Counter Timer 1
   GATE1 = 0x80 ;Gate 1

TL0 .EQU 0x8A                 ;T0 Low Byte

TL1 .EQU 0x8B                 ;T1 Low Byte

TH0 .EQU 0x8C                 ;T0 High Byte

TH1 .EQU 0x8D                 ;T1 High Byte

AUXR .EQU 0x8E                ;Auxiliary Register
   S1ST2     = 0x01 ;Serial Port 1 Baud Rate Generator Select
   EXTRAM    = 0x02 ;Extended RAM Access Control
   T2x12     = 0x04 ;Timer 2 Clock x12 Prescaler Bypass
   T2_CT     = 0x08 ;Timer 2 Counter or Timer Mode Select
   T2R       = 0x10 ;Timer 2 Run Control
   UART_M0x6 = 0x20 ;UART 1 Mode 0 Baudrate Prescaler Select
   T1x12     = 0x40 ;Timer 1 Clock x12 Prescaler Bypass
   T0x12     = 0x80 ;Timer 0 Clock x12 Prescaler Bypass

INTCLKO .EQU 0x8F             ;Interrupt and Clock Output Control Register
   T0CLKO = 0x01 ;Timer 0 Clock Output Control
   T1CLKO = 0x02 ;Timer 1 Clock Output Control
   T2CLKO = 0x04 ;Timer 2 Clock Output Control
   EX2    = 0x10 ;External Interrupt 3 Enable
   EX3    = 0x20 ;External Interrupt 2 Enable
   EX4    = 0x40 ;External Interrupt 4 Enable

P1 .EQU 0x90                  ;Port 1
   ACH0 .EQU 0x90+0 ;ADC Channel 0
   ACH1 .EQU 0x90+1 ;ADC Channel 1
   ACH2 .EQU 0x90+2 ;ADC Channel 2
   ACH3 .EQU 0x90+3 ;ADC Channel 3
   ACH4 .EQU 0x90+4 ;ADC Channel 4
   ACH5 .EQU 0x90+5 ;ADC Channel 5
   ACH6 .EQU 0x90+6 ;ADC Channel 6
   ACH7 .EQU 0x90+7 ;ADC Channel 7
   ADC0 .EQU 0x90+0 ;AtoD Channel 0
   ADC1 .EQU 0x90+1 ;AtoD Channel 1
   ADC2 .EQU 0x90+2 ;AtoD Channel 2
   ADC3 .EQU 0x90+3 ;AtoD Channel 3
   ADC4 .EQU 0x90+4 ;AtoD Channel 4
   ADC5 .EQU 0x90+5 ;AtoD Channel 5
   ADC6 .EQU 0x90+6 ;AtoD Channel 6
   ADC7 .EQU 0x90+7 ;AtoD Channel 7
   AIN0 .EQU 0x90+0 ;Analog Input 0
   AIN1 .EQU 0x90+1 ;Analog Input 1
   AIN2 .EQU 0x90+2 ;Analog Input 2
   AIN3 .EQU 0x90+3 ;Analog Input 3
   AIN4 .EQU 0x90+4 ;Analog Input 4
   AIN5 .EQU 0x90+5 ;Analog Input 5
   AIN6 .EQU 0x90+6 ;Analog Input 6
   AIN7 .EQU 0x90+7 ;Analog Input 7
   P10 .EQU 0x90+0 ;Port 1 Bit 0
   P11 .EQU 0x90+1 ;Port 1 Bit 1
   P12 .EQU 0x90+2 ;Port 1 Bit 2
   P13 .EQU 0x90+3 ;Port 1 Bit 3
   P14 .EQU 0x90+4 ;Port 1 Bit 4
   P15 .EQU 0x90+5 ;Port 1 Bit 5
   P16 .EQU 0x90+6 ;Port 1 Bit 6
   P17 .EQU 0x90+7 ;Port 1 Bit 7
   P1_0 .EQU 0x90+0 ;Port 1 Bit 0
   P1_1 .EQU 0x90+1 ;Port 1 Bit 1
   P1_2 .EQU 0x90+2 ;Port 1 Bit 2
   P1_3 .EQU 0x90+3 ;Port 1 Bit 3
   P1_4 .EQU 0x90+4 ;Port 1 Bit 4
   P1_5 .EQU 0x90+5 ;Port 1 Bit 5
   P1_6 .EQU 0x90+6 ;Port 1 Bit 6
   P1_7 .EQU 0x90+7 ;Port 1 Bit 7
; See device specific data sheet for additional pin names.

P1M1 .EQU 0x91                ;Port 1 Mode Register 1
   P10M1 = 0x01 ;Port 1 bit 0 Mode 1
   P11M1 = 0x02 ;Port 1 bit 1 Mode 1
   P12M1 = 0x04 ;Port 1 bit 2 Mode 1
   P13M1 = 0x08 ;Port 1 bit 3 Mode 1
   P14M1 = 0x10 ;Port 1 bit 4 Mode 1
   P15M1 = 0x20 ;Port 1 bit 5 Mode 1
   P16M1 = 0x40 ;Port 1 bit 6 Mode 1
   P17M1 = 0x80 ;Port 1 bit 7 Mode 1

P1M0 .EQU 0x92                ;Port 1 Mode Register 0
   P10M0 = 0x01 ;Port 1 bit 0 Mode 0
   P11M0 = 0x02 ;Port 1 bit 1 Mode 0
   P12M0 = 0x04 ;Port 1 bit 2 Mode 0
   P13M0 = 0x08 ;Port 1 bit 3 Mode 0
   P14M0 = 0x10 ;Port 1 bit 4 Mode 0
   P15M0 = 0x20 ;Port 1 bit 5 Mode 0
   P16M0 = 0x40 ;Port 1 bit 6 Mode 0
   P17M0 = 0x80 ;Port 1 bit 7 Mode 0

P0M1 .EQU 0x93                ;Port 0 Mode Register 1
   P00M1 = 0x01 ;Port 0 bit 0 Mode 1
   P01M1 = 0x02 ;Port 0 bit 1 Mode 1
   P02M1 = 0x04 ;Port 0 bit 2 Mode 1
   P03M1 = 0x08 ;Port 0 bit 3 Mode 1
   P04M1 = 0x10 ;Port 0 bit 4 Mode 1
   P05M1 = 0x20 ;Port 0 bit 5 Mode 1
   P06M1 = 0x40 ;Port 0 bit 6 Mode 1
   P07M1 = 0x80 ;Port 0 bit 7 Mode 1

P0M0 .EQU 0x94                ;Port 0 Mode Register 0
   P00M0 = 0x01 ;Port 0 bit 0 Mode 0
   P01M0 = 0x02 ;Port 0 bit 1 Mode 0
   P02M0 = 0x04 ;Port 0 bit 2 Mode 0
   P03M0 = 0x08 ;Port 0 bit 3 Mode 0
   P04M0 = 0x10 ;Port 0 bit 4 Mode 0
   P05M0 = 0x20 ;Port 0 bit 5 Mode 0
   P06M0 = 0x40 ;Port 0 bit 6 Mode 0
   P07M0 = 0x80 ;Port 0 bit 7 Mode 0

P2M1 .EQU 0x95                ;Port 2 Mode Register 1
   P20M1 = 0x01 ;Port 2 bit 0 Mode 1
   P21M1 = 0x02 ;Port 2 bit 1 Mode 1
   P22M1 = 0x04 ;Port 2 bit 2 Mode 1
   P23M1 = 0x08 ;Port 2 bit 3 Mode 1
   P24M1 = 0x10 ;Port 2 bit 4 Mode 1
   P25M1 = 0x20 ;Port 2 bit 5 Mode 1
   P26M1 = 0x40 ;Port 2 bit 6 Mode 1
   P27M1 = 0x80 ;Port 2 bit 7 Mode 1

P2M0 .EQU 0x96                ;Port 2 Mode Register 0
   P20M0 = 0x01 ;Port 2 bit 0 Mode 0
   P21M0 = 0x02 ;Port 2 bit 1 Mode 0
   P22M0 = 0x04 ;Port 2 bit 2 Mode 0
   P23M0 = 0x08 ;Port 2 bit 3 Mode 0
   P24M0 = 0x10 ;Port 2 bit 4 Mode 0
   P25M0 = 0x20 ;Port 2 bit 5 Mode 0
   P26M0 = 0x40 ;Port 2 bit 6 Mode 0
   P27M0 = 0x80 ;Port 2 bit 7 Mode 0

AUXR2 .EQU 0x97               ;Auxiliary Register 2
   TXLNRX = 0x10 ;Serial Port 1 TX Loopthrough to RX

SCON .EQU 0x98                ;Serial Control
   RI  .EQU 0x98+0 ;Receive Interrupt
   TI  .EQU 0x98+1 ;Transmit Interrupt
   RB8 .EQU 0x98+2 ;Receive Bit 8
   TB8 .EQU 0x98+3 ;Transmit Bit 8
   REN .EQU 0x98+4 ;Receive Enable
   SM2 .EQU 0x98+5 ;Serial Mode 2
   SM1 .EQU 0x98+6 ;Serial Mode 1
   SM0 .EQU 0x98+7 ;Serial Mode 0
   FE  .EQU 0x98+7 ;Framing Error

SBUF .EQU 0x99                ;Serial Port 1 Data Register

S2CON .EQU 0x9A               ;Serial Port 2 Control Register
   S2RI  = 0x01 ;Serial Port 2 Receive Interrupt Flag
   S2TI  = 0x02 ;Serial Port 2 Transmit Interrupt Flag
   S2RB8 = 0x04 ;Serial Port 2 Receive Bit 8 Data
   S2TB8 = 0x08 ;Serial Port 2 Transmit Bit 8 Data
   S2REN = 0x10 ;Serial Port 2 Receive Enable
   S2SM2 = 0x20 ;Serial Port 2 Select Mode Bit 2
   S2SM0 = 0x80 ;Serial Port 2 Select Mode Bit 0

S2BUF .EQU 0x9B               ;Serial Port 2 Data Register

LIRTRIM .EQU 0x9E             ;Internal RC Clock Frequency Trimming Register

IRTRIM .EQU 0x9F              ;Internal RC Clock Frequency Adjustment Register

P2 .EQU 0xA0                  ;Port 2
   P20 .EQU 0xA0+0 ;Port 2 Bit 0
   P21 .EQU 0xA0+1 ;Port 2 Bit 1
   P22 .EQU 0xA0+2 ;Port 2 Bit 2
   P23 .EQU 0xA0+3 ;Port 2 Bit 3
   P24 .EQU 0xA0+4 ;Port 2 Bit 4
   P25 .EQU 0xA0+5 ;Port 2 Bit 5
   P26 .EQU 0xA0+6 ;Port 2 Bit 6
   P27 .EQU 0xA0+7 ;Port 2 Bit 7
   P2_0 .EQU 0xA0+0 ;Port 2 Bit 0
   P2_1 .EQU 0xA0+1 ;Port 2 Bit 1
   P2_2 .EQU 0xA0+2 ;Port 2 Bit 2
   P2_3 .EQU 0xA0+3 ;Port 2 Bit 3
   P2_4 .EQU 0xA0+4 ;Port 2 Bit 4
   P2_5 .EQU 0xA0+5 ;Port 2 Bit 5
   P2_6 .EQU 0xA0+6 ;Port 2 Bit 6
   P2_7 .EQU 0xA0+7 ;Port 2 Bit 7
; See device specific data sheet for additional pin names.

BUS_SPEED .EQU 0xA1           ;Bus Speed Control Register
   BUSSPEED = 0x07 ;Bus Read-Write Speed Control
   RW_S     = 0xC0 ;Read-Write Control Pin Select

P_SW1 .EQU 0xA2               ;Peripheral Port Switching Register 1
   SPI_S = 0xC0 ;Serial Peripheral Interface Pin Select
   CCP_S = 0x30 ;PCA Pin Select
   S1_S  = 0xC0 ;Serial Port 1 Pin Select

IE .EQU 0xA8                  ;Interrupt Enable
   EX0  .EQU 0xA8+0 ;Enable External 0
   ET0  .EQU 0xA8+1 ;Enable Timer 0
   EX1  .EQU 0xA8+2 ;Enable External 1
   ET1  .EQU 0xA8+3 ;Enable Timer 1
   ES   .EQU 0xA8+4 ;Enable Serial
   EADC .EQU 0xA8+5 ;Enable ADC
   ELVD .EQU 0xA8+6 ;Enable Low Voltage Detect
   EA   .EQU 0xA8+7 ;Enable All

SADDR .EQU 0xA9               ;Slave Address Register

WKTCL .EQU 0xAA               ;Power Down Wakeup Timer Low Byte

WKTCH .EQU 0xAB               ;Power Down Wakeup Timer High Byte
   WKTEN = 0x80 ;Power Down Wakeup Timer Enable

S3CON .EQU 0xAC               ;Serial Port 3 Control Register
   S3RI  = 0x01 ;Serial Port 3 Receive Interrupt Flag
   S3TI  = 0x02 ;Serial Port 3 Transmit Interrupt Flag
   S3RB8 = 0x04 ;Serial Port 3 Receive Bit 8 Data
   S3TB8 = 0x08 ;Serial Port 3 Transmit Bit 8 Data
   S3REN = 0x10 ;Serial Port 3 Receive Enable
   S3SM2 = 0x20 ;Serial Port 3 Select Mode Bit 2
   S3ST3 = 0x40 ;Serial Port 3 Select Timer 3
   S3SM0 = 0x80 ;Serial Port 3 Select Mode Bit 0

S3BUF .EQU 0xAD               ;Serial Port 3 Data Register

TA .EQU 0xAE                  ;Data Pointer Control Register

IE2 .EQU 0xAF                 ;Interrupt Control Register 2
   ES2  = 0x01 ;Enable Serial Port 2 Interrupt
   ESPI = 0x02 ;Enable Serial Peripheral Interface Interrupt
   ET2  = 0x04 ;Enable Timer 2 Interrupt
   ES3  = 0x08 ;Enable Serial Port 3 Interrupt
   ES4  = 0x10 ;Enable Serial Port 4 Interrupt
   ET3  = 0x20 ;Enable Timer 3 Interrupt
   ET4  = 0x40 ;Enable Timer 4 Interrupt
   ECAN = 0x80 ;Enable CAN Interrupt

P3 .EQU 0xB0                  ;Port 3
; SBIT(ACH0, 0xB0, 0); //ADC Channel 8
; SBIT(ACH1, 0xB0, 1); //ADC Channel 9
; SBIT(ACH2, 0xB0, 2); //ADC Channel 10
; SBIT(ACH3, 0xB0, 3); //ADC Channel 11
; SBIT(ACH4, 0xB0, 4); //ADC Channel 12
; SBIT(ACH5, 0xB0, 5); //ADC Channel 13
; SBIT(ACH6, 0xB0, 6); //ADC Channel 14
; SBIT(ADC0, 0xB0, 0); //AtoD Channel 8
; SBIT(ADC1, 0xB0, 1); //AtoD Channel 9
; SBIT(ADC2, 0xB0, 2); //AtoD Channel 10
; SBIT(ADC3, 0xB0, 3); //AtoD Channel 11
; SBIT(ADC4, 0xB0, 4); //AtoD Channel 12
; SBIT(ADC5, 0xB0, 5); //AtoD Channel 13
; SBIT(ADC6, 0xB0, 6); //AtoD Channel 14
; SBIT(AIN0, 0xB0, 0); //Analog Input 8
; SBIT(AIN1, 0xB0, 1); //Analog Input 9
; SBIT(AIN2, 0xB0, 2); //Analog Input 10
; SBIT(AIN3, 0xB0, 3); //Analog Input 11
; SBIT(AIN4, 0xB0, 4); //Analog Input 12
; SBIT(AIN5, 0xB0, 5); //Analog Input 13
; SBIT(AIN6, 0xB0, 6); //Analog Input 14
   P30 .EQU 0xB0+0 ;Port 3 Bit 0
   P31 .EQU 0xB0+1 ;Port 3 Bit 1
   P32 .EQU 0xB0+2 ;Port 3 Bit 2
   P33 .EQU 0xB0+3 ;Port 3 Bit 3
   P34 .EQU 0xB0+4 ;Port 3 Bit 4
   P35 .EQU 0xB0+5 ;Port 3 Bit 5
   P36 .EQU 0xB0+6 ;Port 3 Bit 6
   P37 .EQU 0xB0+7 ;Port 3 Bit 7
   P3_0 .EQU 0xB0+0 ;Port 3 Bit 0
   P3_1 .EQU 0xB0+1 ;Port 3 Bit 1
   P3_2 .EQU 0xB0+2 ;Port 3 Bit 2
   P3_3 .EQU 0xB0+3 ;Port 3 Bit 3
   P3_4 .EQU 0xB0+4 ;Port 3 Bit 4
   P3_5 .EQU 0xB0+5 ;Port 3 Bit 5
   P3_6 .EQU 0xB0+6 ;Port 3 Bit 6
   P3_7 .EQU 0xB0+7 ;Port 3 Bit 7
; See device specific data sheet for additional pin names.

P3M1 .EQU 0xB1                ;Port 3 Mode Register 1
   P30M1 = 0x01 ;Port 3 bit 0 Mode 1
   P31M1 = 0x02 ;Port 3 bit 1 Mode 1
   P32M1 = 0x04 ;Port 3 bit 2 Mode 1
   P33M1 = 0x08 ;Port 3 bit 3 Mode 1
   P34M1 = 0x10 ;Port 3 bit 4 Mode 1
   P35M1 = 0x20 ;Port 3 bit 5 Mode 1
   P36M1 = 0x40 ;Port 3 bit 6 Mode 1
   P37M1 = 0x80 ;Port 3 bit 7 Mode 1

P3M0 .EQU 0xB2                ;Port 3 Mode Register 0
   P30M0 = 0x01 ;Port 3 bit 0 Mode 0
   P31M0 = 0x02 ;Port 3 bit 1 Mode 0
   P32M0 = 0x04 ;Port 3 bit 2 Mode 0
   P33M0 = 0x08 ;Port 3 bit 3 Mode 0
   P34M0 = 0x10 ;Port 3 bit 4 Mode 0
   P35M0 = 0x20 ;Port 3 bit 5 Mode 0
   P36M0 = 0x40 ;Port 3 bit 6 Mode 0
   P37M0 = 0x80 ;Port 3 bit 7 Mode 0

P4M1 .EQU 0xB3                ;Port 4 Mode Register 1
   P40M1 = 0x01 ;Port 4 bit 0 Mode 1
   P41M1 = 0x02 ;Port 4 bit 1 Mode 1
   P42M1 = 0x04 ;Port 4 bit 2 Mode 1
   P43M1 = 0x08 ;Port 4 bit 3 Mode 1
   P44M1 = 0x10 ;Port 4 bit 4 Mode 1
   P45M1 = 0x20 ;Port 4 bit 5 Mode 1
   P46M1 = 0x40 ;Port 4 bit 6 Mode 1
   P47M1 = 0x80 ;Port 4 bit 7 Mode 1

P4M0 .EQU 0xB4                ;Port 4 Mode Register 0
   P40M0 = 0x01 ;Port 4 bit 0 Mode 0
   P41M0 = 0x02 ;Port 4 bit 1 Mode 0
   P42M0 = 0x04 ;Port 4 bit 2 Mode 0
   P43M0 = 0x08 ;Port 4 bit 3 Mode 0
   P44M0 = 0x10 ;Port 4 bit 4 Mode 0
   P45M0 = 0x20 ;Port 4 bit 5 Mode 0
   P46M0 = 0x40 ;Port 4 bit 6 Mode 0
   P47M0 = 0x80 ;Port 4 bit 7 Mode 0

IP2 .EQU 0xB5                 ;Interrupt Priority Register 2
   PS2    = 0x01 ;Serial Port 2 Interrupt Priority
   PSPI   = 0x02 ;Serial Peripheral Interface Interrupt Priority
   PPWM   = 0x04 ;PWM Interrupt Priority
   PPWMFD = 0x08 ;PWM Fault Detect Interrupt Priority
   PX4    = 0x10 ;External Interrupt 4 Priority
   PCMP   = 0x20 ;Comparator Interrupt Priority
   PI2C   = 0x40 ;I2C Interrupt Priority
   PCAN   = 0x80 ;CAN Interrupt Priority

IP2H .EQU 0xB6                ;High Interrupt Priority Register 2
   PS2H    = 0x01 ;Serial Port 2 Interrupt Priority High
   PSPIH   = 0x02 ;Serial Peripheral Interface Interrupt Priority High
   PPWMH   = 0x04 ;PWM Interrupt Priority High
   PPWMFDH = 0x08 ;PWM Fault Detect Interrupt Priority High
   PX4H    = 0x10 ;External Interrupt 4 Priority High
   PCMPH   = 0x20 ;Comparator Interrupt Priority High
   PI2CH   = 0x40 ;I2C Interrupt Priority High
   PCANH   = 0x80 ;CAN Interrupt Priority High

IPH .EQU 0xB7                 ;High Interrupt Priority Register
   PX0H  = 0x01 ;External Interrupt 0 Priority High
   PT0H  = 0x02 ;Timer 0 Interrupt Priority High
   PX1H  = 0x04 ;External Interrupt 1 Priority High
   PT1H  = 0x08 ;Timer 1 Interrupt Priority High
   PSH   = 0x10 ;Serial Port 1 Interrupt Priority High
   PADCH = 0x20 ;ADC Interrupt Priority High
   PLVDH = 0x40 ;Low Voltage Detect Interrupt Priority High
   PPCAH = 0x80 ;CCP-PCA Interrupt Priority High

IP .EQU 0xB8                  ;Interrupt Priority
   PX0  .EQU 0xB8+0 ;Priority External 0
   PT0  .EQU 0xB8+1 ;Priority Timer 0
   PX1  .EQU 0xB8+2 ;Priority External 1
   PT1  .EQU 0xB8+3 ;Priority Timer 1
   PS   .EQU 0xB8+4 ;Priority Serial
   PADC .EQU 0xB8+5 ;Priority ADC
   PLVD .EQU 0xB8+6 ;Priority Low Voltage Detect
   PPCA .EQU 0xB8+7 ;Priority CCP-PCA

SADEN .EQU 0xB9               ;Slave Address Mask Register

P_SW2 .EQU 0xBA               ;Peripheral Port Switching Register 2
   S2_S   = 0x10 ;Serial Port 2 Pin Select
   S3_S   = 0x20 ;Serial Port 3 Pin Select
   S4_S   = 0x40 ;Serial Port 4 Pin Select
   CMPO_S = 0x80 ;Comparator Output Pin Select
   I2C_S  = 0x30 ;I2C Pin Select
   CAN_S  = 0x40 ;CAN Pin Select
   EAXFR  = 0x80 ;Extended RAM Area Transfer Enable

VOCTRL .EQU 0xBB              ;Voltage Control Register
   SCC = 0x80 ;Static Current Control

ADC_CONTR .EQU 0xBC           ;Analog to Digital Converter Control Register
   ADC_CHS   = 0x0F ;ADC Analog Channel Select
   ADC_FLAG  = 0x20 ;ADC Conversion Complete Flag
   ADC_START = 0x40 ;ADC Start Command
   ADC_POWER = 0x80 ;ADC Power Control

ADC_RES .EQU 0xBD             ;Analog to Digital Converter Result High 8 Bits

ADC_RESL .EQU 0xBE            ;Analog to Digital Converter Result Low 2 Bits

P4 .EQU 0xC0                  ;Port 4
   P40 .EQU 0xC0+0 ;Port 4 Bit 0
   P41 .EQU 0xC0+1 ;Port 4 Bit 1
   P42 .EQU 0xC0+2 ;Port 4 Bit 2
   P43 .EQU 0xC0+3 ;Port 4 Bit 3
   P44 .EQU 0xC0+4 ;Port 4 Bit 4
   P45 .EQU 0xC0+5 ;Port 4 Bit 5
   P46 .EQU 0xC0+6 ;Port 4 Bit 6
   P47 .EQU 0xC0+7 ;Port 4 Bit 7
   P4_0 .EQU 0xC0+0 ;Port 4 Bit 0
   P4_1 .EQU 0xC0+1 ;Port 4 Bit 1
   P4_2 .EQU 0xC0+2 ;Port 4 Bit 2
   P4_3 .EQU 0xC0+3 ;Port 4 Bit 3
   P4_4 .EQU 0xC0+4 ;Port 4 Bit 4
   P4_5 .EQU 0xC0+5 ;Port 4 Bit 5
   P4_6 .EQU 0xC0+6 ;Port 4 Bit 6
   P4_7 .EQU 0xC0+7 ;Port 4 Bit 7
; See device specific data sheet for additional pin names.

WDT_CONTR .EQU 0xC1           ;Watchdog Control Register
   WDTPS0   = 0x01 ;Watchdog Timer Prescaler 0
   WDTPS1   = 0x02 ;Watchdog Timer Prescaler 1
   WDTPS2   = 0x04 ;Watchdog Timer Prescaler 2
   WDT_PS   = 0x07 ;Watchdog Timer Prescaler
   IDL_WDT  = 0x08 ;Watchdog Timer Idle Mode Behavior
   CLR_WDT  = 0x10 ;Clear Watchdog Timer
   EN_WDT   = 0x20 ;Enable Watchdog Timer
   WDT_FLAG = 0x80 ;Watchdog Timer Overflow Flag

IAP_DATA .EQU 0xC2            ;In Application Programming Data
ISP_DATA .EQU 0xC2            ;In System Programming Data

IAP_ADDRH .EQU 0xC3           ;In Application Programming Address High
ISP_ADDRH .EQU 0xC3           ;In System Programming Address High

IAP_ADDRL .EQU 0xC4           ;In Application Programming Address Low
ISP_ADDRL .EQU 0xC4           ;In System Programming Address Low

IAP_CMD .EQU 0xC5             ;In Application Programming Command
ISP_CMD .EQU 0xC5             ;In System Programming Command
   MS0    = 0x01 ;Mode Select 0
   MS1    = 0x02 ;Mode Select 1
   IAPCMD = 0x03 ;In Application Programming Command
; Valid commands follow
   IAP_IDL   = 0x00
   IAP_READ  = 0x01
   IAP_WRITE = 0x02
   IAP_ERASE = 0x03
; End of valid commands

IAP_TRIG .EQU 0xC6            ;In Application Programming Trigger
ISP_TRIG .EQU 0xC6            ;In System Programming Trigger

IAP_CONTR .EQU 0xC7           ;In Application Programming Control
ISP_CONTR .EQU 0xC7           ;In System Programming Control
   WT0      = 0x01 ;Wait 0
   WT1      = 0x02 ;Wait 1
   WT2      = 0x04 ;Wait 2
   IAP_WT   = 0x07 ;In Application Programming Wait
   CMD_FAIL = 0x10 ;Command Fail
   SWRST    = 0x20 ;Software Reset Trigger
   SWBS     = 0x40 ;Software Boot Selection
   IAPEN    = 0x80 ;In Application Programming Enable

P5 .EQU 0xC8                  ;Port 5
   P50 .EQU 0xC8+0 ;Port 5 Bit 0
   P51 .EQU 0xC8+1 ;Port 5 Bit 1
   P52 .EQU 0xC8+2 ;Port 5 Bit 2
   P53 .EQU 0xC8+3 ;Port 5 Bit 3
   P54 .EQU 0xC8+4 ;Port 5 Bit 4
   P55 .EQU 0xC8+5 ;Port 5 Bit 5
   P5_0 .EQU 0xC8+0 ;Port 5 Bit 0
   P5_1 .EQU 0xC8+1 ;Port 5 Bit 1
   P5_2 .EQU 0xC8+2 ;Port 5 Bit 2
   P5_3 .EQU 0xC8+3 ;Port 5 Bit 3
   P5_4 .EQU 0xC8+4 ;Port 5 Bit 4
   P5_5 .EQU 0xC8+5 ;Port 5 Bit 5
; See device specific data sheet for additional pin names.

P5M1 .EQU 0xC9                ;Port 5 Mode Register 1
   P50M1 = 0x01 ;Port 5 bit 0 Mode 1
   P51M1 = 0x02 ;Port 5 bit 1 Mode 1
   P52M1 = 0x04 ;Port 5 bit 2 Mode 1
   P53M1 = 0x08 ;Port 5 bit 3 Mode 1
   P54M1 = 0x10 ;Port 5 bit 4 Mode 1
   P55M1 = 0x20 ;Port 5 bit 5 Mode 1

P5M0 .EQU 0xCA                ;Port 5 Mode Register 0
   P50M0 = 0x01 ;Port 5 bit 0 Mode 0
   P51M0 = 0x02 ;Port 5 bit 1 Mode 0
   P52M0 = 0x04 ;Port 5 bit 2 Mode 0
   P53M0 = 0x08 ;Port 5 bit 3 Mode 0
   P54M0 = 0x10 ;Port 5 bit 4 Mode 0
   P55M0 = 0x20 ;Port 5 bit 5 Mode 0

P6M1 .EQU 0xCB                ;Port 6 Mode Register 1
   P60M1 = 0x01 ;Port 6 bit 0 Mode 1
   P61M1 = 0x02 ;Port 6 bit 1 Mode 1
   P62M1 = 0x04 ;Port 6 bit 2 Mode 1
   P63M1 = 0x08 ;Port 6 bit 3 Mode 1
   P64M1 = 0x10 ;Port 6 bit 4 Mode 1
   P65M1 = 0x20 ;Port 6 bit 5 Mode 1
   P66M1 = 0x40 ;Port 6 bit 6 Mode 1
   P67M1 = 0x80 ;Port 6 bit 7 Mode 1

P6M0 .EQU 0xCC                ;Port 6 Mode Register 0
   P60M0 = 0x01 ;Port 6 bit 0 Mode 0
   P61M0 = 0x02 ;Port 6 bit 1 Mode 0
   P62M0 = 0x04 ;Port 6 bit 2 Mode 0
   P63M0 = 0x08 ;Port 6 bit 3 Mode 0
   P64M0 = 0x10 ;Port 6 bit 4 Mode 0
   P65M0 = 0x20 ;Port 6 bit 5 Mode 0
   P66M0 = 0x40 ;Port 6 bit 6 Mode 0
   P67M0 = 0x80 ;Port 6 bit 7 Mode 0

SPSTAT .EQU 0xCD              ;Serial Peripheral Status Register
   WCOL = 0x40 ;Write Collision
   SPIF = 0x80 ;Serial Peripheral Interface Flag

SPCTL .EQU 0xCE               ;Serial Peripheral Control Register
   SPR0 = 0x00 ;Serial Peripheral Rate 0
   SPR1 = 0x01 ;Serial Peripheral Rate 1
   SPR  = 0x03 ;Serial Peripheral Rate
   CPHA = 0x04 ;Clock Phase
   CPOL = 0x08 ;Clock Polarity
   MSTR = 0x10 ;Master
   DORD = 0x20 ;Data Order
   SPEN = 0x40 ;Serial Peripheral Enable
   SSIG = 0x80 ;Slave Select Signal

SPDAT .EQU 0xCF               ;Serial Peripheral Data

PSW .EQU 0xD0                 ;Program status word
   P   .EQU 0xD0+0 ;Parity
   F1  .EQU 0xD0+1 ;Flag 1
   OV  .EQU 0xD0+2 ;Overflow
   RS0 .EQU 0xD0+3 ;Register Select 0
   RS1 .EQU 0xD0+4 ;Register Select 1
   F0  .EQU 0xD0+5 ;Flag 0
   AC  .EQU 0xD0+6 ;Auxiliary Carry
   CY  .EQU 0xD0+7 ;Carry

T4T3M .EQU 0xD1               ;T4 and T3 Mode Register
   T3CLKO = 0x01 ;Timer 3 Clock Output Control
   T3x12  = 0x02 ;Timer 3 Clock x12 Prescaler Bypass
   T3_CT  = 0x04 ;Timer 3 Counter or Timer Mode Select
   T3R    = 0x08 ;Timer 3 Run Control
   T4CLKO = 0x10 ;Timer 4 Clock Output Control
   T4x12  = 0x20 ;Timer 4 Clock x12 Prescaler Bypass
   T4_CT  = 0x40 ;Timer 4 Counter or Timer Mode Select
   T4R    = 0x80 ;Timer 4 Run Control

T4H .EQU 0xD2                 ;T4 High Byte
TH4 .EQU 0xD2

T4L .EQU 0xD3                 ;T4 Low Byte
TL4 .EQU 0xD3

T3H .EQU 0xD4                 ;T3 High Byte
TH3 .EQU 0xD4

T3L .EQU 0xD5                 ;T3 Low Byte
TL3 .EQU 0xD5

T2H .EQU 0xD6                 ;T2 High Byte
TH2 .EQU 0xD6

T2L .EQU 0xD7                 ;T2 Low Byte
TL2 .EQU 0xD7

CCON .EQU 0xD8              ;PCA Control Register
   CCF0 .EQU 0xD8+0 ;PCA Counter 0 Interrupt Flag
   CCF1 .EQU 0xD8+1 ;PCA Counter 1 Interrupt Flag
   CCF2 .EQU 0xD8+2 ;PCA Counter 2 Interrupt Flag
   CCF3 .EQU 0xD8+3 ;PCA Counter 3 Interrupt Flag
   CR   .EQU 0xD8+6 ;PCA Counter Enable
   CF   .EQU 0xD8+7 ;PCA Counter Overflow Flage

CMOD .EQU 0xD9                ;PCA Working Mode Register
   ECF  = 0x01 ;PCA Counter Overflow Interrupt Enable
   CPS0 = 0x02 ;PCA Counter Pulse Source Select 0
   CPS1 = 0x04 ;PCA Counter Pulse Source Select 1
   CPS2 = 0x08 ;PCA Counter Pulse Source Select 2
   CPS  = 0x0E ;PCA Counter Pulse Source Select
   CIDL = 0x80 ;PCA Counter Idle Mode Control

CCAPM0 .EQU 0xDA              ;Compare Capture PWM 0 Mode
   ECCF0  = 0x01 ;Enable PCA Capture Flag 0
   PWM0   = 0x02 ;Pulse Width Modulator 0
   TOG0   = 0x04 ;Toggle 0
   MAT0   = 0x08 ;Match 0
   CCAPN0 = 0x10 ;PCA Capture Negative-going 0
   CCAPP0 = 0x20 ;PCA Capture Positive-going 0
   ECOM0  = 0x40 ;Enable Comparator 0

CCAPM1 .EQU 0xDB              ;Compare Capture PWM 1 Mode
   ECCF1  = 0x01 ;Enable PCA Capture Flag 1
   PWM1   = 0x02 ;Pulse Width Modulator 1
   TOG1   = 0x04 ;Toggle 1
   MAT1   = 0x08 ;Match 1
   CCAPN1 = 0x10 ;PCA Capture Negative-going 1
   CCAPP1 = 0x20 ;PCA Capture Positive-going 1
   ECOM1  = 0x40 ;Enable Comparator 1

CCAPM2 .EQU 0xDC              ;Compare Capture PWM 2 Mode
   ECCF2  = 0x01 ;Enable PCA Capture Flag 2
   PWM2   = 0x02 ;Pulse Width Modulator 2
   TOG2   = 0x04 ;Toggle 2
   MAT2   = 0x08 ;Match 2
   CCAPN2 = 0x10 ;PCA Capture Negative-going 2
   CCAPP2 = 0x20 ;PCA Capture Positive-going 2
   ECOM2  = 0x40 ;Enable Comparator 2

CCAPM3 .EQU 0xDD              ;Compare Capture PWM 3 Mode
   ECCF3  = 0x01 ;Enable PCA Capture Flag 3
   PWM3   = 0x02 ;Pulse Width Modulator 3
   TOG3   = 0x04 ;Toggle 3
   MAT3   = 0x08 ;Match 3
   CCAPN3 = 0x10 ;PCA Capture Negative-going 3
   CCAPP3 = 0x20 ;PCA Capture Positive-going 3
   ECOM3  = 0x40 ;Enable Comparator 3

ADCCFG .EQU 0xDE              ;ADC Configuration Register
   ADCSPEED  = 0x0F ;Clock Speed Control
   RESFMT    = 0x20 ;Result Format Control

IP3 .EQU 0xDF                 ;Interrupt Priority Register 3
   PS3  = 0x01 ;Serial Port 3 Interrupt Priority
   PS4  = 0x02 ;Serial Port 4 Interrupt Priority

ACC .EQU 0xE0                 ;Accumulator
   ACC0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC7 .EQU 0xE0+7 ;Accumulator Bit 7
   ACC_0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC_1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC_2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC_3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC_4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC_5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC_6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC_7 .EQU 0xE0+7 ;Accumulator Bit 7

P7M1 .EQU 0xE1                ;Port 7 Mode Register 1
   P70M1 = 0x01 ;Port 7 bit 0 Mode 1
   P71M1 = 0x02 ;Port 7 bit 1 Mode 1
   P72M1 = 0x04 ;Port 7 bit 2 Mode 1
   P73M1 = 0x08 ;Port 7 bit 3 Mode 1
   P74M1 = 0x10 ;Port 7 bit 4 Mode 1
   P75M1 = 0x20 ;Port 7 bit 5 Mode 1
   P76M1 = 0x40 ;Port 7 bit 6 Mode 1
   P77M1 = 0x80 ;Port 7 bit 7 Mode 1

P7M0 .EQU 0xE2                ;Port 7 Mode Register 0
   P70M0 = 0x01 ;Port 7 bit 0 Mode 0
   P71M0 = 0x02 ;Port 7 bit 1 Mode 0
   P72M0 = 0x04 ;Port 7 bit 2 Mode 0
   P73M0 = 0x08 ;Port 7 bit 3 Mode 0
   P74M0 = 0x10 ;Port 7 bit 4 Mode 0
   P75M0 = 0x20 ;Port 7 bit 5 Mode 0
   P76M0 = 0x40 ;Port 7 bit 6 Mode 0
   P77M0 = 0x80 ;Port 7 bit 7 Mode 0

DPS .EQU 0xE3                 ;DPTR Pointer Selector
   SEL = 0x01 ;Data Pointer Select
   AU0 = 0x08 ;Auto Increment-Decrement Data Pointer 0
   AU1 = 0x10 ;Auto Increment-Decrement Data Pointer 1
   TSL = 0x20 ;Auto Toggle Data Pointer Select
   ID0 = 0x40 ;Increment or Decrement Data Pointer 0
   ID1 = 0x80 ;Increment or Decrement Data Pointer 1

DPL1 .EQU 0xE4                ;Second Data Pointer Low Byte
DPTR1 .EQU 0xE4               ;Second Data Pointer Word

DPH1 .EQU 0xE5                ;Second Data Pointer High Byte

CMPCR1 .EQU 0xE6              ;Comparator Control Register 1
   CMPRES = 0x01 ;Comparator Result
   CMPOE  = 0x02 ;Comparator Output Enable
   NIS    = 0x04 ;Negative Input Source Selection
   PIS    = 0x08 ;Positive Input Source Selection
   NIE    = 0x10 ;Falling Edge Interrupt Enable
   PIE    = 0x20 ;Rising Edge Interrupt Enable
   CMPIF  = 0x40 ;Comparator Interrupt Flag
   CMPEN  = 0x80 ;Comparator Enable

CMPCR2 .EQU 0xE7              ;Comparator Control Register 2
   LCDTY   = 0x3F ;Digital Filter Control
   DISFLT  = 0x40 ;Analog Filter Control
   INVCMPO = 0x80 ;Comparator Output Control

P6 .EQU 0xE8                  ;Port 6
   P60 .EQU 0xE8+0 ;Port 6 Bit 0
   P61 .EQU 0xE8+1 ;Port 6 Bit 1
   P62 .EQU 0xE8+2 ;Port 6 Bit 2
   P63 .EQU 0xE8+3 ;Port 6 Bit 3
   P64 .EQU 0xE8+4 ;Port 6 Bit 4
   P65 .EQU 0xE8+5 ;Port 6 Bit 5
   P66 .EQU 0xE8+6 ;Port 6 Bit 6
   P67 .EQU 0xE8+7 ;Port 6 Bit 7
   P6_0 .EQU 0xE8+0 ;Port 6 Bit 0
   P6_1 .EQU 0xE8+1 ;Port 6 Bit 1
   P6_2 .EQU 0xE8+2 ;Port 6 Bit 2
   P6_3 .EQU 0xE8+3 ;Port 6 Bit 3
   P6_4 .EQU 0xE8+4 ;Port 6 Bit 4
   P6_5 .EQU 0xE8+5 ;Port 6 Bit 5
   P6_6 .EQU 0xE8+6 ;Port 6 Bit 6
   P6_7 .EQU 0xE8+7 ;Port 6 Bit 7
; See device specific data sheet for additional pin names.

CL .EQU 0xE9                  ;PCA Counter Low Byte

CCAP0L .EQU 0xEA              ;PCA Module 0 Capture-Compare Register Low Byte

CCAP1L .EQU 0xEB              ;PCA Module 1 Capture-Compare Register Low Byte

CCAP2L .EQU 0xEC              ;PCA Module 2 Capture-Compare Register Low Byte

CCAP3L .EQU 0xED              ;PCA Module 3 Capture-Compare Register Low Byte

IP3H .EQU 0xEE                ;High Interrupt Priority Register 3
   PS3H  = 0x01 ;Serial Port 3 Interrupt Priority
   PS4H  = 0x02 ;Serial Port 4 Interrupt Priority

AUXINTIF .EQU 0xEF            ;Auxiliary Interrupt Flag Register
   T2IF   = 0x01 ;Timer 2 Overflow Interrupt
   T3IF   = 0x02 ;Timer 1 Overflow Interrupt
   T4IF   = 0x04 ;Timer 0 Overflow Interrupt
   INT2IF = 0x10 ;External Interrupt 2 Request Flag
   INT3IF = 0x20 ;External Interrupt 3 Request Flag
   INT4IF = 0x40 ;External Interrupt 4 Request Flag

B .EQU 0xF0                   ;B
   B0 .EQU 0xF0+0 ;B Bit 0
   B1 .EQU 0xF0+1 ;B Bit 1
   B2 .EQU 0xF0+2 ;B Bit 2
   B3 .EQU 0xF0+3 ;B Bit 3
   B4 .EQU 0xF0+4 ;B Bit 4
   B5 .EQU 0xF0+5 ;B Bit 5
   B6 .EQU 0xF0+6 ;B Bit 6
   B7 .EQU 0xF0+7 ;B Bit 7
   B_0 .EQU 0xF0+0 ;B Bit 0
   B_1 .EQU 0xF0+1 ;B Bit 1
   B_2 .EQU 0xF0+2 ;B Bit 2
   B_3 .EQU 0xF0+3 ;B Bit 3
   B_4 .EQU 0xF0+4 ;B Bit 4
   B_5 .EQU 0xF0+5 ;B Bit 5
   B_6 .EQU 0xF0+6 ;B Bit 6
   B_7 .EQU 0xF0+7 ;B Bit 7

PWMCFG .EQU 0xF1              ;PWM Configuration Register
   ETADC = 0x40 ;Enable ADC Trigger
   CBIF  = 0x80 ;Counter Overflow Interrupt Flag

PCA_PWM0 .EQU 0xF2            ;PCA Module 0 PWM Register
   EPC0L   = 0x01 ;MSB of comparison vaule in PWM mode
   EPC0H   = 0x02 ;MSB of reload vaule in PWM mode
   XCCAP0L = 0x0C ;9th & 10th bit of comparison value in PWM mode
   XCCAP0H = 0x30 ;9th & 10th bit of reload value in PWM mode
   EBS0_0  = 0x40 ;Number of PCAn PWM Bits Control 0
   EBS0_1  = 0x80 ;Number of PCAn PWM Bits Control 1
   EBS0    = 0xC0 ;Number of PCAn PWM Bits Control

PCA_PWM1 .EQU 0xF3            ;PCA Module 1 PWM Register
   EPC1L   = 0x01 ;MSB of comparison vaule in PWM mode
   EPC1H   = 0x02 ;MSB of reload vaule in PWM mode
   XCCAP1L = 0x0C ;9th & 10th bit of comparison value in PWM mode
   XCCAP1H = 0x30 ;9th & 10th bit of reload value in PWM mode
   EBS1_0  = 0x40 ;Number of PCAn PWM Bits Control 0
   EBS1_1  = 0x80 ;Number of PCAn PWM Bits Control 1
   EBS1    = 0xC0 ;Number of PCAn PWM Bits Control

PCA_PWM2 .EQU 0xF4            ;PCA Module 2 PWM Register
   EPC2L   = 0x01 ;MSB of comparison vaule in PWM mode
   EPC2H   = 0x02 ;MSB of reload vaule in PWM mode
   XCCAP2L = 0x0C ;9th & 10th bit of comparison value in PWM mode
   XCCAP2H = 0x30 ;9th & 10th bit of reload value in PWM mode
   EBS2_0  = 0x40 ;Number of PCAn PWM Bits Control 0
   EBS2_1  = 0x80 ;Number of PCAn PWM Bits Control 1
   EBS2    = 0xC0 ;Number of PCAn PWM Bits Control

PCA_PWM3 .EQU 0xF5            ;PCA Module 3 PWM Register
   EPC3L   = 0x01 ;MSB of comparison vaule in PWM mode
   EPC3H   = 0x02 ;MSB of reload vaule in PWM mode
   XCCAP3L = 0x0C ;9th & 10th bit of comparison value in PWM mode
   XCCAP3H = 0x30 ;9th & 10th bit of reload value in PWM mode
   EBS3_0  = 0x40 ;Number of PCAn PWM Bits Control 0
   EBS3_1  = 0x80 ;Number of PCAn PWM Bits Control 1
   EBS3    = 0xC0 ;Number of PCAn PWM Bits Control

PWMIF .EQU 0xF6               ;PWM interrupt Flag Register
   C0IF = 0x01 ;PWM 0 Interrupt Flag
   C1IF = 0x02 ;PWM 1 Interrupt Flag
   C2IF = 0x04 ;PWM 2 Interrupt Flag
   C3IF = 0x08 ;PWM 3 Interrupt Flag
   C4IF = 0x10 ;PWM 4 Interrupt Flag
   C5IF = 0x20 ;PWM 5 Interrupt Flag
   C6IF = 0x40 ;PWM 6 Interrupt Flag
   C7IF = 0x80 ;PWM 7 Interrupt Flag

PWMFDCR .EQU 0xF7             ;PWM Fault Detection Control Register
   FDIF    = 0x01 ;Fault Detect Interrupt Flag
   FDIO    = 0x02 ;Enable Fault Detect Input-Output on P3.5
   FDCMP   = 0x04 ;Enable Fault Detect Comparator
   EFDI    = 0x08 ;Enable Fault Detect Interrupt
   FLTFLIO = 0x10 ;PWM Output Port Action Upon Fault
   ENFD    = 0x20 ;Enable External Fault Detect
   INVIO   = 0x40 ;Input P3.5 Fault Signal Polariy
   INVCMP  = 0x80 ;Comparator Fault Signal Polarity

P7 .EQU 0xF8                  ;Port 7
   P70 .EQU 0xF8+0 ;Port 7 Bit 0
   P71 .EQU 0xF8+1 ;Port 7 Bit 1
   P72 .EQU 0xF8+2 ;Port 7 Bit 2
   P73 .EQU 0xF8+3 ;Port 7 Bit 3
   P74 .EQU 0xF8+4 ;Port 7 Bit 4
   P75 .EQU 0xF8+5 ;Port 7 Bit 5
   P76 .EQU 0xF8+6 ;Port 7 Bit 6
   P77 .EQU 0xF8+7 ;Port 7 Bit 7
   P7_0 .EQU 0xF8+0 ;Port 7 Bit 0
   P7_1 .EQU 0xF8+1 ;Port 7 Bit 1
   P7_2 .EQU 0xF8+2 ;Port 7 Bit 2
   P7_3 .EQU 0xF8+3 ;Port 7 Bit 3
   P7_4 .EQU 0xF8+4 ;Port 7 Bit 4
   P7_5 .EQU 0xF8+5 ;Port 7 Bit 5
   P7_6 .EQU 0xF8+6 ;Port 7 Bit 6
   P7_7 .EQU 0xF8+7 ;Port 7 Bit 7
; See device specific data sheet for additional pin names.

CH .EQU 0xF9                  ;PCA Counter High Byte

CCAP0H .EQU 0xFA              ;PCA Module 0 Capture-Compare Register High Byte

CCAP1H .EQU 0xFB              ;PCA Module 1 Capture-Compare Register High Byte

CCAP2H .EQU 0xFC              ;PCA Module 2 Capture-Compare Register High Byte

CCAP3H .EQU 0xFD              ;PCA Module 3 Capture-Compare Register High Byte

PWMCR .EQU 0xFE               ;PWM Control register
   ECBI  = 0x40 ;Enable Return to Zero Interrupt
   ENPWM = 0x80 ;Enable PWM

RSTCFG .EQU 0xFF              ;Reset Configuration Register
   LVDS   = 0x03 ;Low Voltage Detection Threshold
   P54RST = 0x10 ;Port 5 Pin 4 Reset Pin Enable
   ENLVR  = 0x40 ;Enable Low Voltage Reset

; The following special function registers are in the extended RAM area.
; You need to set bit7 of P_SW2 EAXFR to 1 to read and write them normally.
CKSEL .EQU 0xfe00 ;Clock Select Register
   MCKSEL   = 0x03 ;Main Clock Source Selection
   MCLKO_S  = 0x08 ;Main Clock Output Pin Selection
   MCLKODIV = 0xF0 ;Main Clock Division Coefficient
CLKDIV .EQU 0xfe01 ;Clock Frequency Division Register
IRC24MCR .EQU 0xfe02 ;Internal 24M Oscillator Control Register
   IRC24MST = 0x01 ;Internal RC 24 MHhz Oscillator Stability Indicator
   ENIRC24M = 0x80 ;Enable Internal RC 24 MHz Clock Source
XOSCCR .EQU 0xfe03 ;External Oscillator Control Register
   XOSCST = 0x01 ;External Crystal Oscillator Stability Indicator
   XITYPE = 0x40 ;External Clock Source Type
   ENXOSC = 0x80 ;Enable External Crystal Clock Source
IRC32KCR .EQU 0xfe04 ;Internal 32K Oscillator Control Register
   IRC32KST = 0x01 ;Internal RC 32 KHz Oscillator Stability Indicator
   ENIRC32K = 0x80 ;Enable Internal RC 32 KHz Clock Source
P0PU .EQU 0xfe10 ;Port 0 Pull-up Resistor Control Register
   P00PU = 0x01 ;
   P01PU = 0x02 ;
   P02PU = 0x04 ;
   P03PU = 0x08 ;
   P04PU = 0x10 ;
   P05PU = 0x20 ;
   P06PU = 0x40 ;
   P07PU = 0x80 ;
P1PU .EQU 0xfe11 ;Port 1 Pull-up Resistor Control Register
   P10PU = 0x01 ;
   P11PU = 0x02 ;
   P12PU = 0x04 ;
   P13PU = 0x08 ;
   P14PU = 0x10 ;
   P15PU = 0x20 ;
   P16PU = 0x40 ;
   P17PU = 0x80 ;
P2PU .EQU 0xfe12 ;Port 2 Pull-up Resistor Control Register
   P20PU = 0x01 ;
   P21PU = 0x02 ;
   P22PU = 0x04 ;
   P23PU = 0x08 ;
   P24PU = 0x10 ;
   P25PU = 0x20 ;
   P26PU = 0x40 ;
   P27PU = 0x80 ;
P3PU .EQU 0xfe13 ;Port 3 Pull-up Resistor Control Register
   P30PU = 0x01 ;
   P31PU = 0x02 ;
   P32PU = 0x04 ;
   P33PU = 0x08 ;
   P34PU = 0x10 ;
   P35PU = 0x20 ;
   P36PU = 0x40 ;
   P37PU = 0x80 ;
P4PU .EQU 0xfe14 ;Port 4 Pull-up Resistor Control Register
   P40PU = 0x01 ;
   P41PU = 0x02 ;
   P42PU = 0x04 ;
   P43PU = 0x08 ;
   P44PU = 0x10 ;
   P45PU = 0x20 ;
   P46PU = 0x40 ;
   P47PU = 0x80 ;
P5PU .EQU 0xfe15 ;Port 5 Pull-up Resistor Control Register
   P50PU = 0x01 ;
   P51PU = 0x02 ;
   P52PU = 0x04 ;
   P53PU = 0x08 ;
   P54PU = 0x10 ;
   P55PU = 0x20 ;
P6PU .EQU 0xfe16 ;Port 6 Pull-up Resistor Control Register
   P60PU = 0x01 ;
   P61PU = 0x02 ;
   P62PU = 0x04 ;
   P63PU = 0x08 ;
   P64PU = 0x10 ;
   P65PU = 0x20 ;
   P66PU = 0x40 ;
   P67PU = 0x80 ;
P7PU .EQU 0xfe17 ;Port 7 Pull-up Resistor Control Register
   P70PU = 0x01 ;
   P71PU = 0x02 ;
   P72PU = 0x04 ;
   P73PU = 0x08 ;
   P74PU = 0x10 ;
   P75PU = 0x20 ;
   P76PU = 0x40 ;
   P77PU = 0x80 ;
P0NCS .EQU 0xfe18 ;Port 0 Schmidt Trigger Control Register
   P00NCS = 0x01 ;
   P01NCS = 0x02 ;
   P02NCS = 0x04 ;
   P03NCS = 0x08 ;
   P04NCS = 0x10 ;
   P05NCS = 0x20 ;
   P06NCS = 0x40 ;
   P07NCS = 0x80 ;
P1NCS .EQU 0xfe19 ;Port 1 Schmidt Trigger Control Register
   P10NCS = 0x01 ;
   P11NCS = 0x02 ;
   P12NCS = 0x04 ;
   P13NCS = 0x08 ;
   P14NCS = 0x10 ;
   P15NCS = 0x20 ;
   P16NCS = 0x40 ;
   P17NCS = 0x80 ;
P2NCS .EQU 0xfe1a ;Port 2 Schmidt Trigger Control Register
   P20NCS = 0x01 ;
   P21NCS = 0x02 ;
   P22NCS = 0x04 ;
   P23NCS = 0x08 ;
   P24NCS = 0x10 ;
   P25NCS = 0x20 ;
   P26NCS = 0x40 ;
   P27NCS = 0x80 ;
P3NCS .EQU 0xfe1b ;Port 3 Schmidt Trigger Control Register
   P30NCS = 0x01 ;
   P31NCS = 0x02 ;
   P32NCS = 0x04 ;
   P33NCS = 0x08 ;
   P34NCS = 0x10 ;
   P35NCS = 0x20 ;
   P36NCS = 0x40 ;
   P37NCS = 0x80 ;
P4NCS .EQU 0xfe1c ;Port 4 Schmidt Trigger Control Register
   P40NCS = 0x01 ;
   P41NCS = 0x02 ;
   P42NCS = 0x04 ;
   P43NCS = 0x08 ;
   P44NCS = 0x10 ;
   P45NCS = 0x20 ;
   P46NCS = 0x40 ;
   P47NCS = 0x80 ;
P5NCS .EQU 0xfe1d ;Port 5 Schmidt Trigger Control Register
   P50NCS = 0x01 ;
   P51NCS = 0x02 ;
   P52NCS = 0x04 ;
   P53NCS = 0x08 ;
   P54NCS = 0x10 ;
   P55NCS = 0x20 ;
P6NCS .EQU 0xfe1e ;Port 6 Schmidt Trigger Control Register
   P60NCS = 0x01 ;
   P61NCS = 0x02 ;
   P62NCS = 0x04 ;
   P63NCS = 0x08 ;
   P64NCS = 0x10 ;
   P65NCS = 0x20 ;
   P66NCS = 0x40 ;
   P67NCS = 0x80 ;
P7NCS .EQU 0xfe1f ;Port 7 Schmidt Trigger Control Register
   P70NCS = 0x01 ;
   P71NCS = 0x02 ;
   P72NCS = 0x04 ;
   P73NCS = 0x08 ;
   P74NCS = 0x10 ;
   P75NCS = 0x20 ;
   P76NCS = 0x40 ;
   P77NCS = 0x80 ;
I2CCFG .EQU 0xfe80 ;I2C configuration
   MSSPEED = 0x3F ;I2C Bus Speed Selection
   MSSL    = 0x40 ;Master or Slave Mode Select
   ENI2C   = 0x80 ;Enable I2C Functionality
I2CMSCR .EQU 0xfe81 ;I2C Master Control
   MSCMD = 0x0F ;Master Command Execution
   EMSI  = 0x80 ;Enable Master Interrupt
I2CMSST .EQU 0xfe82 ;I2C Master Status
   MSACKO = 0x01 ;Master Mode Output ACK
   MSACKI = 0x02 ;Master Mode Input ACK
   MSIF   = 0x40 ;Master Mode Interrupt Flag
   MSBUSY = 0x80 ;Master Busy Flag
I2CSLCR .EQU 0xfe83 ;I2C Slave Control
   SLRST = 0x01 ;Slave Reset Mode
   ESTOI = 0x08 ;Enable Interrupt after STOP is received in Slave Mode
   ETXI  = 0x10 ;Enable Interrupt after data is sent in Slave Mode
   ERXI  = 0x20 ;Enable Interrupt after data is received in Slave Mode
   ESTAI = 0x40 ;Enable Interrupt after START is received in Slave Mode
I2CSLST .EQU 0xfe84 ;I2C Slave Status
   SLACKO = 0x01 ;Slave ACK Output Flag
   SLACKI = 0x02 ;Slave ACK Input Flag
   TXING  = 0x04 ;Undocumented
   STOIF  = 0x08 ;STOP signal Interrupt Flag
   TXIF   = 0x10 ;Transmit Data Interrupt Flag
   RXIF   = 0x20 ;Received Data Interrupt Flag
   STAIF  = 0x40 ;START Interrupt Flag in Slave Mode
   SLBUSY = 0x80 ;Slave Busy Flag
I2CSLADR .EQU 0xfe85 ;I2C Slave Address
   MA    = 0x01 ;Slave Device Address Matching
   SLADR = 0xFE ;Slave Device Address
I2CTXD .EQU 0xfe86 ;I2C Data Transmit Register
I2CRXD .EQU 0xfe87 ;I2C Data Receive Register
I2CMSAUX .EQU 0xfe88 ;I2C Master Auxiliary Control
   WDTA = 0x01 ;I2C Write Data Automatic Send Enable in Master Module
PWM0T1 .EQU 0xff00 ;PWM 0 Timer 1 Count Value Word
PWM0T1H .EQU 0xff00 ;PWM 0 Timer 1 Count Value High Byte
PWM0T1L .EQU 0xff01 ;PWM 0 Timer 1 Count Value Low Byte
PWM0T2 .EQU 0xff02 ;PWM 0 Timer 2 Count Value Word
PWM0T2H .EQU 0xff02 ;PWM 0 Timer 2 Count Value High Byte
PWM0T2L .EQU 0xff03 ;PWM 0 Timer 2 Count Value Low Byte
PWM0CR .EQU 0xff04 ;PWM 0 Control Register
   EC0T1SI = 0x01 ;Trigger Point 1 Interrupt Enable
   EC0T2SI = 0x02 ;Trigger Point 2 Interrupt Enable
   EC0I    = 0x04 ;Interrupt Enable
   C0_S    = 0x18 ;Output Pin Selection
   C0INI   = 0x40 ;Initial Output Level
   ENC0O   = 0x80 ;Output Enable
PWM0HLD .EQU 0xff05 ;PWM 0 Level Hold Control
   HC0L = 0x01 ; Hold Low Override
   HC0H = 0x02 ; Hold High Override
PWM1T1 .EQU 0xff10 ;PWM 1 Timer 1 Count Value Word
PWM1T1H .EQU 0xff10 ;PWM 1 Timer 1 Count Value High Byte
PWM1T1L .EQU 0xff11 ;PWM 1 Timer 1 Count Value Low Byte
PWM1T2 .EQU 0xff12 ;PWM 1 Timer 2 Count Value Word
PWM1T2H .EQU 0xff12 ;PWM 1 Timer 2 Count Value High Byte
PWM1T2L .EQU 0xff13 ;PWM 1 Timer 2 Count Value Low Byte
PWM1CR .EQU 0xff14 ;PWM 1 Control Register
   EC1T1SI = 0x01 ;Trigger Point 1 Interrupt Enable
   EC1T2SI = 0x02 ;Trigger Point 2 Interrupt Enable
   EC1I    = 0x04 ;Interrupt Enable
   C1_S    = 0x18 ;Output Pin Selection
   C1INI   = 0x40 ;Initial Output Level
   ENC1O   = 0x80 ;Output Enable
PWM1HLD .EQU 0xff15 ;PWM 1 Level Hold Control
   HC1L = 0x01 ; Hold Low Override
   HC1H = 0x02 ; Hold High Override
PWM2T1 .EQU 0xff20 ;PWM 2 Timer 1 Count Value Word
PWM2T1H .EQU 0xff20 ;PWM 2 Timer 1 Count Value High Byte
PWM2T1L .EQU 0xff21 ;PWM 2 Timer 1 Count Value Low Byte
PWM2T2 .EQU 0xff22 ;PWM 2 Timer 2 Count Value Word
PWM2T2H .EQU 0xff22 ;PWM 2 Timer 2 Count Value High Byte
PWM2T2L .EQU 0xff23 ;PWM 2 Timer 2 Count Value Low Byte
PWM2CR .EQU 0xff24 ;PWM 2 Control Register
   EC2T1SI = 0x01 ;Trigger Point 1 Interrupt Enable
   EC2T2SI = 0x02 ;Trigger Point 2 Interrupt Enable
   EC2I    = 0x04 ;Interrupt Enable
   C2_S    = 0x18 ;Output Pin Selection
   C2INI   = 0x40 ;Initial Output Level
   ENC2O   = 0x80 ;Output Enable
PWM2HLD .EQU 0xff25 ;PWM 2 Level Hold Control
   HC2L = 0x01 ; Hold Low Override
   HC2H = 0x02 ; Hold High Override
PWM3T1 .EQU 0xff30 ;PWM 3 Timer 1 Count Value Word
PWM3T1H .EQU 0xff30 ;PWM 3 Timer 1 Count Value High Byte
PWM3T1L .EQU 0xff31 ;PWM 3 Timer 1 Count Value Low Byte
PWM3T2 .EQU 0xff32 ;PWM 3 Timer 2 Count Value Word
PWM3T2H .EQU 0xff32 ;PWM 2 Timer 2 Count Value High Byte
PWM3T2L .EQU 0xff33 ;PWM 3 Timer 2 Count Value Low Byte
PWM3CR .EQU 0xff34 ;PWM 3 Control Register
   EC3T1SI = 0x01 ;Trigger Point 1 Interrupt Enable
   EC3T2SI = 0x02 ;Trigger Point 2 Interrupt Enable
   EC3I    = 0x04 ;Interrupt Enable
   C3_S    = 0x18 ;Output Pin Selection
   C3INI   = 0x40 ;Initial Output Level
   ENC3O   = 0x80 ;Output Enable
PWM3HLD .EQU 0xff35 ;PWM 3 Level Hold Control
   HC3L = 0x01 ; Hold Low Override
   HC3H = 0x02 ; Hold High Override
PWM4T1 .EQU 0xff40 ;PWM 4 Timer 1 Count Value Word
PWM4T1H .EQU 0xff40 ;PWM 4 Timer 1 Count Value High Byte
PWM4T1L .EQU 0xff41 ;PWM 4 Timer 1 Count Value Low Byte
PWM4T2 .EQU 0xff42 ;PWM 4 Timer 2 Count Value Word
PWM4T2H .EQU 0xff42 ;PWM 4 Timer 2 Count Value High Byte
PWM4T2L .EQU 0xff43 ;PWM 4 Timer 2 Count Value Low Byte
PWM4CR .EQU 0xff44 ;PWM 4 Control Register
   EC4T1SI = 0x01 ;Trigger Point 1 Interrupt Enable
   EC4T2SI = 0x02 ;Trigger Point 2 Interrupt Enable
   EC4I    = 0x04 ;Interrupt Enable
   C4_S    = 0x18 ;Output Pin Selection
   C4INI   = 0x40 ;Initial Output Level
   ENC4O   = 0x80 ;Output Enable
PWM4HLD .EQU 0xff45 ;PWM4 Level Hold Control
   HC4L = 0x01 ; Hold Low Override
   HC4H = 0x02 ; Hold High Override
PWM5T1 .EQU 0xff50 ;PWM 5 Timer 1 Count Value Word
PWM5T1H .EQU 0xff50 ;PWM 5 Timer 1 Count Value High Byte
PWM5T1L .EQU 0xff51 ;PWM 5 Timer 1 Count Value Low Byte
PWM5T2 .EQU 0xff52 ;PWM 5 Timer 2 Count Value Word
PWM5T2H .EQU 0xff52 ;PWM 5 Timer 2 Count Value High Byte
PWM5T2L .EQU 0xff53 ;PWM 5 Timer 2 Count Value Low Byte
PWM5CR .EQU 0xff54 ;PWM 5 Control Register
   EC5T1SI = 0x01 ;Trigger Point 1 Interrupt Enable
   EC5T2SI = 0x02 ;Trigger Point 2 Interrupt Enable
   EC5I    = 0x04 ;Interrupt Enable
   C5_S    = 0x18 ;Output Pin Selection
   C5INI   = 0x40 ;Initial Output Level
   ENC5O   = 0x80 ;Output Enable
PWM5HLD .EQU 0xff55 ;PWM5 Level Hold Control
   HC5L = 0x01 ; Hold Low Override
   HC5H = 0x02 ; Hold High Override
PWM6T1 .EQU 0xff60 ;PWM 6 Timer 1 Count Value Word
PWM6T1H .EQU 0xff60 ;PWM 6 Timer 1 Count Value High Byte
PWM6T1L .EQU 0xff61 ;PWM 6 Timer 1 Count Value Low Byte
PWM6T2 .EQU 0xff62 ;PWM 6 Timer 2 Count Value Word
PWM6T2H .EQU 0xff62 ;PWM 6 Timer 2 Count Value High Byte
PWM6T2L .EQU 0xff63 ;PWM 6 Timer 2 Count Value Low Byte
PWM6CR .EQU 0xff64 ;PWM 6 Control Register
   EC6T1SI = 0x01 ;Trigger Point 1 Interrupt Enable
   EC6T2SI = 0x02 ;Trigger Point 2 Interrupt Enable
   EC6I    = 0x04 ;Interrupt Enable
   C6_S    = 0x18 ;Output Pin Selection
   C6INI   = 0x40 ;Initial Output Level
   ENC6O   = 0x80 ;Output Enable
PWM6HLD .EQU 0xff65 ;PWM6 Level Hold Control
   HC6L = 0x01 ; Hold Low Override
   HC6H = 0x02 ; Hold High Override
PWM7T1 .EQU 0xff70 ;PWM 7 Timer 1 Count Value Word
PWM7T1H .EQU 0xff70 ;PWM 7 Timer 1 Count Value High Byte
PWM7T1L .EQU 0xff71 ;PWM 7 Timer 1 Count Value Low Byte
PWM7T2 .EQU 0xff72 ;PWM 7 Timer 2 Count Value Word
PWM7T2H .EQU 0xff72 ;PWM 7 Timer 2 Count Value High Byte
PWM7T2L .EQU 0xff73 ;PWM 7 Timer 2 Count Value Low Byte
PWM7CR .EQU 0xff74 ;PWM 7 Control Register
   EC7T1SI = 0x01 ;Trigger Point 1 Interrupt Enable
   EC7T2SI = 0x02 ;Trigger Point 2 Interrupt Enable
   EC7I    = 0x04 ;Interrupt Enable
   C7_S    = 0x18 ;Output Pin Selection
   C7INI   = 0x40 ;Initial Output Level
   ENC7O   = 0x80 ;Output Enable
PWM7HLD .EQU 0xff75 ;PWM 7 Level Hold Control
   HC7L = 0x01 ; Hold Low Override
   HC7H = 0x02 ; Hold High Override
PWMC .EQU 0xfff0 ;PWM Counter Word
PWMCH .EQU 0xfff0 ;PWM Counter High Byte
PWMCL .EQU 0xfff1 ;PWM Counter Low Byte
PWMCKS .EQU 0xfff2 ;PWM Clock Selection Register
   PWM_PS = 0x0F ;PWM System Clock Prescaler
   SELT2  = 0x10 ;PWM Clock Source Selection
TADCP .EQU 0xfff3 ;Trigger ADC Count Value Word
TADCPH .EQU 0xfff3 ;Trigger ADC Count Value High Byte
TADCPL .EQU 0xfff4 ;Trigger ADC Count Value Low Byte

;Interrupt_Address = ( Interrupt_Number * 8 ) + 3
;Vectors are named after their corresponding IE, IP or IR register bit so
;that we don't have to invent names and can be more consistent across MCUs.
   X0_VECTOR  = 0  ; 0x03 External Interrupt 0
   T0_VECTOR  = 1  ; 0x0B Timer 0
   X1_VECTOR  = 2  ; 0x13 External Interrupt 1
   T1_VECTOR  = 3  ; 0x1B Timer 1
   S_VECTOR   = 4  ; 0x23 Serial Port 1
   ADC_VECTOR = 5  ; 0x2B Analog to Digital Converter
   LVD_VECTOR = 6  ; 0x33 Low Voltage Detect
   PCA_VECTOR = 7  ; 0x3B Programmable Counter Array (CCP)
   S2_VECTOR  = 8  ; 0x43 Serial Port 2
   SPI_VECTOR = 9  ; 0x4B Serial Peripheral Interface
   X2_VECTOR  = 10 ; 0x53 External Interrupt 2
   X3_VECTOR  = 11 ; 0x5B External Interrupt 3
   T2_VECTOR  = 12 ; 0x63 Timer 2
   ;    -     = 13 ; 0x6B     -
   ;    -     = 14 ; 0x73 System Reserved
   ;    -     = 15 ; 0x7B System Reserved
   X4_VECTOR  = 16 ; 0x83 External Interrupt 4
   S3_VECTOR  = 17 ; 0x8B Serial Port 3
   S4_VECTOR  = 18 ; 0x93 Serial Port 4
   T3_VECTOR  = 19 ; 0x9B Timer 3
   T4_VECTOR  = 20 ; 0xA3 Timer 4
   CMP_VECTOR = 21 ; 0xAB Comparator
   PWM_VECTOR = 22 ; 0xB3 Pulse Width Modulator
   PFD_VECTOR = 23 ; 0xBB PWM Fault Detect
   I2C_VECTOR = 24 ; 0xC3 Inter-Integrated Circuit (IIC)

;.endif
