; PIO compatible header file STC8G.asm 20210829.
; For use with all STC8Gxx series.

;.ifndef STC8G_ASM
;.define STC8G_ASM

; SFR Definition               Description

P0 .EQU 0x80                  ;Port 0
;  ACH0 .EQU 0x80+0 ;ADC Channel 8
;  ACH1 .EQU 0x80+1 ;ADC Channel 9
;  ACH2 .EQU 0x80+2 ;ADC Channel 10
;  ACH3 .EQU 0x80+3 ;ADC Channel 11
;  ACH4 .EQU 0x80+4 ;ADC Channel 12
;  ACH5 .EQU 0x80+5 ;ADC Channel 13
;  ACH6 .EQU 0x80+6 ;ADC Channel 14
;  ADC0 .EQU 0x80+0 ;AtoD Channel 8
;  ADC1 .EQU 0x80+1 ;AtoD Channel 9
;  ADC2 .EQU 0x80+2 ;AtoD Channel 10
;  ADC3 .EQU 0x80+3 ;AtoD Channel 11
;  ADC4 .EQU 0x80+4 ;AtoD Channel 12
;  ADC5 .EQU 0x80+5 ;AtoD Channel 13
;  ADC6 .EQU 0x80+6 ;AtoD Channel 14
;  AIN0 .EQU 0x80+0 ;Analog Input 8
;  AIN1 .EQU 0x80+1 ;Analog Input 9
;  AIN2 .EQU 0x80+2 ;Analog Input 10
;  AIN3 .EQU 0x80+3 ;Analog Input 11
;  AIN4 .EQU 0x80+4 ;Analog Input 12
;  AIN5 .EQU 0x80+5 ;Analog Input 13
;  AIN6 .EQU 0x80+6 ;Analog Input 14
   P00 .EQU 0x80+0 ;Port 0 Bit 0
   P01 .EQU 0x80+1 ;Port 0 Bit 1
   P02 .EQU 0x80+2 ;Port 0 Bit 2
   P03 .EQU 0x80+3 ;Port 0 Bit 3
   P04 .EQU 0x80+4 ;Port 0 Bit 4
   P05 .EQU 0x80+5 ;Port 0 Bit 5
   P06 .EQU 0x80+6 ;Port 0 Bit 6
   P07 .EQU 0x80+7 ;Port 0 Bit 7
   P0_0 .EQU 0x80+0 ;Port 0 Bit 0
   P0_1 .EQU 0x80+1 ;Port 0 Bit 1
   P0_2 .EQU 0x80+2 ;Port 0 Bit 2
   P0_3 .EQU 0x80+3 ;Port 0 Bit 3
   P0_4 .EQU 0x80+4 ;Port 0 Bit 4
   P0_5 .EQU 0x80+5 ;Port 0 Bit 5
   P0_6 .EQU 0x80+6 ;Port 0 Bit 6
   P0_7 .EQU 0x80+7 ;Port 0 Bit 7
; See device specific data sheet for additional pin names.

SP .EQU 0x81                  ;Stack Pointer

;DPTR .EQU 0x82               ;Date Pointer Word
DPL .EQU 0x82                 ;Data Pointer Low Byte

DPH .EQU 0x83                 ;Data Pointer High Byte

S4CON .EQU 0x84               ;Serial Port 4 Control Register
   S4RI  = 0x01 ;Serial Port 4 Receive Interrupt Flag
   S4TI  = 0x02 ;Serial Port 4 Transmit Interrupt Flag
   S4RB8 = 0x04 ;Serial Port 4 Receive Bit 8 Data
   S4TB8 = 0x08 ;Serial Port 4 Transmit Bit 8 Data
   S4REN = 0x10 ;Serial Port 4 Receive Enable
   S4SM2 = 0x20 ;Serial Port 4 Select Mode Bit 2
   S4ST4 = 0x40 ;Serial Port 4 Select Timer 4
   S4SM0 = 0x80 ;Serial Port 4 Select Mode Bit 0

S4BUF .EQU 0x85               ;Serial Port 4 Data Register

PCON .EQU 0x87                ;Power Control Register
   IDL   = 0x01 ;Idle Mode Control
   PD    = 0x02 ;Power Down Mode Control
   GF0   = 0x04 ;User Defined Gereral Purpose Flag 0
   GF1   = 0x08 ;User Defined General Purpose Flag 1
   POF   = 0x10 ;Power On Flag
   LVDF  = 0x20 ;Low Voltage Detect Flag
   SMOD0 = 0x40 ;Frame Error Detection Control
   SMOD  = 0x80 ;Double Baudrate of Serial Port 1

TCON .EQU 0x88                ;Timer Control
   IT0 .EQU 0x88+0 ;Interrupt 0 Type
   IE0 .EQU 0x88+1 ;Interrupt 0 Edge
   IT1 .EQU 0x88+2 ;Interrupt 1 Type
   IE1 .EQU 0x88+3 ;Interrupt 1 Edge
   TR0 .EQU 0x88+4 ;Timer 0 Run
   TF0 .EQU 0x88+5 ;Timer 0 Flag
   TR1 .EQU 0x88+6 ;Timer 1 Run
   TF1 .EQU 0x88+7 ;Timer 1 Flag

TMOD .EQU 0x89                ;Timer Mode
   T0_M0   = 0x01 ;Timer 0 Mode 0
   T0_M1   = 0x02 ;Timer 0 Mode 1
   T0_M    = 0x03 ;Timer 0 Mode
   T0_CT   = 0x04 ;Timer 0 Counter Timer
   T0_GATE = 0x08 ;Timer 0 Gate
   T1_M0   = 0x10 ;Timer 1 Mode 0
   T1_M1   = 0x20 ;Timer 1 Mode 1
   T1_M    = 0x30 ;Timer 1 Mode
   T1_CT   = 0x40 ;Timer 1 Counter Timer
   T1_GATE = 0x80 ;Timer 1 Gate
   M00   = 0x01 ;Mode 0 Timer 0
   M10   = 0x02 ;Mode 1 Timer 0
   M0    = 0x03 ;Timer 0 Mode
   CT0   = 0x04 ;Counter Timer 0
   GATE0 = 0x08 ;Gate 0
   M01   = 0x10 ;Mode 1 Timer 1
   M11   = 0x20 ;Mode 1 Timer 1
   M1    = 0x30 ;Timer 1 Mode
   CT1   = 0x40 ;Counter Timer 1
   GATE1 = 0x80 ;Gate 1

TL0 .EQU 0x8A                 ;T0 Low Byte

TL1 .EQU 0x8B                 ;T1 Low Byte

TH0 .EQU 0x8C                 ;T0 High Byte

TH1 .EQU 0x8D                 ;T1 High Byte

AUXR .EQU 0x8E                ;Auxiliary Register
   S1ST2     = 0x01 ;Serial Port 1 Baud Rate Generator Select
   EXTRAM    = 0x02 ;Extended RAM Access Control
   T2x12     = 0x04 ;Timer 2 Clock x12 Prescaler Bypass
   T2_CT     = 0x08 ;Timer 2 Counter or Timer Mode Select
   T2R       = 0x10 ;Timer 2 Run Control
   UART_M0x6 = 0x20 ;UART 1 Mode 0 Baudrate Prescaler Select
   T1x12     = 0x40 ;Timer 1 Clock x12 Prescaler Bypass
   T0x12     = 0x80 ;Timer 0 Clock x12 Prescaler Bypass

INTCLKO .EQU 0x8F             ;Interrupt and Clock Output Control Register
   T0CLKO = 0x01 ;Timer 0 Clock Output Control
   T1CLKO = 0x02 ;Timer 1 Clock Output Control
   T2CLKO = 0x04 ;Timer 2 Clock Output Control
   EX2    = 0x10 ;External Interrupt 3 Enable
   EX3    = 0x20 ;External Interrupt 2 Enable
   EX4    = 0x40 ;External Interrupt 4 Enable

P1 .EQU 0x90                  ;Port 1
   ACH0 .EQU 0x90+0 ;ADC Channel 0
   ACH1 .EQU 0x90+1 ;ADC Channel 1
   ACH2 .EQU 0x90+2 ;ADC Channel 2
   ACH3 .EQU 0x90+3 ;ADC Channel 3
   ACH4 .EQU 0x90+4 ;ADC Channel 4
   ACH5 .EQU 0x90+5 ;ADC Channel 5
   ACH6 .EQU 0x90+6 ;ADC Channel 6
   ACH7 .EQU 0x90+7 ;ADC Channel 7
   ADC0 .EQU 0x90+0 ;AtoD Channel 0
   ADC1 .EQU 0x90+1 ;AtoD Channel 1
   ADC2 .EQU 0x90+2 ;AtoD Channel 2
   ADC3 .EQU 0x90+3 ;AtoD Channel 3
   ADC4 .EQU 0x90+4 ;AtoD Channel 4
   ADC5 .EQU 0x90+5 ;AtoD Channel 5
   ADC6 .EQU 0x90+6 ;AtoD Channel 6
   ADC7 .EQU 0x90+7 ;AtoD Channel 7
   AIN0 .EQU 0x90+0 ;Analog Input 0
   AIN1 .EQU 0x90+1 ;Analog Input 1
   AIN2 .EQU 0x90+2 ;Analog Input 2
   AIN3 .EQU 0x90+3 ;Analog Input 3
   AIN4 .EQU 0x90+4 ;Analog Input 4
   AIN5 .EQU 0x90+5 ;Analog Input 5
   AIN6 .EQU 0x90+6 ;Analog Input 6
   AIN7 .EQU 0x90+7 ;Analog Input 7
   P10 .EQU 0x90+0 ;Port 1 Bit 0
   P11 .EQU 0x90+1 ;Port 1 Bit 1
   P12 .EQU 0x90+2 ;Port 1 Bit 2
   P13 .EQU 0x90+3 ;Port 1 Bit 3
   P14 .EQU 0x90+4 ;Port 1 Bit 4
   P15 .EQU 0x90+5 ;Port 1 Bit 5
   P16 .EQU 0x90+6 ;Port 1 Bit 6
   P17 .EQU 0x90+7 ;Port 1 Bit 7
   P1_0 .EQU 0x90+0 ;Port 1 Bit 0
   P1_1 .EQU 0x90+1 ;Port 1 Bit 1
   P1_2 .EQU 0x90+2 ;Port 1 Bit 2
   P1_3 .EQU 0x90+3 ;Port 1 Bit 3
   P1_4 .EQU 0x90+4 ;Port 1 Bit 4
   P1_5 .EQU 0x90+5 ;Port 1 Bit 5
   P1_6 .EQU 0x90+6 ;Port 1 Bit 6
   P1_7 .EQU 0x90+7 ;Port 1 Bit 7
; See device specific data sheet for additional pin names.

P1M1 .EQU 0x91                ;Port 1 Mode Register 1
   P10M1 = 0x01 ;Port 1 bit 0 Mode 1
   P11M1 = 0x02 ;Port 1 bit 1 Mode 1
   P12M1 = 0x04 ;Port 1 bit 2 Mode 1
   P13M1 = 0x08 ;Port 1 bit 3 Mode 1
   P14M1 = 0x10 ;Port 1 bit 4 Mode 1
   P15M1 = 0x20 ;Port 1 bit 5 Mode 1
   P16M1 = 0x40 ;Port 1 bit 6 Mode 1
   P17M1 = 0x80 ;Port 1 bit 7 Mode 1

P1M0 .EQU 0x92                ;Port 1 Mode Register 0
   P10M0 = 0x01 ;Port 1 bit 0 Mode 0
   P11M0 = 0x02 ;Port 1 bit 1 Mode 0
   P12M0 = 0x04 ;Port 1 bit 2 Mode 0
   P13M0 = 0x08 ;Port 1 bit 3 Mode 0
   P14M0 = 0x10 ;Port 1 bit 4 Mode 0
   P15M0 = 0x20 ;Port 1 bit 5 Mode 0
   P16M0 = 0x40 ;Port 1 bit 6 Mode 0
   P17M0 = 0x80 ;Port 1 bit 7 Mode 0

P0M1 .EQU 0x93                ;Port 0 Mode Register 1
   P00M1 = 0x01 ;Port 0 bit 0 Mode 1
   P01M1 = 0x02 ;Port 0 bit 1 Mode 1
   P02M1 = 0x04 ;Port 0 bit 2 Mode 1
   P03M1 = 0x08 ;Port 0 bit 3 Mode 1
   P04M1 = 0x10 ;Port 0 bit 4 Mode 1
   P05M1 = 0x20 ;Port 0 bit 5 Mode 1
   P06M1 = 0x40 ;Port 0 bit 6 Mode 1
   P07M1 = 0x80 ;Port 0 bit 7 Mode 1

P0M0 .EQU 0x94                ;Port 0 Mode Register 0
   P00M0 = 0x01 ;Port 0 bit 0 Mode 0
   P01M0 = 0x02 ;Port 0 bit 1 Mode 0
   P02M0 = 0x04 ;Port 0 bit 2 Mode 0
   P03M0 = 0x08 ;Port 0 bit 3 Mode 0
   P04M0 = 0x10 ;Port 0 bit 4 Mode 0
   P05M0 = 0x20 ;Port 0 bit 5 Mode 0
   P06M0 = 0x40 ;Port 0 bit 6 Mode 0
   P07M0 = 0x80 ;Port 0 bit 7 Mode 0

P2M1 .EQU 0x95                ;Port 2 Mode Register 1
   P20M1 = 0x01 ;Port 2 bit 0 Mode 1
   P21M1 = 0x02 ;Port 2 bit 1 Mode 1
   P22M1 = 0x04 ;Port 2 bit 2 Mode 1
   P23M1 = 0x08 ;Port 2 bit 3 Mode 1
   P24M1 = 0x10 ;Port 2 bit 4 Mode 1
   P25M1 = 0x20 ;Port 2 bit 5 Mode 1
   P26M1 = 0x40 ;Port 2 bit 6 Mode 1
   P27M1 = 0x80 ;Port 2 bit 7 Mode 1

P2M0 .EQU 0x96                ;Port 2 Mode Register 0
   P20M0 = 0x01 ;Port 2 bit 0 Mode 0
   P21M0 = 0x02 ;Port 2 bit 1 Mode 0
   P22M0 = 0x04 ;Port 2 bit 2 Mode 0
   P23M0 = 0x08 ;Port 2 bit 3 Mode 0
   P24M0 = 0x10 ;Port 2 bit 4 Mode 0
   P25M0 = 0x20 ;Port 2 bit 5 Mode 0
   P26M0 = 0x40 ;Port 2 bit 6 Mode 0
   P27M0 = 0x80 ;Port 2 bit 7 Mode 0

SCON .EQU 0x98                ;Serial Control
   RI  .EQU 0x98+0 ;Receive Interrupt
   TI  .EQU 0x98+1 ;Transmit Interrupt
   RB8 .EQU 0x98+2 ;Receive Bit 8
   TB8 .EQU 0x98+3 ;Transmit Bit 8
   REN .EQU 0x98+4 ;Receive Enable
   SM2 .EQU 0x98+5 ;Serial Mode 2
   SM1 .EQU 0x98+6 ;Serial Mode 1
   SM0 .EQU 0x98+7 ;Serial Mode 0
   FE  .EQU 0x98+7 ;Framing Error

SBUF .EQU 0x99                ;Serial Port 1 Data Register

S2CON .EQU 0x9A               ;Serial Port 2 Control Register
   S2RI  = 0x01 ;Serial Port 2 Receive Interrupt Flag
   S2TI  = 0x02 ;Serial Port 2 Transmit Interrupt Flag
   S2RB8 = 0x04 ;Serial Port 2 Receive Bit 8 Data
   S2TB8 = 0x08 ;Serial Port 2 Transmit Bit 8 Data
   S2REN = 0x10 ;Serial Port 2 Receive Enable
   S2SM2 = 0x20 ;Serial Port 2 Select Mode Bit 2
   S2SM0 = 0x80 ;Serial Port 2 Select Mode Bit 0

S2BUF .EQU 0x9B               ;Serial Port 2 Data Register

LIRTRIM .EQU 0x9E             ;Internal RC Clock Frequency Trimming Register

IRTRIM .EQU 0x9F              ;Internal RC Clock Frequency Adjustment Register

P2 .EQU 0xA0                  ;Port 2
   P20 .EQU 0xA0+0 ;Port 2 Bit 0
   P21 .EQU 0xA0+1 ;Port 2 Bit 1
   P22 .EQU 0xA0+2 ;Port 2 Bit 2
   P23 .EQU 0xA0+3 ;Port 2 Bit 3
   P24 .EQU 0xA0+4 ;Port 2 Bit 4
   P25 .EQU 0xA0+5 ;Port 2 Bit 5
   P26 .EQU 0xA0+6 ;Port 2 Bit 6
   P27 .EQU 0xA0+7 ;Port 2 Bit 7
   P2_0 .EQU 0xA0+0 ;Port 2 Bit 0
   P2_1 .EQU 0xA0+1 ;Port 2 Bit 1
   P2_2 .EQU 0xA0+2 ;Port 2 Bit 2
   P2_3 .EQU 0xA0+3 ;Port 2 Bit 3
   P2_4 .EQU 0xA0+4 ;Port 2 Bit 4
   P2_5 .EQU 0xA0+5 ;Port 2 Bit 5
   P2_6 .EQU 0xA0+6 ;Port 2 Bit 6
   P2_7 .EQU 0xA0+7 ;Port 2 Bit 7
; See device specific data sheet for additional pin names.

BUS_SPEED .EQU 0xA1           ;Bus Speed Control Register
   BUSSPEED = 0x07 ;Bus Read-Write Speed Control
   RW_S     = 0xC0 ;Read-Write Control Pin Select

P_SW1 .EQU 0xA2               ;Peripheral Port Switching Register 1
   SPI_S = 0xC0 ;Serial Peripheral Interface Pin Select
   CCP_S = 0x30 ;PCA Pin Select
   S1_S  = 0xC0 ;Serial Port 1 Pin Select

IE .EQU 0xA8                  ;Interrupt Enable
   EX0  .EQU 0xA8+0 ;Enable External 0
   ET0  .EQU 0xA8+1 ;Enable Timer 0
   EX1  .EQU 0xA8+2 ;Enable External 1
   ET1  .EQU 0xA8+3 ;Enable Timer 1
   ES   .EQU 0xA8+4 ;Enable Serial
   EADC .EQU 0xA8+5 ;Enable ADC
   ELVD .EQU 0xA8+6 ;Enable Low Voltage Detect
   EA   .EQU 0xA8+7 ;Enable All

SADDR .EQU 0xA9               ;Slave Address Register

WKTCL .EQU 0xAA               ;Power Down Wakeup Timer Low Byte

WKTCH .EQU 0xAB               ;Power Down Wakeup Timer High Byte
   WKTEN = 0x80 ;Power Down Wakeup Timer Enable

S3CON .EQU 0xAC               ;Serial Port 3 Control Register
   S3RI  = 0x01 ;Serial Port 3 Receive Interrupt Flag
   S3TI  = 0x02 ;Serial Port 3 Transmit Interrupt Flag
   S3RB8 = 0x04 ;Serial Port 3 Receive Bit 8 Data
   S3TB8 = 0x08 ;Serial Port 3 Transmit Bit 8 Data
   S3REN = 0x10 ;Serial Port 3 Receive Enable
   S3SM2 = 0x20 ;Serial Port 3 Select Mode Bit 2
   S3ST3 = 0x40 ;Serial Port 3 Select Timer 3
   S3SM0 = 0x80 ;Serial Port 3 Select Mode Bit 0

S3BUF .EQU 0xAD               ;Serial Port 3 Data Register

TA .EQU 0xAE                  ;Data Pointer Control Register

IE2 .EQU 0xAF                 ;Interrupt Control Register 2
   ES2  = 0x01 ;Enable Serial Port 2 Interrupt
   ESPI = 0x02 ;Enable Serial Peripheral Interface Interrupt
   ET2  = 0x04 ;Enable Timer 2 Interrupt
   ES3  = 0x08 ;Enable Serial Port 3 Interrupt
   ES4  = 0x10 ;Enable Serial Port 4 Interrupt
   ET3  = 0x20 ;Enable Timer 3 Interrupt
   ET4  = 0x40 ;Enable Timer 4 Interrupt
   ECAN = 0x80 ;Enable CAN Interrupt

P3 .EQU 0xB0                  ;Port 3
;  ACH0 .EQU 0xB0+0 ;ADC Channel 8
;  ACH1 .EQU 0xB0+1 ;ADC Channel 9
;  ACH2 .EQU 0xB0+2 ;ADC Channel 10
;  ACH3 .EQU 0xB0+3 ;ADC Channel 11
;  ACH4 .EQU 0xB0+4 ;ADC Channel 12
;  ACH5 .EQU 0xB0+5 ;ADC Channel 13
;  ACH6 .EQU 0xB0+6 ;ADC Channel 14
;  ADC0 .EQU 0xB0+0 ;AtoD Channel 8
;  ADC1 .EQU 0xB0+1 ;AtoD Channel 9
;  ADC2 .EQU 0xB0+2 ;AtoD Channel 10
;  ADC3 .EQU 0xB0+3 ;AtoD Channel 11
;  ADC4 .EQU 0xB0+4 ;AtoD Channel 12
;  ADC5 .EQU 0xB0+5 ;AtoD Channel 13
;  ADC6 .EQU 0xB0+6 ;AtoD Channel 14
;  AIN0 .EQU 0xB0+0 ;Analog Input 8
;  AIN1 .EQU 0xB0+1 ;Analog Input 9
;  AIN2 .EQU 0xB0+2 ;Analog Input 10
;  AIN3 .EQU 0xB0+3 ;Analog Input 11
;  AIN4 .EQU 0xB0+4 ;Analog Input 12
;  AIN5 .EQU 0xB0+5 ;Analog Input 13
;  AIN6 .EQU 0xB0+6 ;Analog Input 14
   P30 .EQU 0xB0+0 ;Port 3 Bit 0
   P31 .EQU 0xB0+1 ;Port 3 Bit 1
   P32 .EQU 0xB0+2 ;Port 3 Bit 2
   P33 .EQU 0xB0+3 ;Port 3 Bit 3
   P34 .EQU 0xB0+4 ;Port 3 Bit 4
   P35 .EQU 0xB0+5 ;Port 3 Bit 5
   P36 .EQU 0xB0+6 ;Port 3 Bit 6
   P37 .EQU 0xB0+7 ;Port 3 Bit 7
   P3_0 .EQU 0xB0+0 ;Port 3 Bit 0
   P3_1 .EQU 0xB0+1 ;Port 3 Bit 1
   P3_2 .EQU 0xB0+2 ;Port 3 Bit 2
   P3_3 .EQU 0xB0+3 ;Port 3 Bit 3
   P3_4 .EQU 0xB0+4 ;Port 3 Bit 4
   P3_5 .EQU 0xB0+5 ;Port 3 Bit 5
   P3_6 .EQU 0xB0+6 ;Port 3 Bit 6
   P3_7 .EQU 0xB0+7 ;Port 3 Bit 7
; See device specific data sheet for additional pin names.

P3M1 .EQU 0xB1                ;Port 3 Mode Register 1
   P30M1 = 0x01 ;Port 3 bit 0 Mode 1
   P31M1 = 0x02 ;Port 3 bit 1 Mode 1
   P32M1 = 0x04 ;Port 3 bit 2 Mode 1
   P33M1 = 0x08 ;Port 3 bit 3 Mode 1
   P34M1 = 0x10 ;Port 3 bit 4 Mode 1
   P35M1 = 0x20 ;Port 3 bit 5 Mode 1
   P36M1 = 0x40 ;Port 3 bit 6 Mode 1
   P37M1 = 0x80 ;Port 3 bit 7 Mode 1

P3M0 .EQU 0xB2                ;Port 3 Mode Register 0
   P30M0 = 0x01 ;Port 3 bit 0 Mode 0
   P31M0 = 0x02 ;Port 3 bit 1 Mode 0
   P32M0 = 0x04 ;Port 3 bit 2 Mode 0
   P33M0 = 0x08 ;Port 3 bit 3 Mode 0
   P34M0 = 0x10 ;Port 3 bit 4 Mode 0
   P35M0 = 0x20 ;Port 3 bit 5 Mode 0
   P36M0 = 0x40 ;Port 3 bit 6 Mode 0
   P37M0 = 0x80 ;Port 3 bit 7 Mode 0

P4M1 .EQU 0xB3                ;Port 4 Mode Register 1
   P40M1 = 0x01 ;Port 4 bit 0 Mode 1
   P41M1 = 0x02 ;Port 4 bit 1 Mode 1
   P42M1 = 0x04 ;Port 4 bit 2 Mode 1
   P43M1 = 0x08 ;Port 4 bit 3 Mode 1
   P44M1 = 0x10 ;Port 4 bit 4 Mode 1
   P45M1 = 0x20 ;Port 4 bit 5 Mode 1
   P46M1 = 0x40 ;Port 4 bit 6 Mode 1
   P47M1 = 0x80 ;Port 4 bit 7 Mode 1

P4M0 .EQU 0xB4                ;Port 4 Mode Register 0
   P40M0 = 0x01 ;Port 4 bit 0 Mode 0
   P41M0 = 0x02 ;Port 4 bit 1 Mode 0
   P42M0 = 0x04 ;Port 4 bit 2 Mode 0
   P43M0 = 0x08 ;Port 4 bit 3 Mode 0
   P44M0 = 0x10 ;Port 4 bit 4 Mode 0
   P45M0 = 0x20 ;Port 4 bit 5 Mode 0
   P46M0 = 0x40 ;Port 4 bit 6 Mode 0
   P47M0 = 0x80 ;Port 4 bit 7 Mode 0

IP2 .EQU 0xB5                 ;Interrupt Priority Register 2
   PS2    = 0x01 ;Serial Port 2 Interrupt Priority
   PSPI   = 0x02 ;Serial Peripheral Interface Interrupt Priority
   PPWM   = 0x04 ;PWM Interrupt Priority
   PPWMFD = 0x08 ;PWM Fault Detect Interrupt Priority
   PX4    = 0x10 ;External Interrupt 4 Priority
   PCMP   = 0x20 ;Comparator Interrupt Priority
   PI2C   = 0x40 ;I2C Interrupt Priority
   PCAN   = 0x80 ;CAN Interrupt Priority

IP2H .EQU 0xB6                ;High Interrupt Priority Register 2
   PS2H    = 0x01 ;Serial Port 2 Interrupt Priority High
   PSPIH   = 0x02 ;Serial Peripheral Interface Interrupt Priority High
   PPWMH   = 0x04 ;PWM Interrupt Priority High
   PPWMFDH = 0x08 ;PWM Fault Detect Interrupt Priority High
   PX4H    = 0x10 ;External Interrupt 4 Priority High
   PCMPH   = 0x20 ;Comparator Interrupt Priority High
   PI2CH   = 0x40 ;I2C Interrupt Priority High
   PCANH   = 0x80 ;CAN Interrupt Priority High

IPH .EQU 0xB7                 ;High Interrupt Priority Register
   PX0H  = 0x01 ;External Interrupt 0 Priority High
   PT0H  = 0x02 ;Timer 0 Interrupt Priority High
   PX1H  = 0x04 ;External Interrupt 1 Priority High
   PT1H  = 0x08 ;Timer 1 Interrupt Priority High
   PSH   = 0x10 ;Serial Port 1 Interrupt Priority High
   PADCH = 0x20 ;ADC Interrupt Priority High
   PLVDH = 0x40 ;Low Voltage Detect Interrupt Priority High
   PPCAH = 0x80 ;CCP-PCA Interrupt Priority High

IP .EQU 0xB8                  ;Interrupt Priority
   PX0  .EQU 0xB8+0 ;Priority External 0
   PT0  .EQU 0xB8+1 ;Priority Timer 0
   PX1  .EQU 0xB8+2 ;Priority External 1
   PT1  .EQU 0xB8+3 ;Priority Timer 1
   PS   .EQU 0xB8+4 ;Priority Serial
   PADC .EQU 0xB8+5 ;Priority ADC
   PLVD .EQU 0xB8+6 ;Priority Low Voltage Detect
   PPCA .EQU 0xB8+7 ;Priority CCP-PCA

SADEN .EQU 0xB9               ;Slave Address Mask Register

P_SW2 .EQU 0xBA               ;Peripheral Port Switching Register 2
   S2_S   = 0x10 ;Serial Port 2 Pin Select
   S3_S   = 0x20 ;Serial Port 3 Pin Select
   S4_S   = 0x40 ;Serial Port 4 Pin Select
   CMPO_S = 0x80 ;Comparator Output Pin Select
   I2C_S  = 0x30 ;I2C Pin Select
   CAN_S  = 0x40 ;CAN Pin Select
   EAXFR  = 0x80 ;Extended RAM Area Transfer Enable

ADC_CONTR .EQU 0xBC           ;Analog to Digital Converter Control Register
   ADC_CHS   = 0x0F ;ADC Analog Channel Select
   ADC_EPWMT = 0x10 ;ADC Enable PWM Trigger
   ADC_FLAG  = 0x20 ;ADC Conversion Complete Flag
   ADC_START = 0x40 ;ADC Start Command
   ADC_POWER = 0x80 ;ADC Power Control

ADC_RES .EQU 0xBD             ;Analog to Digital Converter Result High 8 Bits

ADC_RESL .EQU 0xBE            ;Analog to Digital Converter Result Low 2 Bits

P4 .EQU 0xC0                  ;Port 4
   P40 .EQU 0xC0+0 ;Port 4 Bit 0
   P41 .EQU 0xC0+1 ;Port 4 Bit 1
   P42 .EQU 0xC0+2 ;Port 4 Bit 2
   P43 .EQU 0xC0+3 ;Port 4 Bit 3
   P44 .EQU 0xC0+4 ;Port 4 Bit 4
   P45 .EQU 0xC0+5 ;Port 4 Bit 5
   P46 .EQU 0xC0+6 ;Port 4 Bit 6
   P47 .EQU 0xC0+7 ;Port 4 Bit 7
   P4_0 .EQU 0xC0+0 ;Port 4 Bit 0
   P4_1 .EQU 0xC0+1 ;Port 4 Bit 1
   P4_2 .EQU 0xC0+2 ;Port 4 Bit 2
   P4_3 .EQU 0xC0+3 ;Port 4 Bit 3
   P4_4 .EQU 0xC0+4 ;Port 4 Bit 4
   P4_5 .EQU 0xC0+5 ;Port 4 Bit 5
   P4_6 .EQU 0xC0+6 ;Port 4 Bit 6
   P4_7 .EQU 0xC0+7 ;Port 4 Bit 7
; See device specific data sheet for additional pin names.

WDT_CONTR .EQU 0xC1           ;Watchdog Control Register
   WDTPS0   = 0x01 ;Watchdog Timer Prescaler 0
   WDTPS1   = 0x02 ;Watchdog Timer Prescaler 1
   WDTPS2   = 0x04 ;Watchdog Timer Prescaler 2
   WDT_PS   = 0x07 ;Watchdog Timer Prescaler
   IDL_WDT  = 0x08 ;Watchdog Timer Idle Mode Behavior
   CLR_WDT  = 0x10 ;Clear Watchdog Timer
   EN_WDT   = 0x20 ;Enable Watchdog Timer
   WDT_FLAG = 0x80 ;Watchdog Timer Overflow Flag

IAP_DATA .EQU 0xC2            ;In Application Programming Data
ISP_DATA .EQU 0xC2            ;In System Programming Data

IAP_ADDRH .EQU 0xC3           ;In Application Programming Address High
ISP_ADDRH .EQU 0xC3           ;In System Programming Address High

IAP_ADDRL .EQU 0xC4           ;In Application Programming Address Low
ISP_ADDRL .EQU 0xC4           ;In System Programming Address Low

IAP_CMD .EQU 0xC5             ;In Application Programming Command
ISP_CMD .EQU 0xC5             ;In System Programming Command
   MS0    = 0x01 ;Mode Select 0
   MS1    = 0x02 ;Mode Select 1
   IAPCMD = 0x03 ;In Application Programming Command
; Valid commands follow
   IAP_IDL   = 0x00
   IAP_READ  = 0x01
   IAP_WRITE = 0x02
   IAP_ERASE = 0x03
; End of valid commands

IAP_TRIG .EQU 0xC6            ;In Application Programming Trigger
ISP_TRIG .EQU 0xC6            ;In System Programming Trigger

IAP_CONTR .EQU 0xC7           ;In Application Programming Control
ISP_CONTR .EQU 0xC7           ;In System Programming Control
   WT0      = 0x01 ;Wait 0
   WT1      = 0x02 ;Wait 1
   WT2      = 0x04 ;Wait 2
   IAP_WT   = 0x07 ;In Application Programming Wait
   CMD_FAIL = 0x10 ;Command Fail
   SWRST    = 0x20 ;Software Reset Trigger
   SWBS     = 0x40 ;Software Boot Selection
   IAPEN    = 0x80 ;In Application Programming Enable

P5 .EQU 0xC8                  ;Port 5
   P50 .EQU 0xC8+0 ;Port 5 Bit 0
   P51 .EQU 0xC8+1 ;Port 5 Bit 1
   P52 .EQU 0xC8+2 ;Port 5 Bit 2
   P53 .EQU 0xC8+3 ;Port 5 Bit 3
   P54 .EQU 0xC8+4 ;Port 5 Bit 4
   P55 .EQU 0xC8+5 ;Port 5 Bit 5
   P5_0 .EQU 0xC8+0 ;Port 5 Bit 0
   P5_1 .EQU 0xC8+1 ;Port 5 Bit 1
   P5_2 .EQU 0xC8+2 ;Port 5 Bit 2
   P5_3 .EQU 0xC8+3 ;Port 5 Bit 3
   P5_4 .EQU 0xC8+4 ;Port 5 Bit 4
   P5_5 .EQU 0xC8+5 ;Port 5 Bit 5
; See device specific data sheet for additional pin names.

P5M1 .EQU 0xC9                ;Port 5 Mode Register 1
   P50M1 = 0x01 ;Port 5 bit 0 Mode 1
   P51M1 = 0x02 ;Port 5 bit 1 Mode 1
   P52M1 = 0x04 ;Port 5 bit 2 Mode 1
   P53M1 = 0x08 ;Port 5 bit 3 Mode 1
   P54M1 = 0x10 ;Port 5 bit 4 Mode 1
   P55M1 = 0x20 ;Port 5 bit 5 Mode 1

P5M0 .EQU 0xCA                ;Port 5 Mode Register 0
   P50M0 = 0x01 ;Port 5 bit 0 Mode 0
   P51M0 = 0x02 ;Port 5 bit 1 Mode 0
   P52M0 = 0x04 ;Port 5 bit 2 Mode 0
   P53M0 = 0x08 ;Port 5 bit 3 Mode 0
   P54M0 = 0x10 ;Port 5 bit 4 Mode 0
   P55M0 = 0x20 ;Port 5 bit 5 Mode 0

P6M1 .EQU 0xCB                ;Port 6 Mode Register 1
   P60M1 = 0x01 ;Port 6 bit 0 Mode 1
   P61M1 = 0x02 ;Port 6 bit 1 Mode 1
   P62M1 = 0x04 ;Port 6 bit 2 Mode 1
   P63M1 = 0x08 ;Port 6 bit 3 Mode 1
   P64M1 = 0x10 ;Port 6 bit 4 Mode 1
   P65M1 = 0x20 ;Port 6 bit 5 Mode 1
   P66M1 = 0x40 ;Port 6 bit 6 Mode 1
   P67M1 = 0x80 ;Port 6 bit 7 Mode 1

P6M0 .EQU 0xCC                ;Port 6 Mode Register 0
   P60M0 = 0x01 ;Port 6 bit 0 Mode 0
   P61M0 = 0x02 ;Port 6 bit 1 Mode 0
   P62M0 = 0x04 ;Port 6 bit 2 Mode 0
   P63M0 = 0x08 ;Port 6 bit 3 Mode 0
   P64M0 = 0x10 ;Port 6 bit 4 Mode 0
   P65M0 = 0x20 ;Port 6 bit 5 Mode 0
   P66M0 = 0x40 ;Port 6 bit 6 Mode 0
   P67M0 = 0x80 ;Port 6 bit 7 Mode 0

SPSTAT .EQU 0xCD              ;Serial Peripheral Status Register
   WCOL = 0x40 ;Write Collision
   SPIF = 0x80 ;Serial Peripheral Interface Flag

SPCTL .EQU 0xCE               ;Serial Peripheral Control Register
   SPR0 = 0x00 ;Serial Peripheral Rate 0
   SPR1 = 0x01 ;Serial Peripheral Rate 1
   SPR  = 0x03 ;Serial Peripheral Rate
   CPHA = 0x04 ;Clock Phase
   CPOL = 0x08 ;Clock Polarity
   MSTR = 0x10 ;Master
   DORD = 0x20 ;Data Order
   SPEN = 0x40 ;Serial Peripheral Enable
   SSIG = 0x80 ;Slave Select Signal

SPDAT .EQU 0xCF               ;Serial Peripheral Data

PSW .EQU 0xD0                 ;Program status word
   P   .EQU 0xD0+0 ;Parity
   F1  .EQU 0xD0+1 ;Flag 1
   OV  .EQU 0xD0+2 ;Overflow
   RS0 .EQU 0xD0+3 ;Register Select 0
   RS1 .EQU 0xD0+4 ;Register Select 1
   F0  .EQU 0xD0+5 ;Flag 0
   AC  .EQU 0xD0+6 ;Auxiliary Carry
   CY  .EQU 0xD0+7 ;Carry

T4T3M .EQU 0xD1               ;T4 and T3 Mode Register
   T3CLKO = 0x01 ;Timer 3 Clock Output Control
   T3x12  = 0x02 ;Timer 3 Clock x12 Prescaler Bypass
   T3_CT  = 0x04 ;Timer 3 Counter or Timer Mode Select
   T3R    = 0x08 ;Timer 3 Run Control
   T4CLKO = 0x10 ;Timer 4 Clock Output Control
   T4x12  = 0x20 ;Timer 4 Clock x12 Prescaler Bypass
   T4_CT  = 0x40 ;Timer 4 Counter or Timer Mode Select
   T4R    = 0x80 ;Timer 4 Run Control

T4H .EQU 0xD2                 ;T4 High Byte
TH4 .EQU 0xD2

T4L .EQU 0xD3                 ;T4 Low Byte
TL4 .EQU 0xD3

T3H .EQU 0xD4                 ;T3 High Byte
TH3 .EQU 0xD4

T3L .EQU 0xD5                 ;T3 Low Byte
TL3 .EQU 0xD5

T2H .EQU 0xD6                 ;T2 High Byte
TH2 .EQU 0xD6

T2L .EQU 0xD7                 ;T2 Low Byte
TL2 .EQU 0xD7

CCON .EQU 0xD8              ;PCA Control Register
   CCF0 .EQU 0xD8+0 ;PCA Counter 0 Interrupt Flag
   CCF1 .EQU 0xD8+1 ;PCA Counter 1 Interrupt Flag
   CCF2 .EQU 0xD8+2 ;PCA Counter 2 Interrupt Flag
   CCF3 .EQU 0xD8+3 ;PCA Counter 3 Interrupt Flag
   CR   .EQU 0xD8+6 ;PCA Counter Enable
   CF   .EQU 0xD8+7 ;PCA Counter Overflow Flage

CMOD .EQU 0xD9                ;PCA Working Mode Register
   ECF  = 0x01 ;PCA Counter Overflow Interrupt Enable
   CPS0 = 0x02 ;PCA Counter Pulse Source Select 0
   CPS1 = 0x04 ;PCA Counter Pulse Source Select 1
   CPS2 = 0x08 ;PCA Counter Pulse Source Select 2
   CPS  = 0x0E ;PCA Counter Pulse Source Select
   CIDL = 0x80 ;PCA Counter Idle Mode Control

CCAPM0 .EQU 0xDA              ;Compare Capture PWM 0 Mode
   ECCF0  = 0x01 ;Enable PCA Capture Flag 0
   PWM0   = 0x02 ;Pulse Width Modulator 0
   TOG0   = 0x04 ;Toggle 0
   MAT0   = 0x08 ;Match 0
   CCAPN0 = 0x10 ;PCA Capture Negative-going 0
   CCAPP0 = 0x20 ;PCA Capture Positive-going 0
   ECOM0  = 0x40 ;Enable Comparator 0

CCAPM1 .EQU 0xDB              ;Compare Capture PWM 1 Mode
   ECCF1  = 0x01 ;Enable PCA Capture Flag 1
   PWM1   = 0x02 ;Pulse Width Modulator 1
   TOG1   = 0x04 ;Toggle 1
   MAT1   = 0x08 ;Match 1
   CCAPN1 = 0x10 ;PCA Capture Negative-going 1
   CCAPP1 = 0x20 ;PCA Capture Positive-going 1
   ECOM1  = 0x40 ;Enable Comparator 1

CCAPM2 .EQU 0xDC              ;Compare Capture PWM 2 Mode
   ECCF2  = 0x01 ;Enable PCA Capture Flag 2
   PWM2   = 0x02 ;Pulse Width Modulator 2
   TOG2   = 0x04 ;Toggle 2
   MAT2   = 0x08 ;Match 2
   CCAPN2 = 0x10 ;PCA Capture Negative-going 2
   CCAPP2 = 0x20 ;PCA Capture Positive-going 2
   ECOM2  = 0x40 ;Enable Comparator 2

ADCCFG .EQU 0xDE              ;ADC Configuration Register
   ADCSPEED  = 0x0F ;Clock Speed Control
   RESFMT    = 0x20 ;Result Format Control

IP3 .EQU 0xDF                 ;Interrupt Priority Register 3
   PS3  = 0x01 ;Serial Port 3 Interrupt Priority
   PS4  = 0x02 ;Serial Port 4 Interrupt Priority
   PRTC = 0x04 ;RTC Interrupt Priority Control

ACC .EQU 0xE0                 ;Accumulator
   ACC0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC7 .EQU 0xE0+7 ;Accumulator Bit 7
   ACC_0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC_1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC_2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC_3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC_4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC_5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC_6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC_7 .EQU 0xE0+7 ;Accumulator Bit 7

P7M1 .EQU 0xE1                ;Port 7 Mode Register 1
   P70M1 = 0x01 ;Port 7 bit 0 Mode 1
   P71M1 = 0x02 ;Port 7 bit 1 Mode 1
   P72M1 = 0x04 ;Port 7 bit 2 Mode 1
   P73M1 = 0x08 ;Port 7 bit 3 Mode 1
   P74M1 = 0x10 ;Port 7 bit 4 Mode 1
   P75M1 = 0x20 ;Port 7 bit 5 Mode 1
   P76M1 = 0x40 ;Port 7 bit 6 Mode 1
   P77M1 = 0x80 ;Port 7 bit 7 Mode 1

P7M0 .EQU 0xE2                ;Port 7 Mode Register 0
   P70M0 = 0x01 ;Port 7 bit 0 Mode 0
   P71M0 = 0x02 ;Port 7 bit 1 Mode 0
   P72M0 = 0x04 ;Port 7 bit 2 Mode 0
   P73M0 = 0x08 ;Port 7 bit 3 Mode 0
   P74M0 = 0x10 ;Port 7 bit 4 Mode 0
   P75M0 = 0x20 ;Port 7 bit 5 Mode 0
   P76M0 = 0x40 ;Port 7 bit 6 Mode 0
   P77M0 = 0x80 ;Port 7 bit 7 Mode 0

DPS .EQU 0xE3                 ;DPTR Pointer Selector
   SEL = 0x01 ;Data Pointer Select
   AU0 = 0x08 ;Auto Increment-Decrement Data Pointer 0
   AU1 = 0x10 ;Auto Increment-Decrement Data Pointer 1
   TSL = 0x20 ;Auto Toggle Data Pointer Select
   ID0 = 0x40 ;Increment or Decrement Data Pointer 0
   ID1 = 0x80 ;Increment or Decrement Data Pointer 1

DPL1 .EQU 0xE4                ;Second Data Pointer Low Byte
DPTR1 .EQU 0xE4               ;Second Data Pointer Word

DPH1 .EQU 0xE5                ;Second Data Pointer High Byte

CMPCR1 .EQU 0xE6              ;Comparator Control Register 1
   CMPRES = 0x01 ;Comparator Result
   CMPOE  = 0x02 ;Comparator Output Enable
   NIS    = 0x04 ;Negative Input Source Selection
   PIS    = 0x08 ;Positive Input Source Selection
   NIE    = 0x10 ;Falling Edge Interrupt Enable
   PIE    = 0x20 ;Rising Edge Interrupt Enable
   CMPIF  = 0x40 ;Comparator Interrupt Flag
   CMPEN  = 0x80 ;Comparator Enable

CMPCR2 .EQU 0xE7              ;Comparator Control Register 2
   LCDTY   = 0x3F ;Digital Filter Control
   DISFLT  = 0x40 ;Analog Filter Control
   INVCMPO = 0x80 ;Comparator Output Control

P6 .EQU 0xE8                  ;Port 6
   P60 .EQU 0xE8+0 ;Port 6 Bit 0
   P61 .EQU 0xE8+1 ;Port 6 Bit 1
   P62 .EQU 0xE8+2 ;Port 6 Bit 2
   P63 .EQU 0xE8+3 ;Port 6 Bit 3
   P64 .EQU 0xE8+4 ;Port 6 Bit 4
   P65 .EQU 0xE8+5 ;Port 6 Bit 5
   P66 .EQU 0xE8+6 ;Port 6 Bit 6
   P67 .EQU 0xE8+7 ;Port 6 Bit 7
   P6_0 .EQU 0xE8+0 ;Port 6 Bit 0
   P6_1 .EQU 0xE8+1 ;Port 6 Bit 1
   P6_2 .EQU 0xE8+2 ;Port 6 Bit 2
   P6_3 .EQU 0xE8+3 ;Port 6 Bit 3
   P6_4 .EQU 0xE8+4 ;Port 6 Bit 4
   P6_5 .EQU 0xE8+5 ;Port 6 Bit 5
   P6_6 .EQU 0xE8+6 ;Port 6 Bit 6
   P6_7 .EQU 0xE8+7 ;Port 6 Bit 7
; See device specific data sheet for additional pin names.

CL .EQU 0xE9                  ;PCA Counter Low Byte

CCAP0L .EQU 0xEA              ;PCA Module 0 Capture-Compare Register Low Byte

CCAP1L .EQU 0xEB              ;PCA Module 1 Capture-Compare Register Low Byte

CCAP2L .EQU 0xEC              ;PCA Module 2 Capture-Compare Register Low Byte

IP3H .EQU 0xEE                ;High Interrupt Priority Register 3
   PS3H  = 0x01 ;Serial Port 3 Interrupt Priority
   PS4H  = 0x02 ;Serial Port 4 Interrupt Priority
   PRTCH = 0x04 ;RTC Interrupt Priority Control

AUXINTIF .EQU 0xEF            ;Auxiliary Interrupt Flag Register
   T2IF   = 0x01 ;Timer 2 Overflow Interrupt
   T3IF   = 0x02 ;Timer 1 Overflow Interrupt
   T4IF   = 0x04 ;Timer 0 Overflow Interrupt
   INT2IF = 0x10 ;External Interrupt 2 Request Flag
   INT3IF = 0x20 ;External Interrupt 3 Request Flag
   INT4IF = 0x40 ;External Interrupt 4 Request Flag

B .EQU 0xF0                   ;B
   B0 .EQU 0xF0+0 ;B Bit 0
   B1 .EQU 0xF0+1 ;B Bit 1
   B2 .EQU 0xF0+2 ;B Bit 2
   B3 .EQU 0xF0+3 ;B Bit 3
   B4 .EQU 0xF0+4 ;B Bit 4
   B5 .EQU 0xF0+5 ;B Bit 5
   B6 .EQU 0xF0+6 ;B Bit 6
   B7 .EQU 0xF0+7 ;B Bit 7
   B_0 .EQU 0xF0+0 ;B Bit 0
   B_1 .EQU 0xF0+1 ;B Bit 1
   B_2 .EQU 0xF0+2 ;B Bit 2
   B_3 .EQU 0xF0+3 ;B Bit 3
   B_4 .EQU 0xF0+4 ;B Bit 4
   B_5 .EQU 0xF0+5 ;B Bit 5
   B_6 .EQU 0xF0+6 ;B Bit 6
   B_7 .EQU 0xF0+7 ;B Bit 7

PWMSET .EQU 0xF1              ;Enhanced PWM Clobal Configuration Register
   ENPWM0   = 0x01 ;Enable PWM 0
   ENPWM1   = 0x02 ;Enable PWM 1
   ENPWM2   = 0x04 ;Enable PWM 2
   ENPWM3   = 0x08 ;Enable PWM 3
   ENPWM4   = 0x10 ;Enable PWM 4
   ENPWM5   = 0x20 ;Enable PWM 5
   PWMRST   = 0x40 ;PWM Reset
   ENGLBSET = 0x80 ;Enable Global Setup

PCA_PWM0 .EQU 0xF2            ;PCA Module 0 PWM Register
   EPC0L   = 0x01 ;MSB of comparison vaule in PWM mode
   EPC0H   = 0x02 ;MSB of reload vaule in PWM mode
   XCCAP0L = 0x0C ;9th & 10th bit of comparison value in PWM mode
   XCCAP0H = 0x30 ;9th & 10th bit of reload value in PWM mode
   EBS0_0  = 0x40 ;Number of PCAn PWM Bits Control 0
   EBS0_1  = 0x80 ;Number of PCAn PWM Bits Control 1
   EBS0    = 0xC0 ;Number of PCAn PWM Bits Control

PCA_PWM1 .EQU 0xF3            ;PCA Module 1 PWM Register
   EPC1L   = 0x01 ;MSB of comparison vaule in PWM mode
   EPC1H   = 0x02 ;MSB of reload vaule in PWM mode
   XCCAP1L = 0x0C ;9th & 10th bit of comparison value in PWM mode
   XCCAP1H = 0x30 ;9th & 10th bit of reload value in PWM mode
   EBS1_0  = 0x40 ;Number of PCAn PWM Bits Control 0
   EBS1_1  = 0x80 ;Number of PCAn PWM Bits Control 1
   EBS1    = 0xC0 ;Number of PCAn PWM Bits Control

PCA_PWM2 .EQU 0xF4            ;PCA Module 2 PWM Register
   EPC2L   = 0x01 ;MSB of comparison vaule in PWM mode
   EPC2H   = 0x02 ;MSB of reload vaule in PWM mode
   XCCAP2L = 0x0C ;9th & 10th bit of comparison value in PWM mode
   XCCAP2H = 0x30 ;9th & 10th bit of reload value in PWM mode
   EBS2_0  = 0x40 ;Number of PCAn PWM Bits Control 0
   EBS2_1  = 0x80 ;Number of PCAn PWM Bits Control 1
   EBS2    = 0xC0 ;Number of PCAn PWM Bits Control

IAP_TPS .EQU 0xF5             ;IAP Wait Time Control Register
   IAPTPS = 0x3F ;Set Wait Time Per Operating Frequency

PWMCFG01 .EQU 0xF6            ;Enhanced PWM Channel 0 and 1 Configuration Register
   PWM0CEN  = 0x01 ;PWM 0 Counter Enable
   ENPWM0TA = 0x02 ;Enable PWM0 Trigger ADC
   EPWM0CBI = 0x04 ;Enable PWM 0 Counter Overflow Interrupt
   PWM0CBIF = 0x08 ;PWM 0 Counter Overflow Interrupt Flag
   PWM1CEN  = 0x10 ;PWM 1 Counter Enable
   FLTPS0   = 0x20 ;Fault Pin Select 0
   EPWM1CBI = 0x40 ;Enable PWM 1 Counter Overflow Interrupt
   PWM1CBIF = 0x80 ;PWM 1 Counter Overflow Interrupt Flag

PWMCFG23 .EQU 0xF7            ;Enhanced PWM Channel 2 and 3 Configuration Register
   PWM2CEN  = 0x01 ;PWM 2 Counter Enable
   ENPWM2TA = 0x02 ;Enable PWM2 Trigger ADC
   EPWM2CBI = 0x04 ;Enable PWM 2 Counter Overflow Interrupt
   PWM2CBIF = 0x08 ;PWM 2 Counter Overflow Interrupt Flag
   PWM3CEN  = 0x10 ;PWM 3 Counter Enable
   FLTPS1   = 0x20 ;Fault Pin Select 1
   EPWM3CBI = 0x40 ;Enable PWM 3 Counter Overflow Interrupt
   PWM3CBIF = 0x80 ;PWM 3 Counter Overflow Interrupt Flag

P7 .EQU 0xF8                  ;Port 7
   P70 .EQU 0xF8+0 ;Port 7 Bit 0
   P71 .EQU 0xF8+1 ;Port 7 Bit 1
   P72 .EQU 0xF8+2 ;Port 7 Bit 2
   P73 .EQU 0xF8+3 ;Port 7 Bit 3
   P74 .EQU 0xF8+4 ;Port 7 Bit 4
   P75 .EQU 0xF8+5 ;Port 7 Bit 5
   P76 .EQU 0xF8+6 ;Port 7 Bit 6
   P77 .EQU 0xF8+7 ;Port 7 Bit 7
   P7_0 .EQU 0xF8+0 ;Port 7 Bit 0
   P7_1 .EQU 0xF8+1 ;Port 7 Bit 1
   P7_2 .EQU 0xF8+2 ;Port 7 Bit 2
   P7_3 .EQU 0xF8+3 ;Port 7 Bit 3
   P7_4 .EQU 0xF8+4 ;Port 7 Bit 4
   P7_5 .EQU 0xF8+5 ;Port 7 Bit 5
   P7_6 .EQU 0xF8+6 ;Port 7 Bit 6
   P7_7 .EQU 0xF8+7 ;Port 7 Bit 7
; See device specific data sheet for additional pin names.

CH .EQU 0xF9                  ;PCA Counter High Byte

CCAP0H .EQU 0xFA              ;PCA Module 0 Capture-Compare Register High Byte

CCAP1H .EQU 0xFB              ;PCA Module 1 Capture-Compare Register High Byte

CCAP2H .EQU 0xFC              ;PCA Module 2 Capture-Compare Register High Byte

PWMCFG45 .EQU 0xFE            ;Enhanced PWM Channel 4 and 5 Configuration Register
   PWM4CEN  = 0x01 ;PWM 4 Counter Enable
   ENPWM4TA = 0x02 ;Enable PWM4 Trigger ADC
   EPWM4CBI = 0x04 ;Enable PWM 4 Counter Overflow Interrupt
   PWM4CBIF = 0x08 ;PWM 4 Counter Overflow Interrupt Flag
   PWM5CEN  = 0x10 ;PWM 5 Counter Enable
   FLTPS2   = 0x20 ;Fault Pin Select 2
   EPWM5CBI = 0x40 ;Enable PWM 5 Counter Overflow Interrupt
   PWM5CBIF = 0x80 ;PWM 5 Counter Overflow Interrupt Flag

RSTCFG .EQU 0xFF              ;Reset Configuration Register
   LVDS   = 0x03 ;Low Voltage Detection Threshold
   P54RST = 0x10 ;Port 5 Pin 4 Reset Pin Enable
   ENLVR  = 0x40 ;Enable Low Voltage Reset

; The following special function registers are in the extended RAM area.
; You need to set bit7 of P_SW2 EAXFR to 1 to read and write them normally.
COMEN .EQU 0xfb00 ;LED Common Enable
   C0EN = 0x01 ;
   C1EN = 0x02 ;
   C2EN = 0x04 ;
   C3EN = 0x08 ;
   C4EN = 0x10 ;
   C5EN = 0x20 ;
   C6EN = 0x40 ;
   C7EN = 0x80 ;
SEGENL .EQU 0xfb01 ;Segment Enable Low Byte
   S0EN = 0x01 ;
   S1EN = 0x02 ;
   S2EN = 0x04 ;
   S3EN = 0x08 ;
   S4EN = 0x10 ;
   S5EN = 0x20 ;
   S6EN = 0x40 ;
   S7EN = 0x80 ;
SEGENH .EQU 0xfb02 ;Segment Enable High Byte
   S8EN  = 0x01 ;
   S9EN  = 0x02 ;
   S10EN = 0x04 ;
   S11EN = 0x08 ;
   S12EN = 0x10 ;
   S13EN = 0x20 ;
   S14EN = 0x40 ;
   S15EN = 0x80 ;
LEDCTRL .EQU 0xfb03 ;LED Control
   LEDDUTY = 0x07 ;LED Duty Cycle Adjustment
   LEDMODE = 0x30 ;LED Driver Mode
   LEDON   = 0x80 ;LED Driver Enable
LEDCKS .EQU 0xfb04 ;LED Clock Division
COM0_DA_L .EQU 0xfb10 ;Common Anode阳 Display Data 0
COM1_DA_L .EQU 0xfb11 ;Common Anode阳 Display Data 1
COM2_DA_L .EQU 0xfb12 ;Common Anode阳 Display Data 2
COM3_DA_L .EQU 0xfb13 ;Common Anode阳 Display Data 3
COM4_DA_L .EQU 0xfb14 ;Common Anode阳 Display Data 4
COM5_DA_L .EQU 0xfb15 ;Common Anode阳 Display Data 5
COM6_DA_L .EQU 0xfb16 ;Common Anode阳 Display Data 6
COM7_DA_L .EQU 0xfb17 ;Common Anode阳 Display Data 7
COM0_DA_H .EQU 0xfb18 ;Common Anode阳 Display Data 8
COM1_DA_H .EQU 0xfb19 ;Common Anode阳 Display Data 9
COM2_DA_H .EQU 0xfb1a ;Common Anode阳 Display Data 10
COM3_DA_H .EQU 0xfb1b ;Common Anode阳 Display Data 11
COM4_DA_H .EQU 0xfb1c ;Common Anode阳 Display Data 12
COM5_DA_H .EQU 0xfb1d ;Common Anode阳 Display Data 13
COM6_DA_H .EQU 0xfb1e ;Common Anode阳 Display Data 14
COM7_DA_H .EQU 0xfb1f ;Common Anode阳 Display Data 15
COM0_DC_L .EQU 0xfb20 ;Common Cathode阴 Display Data 0
COM1_DC_L .EQU 0xfb21 ;Common Cathode阴 Display Data 1
COM2_DC_L .EQU 0xfb22 ;Common Cathode阴 Display Data 2
COM3_DC_L .EQU 0xfb23 ;Common Cathode阴 Display Data 3
COM4_DC_L .EQU 0xfb24 ;Common Cathode阴 Display Data 4
COM5_DC_L .EQU 0xfb25 ;Common Cathode阴 Display Data 5
COM6_DC_L .EQU 0xfb26 ;Common Cathode阴 Display Data 6
COM7_DC_L .EQU 0xfb27 ;Common Cathode阴 Display Data 7
COM0_DC_H .EQU 0xfb28 ;Common Cathode阴 Display Data 8
COM1_DC_H .EQU 0xfb29 ;Common Cathode阴 Display Data 9
COM2_DC_H .EQU 0xfb2a ;Common Cathode阴 Display Data 10
COM3_DC_H .EQU 0xfb2b ;Common Cathode阴 Display Data 11
COM4_DC_H .EQU 0xfb2c ;Common Cathode阴 Display Data 12
COM5_DC_H .EQU 0xfb2d ;Common Cathode阴 Display Data 13
COM6_DC_H .EQU 0xfb2e ;Common Cathode阴 Display Data 14
COM7_DC_H .EQU 0xfb2f ;Common Cathode阴 Display Data 15
TSCHEN1 .EQU 0xfb40 ;Touch Sensor Enable Register 1
   TKEN0 = 0x01 ;
   TKEN1 = 0x02 ;
   TKEN2 = 0x04 ;
   TKEN3 = 0x08 ;
   TKEN4 = 0x10 ;
   TKEN5 = 0x20 ;
   TKEN6 = 0x40 ;
   TKEN7 = 0x80 ;
TSCHEN2 .EQU 0xfb41 ;Touch Sensor Enable Register 2
   TKEN8  = 0x01 ;
   TKEN9  = 0x02 ;
   TKEN10 = 0x04 ;
   TKEN11 = 0x08 ;
   TKEN12 = 0x10 ;
   TKEN13 = 0x20 ;
   TKEN14 = 0x40 ;
   TKEN15 = 0x80 ;
TSCFG1 .EQU 0xfb42 ;Touch Sensor Config Register 1
   DT  = 0x07 ;Discharge Time
   SCR = 0x70 ;Switched Capacitor Rate
TSCFG2 .EQU 0xfb43 ;Touch Sensor Config Register 2
   TSVR = 0x03 ;Touch Sensor Voltage Reference
TSWUTC .EQU 0xfb44 ;Touch Sensor Wakeup Control
TSCTRL .EQU 0xfb45 ;Touch Sensor Control
   TSSAMP = 0x03 ;Touch Sensor Multiple Scan Averaging
   TSWUEN = 0x04 ;Touch Sensor Wakeup Enable
   TSDCEN = 0x08 ;Touch Sensor Digital Comparator Enable
   TSWUCS = 0x10 ;Touch Sensor Wakeup Clock Select
   TSWAIT = 0x20 ;Touch Sensor WAIT Control
   SINGLE = 0x40 ;Single Scan Mode Control
   TSGO   = 0x80 ;Touch Sensor Enable
TSSTA1 .EQU 0xfb46 ;Touch Sensor Status Register 1
   TSWKCHN = 0x0F ;Touch Sensor Scan Status Flags
   LEDWK   = 0x80 ;LED Working Status
TSSTA2 .EQU 0xfb47 ;Touch Sensor Status Register 2
   TSDNCHN = 0x0F ;Touch Sensor Channel Completion Status
   TSDOV   = 0x40 ;Touch Sensor Data Overflow Flag
   TSIF    = 0x80 ;Touch Sensor Interrup Flag
TSRT .EQU 0xfb48 ;Touch Sensor Time Control
TSDAT .EQU 0xfb49 ;Touch Sensor Data Word
TSDATH .EQU 0xfb49 ;Touch Sensor Data High Byte
TSDATL .EQU 0xfb4a ;Touch Sensor Data Low Byte
TSTH00 .EQU 0xfb50 ;Touch Sensor 0 Threshold Word
TSTH00H .EQU 0xfb50 ;Touch Sensor 0 Threshold High Byte
TSTH00L .EQU 0xfb51 ;Touch Sensor 0 Threshold Low Byte
TSTH01 .EQU 0xfb52 ;Touch Sensor 1 Threshold Word
TSTH01H .EQU 0xfb52 ;Touch Sensor 1 Threshold High Byte
TSTH01L .EQU 0xfb53 ;Touch Sensor 1 Threshold Low Byte
TSTH02 .EQU 0xfb54 ;Touch Sensor 2 Threshold Word
TSTH02H .EQU 0xfb54 ;Touch Sensor 2 Threshold High Byte
TSTH02L .EQU 0xfb55 ;Touch Sensor 2 Threshold Low Byte
TSTH03 .EQU 0xfb56 ;Touch Sensor 3 Threshold Word
TSTH03H .EQU 0xfb56 ;Touch Sensor 3 Threshold High Byte
TSTH03L .EQU 0xfb57 ;Touch Sensor 3 Threshold Low Byte
TSTH04 .EQU 0xfb58 ;Touch Sensor 4 Threshold Word
TSTH04H .EQU 0xfb58 ;Touch Sensor 4 Threshold High Byte
TSTH04L .EQU 0xfb59 ;Touch Sensor 4 Threshold Low Byte
TSTH05 .EQU 0xfb5a ;Touch Sensor 5 Threshold Word
TSTH05H .EQU 0xfb5a ;Touch Sensor 5 Threshold High Byte
TSTH05L .EQU 0xfb5b ;Touch Sensor 5 Threshold Low Byte
TSTH06 .EQU 0xfb5c ;Touch Sensor 6 Threshold Word
TSTH06H .EQU 0xfb5c ;Touch Sensor 6 Threshold High Byte
TSTH06L .EQU 0xfb5d ;Touch Sensor 6 Threshold Low Byte
TSTH07 .EQU 0xfb5e ;Touch Sensor 7 Threshold Word
TSTH07H .EQU 0xfb5e ;Touch Sensor 7 Threshold High Byte
TSTH07L .EQU 0xfb5f ;Touch Sensor 7 Threshold Low Byte
TSTH08 .EQU 0xfb60 ;Touch Sensor 8 Threshold Word
TSTH08H .EQU 0xfb60 ;Touch Sensor 8 Threshold High Byte
TSTH08L .EQU 0xfb61 ;Touch Sensor 8 Threshold Low Byte
TSTH09 .EQU 0xfb62 ;Touch Sensor 9 Threshold Word
TSTH09H .EQU 0xfb62 ;Touch Sensor 9 Threshold High Byte
TSTH09L .EQU 0xfb63 ;Touch Sensor 9 Threshold Low Byte
TSTH10 .EQU 0xfb64 ;Touch Sensor 10 Threshold Word
TSTH10H .EQU 0xfb64 ;Touch Sensor 10 Threshold High Byte
TSTH10L .EQU 0xfb65 ;Touch Sensor 10 Threshold Low Byte
TSTH11 .EQU 0xfb66 ;Touch Sensor 11 Threshold Word
TSTH11H .EQU 0xfb66 ;Touch Sensor 11 Threshold High Byte
TSTH11L .EQU 0xfb67 ;Touch Sensor 11 Threshold Low Byte
TSTH12 .EQU 0xfb68 ;Touch Sensor 12 Threshold Word
TSTH12H .EQU 0xfb68 ;Touch Sensor 12 Threshold High Byte
TSTH12L .EQU 0xfb69 ;Touch Sensor 12 Threshold Low Byte
TSTH13 .EQU 0xfb6a ;Touch Sensor 13 Threshold Word
TSTH13H .EQU 0xfb6a ;Touch Sensor 13 Threshold High Byte
TSTH13L .EQU 0xfb6b ;Touch Sensor 13 Threshold Low Byte
TSTH14 .EQU 0xfb6c ;Touch Sensor 14 Threshold Word
TSTH14H .EQU 0xfb6c ;Touch Sensor 14 Threshold High Byte
TSTH14L .EQU 0xfb6d ;Touch Sensor 14 Threshold Low Byte
TSTH15 .EQU 0xfb6e ;Touch Sensor 15 Threshold Word
TSTH15H .EQU 0xfb6e ;Touch Sensor 15 Threshold High Byte
TSTH15L .EQU 0xfb6f ;Touch Sensor 15 Threshold Low Byte
PWM3C .EQU 0xfc00 ;PWM 3 Counter Word
PWM3CH .EQU 0xfc00 ;PWM 3 Counter High Byte
PWM3CL .EQU 0xfc01 ;PWM 3 Counter Low Byte
PWM3CKS .EQU 0xfc02 ;PWM 3 Clock Selection
   PWM_PS = 0x0F ;PWM System Clock Prescaler
   SELT2  = 0x10 ;PWM Clock Source Selection
PWM3IF .EQU 0xfc05 ;PWM 3 Interrupt Flags
   C0IF = 0x01 ;Channel 0 Interrupt Flag
   C1IF = 0x02 ;Channel 1 Interrupt Flag
   C2IF = 0x04 ;Channel 2 Interrupt Flag
   C3IF = 0x08 ;Channel 3 Interrupt Flag
   C4IF = 0x10 ;Channel 4 Interrupt Flag
   C5IF = 0x20 ;Channel 5 Interrupt Flag
   C6IF = 0x40 ;Channel 6 Interrupt Flag
   C7IF = 0x80 ;Channel 7 Interrupt Flag
PWM3FDCR .EQU 0xfc06 ;PWM 3 Fault Detect Control Register
   FDIF    = 0x01 ;Fault Detect Interrupt Flag
   FDIO    = 0x02 ;IO Port Fault Detect
   FDCMP   = 0x04 ;Comparator Fault Detect
   EFDI    = 0x08 ;Enable Fault Detect Interrupt
   FLTFLIO = 0x10 ;Fault Detect IO Port Action
   ENFD    = 0x20 ;Enable Fault Detect
   INVIO   = 0x40 ;Invert IO Port Fault Detect Level
   INVCMP  = 0x80 ;Invert Comparator Fault Detect Level
PWM30T1 .EQU 0xfc10 ;PWM 3 Chanel 0 Timer 1 Word
PWM30T1H .EQU 0xfc10 ;PWM 3 Chanel 0 Timer 1 High Byte
PWM30T1L .EQU 0xfc11 ;PWM 3 Chanel 0 Timer 1 Low Byte
PWM30T2 .EQU 0xfc12 ;PWM 3 Chanel 0 Timer 2 Word
PWM30T2H .EQU 0xfc12 ;PWM 3 Chanel 0 Timer 2 High Byte
PWM30T2L .EQU 0xfc13 ;PWM 3 Chanel 0 Timer 2 Low Byte
PWM30CR .EQU 0xfc14 ;PWM 3 Chanel 0 Control Register
   PWM30_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM30_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM30_ENI   = 0x04 ;Enable Interrupt
   PWM30_INI   = 0x40 ;Initial Output Level
   PWM30_ENO   = 0x80 ;PWM Output Enable Bit
PWM30HLD .EQU 0xfc15 ;PWM 3 Chanel 0 Level Hold Control
   PWM30_HLDL = 0x01 ;Hold Low Override
   PWM30_HLDH = 0x02 ;Hold High Override
PWM31T1 .EQU 0xfc18 ;PWM 3 Chanel 1 Timer 1 Word
PWM31T1H .EQU 0xfc18 ;PWM 3 Chanel 1 Timer 1 High Byte
PWM31T1L .EQU 0xfc19 ;PWM 3 Chanel 1 Timer 1 Low Byte
PWM31T2 .EQU 0xfc1a ;PWM 3 Chanel 1 Timer 2 Word
PWM31T2H .EQU 0xfc1a ;PWM 3 Chanel 1 Timer 2 High Byte
PWM31T2L .EQU 0xfc1b ;PWM 3 Chanel 1 Timer 2 Low Byte
PWM31CR .EQU 0xfc1c ;PWM 3 Chanel 1 Control Register
   PWM31_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM31_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM31_ENI   = 0x04 ;Enable Interrupt
   PWM31_INI   = 0x40 ;Initial Output Level
   PWM31_ENO   = 0x80 ;PWM Output Enable Bit
PWM31HLD .EQU 0xfc1d ;PWM 3 Chanel 1 Level Hold Control
   PWM31_HLDL = 0x01 ;Hold Low Override
   PWM31_HLDH = 0x02 ;Hold High Override
PWM32T1 .EQU 0xfc20 ;PWM 3 Chanel 2 Timer 1 Word
PWM32T1H .EQU 0xfc20 ;PWM 3 Chanel 2 Timer 1 High Byte
PWM32T1L .EQU 0xfc21 ;PWM 3 Chanel 2 Timer 1 Low Byte
PWM32T2 .EQU 0xfc22 ;PWM 3 Chanel 2 Timer 2 Word
PWM32T2H .EQU 0xfc22 ;PWM 3 Chanel 2 Timer 2 High Byte
PWM32T2L .EQU 0xfc23 ;PWM 3 Chanel 2 Timer 2 Low Byte
PWM32CR .EQU 0xfc24 ;PWM 3 Chanel 2 Control Register
   PWM32_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM32_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM32_ENI   = 0x04 ;Enable Interrupt
   PWM32_INI   = 0x40 ;Initial Output Level
   PWM32_ENO   = 0x80 ;PWM Output Enable Bit
PWM32HLD .EQU 0xfc25 ;PWM 3 Chanel 2 Level Hold Control
   PWM32_HLDL = 0x01 ;Hold Low Override
   PWM32_HLDH = 0x02 ;Hold High Override
PWM33T1 .EQU 0xfc28 ;PWM 3 Chanel 3 Timer 1 Word
PWM33T1H .EQU 0xfc28 ;PWM 3 Chanel 3 Timer 1 High Byte
PWM33T1L .EQU 0xfc29 ;PWM 3 Chanel 3 Timer 1 Low Byte
PWM33T2 .EQU 0xfc2a ;PWM 3 Chanel 3 Timer 2 Word
PWM33T2H .EQU 0xfc2a ;PWM 3 Chanel 3 Timer 2 High Byte
PWM33T2L .EQU 0xfc2b ;PWM 3 Chanel 3 Timer 2 Low Byte
PWM33CR .EQU 0xfc2c ;PWM 3 Chanel 3 Control Register
   PWM33_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM33_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM33_ENI   = 0x04 ;Enable Interrupt
   PWM33_INI   = 0x40 ;Initial Output Level
   PWM33_ENO   = 0x80 ;Output Enable
PWM33HLD .EQU 0xfc2d ;PWM 3 Chanel 3 Level Hold Control
   PWM33_HLDL = 0x01 ;Hold Low Override
   PWM33_HLDH = 0x02 ;Hold High Override
PWM34T1 .EQU 0xfc30 ;PWM 3 Chanel 4 Timer 1 Word
PWM34T1H .EQU 0xfc30 ;PWM 3 Chanel 4 Timer 1 High Byte
PWM34T1L .EQU 0xfc31 ;PWM 3 Chanel 4 Timer 1 Low Byte
PWM34T2 .EQU 0xfc32 ;PWM 3 Chanel 4 Timer 2 Word
PWM34T2H .EQU 0xfc32 ;PWM 3 Chanel 4 Timer 2 High Byte
PWM34T2L .EQU 0xfc33 ;PWM 3 Chanel 4 Timer 2 Low Byte
PWM34CR .EQU 0xfc34 ;PWM 3 Chanel 4 Control Register
   PWM34_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM34_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM34_ENI   = 0x04 ;Enable Interrupt
   PWM34_INI   = 0x40 ;Initial Output Level
   PWM34_ENO   = 0x80 ;Output Enable
PWM34HLD .EQU 0xfc35 ;PWM 3 Chanel 4 Level Hold Control
   PWM34_HLDL = 0x01 ;Hold Low Override
   PWM34_HLDH = 0x02 ;Hold High Override
PWM35T1 .EQU 0xfc38 ;PWM 3 Chanel 5 Timer 1 Word
PWM35T1H .EQU 0xfc38 ;PWM 3 Chanel 5 Timer 1 High Byte
PWM35T1L .EQU 0xfc39 ;PWM 3 Chanel 5 Timer 1 Low Byte
PWM35T2 .EQU 0xfc3a ;PWM 3 Chanel 5 Timer 2 Word
PWM35T2H .EQU 0xfc3a ;PWM 3 Chanel 5 Timer 2 High Byte
PWM35T2L .EQU 0xfc3b ;PWM 3 Chanel 5 Timer 2 Low Byte
PWM35CR .EQU 0xfc3c ;PWM 3 Chanel 5 Control Register
   PWM35_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM35_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM35_ENI   = 0x04 ;Enable Interrupt
   PWM35_INI   = 0x40 ;Initial Output Level
   PWM35_ENO   = 0x80 ;Output Enable
PWM35HLD .EQU 0xfc3d ;PWM 3 Chanel 5 Level Hold Control
   PWM35_HLDL = 0x01 ;Hold Low Override
   PWM35_HLDH = 0x02 ;Hold High Override
PWM36T1 .EQU 0xfc40 ;PWM 3 Chanel 6 Timer 1 Word
PWM36T1H .EQU 0xfc40 ;PWM 3 Chanel 6 Timer 1 High Byte
PWM36T1L .EQU 0xfc41 ;PWM 3 Chanel 6 Timer 1 Low Byte
PWM36T2 .EQU 0xfc42 ;PWM 3 Chanel 6 Timer 2 Word
PWM36T2H .EQU 0xfc42 ;PWM 3 Chanel 6 Timer 2 High Byte
PWM36T2L .EQU 0xfc43 ;PWM 3 Chanel 7 Timer 2 Low Byte
PWM36CR .EQU 0xfc44 ;PWM 3 Chanel 6 Control Register
   PWM36_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM36_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM36_ENI   = 0x04 ;Enable Interrupt
   PWM36_INI   = 0x40 ;Initial Output Level
   PWM36_ENO   = 0x80 ;Output Enable
PWM36HLD .EQU 0xfc45 ;PWM 3 Chanel 6 Level Hold Control
   PWM36_HLDL = 0x01 ;Hold Low Override
   PWM36_HLDH = 0x02 ;Hold High Override
PWM37T1 .EQU 0xfc48 ;PWM 3 Chanel 7 Timer 1 Word
PWM37T1H .EQU 0xfc48 ;PWM 3 Chanel 7 Timer 1 High Byte
PWM37T1L .EQU 0xfc49 ;PWM 3 Chanel 7 Timer 1 Low Byte
PWM37T2 .EQU 0xfc4a ;PWM 3 Chanel 7 Timer 2 Word
PWM37T2H .EQU 0xfc4a ;PWM 3 Chanel 7 Timer 2 High Byte
PWM37T2L .EQU 0xfc4b ;PWM 3 Chanel 7 Timer 2 Low Byte
PWM37CR .EQU 0xfc4c ;PWM 3 Chanel 7 Control Register
   PWM37_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM37_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM37_ENI   = 0x04 ;Enable Interrupt
   PWM37_INI   = 0x40 ;Initial Output Level
   PWM37_ENO   = 0x80 ;Output Enable
PWM37HLD .EQU 0xfc4d ;PWM 3 Chanel 7 Level Hold Control
   PWM37_HLDL = 0x01 ;Hold Low Override
   PWM37_HLDH = 0x02 ;Hold High Override
PWM4C .EQU 0xfc50 ;PWM 4 Counter Word
PWM4CH .EQU 0xfc50 ;PWM 4 Counter High Byte
PWM4CL .EQU 0xfc51 ;PWM 4 Counter Low Byte
PWM4CKS .EQU 0xfc52 ;PWM 4 Clock Selection
   PWM_PS = 0x0F ;PWM System Clock Prescaler
   SELT2  = 0x10 ;PWM Clock Source Selection
PWM4TADC .EQU 0xfc53 ;PWM 4 Trigger ADC Count Word
PWM4TADCH .EQU 0xfc53 ;PWM 4 Trigger ADC Count High Byte
PWM4TADCL .EQU 0xfc54 ;PWM 4 Trigger ADC Count Low Byte
PWM4IF .EQU 0xfc55 ;PWM 4 Interrupt Flags
   C0IF = 0x01 ;Channel 0 Interrupt Flag
   C1IF = 0x02 ;Channel 1 Interrupt Flag
   C2IF = 0x04 ;Channel 2 Interrupt Flag
   C3IF = 0x08 ;Channel 3 Interrupt Flag
   C4IF = 0x10 ;Channel 4 Interrupt Flag
   C5IF = 0x20 ;Channel 5 Interrupt Flag
   C6IF = 0x40 ;Channel 6 Interrupt Flag
   C7IF = 0x80 ;Channel 7 Interrupt Flag
PWM4FDCR .EQU 0xfc56 ;PWM 4 Fault Detect Control Register
   FDIF    = 0x01 ;Fault Detect Interrupt Flag
   FDIO    = 0x02 ;IO Port Fault Detect
   FDCMP   = 0x04 ;Comparator Fault Detect
   EFDI    = 0x08 ;Enable Fault Detect Interrupt
   FLTFLIO = 0x10 ;Fault Detect IO Port Action
   ENFD    = 0x20 ;Enable Fault Detect
   INVIO   = 0x40 ;Invert IO Port Fault Detect Level
   INVCMP  = 0x80 ;Invert Comparator Fault Detect Level
PWM40T1 .EQU 0xfc60 ;PWM 4 Chanel 0 Timer 1 Word
PWM40T1H .EQU 0xfc60 ;PWM 4 Chanel 0 Timer 1 High Byte
PWM40T1L .EQU 0xfc61 ;PWM 4 Chanel 0 Timer 1 Low Byte
PWM40T2 .EQU 0xfc62 ;PWM 4 Chanel 0 Timer 2 Word
PWM40T2H .EQU 0xfc62 ;PWM 4 Chanel 0 Timer 2 High Byte
PWM40T2L .EQU 0xfc63 ;PWM 4 Chanel 0 Timer 2 Low Byte
PWM40CR .EQU 0xfc64 ;PWM 4 Chanel 0 Control Register
   PWM40_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM40_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM40_ENI   = 0x04 ;Enable Interrupt
   PWM40_INI   = 0x40 ;Initial Output Level
   PWM40_ENO   = 0x80 ;PWM Output Enable Bit
PWM40HLD .EQU 0xfc65 ;PWM 4 Chanel 0 Level Hold Control
   PWM40_HLDL = 0x01 ;Hold Low Override
   PWM40_HLDH = 0x02 ;Hold High Override
PWM41T1 .EQU 0xfc68 ;PWM 4 Chanel 1 Timer 1 Word
PWM41T1H .EQU 0xfc68 ;PWM 4 Chanel 1 Timer 1 High Byte
PWM41T1L .EQU 0xfc69 ;PWM 4 Chanel 1 Timer 1 Low Byte
PWM41T2 .EQU 0xfc6a ;PWM 4 Chanel 1 Timer 2 Word
PWM41T2H .EQU 0xfc6a ;PWM 4 Chanel 1 Timer 2 High Byte
PWM41T2L .EQU 0xfc6b ;PWM 4 Chanel 1 Timer 2 Low Byte
PWM41CR .EQU 0xfc6c ;PWM 4 Chanel 1 Control Register
   PWM41_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM41_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM41_ENI   = 0x04 ;Enable Interrupt
   PWM41_INI   = 0x40 ;Initial Output Level
   PWM41_ENO   = 0x80 ;PWM Output Enable Bit
PWM41HLD .EQU 0xfc6d ;PWM 4 Chanel 1 Level Hold Control
   PWM41_HLDL = 0x01 ;Hold Low Override
   PWM41_HLDH = 0x02 ;Hold High Override
PWM42T1 .EQU 0xfc70 ;PWM 4 Chanel 2 Timer 1 Word
PWM42T1H .EQU 0xfc70 ;PWM 4 Chanel 2 Timer 1 High Byte
PWM42T1L .EQU 0xfc71 ;PWM 4 Chanel 2 Timer 1 Low Byte
PWM42T2 .EQU 0xfc72 ;PWM 4 Chanel 2 Timer 2 Word
PWM42T2H .EQU 0xfc72 ;PWM 4 Chanel 2 Timer 2 High Byte
PWM42T2L .EQU 0xfc73 ;PWM 4 Chanel 2 Timer 2 Low Byte
PWM42CR .EQU 0xfc74 ;PWM 4 Chanel 2 Control Register
   PWM42_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM42_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM42_ENI   = 0x04 ;Enable Interrupt
   PWM42_INI   = 0x40 ;Initial Output Level
   PWM42_ENO   = 0x80 ;PWM Output Enable Bit
PWM42HLD .EQU 0xfc75 ;PWM 4 Chanel 2 Level Hold Control
   PWM42_HLDL = 0x01 ;Hold Low Override
   PWM42_HLDH = 0x02 ;Hold High Override
PWM43T1 .EQU 0xfc78 ;PWM 4 Chanel 3 Timer 1 Word
PWM43T1H .EQU 0xfc78 ;PWM 4 Chanel 3 Timer 1 High Byte
PWM43T1L .EQU 0xfc79 ;PWM 4 Chanel 3 Timer 1 Low Byte
PWM43T2 .EQU 0xfc7a ;PWM 4 Chanel 3 Timer 2 Word
PWM43T2H .EQU 0xfc7a ;PWM 4 Chanel 3 Timer 2 High Byte
PWM43T2L .EQU 0xfc7b ;PWM 4 Chanel 3 Timer 2 Low Byte
PWM43CR .EQU 0xfc7c ;PWM 4 Chanel 3 Control Register
   PWM43_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM43_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM43_ENI   = 0x04 ;Enable Interrupt
   PWM43_INI   = 0x40 ;Initial Output Level
   PWM43_ENO   = 0x80 ;PWM Output Enable Bit
PWM43HLD .EQU 0xfc7d ;PWM 4 Chanel 3 Level Hold Control
   PWM43_HLDL = 0x01 ;Hold Low Override
   PWM43_HLDH = 0x02 ;Hold High Override
PWM44T1 .EQU 0xfc80 ;PWM 4 Chanel 4 Timer 1 Word
PWM44T1H .EQU 0xfc80 ;PWM 4 Chanel 4 Timer 1 High Byte
PWM44T1L .EQU 0xfc81 ;PWM 4 Chanel 4 Timer 1 Low Byte
PWM44T2 .EQU 0xfc82 ;PWM 4 Chanel 4 Timer 2 Word
PWM44T2H .EQU 0xfc82 ;PWM 4 Chanel 4 Timer 2 High Byte
PWM44T2L .EQU 0xfc83 ;PWM 4 Chanel 4 Timer 2 Low Byte
PWM44CR .EQU 0xfc84 ;PWM 4 Chanel 4 Control Register
   PWM44_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM44_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM44_ENI   = 0x04 ;Enable Interrupt
   PWM44_INI   = 0x40 ;Initial Output Level
   PWM44_ENO   = 0x80 ;PWM Output Enable Bit
PWM44HLD .EQU 0xfc85 ;PWM 4 Chanel 4 Level Hold Control
   PWM44_HLDL = 0x01 ;Hold Low Override
   PWM44_HLDH = 0x02 ;Hold High Override
PWM45T1 .EQU 0xfc88 ;PWM 4 Chanel 5 Timer 1 Word
PWM45T1H .EQU 0xfc88 ;PWM 4 Chanel 5 Timer 1 High Byte
PWM45T1L .EQU 0xfc89 ;PWM 4 Chanel 5 Timer 1 Low Byte
PWM45T2 .EQU 0xfc8a ;PWM 4 Chanel 5 Timer 2 Word
PWM45T2H .EQU 0xfc8a ;PWM 4 Chanel 5 Timer 2 High Byte
PWM45T2L .EQU 0xfc8b ;PWM 4 Chanel 5 Timer 2 Low Byte
PWM45CR .EQU 0xfc8c ;PWM 4 Chanel 5 Control Register
   PWM45_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM45_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM45_ENI   = 0x04 ;Enable Interrupt
   PWM45_INI   = 0x40 ;Initial Output Level
   PWM45_ENO   = 0x80 ;PWM Output Enable Bit
PWM45HLD .EQU 0xfc8d ;PWM 4 Chanel 5 Level Hold Control
   PWM45_HLDL = 0x01 ;Hold Low Override
   PWM45_HLDH = 0x02 ;Hold High Override
PWM46T1 .EQU 0xfc90 ;PWM 4 Chanel 6 Timer 1 Word
PWM46T1H .EQU 0xfc90 ;PWM 4 Chanel 6 Timer 1 High Byte
PWM46T1L .EQU 0xfc91 ;PWM 4 Chanel 6 Timer 1 Low Byte
PWM46T2 .EQU 0xfc92 ;PWM 4 Chanel 6 Timer 2 Word
PWM46T2H .EQU 0xfc92 ;PWM 4 Chanel 6 Timer 2 High Byte
PWM46T2L .EQU 0xfc93 ;PWM 4 Chanel 6 Timer 2 Low Byte
PWM46CR .EQU 0xfc94 ;PWM 4 Chanel 6 Control Register
   PWM46_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM46_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM46_ENI   = 0x04 ;Enable Interrupt
   PWM46_INI   = 0x40 ;Initial Output Level
   PWM46_ENO   = 0x80 ;PWM Output Enable Bit
PWM46HLD .EQU 0xfc95 ;PWM 4 Chanel 6 Level Hold Control
   PWM46_HLDL = 0x01 ;Hold Low Override
   PWM46_HLDH = 0x02 ;Hold High Override
PWM47T1 .EQU 0xfc98 ;PWM 4 Chanel 7 Timer 1 Word
PWM47T1H .EQU 0xfc98 ;PWM 4 Chanel 7 Timer 1 High Byte
PWM47T1L .EQU 0xfc99 ;PWM 4 Chanel 7 Timer 1 Low Byte
PWM47T2 .EQU 0xfc9a ;PWM 4 Chanel 7 Timer 2 Word
PWM47T2H .EQU 0xfc9a ;PWM 4 Chanel 7 Timer 2 High Byte
PWM47T2L .EQU 0xfc9b ;PWM 4 Chanel 7 Timer 2 Low Byte
PWM47CR .EQU 0xfc9c ;PWM 4 Chanel 7 Control Register
   PWM47_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM47_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM47_ENI   = 0x04 ;Enable Interrupt
   PWM47_INI   = 0x40 ;Initial Output Level
   PWM47_ENO   = 0x80 ;PWM Output Enable Bit
PWM47HLD .EQU 0xfc9d ;PWM 4 Chanel 7 Level Hold Control
   PWM47_HLDL = 0x01 ;Hold Low Override
   PWM47_HLDH = 0x02 ;Hold High Override
PWM5C .EQU 0xfca0 ;PWM 5 Counter Word
PWM5CH .EQU 0xfca0 ;PWM 5 Counter High Byte
PWM5CL .EQU 0xfca1 ;PWM 5 Counter Low Byte
PWM5CKS .EQU 0xfca2 ;PWM 5 Clock Selection
   PWM_PS = 0x0F ;PWM System Clock Prescaler
   SELT2  = 0x10 ;PWM Clock Source Selection
PWM5IF .EQU 0xfca5 ;PWM 5 Interrupt Flags
   C0IF = 0x01 ;Channel 0 Interrupt Flag
   C1IF = 0x02 ;Channel 1 Interrupt Flag
   C2IF = 0x04 ;Channel 2 Interrupt Flag
   C3IF = 0x08 ;Channel 3 Interrupt Flag
   C4IF = 0x10 ;Channel 4 Interrupt Flag
   C5IF = 0x20 ;Channel 5 Interrupt Flag
   C6IF = 0x40 ;Channel 6 Interrupt Flag
   C7IF = 0x80 ;Channel 7 Interrupt Flag
PWM5FDCR .EQU 0xfca6 ;PWM 5 Fault Detect Control Register
   FDIF    = 0x01 ;Fault Detect Interrupt Flag
   FDIO    = 0x02 ;IO Port Fault Detect
   FDCMP   = 0x04 ;Comparator Fault Detect
   EFDI    = 0x08 ;Enable Fault Detect Interrupt
   FLTFLIO = 0x10 ;Fault Detect IO Port Action
   ENFD    = 0x20 ;Enable Fault Detect
   INVIO   = 0x40 ;Invert IO Port Fault Detect Level
   INVCMP  = 0x80 ;Invert Comparator Fault Detect Level
PWM50T1 .EQU 0xfcb0 ;PWM 5 Chanel 0 Timer 1 Word
PWM50T1H .EQU 0xfcb0 ;PWM 5 Chanel 0 Timer 1 High Byte
PWM50T1L .EQU 0xfcb1 ;PWM 5 Chanel 0 Timer 1 Low Byte
PWM50T2 .EQU 0xfcb2 ;PWM 5 Chanel 0 Timer 2 Word
PWM50T2H .EQU 0xfcb2 ;PWM 5 Chanel 0 Timer 2 High Byte
PWM50T2L .EQU 0xfcb3 ;PWM 5 Chanel 0 Timer 2 Low Byte
PWM50CR .EQU 0xfcb4 ;PWM 5 Chanel 0 Control Register
   PWM50_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM50_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM50_ENI   = 0x04 ;Enable Interrupt
   PWM50_INI   = 0x40 ;Initial Output Level
   PWM50_ENO   = 0x80 ;PWM Output Enable Bit
PWM50HLD .EQU 0xfcb5 ;PWM 5 Chanel 0 Level Hold Control
   PWM50_HLDL = 0x01 ;Hold Low Override
   PWM50_HLDH = 0x02 ;Hold High Override
PWM51T1 .EQU 0xfcb8 ;PWM 5 Chanel 1 Timer 1 Word
PWM51T1H .EQU 0xfcb8 ;PWM 5 Chanel 1 Timer 1 High Byte
PWM51T1L .EQU 0xfcb9 ;PWM 5 Chanel 1 Timer 1 Low Byte
PWM51T2 .EQU 0xfcba ;PWM 5 Chanel 1 Timer 2 Word
PWM51T2H .EQU 0xfcba ;PWM 5 Chanel 1 Timer 2 High Byte
PWM51T2L .EQU 0xfcbb ;PWM 5 Chanel 1 Timer 2 Low Byte
PWM51CR .EQU 0xfcbc ;PWM 5 Chanel 1 Control Register
   PWM51_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM51_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM51_ENI   = 0x04 ;Enable Interrupt
   PWM51_INI   = 0x40 ;Initial Output Level
   PWM51_ENO   = 0x80 ;PWM Output Enable Bit
PWM51HLD .EQU 0xfcbd ;PWM 5 Chanel 1 Level Hold Control
   PWM51_HLDL = 0x01 ;Hold Low Override
   PWM51_HLDH = 0x02 ;Hold High Override
PWM52T1 .EQU 0xfcc0 ;PWM 5 Chanel 2 Timer 1 Word
PWM52T1H .EQU 0xfcc0 ;PWM 5 Chanel 2 Timer 1 High Byte
PWM52T1L .EQU 0xfcc1 ;PWM 5 Chanel 2 Timer 1 Low Byte
PWM52T2 .EQU 0xfcc2 ;PWM 5 Chanel 2 Timer 2 Word
PWM52T2H .EQU 0xfcc2 ;PWM 5 Chanel 2 Timer 2 High Byte
PWM52T2L .EQU 0xfcc3 ;PWM 5 Chanel 2 Timer 2 Low Byte
PWM52CR .EQU 0xfcc4 ;PWM 5 Chanel 2 Control Register
   PWM52_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM52_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM52_ENI   = 0x04 ;Enable Interrupt
   PWM52_INI   = 0x40 ;Initial Output Level
   PWM52_ENO   = 0x80 ;PWM Output Enable Bit
PWM52HLD .EQU 0xfcc5 ;PWM 5 Chanel 2 Level Hold Control
   PWM52_HLDL = 0x01 ;Hold Low Override
   PWM52_HLDH = 0x02 ;Hold High Override
PWM53T1 .EQU 0xfcc8 ;PWM 5 Chanel 3 Timer 1 Word
PWM53T1H .EQU 0xfcc8 ;PWM 5 Chanel 3 Timer 1 High Byte
PWM53T1L .EQU 0xfcc9 ;PWM 5 Chanel 3 Timer 1 Low Byte
PWM53T2 .EQU 0xfcca ;PWM 5 Chanel 3 Timer 2 Word
PWM53T2H .EQU 0xfcca ;PWM 5 Chanel 3 Timer 2 High Byte
PWM53T2L .EQU 0xfccb ;PWM 5 Chanel 3 Timer 2 Low Byte
PWM53CR .EQU 0xfccc ;PWM 5 Chanel 3 Control Register
   PWM53_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM53_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM53_ENI   = 0x04 ;Enable Interrupt
   PWM53_INI   = 0x40 ;Initial Output Level
   PWM53_ENO   = 0x80 ;PWM Output Enable Bit
PWM53HLD .EQU 0xfccd ;PWM 5 Chanel 3 Level Hold Control
   PWM53_HLDL = 0x01 ;Hold Low Override
   PWM53_HLDH = 0x02 ;Hold High Override
PWM54T1 .EQU 0xfcd0 ;PWM 5 Chanel 4 Timer 1 Word
PWM54T1H .EQU 0xfcd0 ;PWM 5 Chanel 4 Timer 1 High Byte
PWM54T1L .EQU 0xfcd1 ;PWM 5 Chanel 4 Timer 1 Low Byte
PWM54T2 .EQU 0xfcd2 ;PWM 5 Chanel 4 Timer 2 Word
PWM54T2H .EQU 0xfcd2 ;PWM 5 Chanel 4 Timer 2 High Byte
PWM54T2L .EQU 0xfcd3 ;PWM 5 Chanel 4 Timer 2 Low Byte
PWM54CR .EQU 0xfcd4 ;PWM 5 Chanel 4 Control Register
   PWM54_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM54_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM54_ENI   = 0x04 ;Enable Interrupt
   PWM54_INI   = 0x40 ;Initial Output Level
   PWM54_ENO   = 0x80 ;PWM Output Enable Bit
PWM54HLD .EQU 0xfcd5 ;PWM 5 Chanel 4 Level Hold Control
   PWM54_HLDL = 0x01 ;Hold Low Override
   PWM54_HLDH = 0x02 ;Hold High Override
PWM55T1 .EQU 0xfcd8 ;PWM 5 Chanel 5 Timer 1 Word
PWM55T1H .EQU 0xfcd8 ;PWM 5 Chanel 5 Timer 1 High Byte
PWM55T1L .EQU 0xfcd9 ;PWM 5 Chanel 5 Timer 1 Low Byte
PWM55T2 .EQU 0xfcda ;PWM 5 Chanel 5 Timer 2 Word
PWM55T2H .EQU 0xfcda ;PWM 5 Chanel 5 Timer 2 High Byte
PWM55T2L .EQU 0xfcdb ;PWM 5 Chanel 5 Timer 2 Low Byte
PWM55CR .EQU 0xfcdc ;PWM 5 Chanel 5 Control Register
   PWM55_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM55_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM55_ENI   = 0x04 ;Enable Interrupt
   PWM55_INI   = 0x40 ;Initial Output Level
   PWM55_ENO   = 0x80 ;PWM Output Enable Bit
PWM55HLD .EQU 0xfcdd ;PWM 5 Chanel 5 Level Hold Control
   PWM55_HLDL = 0x01 ;Hold Low Override
   PWM55_HLDH = 0x02 ;Hold High Override
PWM56T1 .EQU 0xfce0 ;PWM 5 Chanel 6 Timer 1 Word
PWM56T1H .EQU 0xfce0 ;PWM 5 Chanel 6 Timer 1 High Byte
PWM56T1L .EQU 0xfce1 ;PWM 5 Chanel 6 Timer 1 Low Byte
PWM56T2 .EQU 0xfce2 ;PWM 5 Chanel 6 Timer 2 Word
PWM56T2H .EQU 0xfce2 ;PWM 5 Chanel 6 Timer 2 High Byte
PWM56T2L .EQU 0xfce3 ;PWM 5 Chanel 6 Timer 2 Low Byte
PWM56CR .EQU 0xfce4 ;PWM 5 Chanel 6 Control Register
   PWM56_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM56_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM56_ENI   = 0x04 ;Enable Interrupt
   PWM56_INI   = 0x40 ;Initial Output Level
   PWM56_ENO   = 0x80 ;PWM Output Enable Bit
PWM56HLD .EQU 0xfce5 ;PWM 5 Chanel 6 Level Hold Control
   PWM56_HLDL = 0x01 ;Hold Low Override
   PWM56_HLDH = 0x02 ;Hold High Override
PWM57T1 .EQU 0xfce8 ;PWM 5 Chanel 7 Timer 1 Word
PWM57T1H .EQU 0xfce8 ;PWM 5 Chanel 7 Timer 1 High Byte
PWM57T1L .EQU 0xfce9 ;PWM 5 Chanel 7 Timer 1 Low Byte
PWM57T2 .EQU 0xfcea ;PWM 5 Chanel 7 Timer 2 Word
PWM57T2H .EQU 0xfcea ;PWM 5 Chanel 7 Timer 2 High Byte
PWM57T2L .EQU 0xfceb ;PWM 5 Chanel 7 Timer 2 Low Byte
PWM57CR .EQU 0xfcec ;PWM 5 Chanel 7 Control Register
   PWM57_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM57_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM57_ENI   = 0x04 ;Enable Interrupt
   PWM57_INI   = 0x40 ;Initial Output Level
   PWM57_ENO   = 0x80 ;PWM Output Enable Bit
PWM57HLD .EQU 0xfced ;PWM 5 Chanel 7 Level Hold Control
   PWM57_HLDL = 0x01 ;Hold Low Override
   PWM57_HLDH = 0x02 ;Hold High Override
MD3 .EQU 0xfcf0 ;Operand 3 Data Register
MD2 .EQU 0xfcf1 ;Operand 2 Data Register
MD1 .EQU 0xfcf2 ;Operand 1 Data Register
MD0 .EQU 0xfcf3 ;Operand 0 Data Register
MD5 .EQU 0xfcf4 ;Operand 5 Data Register
MD4 .EQU 0xfcf5 ;Operand 4 Data Register
ARCON .EQU 0xfcf6 ;Multiply Divide Unit Array Control
   SC     = 0x1F ;Shift Count
   ARMODE = 0xE0 ;Mode Select
OPCON .EQU 0xfcf7 ;Multiply Divide Unit Operation Control
   ENOP = 0x01 ;Enable Operation
   RST  = 0x02 ;Software Reset
   MDOV = 0x40 ;Overflow Flag
P0INTE .EQU 0xfd00 ;Port 0 Interrupt Enable Register
   P00INTE = 0x01 ;
   P01INTE = 0x02 ;
   P02INTE = 0x04 ;
   P03INTE = 0x08 ;
   P04INTE = 0x10 ;
   P05INTE = 0x20 ;
   P06INTE = 0x40 ;
   P07INTE = 0x80 ;
P1INTE .EQU 0xfd01 ;Port 1 Interrupt Enable Register
   P10INTE = 0x01 ;
   P11INTE = 0x02 ;
   P12INTE = 0x04 ;
   P13INTE = 0x08 ;
   P14INTE = 0x10 ;
   P15INTE = 0x20 ;
   P16INTE = 0x40 ;
   P17INTE = 0x80 ;
P2INTE .EQU 0xfd02 ;Port 2 Interrupt Enable Register
   P20INTE = 0x01 ;
   P21INTE = 0x02 ;
   P22INTE = 0x04 ;
   P23INTE = 0x08 ;
   P24INTE = 0x10 ;
   P25INTE = 0x20 ;
   P26INTE = 0x40 ;
   P27INTE = 0x80 ;
P3INTE .EQU 0xfd03 ;Port 3 Interrupt Enable Register
   P30INTE = 0x01 ;
   P31INTE = 0x02 ;
   P32INTE = 0x04 ;
   P33INTE = 0x08 ;
   P34INTE = 0x10 ;
   P35INTE = 0x20 ;
   P36INTE = 0x40 ;
   P37INTE = 0x80 ;
P4INTE .EQU 0xfd04 ;Port 4 Interrupt Enable Register
   P40INTE = 0x01 ;
   P41INTE = 0x02 ;
   P42INTE = 0x04 ;
   P43INTE = 0x08 ;
   P44INTE = 0x10 ;
   P45INTE = 0x20 ;
   P46INTE = 0x40 ;
   P47INTE = 0x80 ;
P5INTE .EQU 0xfd05 ;Port 5 Interrupt Enable Register
   P50INTE = 0x01 ;
   P51INTE = 0x02 ;
   P52INTE = 0x04 ;
   P53INTE = 0x08 ;
   P54INTE = 0x10 ;
   P55INTE = 0x20 ;
P6INTE .EQU 0xfd06 ;Port 6 Interrupt Enable Register
   P60INTE = 0x01 ;
   P61INTE = 0x02 ;
   P62INTE = 0x04 ;
   P63INTE = 0x08 ;
   P64INTE = 0x10 ;
   P65INTE = 0x20 ;
   P66INTE = 0x40 ;
   P67INTE = 0x80 ;
P7INTE .EQU 0xfd07 ;Port 7 Interrupt Enable Register
   P70INTE = 0x01 ;
   P71INTE = 0x02 ;
   P72INTE = 0x04 ;
   P73INTE = 0x08 ;
   P74INTE = 0x10 ;
   P75INTE = 0x20 ;
   P76INTE = 0x40 ;
   P77INTE = 0x80 ;
P0INTF .EQU 0xfd10 ;Port 0 Interrupt Flag Register
   P00INTF = 0x01 ;
   P01INTF = 0x02 ;
   P02INTF = 0x04 ;
   P03INTF = 0x08 ;
   P04INTF = 0x10 ;
   P05INTF = 0x20 ;
   P06INTF = 0x40 ;
   P07INTF = 0x80 ;
P1INTF .EQU 0xfd11 ;Port 1 Interrupt Flag Register
   P10INTF = 0x01 ;
   P11INTF = 0x02 ;
   P12INTF = 0x04 ;
   P13INTF = 0x08 ;
   P14INTF = 0x10 ;
   P15INTF = 0x20 ;
   P16INTF = 0x40 ;
   P17INTF = 0x80 ;
P2INTF .EQU 0xfd12 ;Port 2 Interrupt Flag Register
   P20INTF = 0x01 ;
   P21INTF = 0x02 ;
   P22INTF = 0x04 ;
   P23INTF = 0x08 ;
   P24INTF = 0x10 ;
   P25INTF = 0x20 ;
   P26INTF = 0x40 ;
   P27INTF = 0x80 ;
P3INTF .EQU 0xfd13 ;Port 3 Interrupt Flag Register
   P30INTF = 0x01 ;
   P31INTF = 0x02 ;
   P32INTF = 0x04 ;
   P33INTF = 0x08 ;
   P34INTF = 0x10 ;
   P35INTF = 0x20 ;
   P36INTF = 0x40 ;
   P37INTF = 0x80 ;
P4INTF .EQU 0xfd14 ;Port 4 Interrupt Flag Register
   P40INTF = 0x01 ;
   P41INTF = 0x02 ;
   P42INTF = 0x04 ;
   P43INTF = 0x08 ;
   P44INTF = 0x10 ;
   P45INTF = 0x20 ;
   P46INTF = 0x40 ;
   P47INTF = 0x80 ;
P5INTF .EQU 0xfd15 ;Port 5 Interrupt Flag Register
   P50INTF = 0x01 ;
   P51INTF = 0x02 ;
   P52INTF = 0x04 ;
   P53INTF = 0x08 ;
   P54INTF = 0x10 ;
   P55INTF = 0x20 ;
P6INTF .EQU 0xfd16 ;Port 6 Interrupt Flag Register
   P60INTF = 0x01 ;
   P61INTF = 0x02 ;
   P62INTF = 0x04 ;
   P63INTF = 0x08 ;
   P64INTF = 0x10 ;
   P65INTF = 0x20 ;
   P66INTF = 0x40 ;
   P67INTF = 0x80 ;
P7INTF .EQU 0xfd17 ;Port 7 Interrupt Flag Register
   P70INTF = 0x01 ;
   P71INTF = 0x02 ;
   P72INTF = 0x04 ;
   P73INTF = 0x08 ;
   P74INTF = 0x10 ;
   P75INTF = 0x20 ;
   P76INTF = 0x40 ;
   P77INTF = 0x80 ;
P0IM0 .EQU 0xfd20 ;Port 0 Interrupt Mode Register 0
   P00IM0 = 0x01 ;
   P01IM0 = 0x02 ;
   P02IM0 = 0x04 ;
   P03IM0 = 0x08 ;
   P04IM0 = 0x10 ;
   P05IM0 = 0x20 ;
   P06IM0 = 0x40 ;
   P07IM0 = 0x80 ;
P1IM0 .EQU 0xfd21 ;Port 1 Interrupt Mode Register 0
   P10IM0 = 0x01 ;
   P11IM0 = 0x02 ;
   P12IM0 = 0x04 ;
   P13IM0 = 0x08 ;
   P14IM0 = 0x10 ;
   P15IM0 = 0x20 ;
   P16IM0 = 0x40 ;
   P17IM0 = 0x80 ;
P2IM0 .EQU 0xfd22 ;Port 2 Interrupt Mode Register 0
   P20IM0 = 0x01 ;
   P21IM0 = 0x02 ;
   P22IM0 = 0x04 ;
   P23IM0 = 0x08 ;
   P24IM0 = 0x10 ;
   P25IM0 = 0x20 ;
   P26IM0 = 0x40 ;
   P27IM0 = 0x80 ;
P3IM0 .EQU 0xfd23 ;Port 3 Interrupt Mode Register 0
   P30IM0 = 0x01 ;
   P31IM0 = 0x02 ;
   P32IM0 = 0x04 ;
   P33IM0 = 0x08 ;
   P34IM0 = 0x10 ;
   P35IM0 = 0x20 ;
   P36IM0 = 0x40 ;
   P37IM0 = 0x80 ;
P4IM0 .EQU 0xfd24 ;Port 4 Interrupt Mode Register 0
   P40IM0 = 0x01 ;
   P41IM0 = 0x02 ;
   P42IM0 = 0x04 ;
   P43IM0 = 0x08 ;
   P44IM0 = 0x10 ;
   P45IM0 = 0x20 ;
   P46IM0 = 0x40 ;
   P47IM0 = 0x80 ;
P5IM0 .EQU 0xfd25 ;Port 5 Interrupt Mode Register 0
   P50IM0 = 0x01 ;
   P51IM0 = 0x02 ;
   P52IM0 = 0x04 ;
   P53IM0 = 0x08 ;
   P54IM0 = 0x10 ;
   P55IM0 = 0x20 ;
P6IM0 .EQU 0xfd26 ;Port 6 Interrupt Mode Register 0
   P60IM0 = 0x01 ;
   P61IM0 = 0x02 ;
   P62IM0 = 0x04 ;
   P63IM0 = 0x08 ;
   P64IM0 = 0x10 ;
   P65IM0 = 0x20 ;
   P66IM0 = 0x40 ;
   P67IM0 = 0x80 ;
P7IM0 .EQU 0xfd27 ;Port 7 Interrupt Mode Register 0
   P70IM0 = 0x01 ;
   P71IM0 = 0x02 ;
   P72IM0 = 0x04 ;
   P73IM0 = 0x08 ;
   P74IM0 = 0x10 ;
   P75IM0 = 0x20 ;
   P76IM0 = 0x40 ;
   P77IM0 = 0x80 ;
P0IM1 .EQU 0xfd30 ;Port 0 Interrupt Mode Register 1
   P00IM1 = 0x01 ;
   P01IM1 = 0x02 ;
   P02IM1 = 0x04 ;
   P03IM1 = 0x08 ;
   P04IM1 = 0x10 ;
   P05IM1 = 0x20 ;
   P06IM1 = 0x40 ;
   P07IM1 = 0x80 ;
P1IM1 .EQU 0xfd31 ;Port 1 Interrupt Mode Register 1
   P10IM1 = 0x01 ;
   P11IM1 = 0x02 ;
   P12IM1 = 0x04 ;
   P13IM1 = 0x08 ;
   P14IM1 = 0x10 ;
   P15IM1 = 0x20 ;
   P16IM1 = 0x40 ;
   P17IM1 = 0x80 ;
P2IM1 .EQU 0xfd32 ;Port 2 Interrupt Mode Register 1
   P20IM1 = 0x01 ;
   P21IM1 = 0x02 ;
   P22IM1 = 0x04 ;
   P23IM1 = 0x08 ;
   P24IM1 = 0x10 ;
   P25IM1 = 0x20 ;
   P26IM1 = 0x40 ;
   P27IM1 = 0x80 ;
P3IM1 .EQU 0xfd33 ;Port 3 Interrupt Mode Register 1
   P30IM1 = 0x01 ;
   P31IM1 = 0x02 ;
   P32IM1 = 0x04 ;
   P33IM1 = 0x08 ;
   P34IM1 = 0x10 ;
   P35IM1 = 0x20 ;
   P36IM1 = 0x40 ;
   P37IM1 = 0x80 ;
P4IM1 .EQU 0xfd34 ;Port 4 Interrupt Mode Register 1
   P40IM1 = 0x01 ;
   P41IM1 = 0x02 ;
   P42IM1 = 0x04 ;
   P43IM1 = 0x08 ;
   P44IM1 = 0x10 ;
   P45IM1 = 0x20 ;
   P46IM1 = 0x40 ;
   P47IM1 = 0x80 ;
P5IM1 .EQU 0xfd35 ;Port 5 Interrupt Mode Register 1
   P50IM1 = 0x01 ;
   P51IM1 = 0x02 ;
   P52IM1 = 0x04 ;
   P53IM1 = 0x08 ;
   P54IM1 = 0x10 ;
   P55IM1 = 0x20 ;
P6IM1 .EQU 0xfd36 ;Port 6 Interrupt Mode Register 1
   P60IM1 = 0x01 ;
   P61IM1 = 0x02 ;
   P62IM1 = 0x04 ;
   P63IM1 = 0x08 ;
   P64IM1 = 0x10 ;
   P65IM1 = 0x20 ;
   P66IM1 = 0x40 ;
   P67IM1 = 0x80 ;
P7IM1 .EQU 0xfd37 ;Port 7 Interrupt Mode Register 1
   P70IM1 = 0x01 ;
   P71IM1 = 0x02 ;
   P72IM1 = 0x04 ;
   P73IM1 = 0x08 ;
   P74IM1 = 0x10 ;
   P75IM1 = 0x20 ;
   P76IM1 = 0x40 ;
   P77IM1 = 0x80 ;
P0WKUE .EQU 0xfd40 ;Port 0 Wake-up Enable Register
   P00WKUE = 0x01 ;
   P01WKUE = 0x02 ;
   P02WKUE = 0x04 ;
   P03WKUE = 0x08 ;
   P04WKUE = 0x10 ;
   P05WKUE = 0x20 ;
   P06WKUE = 0x40 ;
   P07WKUE = 0x80 ;
P1WKUE .EQU 0xfd41 ;Port 1 Wake-up Enable Register
   P10WKUE = 0x01 ;
   P11WKUE = 0x02 ;
   P12WKUE = 0x04 ;
   P13WKUE = 0x08 ;
   P14WKUE = 0x10 ;
   P15WKUE = 0x20 ;
   P16WKUE = 0x40 ;
   P17WKUE = 0x80 ;
P2WKUE .EQU 0xfd42 ;Port 2 Wake-up Enable Register
   P20WKUE = 0x01 ;
   P21WKUE = 0x02 ;
   P22WKUE = 0x04 ;
   P23WKUE = 0x08 ;
   P24WKUE = 0x10 ;
   P25WKUE = 0x20 ;
   P26WKUE = 0x40 ;
   P27WKUE = 0x80 ;
P3WKUE .EQU 0xfd43 ;Port 3 Wake-up Enable Register
   P30WKUE = 0x01 ;
   P31WKUE = 0x02 ;
   P32WKUE = 0x04 ;
   P33WKUE = 0x08 ;
   P34WKUE = 0x10 ;
   P35WKUE = 0x20 ;
   P36WKUE = 0x40 ;
   P37WKUE = 0x80 ;
P4WKUE .EQU 0xfd44 ;Port 4 Wake-up Enable Register
   P40WKUE = 0x01 ;
   P41WKUE = 0x02 ;
   P42WKUE = 0x04 ;
   P43WKUE = 0x08 ;
   P44WKUE = 0x10 ;
   P45WKUE = 0x20 ;
   P46WKUE = 0x40 ;
   P47WKUE = 0x80 ;
P5WKUE .EQU 0xfd45 ;Port 5 Wake-up Enable Register
   P50WKUE = 0x01 ;
   P51WKUE = 0x02 ;
   P52WKUE = 0x04 ;
   P53WKUE = 0x08 ;
   P54WKUE = 0x10 ;
   P55WKUE = 0x20 ;
P6WKUE .EQU 0xfd46 ;Port 6 Wake-up Enable Register
   P60WKUE = 0x01 ;
   P61WKUE = 0x02 ;
   P62WKUE = 0x04 ;
   P63WKUE = 0x08 ;
   P64WKUE = 0x10 ;
   P65WKUE = 0x20 ;
   P66WKUE = 0x40 ;
   P67WKUE = 0x80 ;
P7WKUE .EQU 0xfd47 ;Port 7 Wake-up Enable Register
   P70WKUE = 0x01 ;
   P71WKUE = 0x02 ;
   P72WKUE = 0x04 ;
   P73WKUE = 0x08 ;
   P74WKUE = 0x10 ;
   P75WKUE = 0x20 ;
   P76WKUE = 0x40 ;
   P77WKUE = 0x80 ;
PINIPL .EQU 0xfd60 ;IO Port Interrupt Priority Low
   P0IP = 0x01 ;
   P1IP = 0x02 ;
   P2IP = 0x04 ;
   P3IP = 0x08 ;
   P4IP = 0x10 ;
   P5IP = 0x20 ;
   P6IP = 0x40 ;
   P7IP = 0x80 ;
PINIPH .EQU 0xfd61 ;IO Port Interrupt Priority High
   P0IPH = 0x01 ;
   P1IPH = 0x02 ;
   P2IPH = 0x04 ;
   P3IPH = 0x08 ;
   P4IPH = 0x10 ;
   P5IPH = 0x20 ;
   P6IPH = 0x40 ;
   P7IPH = 0x80 ;
CKSEL .EQU 0xfe00 ;Clock Select Register
   MCKSEL = 0x03 ;Main Clock Source Selection
CLKDIV .EQU 0xfe01 ;Clock Frequency Division Register
HIRCCR .EQU 0xfe02 ;High Accuracy Internal RC Control Register
   HIRCST = 0x01 ;Internal High Speed/Precision Oscillator Stability Indicator
   ENHIRC = 0x80 ;Enable Internal High Speed/Precision Clock Source
XOSCCR .EQU 0xfe03 ;External Oscillator Control Register
   XOSCST = 0x01 ;External Crystal Oscillator Stability Indicator
   XITYPE = 0x40 ;External Clock Source Type
   ENXOSC = 0x80 ;Enable External Crystal Clock Source
IRC32KCR .EQU 0xfe04 ;Internal 32K Oscillator Control Register
   IRC32KST = 0x01 ;Internal RC 32 KHz Oscillator Stability Indicator
   ENIRC32K = 0x80 ;Enable Internal RC 32 KHz Clock Source
MCLKOCR .EQU 0xfe05 ;Main Clock Output Control Register
   MCLKODIV = 0x7F ;Main Clock Output Division Coefficient
   MCLKO_S    = 0x80 ;Main Clock Output Pin Selection
IRCDB .EQU 0xfe06 ;Internal RC High Speed Oscillator
   IRCDB_PAR = 0xFF ;
X32KCR .EQU 0xfe08 ;External 32 KHz Oscillator Control Register
   X32KST  = 0x01 ;External 32 KHz Crystal Oscillator Stability Indicator
   GAIN32K = 0x40 ;External 32 KHz Crystal Oscillator Gain Control
   ENX32K  = 0x80 ;Enable External 32 KHz Crystal Oscillator
P0PU .EQU 0xfe10 ;Port 0 Pull-up Resistor Control Register
   P00PU = 0x01 ;
   P01PU = 0x02 ;
   P02PU = 0x04 ;
   P03PU = 0x08 ;
   P04PU = 0x10 ;
   P05PU = 0x20 ;
   P06PU = 0x40 ;
   P07PU = 0x80 ;
P1PU .EQU 0xfe11 ;Port 1 Pull-up Resistor Control Register
   P10PU = 0x01 ;
   P11PU = 0x02 ;
   P12PU = 0x04 ;
   P13PU = 0x08 ;
   P14PU = 0x10 ;
   P15PU = 0x20 ;
   P16PU = 0x40 ;
   P17PU = 0x80 ;
P2PU .EQU 0xfe12 ;Port 2 Pull-up Resistor Control Register
   P20PU = 0x01 ;
   P21PU = 0x02 ;
   P22PU = 0x04 ;
   P23PU = 0x08 ;
   P24PU = 0x10 ;
   P25PU = 0x20 ;
   P26PU = 0x40 ;
   P27PU = 0x80 ;
P3PU .EQU 0xfe13 ;Port 3 Pull-up Resistor Control Register
   P30PU = 0x01 ;
   P31PU = 0x02 ;
   P32PU = 0x04 ;
   P33PU = 0x08 ;
   P34PU = 0x10 ;
   P35PU = 0x20 ;
   P36PU = 0x40 ;
   P37PU = 0x80 ;
P4PU .EQU 0xfe14 ;Port 4 Pull-up Resistor Control Register
   P40PU = 0x01 ;
   P41PU = 0x02 ;
   P42PU = 0x04 ;
   P43PU = 0x08 ;
   P44PU = 0x10 ;
   P45PU = 0x20 ;
   P46PU = 0x40 ;
   P47PU = 0x80 ;
P5PU .EQU 0xfe15 ;Port 5 Pull-up Resistor Control Register
   P50PU = 0x01 ;
   P51PU = 0x02 ;
   P52PU = 0x04 ;
   P53PU = 0x08 ;
   P54PU = 0x10 ;
   P55PU = 0x20 ;
P6PU .EQU 0xfe16 ;Port 6 Pull-up Resistor Control Register
   P60PU = 0x01 ;
   P61PU = 0x02 ;
   P62PU = 0x04 ;
   P63PU = 0x08 ;
   P64PU = 0x10 ;
   P65PU = 0x20 ;
   P66PU = 0x40 ;
   P67PU = 0x80 ;
P7PU .EQU 0xfe17 ;Port 7 Pull-up Resistor Control Register
   P70PU = 0x01 ;
   P71PU = 0x02 ;
   P72PU = 0x04 ;
   P73PU = 0x08 ;
   P74PU = 0x10 ;
   P75PU = 0x20 ;
   P76PU = 0x40 ;
   P77PU = 0x80 ;
P0NCS .EQU 0xfe18 ;Port 0 Schmidt Trigger Control Register
   P00NCS = 0x01 ;
   P01NCS = 0x02 ;
   P02NCS = 0x04 ;
   P03NCS = 0x08 ;
   P04NCS = 0x10 ;
   P05NCS = 0x20 ;
   P06NCS = 0x40 ;
   P07NCS = 0x80 ;
P1NCS .EQU 0xfe19 ;Port 1 Schmidt Trigger Control Register
   P10NCS = 0x01 ;
   P11NCS = 0x02 ;
   P12NCS = 0x04 ;
   P13NCS = 0x08 ;
   P14NCS = 0x10 ;
   P15NCS = 0x20 ;
   P16NCS = 0x40 ;
   P17NCS = 0x80 ;
P2NCS .EQU 0xfe1a ;Port 2 Schmidt Trigger Control Register
   P20NCS = 0x01 ;
   P21NCS = 0x02 ;
   P22NCS = 0x04 ;
   P23NCS = 0x08 ;
   P24NCS = 0x10 ;
   P25NCS = 0x20 ;
   P26NCS = 0x40 ;
   P27NCS = 0x80 ;
P3NCS .EQU 0xfe1b ;Port 3 Schmidt Trigger Control Register
   P30NCS = 0x01 ;
   P31NCS = 0x02 ;
   P32NCS = 0x04 ;
   P33NCS = 0x08 ;
   P34NCS = 0x10 ;
   P35NCS = 0x20 ;
   P36NCS = 0x40 ;
   P37NCS = 0x80 ;
P4NCS .EQU 0xfe1c ;Port 4 Schmidt Trigger Control Register
   P40NCS = 0x01 ;
   P41NCS = 0x02 ;
   P42NCS = 0x04 ;
   P43NCS = 0x08 ;
   P44NCS = 0x10 ;
   P45NCS = 0x20 ;
   P46NCS = 0x40 ;
   P47NCS = 0x80 ;
P5NCS .EQU 0xfe1d ;Port 5 Schmidt Trigger Control Register
   P50NCS = 0x01 ;
   P51NCS = 0x02 ;
   P52NCS = 0x04 ;
   P53NCS = 0x08 ;
   P54NCS = 0x10 ;
   P55NCS = 0x20 ;
P6NCS .EQU 0xfe1e ;Port 6 Schmidt Trigger Control Register
   P60NCS = 0x01 ;
   P61NCS = 0x02 ;
   P62NCS = 0x04 ;
   P63NCS = 0x08 ;
   P64NCS = 0x10 ;
   P65NCS = 0x20 ;
   P66NCS = 0x40 ;
   P67NCS = 0x80 ;
P7NCS .EQU 0xfe1f ;Port 7 Schmidt Trigger Control Register
   P70NCS = 0x01 ;
   P71NCS = 0x02 ;
   P72NCS = 0x04 ;
   P73NCS = 0x08 ;
   P74NCS = 0x10 ;
   P75NCS = 0x20 ;
   P76NCS = 0x40 ;
   P77NCS = 0x80 ;
P0SR .EQU 0xfe20 ;Port 0 Slew Rate Control Register
   P00SR = 0x01 ;
   P01SR = 0x02 ;
   P02SR = 0x04 ;
   P03SR = 0x08 ;
   P04SR = 0x10 ;
   P05SR = 0x20 ;
   P06SR = 0x40 ;
   P07SR = 0x80 ;
P1SR .EQU 0xfe21 ;Port 1 Slew Rate Control Register
   P10SR = 0x01 ;
   P11SR = 0x02 ;
   P12SR = 0x04 ;
   P13SR = 0x08 ;
   P14SR = 0x10 ;
   P15SR = 0x20 ;
   P16SR = 0x40 ;
   P17SR = 0x80 ;
P2SR .EQU 0xfe22 ;Port 2 Slew Rate Control Register
   P20SR = 0x01 ;
   P21SR = 0x02 ;
   P22SR = 0x04 ;
   P23SR = 0x08 ;
   P24SR = 0x10 ;
   P25SR = 0x20 ;
   P26SR = 0x40 ;
   P27SR = 0x80 ;
P3SR .EQU 0xfe23 ;Port 3 Slew Rate Control Register
   P30SR = 0x01 ;
   P31SR = 0x02 ;
   P32SR = 0x04 ;
   P33SR = 0x08 ;
   P34SR = 0x10 ;
   P35SR = 0x20 ;
   P36SR = 0x40 ;
   P37SR = 0x80 ;
P4SR .EQU 0xfe24 ;Port 4 Slew Rate Control Register
   P40SR = 0x01 ;
   P41SR = 0x02 ;
   P42SR = 0x04 ;
   P43SR = 0x08 ;
   P44SR = 0x10 ;
   P45SR = 0x20 ;
   P46SR = 0x40 ;
   P47SR = 0x80 ;
P5SR .EQU 0xfe25 ;Port 5 Slew Rate Control Register
   P50SR = 0x01 ;
   P51SR = 0x02 ;
   P52SR = 0x04 ;
   P53SR = 0x08 ;
   P54SR = 0x10 ;
   P55SR = 0x20 ;
P6SR .EQU 0xfe26 ;Port 6 Slew Rate Control Register
   P60SR = 0x01 ;
   P61SR = 0x02 ;
   P62SR = 0x04 ;
   P63SR = 0x08 ;
   P64SR = 0x10 ;
   P65SR = 0x20 ;
   P66SR = 0x40 ;
   P67SR = 0x80 ;
P7SR .EQU 0xfe27 ;Port 7 Slew Rate Control Register
   P70SR = 0x01 ;
   P71SR = 0x02 ;
   P72SR = 0x04 ;
   P73SR = 0x08 ;
   P74SR = 0x10 ;
   P75SR = 0x20 ;
   P76SR = 0x40 ;
   P77SR = 0x80 ;
P0DR .EQU 0xfe28 ;Port 0 Drive Current Control Register
   P00DR = 0x01 ;
   P01DR = 0x02 ;
   P02DR = 0x04 ;
   P03DR = 0x08 ;
   P04DR = 0x10 ;
   P05DR = 0x20 ;
   P06DR = 0x40 ;
   P07DR = 0x80 ;
P1DR .EQU 0xfe29 ;Port 1 Drive Current Control Register
   P10DR = 0x01 ;
   P11DR = 0x02 ;
   P12DR = 0x04 ;
   P13DR = 0x08 ;
   P14DR = 0x10 ;
   P15DR = 0x20 ;
   P16DR = 0x40 ;
   P17DR = 0x80 ;
P2DR .EQU 0xfe2a ;Port 2 Drive Current Control Register
   P20DR = 0x01 ;
   P21DR = 0x02 ;
   P22DR = 0x04 ;
   P23DR = 0x08 ;
   P24DR = 0x10 ;
   P25DR = 0x20 ;
   P26DR = 0x40 ;
   P27DR = 0x80 ;
P3DR .EQU 0xfe2b ;Port 3 Drive Current Control Register
   P30DR = 0x01 ;
   P31DR = 0x02 ;
   P32DR = 0x04 ;
   P33DR = 0x08 ;
   P34DR = 0x10 ;
   P35DR = 0x20 ;
   P36DR = 0x40 ;
   P37DR = 0x80 ;
P4DR .EQU 0xfe2c ;Port 4 Drive Current Control Register
   P40DR = 0x01 ;
   P41DR = 0x02 ;
   P42DR = 0x04 ;
   P43DR = 0x08 ;
   P44DR = 0x10 ;
   P45DR = 0x20 ;
   P46DR = 0x40 ;
   P47DR = 0x80 ;
P5DR .EQU 0xfe2d ;Port 5 Drive Current Control Register
   P50DR = 0x01 ;
   P51DR = 0x02 ;
   P52DR = 0x04 ;
   P53DR = 0x08 ;
   P54DR = 0x10 ;
   P55DR = 0x20 ;
P6DR .EQU 0xfe2e ;Port 6 Drive Current Control Register
   P60DR = 0x01 ;
   P61DR = 0x02 ;
   P62DR = 0x04 ;
   P63DR = 0x08 ;
   P64DR = 0x10 ;
   P65DR = 0x20 ;
   P66DR = 0x40 ;
   P67DR = 0x80 ;
P7DR .EQU 0xfe2f ;Port 7 Drive Current Control Register
   P70DR = 0x01 ;
   P71DR = 0x02 ;
   P72DR = 0x04 ;
   P73DR = 0x08 ;
   P74DR = 0x10 ;
   P75DR = 0x20 ;
   P76DR = 0x40 ;
   P77DR = 0x80 ;
P0IE .EQU 0xfe30 ;Port 0 Digital Input Enable Register
   P00IE = 0x01 ;
   P01IE = 0x02 ;
   P02IE = 0x04 ;
   P03IE = 0x08 ;
   P04IE = 0x10 ;
   P05IE = 0x20 ;
   P06IE = 0x40 ;
   P07IE = 0x80 ;
P1IE .EQU 0xfe31 ;Port 1 Digital Input Enable Register
   P10IE = 0x01 ;
   P11IE = 0x02 ;
   P12IE = 0x04 ;
   P13IE = 0x08 ;
   P14IE = 0x10 ;
   P15IE = 0x20 ;
   P16IE = 0x40 ;
   P17IE = 0x80 ;
P2IE .EQU 0xfe32 ;Port 2 Digital Input Enable Register
   P20IE = 0x01 ;
   P21IE = 0x02 ;
   P22IE = 0x04 ;
   P23IE = 0x08 ;
   P24IE = 0x10 ;
   P25IE = 0x20 ;
   P26IE = 0x40 ;
   P27IE = 0x80 ;
P3IE .EQU 0xfe33 ;Port 3 Digital Input Enable Register
   P30IE = 0x01 ;
   P31IE = 0x02 ;
   P32IE = 0x04 ;
   P33IE = 0x08 ;
   P34IE = 0x10 ;
   P35IE = 0x20 ;
   P36IE = 0x40 ;
   P37IE = 0x80 ;
P4IE .EQU 0xfe34 ;Port 4 Digital Input Enable Register
   P40IE = 0x01 ;
   P41IE = 0x02 ;
   P42IE = 0x04 ;
   P43IE = 0x08 ;
   P44IE = 0x10 ;
   P45IE = 0x20 ;
   P46IE = 0x40 ;
   P47IE = 0x80 ;
P5IE .EQU 0xfe35 ;Port 5 Digital Input Enable Register
   P50IE = 0x01 ;
   P51IE = 0x02 ;
   P52IE = 0x04 ;
   P53IE = 0x08 ;
   P54IE = 0x10 ;
   P55IE = 0x20 ;
P6IE .EQU 0xfe36 ;Port 6 Digital Input Enable Register
   P60IE = 0x01 ;
   P61IE = 0x02 ;
   P62IE = 0x04 ;
   P63IE = 0x08 ;
   P64IE = 0x10 ;
   P65IE = 0x20 ;
   P66IE = 0x40 ;
   P67IE = 0x80 ;
P7IE .EQU 0xfe37 ;Port 7 Digital Input Enable Register
   P70IE = 0x01 ;
   P71IE = 0x02 ;
   P72IE = 0x04 ;
   P73IE = 0x08 ;
   P74IE = 0x10 ;
   P75IE = 0x20 ;
   P76IE = 0x40 ;
   P77IE = 0x80 ;
RTCCR .EQU 0xfe60 ;Real Time Clock Control Register
   RUNRTC = 0x01 ;Real Time Clock Run-Stop
RTCCFG .EQU 0xfe61 ;Real Time Clock Config Register
   SETRTC = 0x01 ;Set Real Time Clock
   RTCCKS = 0x02 ;Real Time Clock Clock-Source Select
RTCIEN .EQU 0xfe62 ;Real Time Clock Interrupt Enable
   ESEC32I = 0x01 ;Enable 1/32s Interrupt
   ESEC8I  = 0x02 ;Enable 1/8s Interrupt
   ESEC2I  = 0x04 ;Enable 1/2s Interrupt
   ESECI   = 0x08 ;Enable Seconds Interrupt
   EMINI   = 0x10 ;Enable Minutes Interrupt
   EHOURI  = 0x20 ;Enable Hourly Interrupt
   EDAYI   = 0x40 ;Enable Daily Interrupt
   EALAI   = 0x80 ;Enable Alarm Interrupt
RTCIF .EQU 0xfe63 ;Real Time Clock Interrupt Flag
   SEC32IF = 0x01 ;1/32s Interrupt Flag
   SEC8IF  = 0x02 ;1/8s Interrupt Flag
   SEC2IF  = 0x04 ;1/2s Interrupt Flag
   SECIF   = 0x08 ;Seconds Interrupt Flag
   MINIF   = 0x10 ;Minutes Interrupt Flag
   HOURIF  = 0x20 ;Hourly Interrupt Flag
   DAYIF   = 0x40 ;Daily Interrupt Flag
   ALAIF   = 0x80 ;Alarm Interrupt Flag
ALAHOUR .EQU 0xfe64 ;Alarm Hour Value
ALAMIN .EQU 0xfe65 ;Alarm Minute Value
ALASEC .EQU 0xfe66 ;Alarm Second Value
ALASSEC .EQU 0xfe67 ;Alarm Subsecond 1/127s Value
INIYEAR .EQU 0xfe68 ;Initialize Year
INIMONTH .EQU 0xfe69 ;Initialize Month
INIDAY .EQU 0xfe6a ;Initialize Day
INIHOUR .EQU 0xfe6b ;Initialize Hour
INIMIN .EQU 0xfe6c ;Initialize Minute
INISEC .EQU 0xfe6d ;Initialize Second
INISSEC .EQU 0xfe6e ;Initialize Subsecond 1/127s
YEAR .EQU 0xfe70 ;Current Year
MONTH .EQU 0xfe71 ;Current Month
DAY .EQU 0xfe72 ;Current Day
HOUR .EQU 0xfe73 ;Current Hour
MIN .EQU 0xfe74 ;Current Minute
SEC .EQU 0xfe75 ;Current Second
SSEC .EQU 0xfe76 ;Current Subsecond 1/127s
I2CCFG .EQU 0xfe80 ;I2C configuration
   MSSPEED = 0x3F ;I2C Bus Speed Selection
   MSSL    = 0x40 ;Master or Slave Mode Select
   ENI2C   = 0x80 ;Enable I2C Functionality
I2CMSCR .EQU 0xfe81 ;I2C Master Control
   MSCMD = 0x0F ;Master Command Execution
   EMSI  = 0x80 ;Enable Master Interrupt
I2CMSST .EQU 0xfe82 ;I2C Master Status
   MSACKO = 0x01 ;Master Mode Output ACK
   MSACKI = 0x02 ;Master Mode Input ACK
   MSIF   = 0x40 ;Master Mode Interrupt Flag
   MSBUSY = 0x80 ;Master Busy Flag
I2CSLCR .EQU 0xfe83 ;I2C Slave Control
   SLRST = 0x01 ;Slave Reset Mode
   ESTOI = 0x08 ;Enable Interrupt after STOP is received in Slave Mode
   ETXI  = 0x10 ;Enable Interrupt after data is sent in Slave Mode
   ERXI  = 0x20 ;Enable Interrupt after data is received in Slave Mode
   ESTAI = 0x40 ;Enable Interrupt after START is received in Slave Mode
I2CSLST .EQU 0xfe84 ;I2C Slave Status
   SLACKO = 0x01 ;Slave ACK Output Flag
   SLACKI = 0x02 ;Slave ACK Input Flag
   TXING  = 0x04 ;Undocumented
   STOIF  = 0x08 ;STOP signal Interrupt Flag
   TXIF   = 0x10 ;Transmit Data Interrupt Flag
   RXIF   = 0x20 ;Received Data Interrupt Flag
   STAIF  = 0x40 ;START Interrupt Flag in Slave Mode
   SLBUSY = 0x80 ;Slave Busy Flag
I2CSLADR .EQU 0xfe85 ;I2C Slave Address
   MA    = 0x01 ;Slave Device Address Matching
   SLADR = 0xFE ;Slave Device Address
I2CTXD .EQU 0xfe86 ;I2C Data Transmit Register
I2CRXD .EQU 0xfe87 ;I2C Data Receive Register
I2CMSAUX .EQU 0xfe88 ;I2C Master Auxiliary Control
   WDTA = 0x01 ;I2C Write Data Automatic Send Enable in Master Module
TM2PS .EQU 0xfea2 ;Timer 2 Prescaler
TM3PS .EQU 0xfea3 ;Timer 3 Prescaler
TM4PS .EQU 0xfea4 ;Timer 4 Prescaler
ADCTIM .EQU 0xfea8 ;ADC Timing Control
T3T4PS .EQU 0xfeac ;Undocumented
PWM0C .EQU 0xff00 ;PWM 0 Counter Word
PWM0CH .EQU 0xff00 ;PWM 0 Counter High Byte
PWM0CL .EQU 0xff01 ;PWM 0 Counter Low Byte
PWM0CKS .EQU 0xff02 ;PWM 0 Clock Selection
   PWM_PS = 0x0F ;PWM System Clock Prescaler
   SELT2  = 0x10 ;PWM Clock Source Selection
PWM0TADC .EQU 0xff03 ;PWM 0 Trigger ADC Count Word
PWM0TADCH .EQU 0xff03 ;PWM 0 Trigger ADC Count High Byte
PWM0TADCL .EQU 0xff04 ;PWM 0 Trigger ADC Count Low Byte
PWM0IF .EQU 0xff05 ;PWM 0 Interrupt Flags
   C0IF = 0x01 ;Channel 0 Interrupt Flag
   C1IF = 0x02 ;Channel 1 Interrupt Flag
   C2IF = 0x04 ;Channel 2 Interrupt Flag
   C3IF = 0x08 ;Channel 3 Interrupt Flag
   C4IF = 0x10 ;Channel 4 Interrupt Flag
   C5IF = 0x20 ;Channel 5 Interrupt Flag
   C6IF = 0x40 ;Channel 6 Interrupt Flag
   C7IF = 0x80 ;Channel 7 Interrupt Flag
PWM0FDCR .EQU 0xff06 ;PWM 0 Fault Detect Control Register
   FDIF    = 0x01 ;Fault Detect Interrupt Flag
   FDIO    = 0x02 ;IO Port Fault Detect
   FDCMP   = 0x04 ;Comparator Fault Detect
   EFDI    = 0x08 ;Enable Fault Detect Interrupt
   FLTFLIO = 0x10 ;Fault Detect IO Port Action
   ENFD    = 0x20 ;Enable Fault Detect
   INVIO   = 0x40 ;Invert IO Port Fault Detect Level
   INVCMP  = 0x80 ;Invert Comparator Fault Detect Level
PWM00T1 .EQU 0xff10 ;PWM 0 Chanel 0 Timer 1 Word
PWM00T1H .EQU 0xff10 ;PWM 0 Chanel 0 Timer 1 High Byte
PWM00T1L .EQU 0xff11 ;PWM 0 Chanel 0 Timer 1 Low Byte
PWM00T2 .EQU 0xff12 ;PWM 0 Chanel 0 Timer 2 Word
PWM00T2H .EQU 0xff12 ;PWM 0 Chanel 0 Timer 2 High Byte
PWM00T2L .EQU 0xff13 ;PWM 0 Chanel 0 Timer 2 Low Byte
PWM00CR .EQU 0xff14 ;PWM 0 Chanel 0 Control Register
   PWM00_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM00_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM00_ENI   = 0x04 ;Enable Interrupt
   PWM00_INI   = 0x40 ;Initial Output Level
   PWM00_ENO   = 0x80 ;PWM Output Enable Bit
PWM00HLD .EQU 0xff15 ;PWM 0 Chanel 0 Level Hold Control
   PWM00_HLDL = 0x01 ;Hold Low Override
   PWM00_HLDH = 0x02 ;Hold High Override
PWM01T1 .EQU 0xff18 ;PWM 0 Chanel 1 Timer 1 Word
PWM01T1H .EQU 0xff18 ;PWM 0 Chanel 1 Timer 1 High Byte
PWM01T1L .EQU 0xff19 ;PWM 0 Chanel 1 Timer 1 Low Byte
PWM01T2 .EQU 0xff1a ;PWM 0 Chanel 1 Timer 2 Word
PWM01T2H .EQU 0xff1a ;PWM 0 Chanel 1 Timer 2 High Byte
PWM01T2L .EQU 0xff1b ;PWM 0 Chanel 1 Timer 2 Low Byte
PWM01CR .EQU 0xff1c ;PWM 0 Chanel 1 Control Register
   PWM41_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM41_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM41_ENI   = 0x04 ;Enable Interrupt
   PWM41_INI   = 0x40 ;Initial Output Level
   PWM41_ENO   = 0x80 ;PWM Output Enable Bit
PWM01HLD .EQU 0xff1d ;PWM 0 Chanel 1 Level Hold Control
PWM02T1 .EQU 0xff20 ;PWM 0 Chanel 2 Timer 1 Word
PWM02T1H .EQU 0xff20 ;PWM 0 Chanel 2 Timer 1 High Byte
PWM02T1L .EQU 0xff21 ;PWM 0 Chanel 2 Timer 1 Low Byte
PWM02T2 .EQU 0xff22 ;PWM 0 Chanel 2 Timer 2 Word
PWM02T2H .EQU 0xff22 ;PWM 0 Chanel 2 Timer 2 High Byte
PWM02T2L .EQU 0xff23 ;PWM 0 Chanel 2 Timer 2 Low Byte
PWM02CR .EQU 0xff24 ;PWM 0 Chanel 2 Control Register
   PWM02_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM02_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM02_ENI   = 0x04 ;Enable Interrupt
   PWM02_INI   = 0x40 ;Initial Output Level
   PWM02_ENO   = 0x80 ;PWM Output Enable Bit
PWM02HLD .EQU 0xff25 ;PWM 0 Chanel 2 Level Hold Control
   PWM02_HLDL = 0x01 ;Hold Low Override
   PWM02_HLDH = 0x02 ;Hold High Override
PWM03T1 .EQU 0xff28 ;PWM 0 Chanel 3 Timer 1 Word
PWM03T1H .EQU 0xff28 ;PWM 0 Chanel 3 Timer 1 High Byte
PWM03T1L .EQU 0xff29 ;PWM 0 Chanel 3 Timer 1 Low Byte
PWM03T2 .EQU 0xff2a ;PWM 0 Chanel 3 Timer 2 Word
PWM03T2H .EQU 0xff2a ;PWM 0 Chanel 3 Timer 2 High Byte
PWM03T2L .EQU 0xff2b ;PWM 0 Chanel 3 Timer 2 Low Byte
PWM03CR .EQU 0xff2c ;PWM 0 Chanel 3 Control Register
   PWM03_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM03_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM03_ENI   = 0x04 ;Enable Interrupt
   PWM03_INI   = 0x40 ;Initial Output Level
   PWM03_ENO   = 0x80 ;PWM Output Enable Bit
PWM03HLD .EQU 0xff2d ;PWM 0 Chanel 3 Level Hold Control
   PWM03_HLDL = 0x01 ;Hold Low Override
   PWM03_HLDH = 0x02 ;Hold High Override
PWM04T1 .EQU 0xff30 ;PWM 0 Chanel 4 Timer 1 Word
PWM04T1H .EQU 0xff30 ;PWM 0 Chanel 4 Timer 1 High Byte
PWM04T1L .EQU 0xff31 ;PWM 0 Chanel 4 Timer 1 Low Byte
PWM04T2 .EQU 0xff32 ;PWM 0 Chanel 4 Timer 2 Word
PWM04T2H .EQU 0xff32 ;PWM 0 Chanel 4 Timer 2 High Byte
PWM04T2L .EQU 0xff33 ;PWM 0 Chanel 4 Timer 2 Low Byte
PWM04CR .EQU 0xff34 ;PWM 0 Chanel 4 Control Register
   PWM04_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM04_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM04_ENI   = 0x04 ;Enable Interrupt
   PWM04_INI   = 0x40 ;Initial Output Level
   PWM04_ENO   = 0x80 ;PWM Output Enable Bit
PWM04HLD .EQU 0xff35 ;PWM 0 Chanel 4 Level Hold Control
   PWM04_HLDL = 0x01 ;Hold Low Override
   PWM04_HLDH = 0x02 ;Hold High Override
PWM05T1 .EQU 0xff38 ;PWM 0 Chanel 5 Timer 1 Word
PWM05T1H .EQU 0xff38 ;PWM 0 Chanel 5 Timer 1 High Byte
PWM05T1L .EQU 0xff39 ;PWM 0 Chanel 5 Timer 1 Low Byte
PWM05T2 .EQU 0xff3a ;PWM 0 Chanel 5 Timer 2 Word
PWM05T2H .EQU 0xff3a ;PWM 0 Chanel 5 Timer 2 High Byte
PWM05T2L .EQU 0xff3b ;PWM 0 Chanel 5 Timer 2 Low Byte
PWM05CR .EQU 0xff3c ;PWM 0 Chanel 5 Control Register
   PWM05_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM05_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM05_ENI   = 0x04 ;Enable Interrupt
   PWM05_INI   = 0x40 ;Initial Output Level
   PWM05_ENO   = 0x80 ;PWM Output Enable Bit
PWM05HLD .EQU 0xff3d ;PWM 0 Chanel 5 Level Hold Control
   PWM05_HLDL = 0x01 ;Hold Low Override
   PWM05_HLDH = 0x02 ;Hold High Override
PWM06T1 .EQU 0xff40 ;PWM 0 Chanel 6 Timer 1 Word
PWM06T1H .EQU 0xff40 ;PWM 0 Chanel 6 Timer 1 High Byte
PWM06T1L .EQU 0xff41 ;PWM 0 Chanel 6 Timer 1 Low Byte
PWM06T2 .EQU 0xff42 ;PWM 0 Chanel 6 Timer 2 Word
PWM06T2H .EQU 0xff42 ;PWM 0 Chanel 6 Timer 2 High Byte
PWM06T2L .EQU 0xff43 ;PWM 0 Chanel 6 Timer 2 Low Byte
PWM06CR .EQU 0xff44 ;PWM 0 Chanel 6 Control Register
   PWM06_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM06_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM06_ENI   = 0x04 ;Enable Interrupt
   PWM06_INI   = 0x40 ;Initial Output Level
   PWM06_ENO   = 0x80 ;PWM Output Enable Bit
PWM06HLD .EQU 0xff45 ;PWM 0 Chanel 6 Level Hold Control
   PWM06_HLDL = 0x01 ;Hold Low Override
   PWM06_HLDH = 0x02 ;Hold High Override
PWM07T1 .EQU 0xff48 ;PWM 0 Chanel 7 Timer 1 Word
PWM07T1H .EQU 0xff48 ;PWM 0 Chanel 7 Timer 1 High Byte
PWM07T1L .EQU 0xff49 ;PWM 0 Chanel 7 Timer 1 Low Byte
PWM07T2 .EQU 0xff4a ;PWM 0 Chanel 7 Timer 2 Word
PWM07T2H .EQU 0xff4a ;PWM 0 Chanel 7 Timer 2 High Byte
PWM07T2L .EQU 0xff4b ;PWM 0 Chanel 7 Timer 2 Low Byte
PWM07CR .EQU 0xff4c ;PWM 0 Chanel 7 Control Register
   PWM07_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM07_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM07_ENI   = 0x04 ;Enable Interrupt
   PWM07_INI   = 0x40 ;Initial Output Level
   PWM07_ENO   = 0x80 ;PWM Output Enable Bit
PWM07HLD .EQU 0xff4d ;PWM 0 Chanel 7 Level Hold Control
   PWM07_HLDL = 0x01 ;Hold Low Override
   PWM07_HLDH = 0x02 ;Hold High Override
PWM1C .EQU 0xff50 ;PWM 1 Counter Word
PWM1CH .EQU 0xff50 ;PWM 1 Counter High Byte
PWM1CL .EQU 0xff51 ;PWM 1 Counter Low Byte
PWM1CKS .EQU 0xff52 ;PWM 1 Clock Selection
   PWM_PS = 0x0F ;PWM System Clock Prescaler
   SELT2  = 0x10 ;PWM Clock Source Selection
PWM1IF .EQU 0xff55 ;PWM 1 Interrupt Flags
   C0IF = 0x01 ;Channel 0 Interrupt Flag
   C1IF = 0x02 ;Channel 1 Interrupt Flag
   C2IF = 0x04 ;Channel 2 Interrupt Flag
   C3IF = 0x08 ;Channel 3 Interrupt Flag
   C4IF = 0x10 ;Channel 4 Interrupt Flag
   C5IF = 0x20 ;Channel 5 Interrupt Flag
   C6IF = 0x40 ;Channel 6 Interrupt Flag
   C7IF = 0x80 ;Channel 7 Interrupt Flag
PWM1FDCR .EQU 0xff56 ;PWM 1 Fault Detect Control Register
   FDIF    = 0x01 ;Fault Detect Interrupt Flag
   FDIO    = 0x02 ;IO Port Fault Detect
   FDCMP   = 0x04 ;Comparator Fault Detect
   EFDI    = 0x08 ;Enable Fault Detect Interrupt
   FLTFLIO = 0x10 ;Fault Detect IO Port Action
   ENFD    = 0x20 ;Enable Fault Detect
   INVIO   = 0x40 ;Invert IO Port Fault Detect Level
   INVCMP  = 0x80 ;Invert Comparator Fault Detect Level
PWM10T1 .EQU 0xff60 ;PWM 1 Chanel 0 Timer 1 Word
PWM10T1H .EQU 0xff60 ;PWM 1 Chanel 0 Timer 1 High Byte
PWM10T1L .EQU 0xff61 ;PWM 1 Chanel 0 Timer 1 Low Byte
PWM10T2 .EQU 0xff62 ;PWM 1 Chanel 0 Timer 2 Word
PWM10T2H .EQU 0xff62 ;PWM 1 Chanel 0 Timer 2 High Byte
PWM10T2L .EQU 0xff63 ;PWM 1 Chanel 0 Timer 2 Low Byte
PWM10CR .EQU 0xff64 ;PWM 1 Chanel 0 Control Register
   PWM10_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM10_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM10_ENI   = 0x04 ;Enable Interrupt
   PWM10_INI   = 0x40 ;Initial Output Level
   PWM10_ENO   = 0x80 ;PWM Output Enable Bit
PWM10HLD .EQU 0xff65 ;PWM 1 Chanel 0 Level Hold Control
   PWM10_HLDL = 0x01 ;Hold Low Override
   PWM10_HLDH = 0x02 ;Hold High Override
PWM11T1 .EQU 0xff68 ;PWM 1 Chanel 1 Timer 1 Word
PWM11T1H .EQU 0xff68 ;PWM 1 Chanel 1 Timer 1 High Byte
PWM11T1L .EQU 0xff69 ;PWM 1 Chanel 1 Timer 1 Low Byte
PWM11T2 .EQU 0xff6a ;PWM 1 Chanel 1 Timer 2 Word
PWM11T2H .EQU 0xff6a ;PWM 1 Chanel 1 Timer 2 High Byte
PWM11T2L .EQU 0xff6b ;PWM 1 Chanel 1 Timer 2 Low Byte
PWM11CR .EQU 0xff6c ;PWM 1 Chanel 1 Control Register
   PWM11_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM11_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM11_ENI   = 0x04 ;Enable Interrupt
   PWM11_INI   = 0x40 ;Initial Output Level
   PWM11_ENO   = 0x80 ;PWM Output Enable Bit
PWM11HLD .EQU 0xff6d ;PWM 1 Chanel 1 Level Hold Control
   PWM11_HLDL = 0x01 ;Hold Low Override
   PWM11_HLDH = 0x02 ;Hold High Override
PWM12T1 .EQU 0xff70 ;PWM 1 Chanel 2 Timer 1 Word
PWM12T1H .EQU 0xff70 ;PWM 1 Chanel 2 Timer 1 High Byte
PWM12T1L .EQU 0xff71 ;PWM 1 Chanel 2 Timer 1 Low Byte
PWM12T2 .EQU 0xff72 ;PWM 1 Chanel 2 Timer 2 Word
PWM12T2H .EQU 0xff72 ;PWM 1 Chanel 2 Timer 2 High Byte
PWM12T2L .EQU 0xff73 ;PWM 1 Chanel 2 Timer 2 Low Byte
PWM12CR .EQU 0xff74 ;PWM 1 Chanel 2 Control Register
   PWM12_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM12_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM12_ENI   = 0x04 ;Enable Interrupt
   PWM12_INI   = 0x40 ;Initial Output Level
   PWM12_ENO   = 0x80 ;PWM Output Enable Bit
PWM12HLD .EQU 0xff75 ;PWM 1 Chanel 2 Level Hold Control
   PWM12_HLDL = 0x01 ;Hold Low Override
   PWM12_HLDH = 0x02 ;Hold High Override
   PWM43_HLDL = 0x01 ;Hold Low Override
   PWM43_HLDH = 0x02 ;Hold High Override
PWM13T1 .EQU 0xff78 ;PWM 1 Chanel 3 Timer 1 Word
PWM13T1H .EQU 0xff78 ;PWM 1 Chanel 3 Timer 1 High Byte
PWM13T1L .EQU 0xff79 ;PWM 1 Chanel 3 Timer 1 Low Byte
PWM13T2 .EQU 0xff7a ;PWM 1 Chanel 3 Timer 2 Word
PWM13T2H .EQU 0xff7a ;PWM 1 Chanel 3 Timer 2 High Byte
PWM13T2L .EQU 0xff7b ;PWM 1 Chanel 3 Timer 2 Low Byte
PWM13CR .EQU 0xff7c ;PWM 1 Chanel 3 Control Register
   PWM13_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM13_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM13_ENI   = 0x04 ;Enable Interrupt
   PWM13_INI   = 0x40 ;Initial Output Level
   PWM13_ENO   = 0x80 ;PWM Output Enable Bit
PWM13HLD .EQU 0xff7d ;PWM 1 Chanel 3 Level Hold Control
   PWM13_HLDL = 0x01 ;Hold Low Override
   PWM13_HLDH = 0x02 ;Hold High Override
PWM14T1 .EQU 0xff80 ;PWM 1 Chanel 4 Timer 1 Word
PWM14T1H .EQU 0xff80 ;PWM 1 Chanel 4 Timer 1 High Byte
PWM14T1L .EQU 0xff81 ;PWM 1 Chanel 4 Timer 1 Low Byte
PWM14T2 .EQU 0xff82 ;PWM 1 Chanel 4 Timer 2 Word
PWM14T2H .EQU 0xff82 ;PWM 1 Chanel 4 Timer 2 High Byte
PWM14T2L .EQU 0xff83 ;PWM 1 Chanel 4 Timer 2 Low Byte
PWM14CR .EQU 0xff84 ;PWM 1 Chanel 4 Control Register
   PWM14_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM14_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM14_ENI   = 0x04 ;Enable Interrupt
   PWM14_INI   = 0x40 ;Initial Output Level
   PWM14_ENO   = 0x80 ;PWM Output Enable Bit
PWM14HLD .EQU 0xff85 ;PWM 1 Chanel 4 Level Hold Control
   PWM14_HLDL = 0x01 ;Hold Low Override
   PWM14_HLDH = 0x02 ;Hold High Override
PWM15T1 .EQU 0xff88 ;PWM 1 Chanel 5 Timer 1 Word
PWM15T1H .EQU 0xff88 ;PWM 1 Chanel 5 Timer 1 High Byte
PWM15T1L .EQU 0xff89 ;PWM 1 Chanel 5 Timer 1 Low Byte
PWM15T2 .EQU 0xff8a ;PWM 1 Chanel 5 Timer 2 Word
PWM15T2H .EQU 0xff8a ;PWM 1 Chanel 5 Timer 2 High Byte
PWM15T2L .EQU 0xff8b ;PWM 1 Chanel 5 Timer 2 Low Byte
PWM15CR .EQU 0xff8c ;PWM 1 Chanel 5 Control Register
   PWM15_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM15_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM15_ENI   = 0x04 ;Enable Interrupt
   PWM15_INI   = 0x40 ;Initial Output Level
   PWM15_ENO   = 0x80 ;PWM Output Enable Bit
PWM15HLD .EQU 0xff8d ;PWM 1 Chanel 5 Level Hold Control
   PWM15_HLDL = 0x01 ;Hold Low Override
   PWM15_HLDH = 0x02 ;Hold High Override
PWM16T1 .EQU 0xff90 ;PWM 1 Chanel 6 Timer 1 Word
PWM16T1H .EQU 0xff90 ;PWM 1 Chanel 6 Timer 1 High Byte
PWM16T1L .EQU 0xff91 ;PWM 1 Chanel 6 Timer 1 Low Byte
PWM16T2 .EQU 0xff92 ;PWM 1 Chanel 6 Timer 2 Word
PWM16T2H .EQU 0xff92 ;PWM 1 Chanel 6 Timer 2 High Byte
PWM16T2L .EQU 0xff93 ;PWM 1 Chanel 6 Timer 2 Low Byte
PWM16CR .EQU 0xff94 ;PWM 1 Chanel 6 Control Register
   PWM16_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM16_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM16_ENI   = 0x04 ;Enable Interrupt
   PWM16_INI   = 0x40 ;Initial Output Level
   PWM16_ENO   = 0x80 ;PWM Output Enable Bit
PWM16HLD .EQU 0xff95 ;PWM 1 Chanel 6 Level Hold Control
   PWM16_HLDL = 0x01 ;Hold Low Override
   PWM16_HLDH = 0x02 ;Hold High Override
PWM17T1 .EQU 0xff98 ;PWM 1 Chanel 7 Timer 1 Word
PWM17T1H .EQU 0xff98 ;PWM 1 Chanel 7 Timer 1 High Byte
PWM17T1L .EQU 0xff99 ;PWM 1 Chanel 7 Timer 1 Low Byte
PWM17T2 .EQU 0xff9a ;PWM 1 Chanel 7 Timer 2 Word
PWM17T2H .EQU 0xff9a ;PWM 1 Chanel 7 Timer 2 High Byte
PWM17T2L .EQU 0xff9b ;PWM 1 Chanel 7 Timer 2 Low Byte
PWM17CR .EQU 0xff9c ;PWM 1 Chanel 7 Control Register
   PWM17_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM17_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM17_ENI   = 0x04 ;Enable Interrupt
   PWM17_INI   = 0x40 ;Initial Output Level
   PWM17_ENO   = 0x80 ;PWM Output Enable Bit
PWM17HLD .EQU 0xff9d ;PWM 1 Chanel 7 Level Hold Control
   PWM17_HLDL = 0x01 ;Hold Low Override
   PWM17_HLDH = 0x02 ;Hold High Override
PWM2C .EQU 0xffa0 ;PWM 2 Counter Word
PWM2CH .EQU 0xffa0 ;PWM 2 Counter High Byte
PWM2CL .EQU 0xffa1 ;PWM 2 Counter Low Byte
PWM2CKS .EQU 0xffa2 ;PWM 2 Clock Selection
   PWM_PS = 0x0F ;PWM System Clock Prescaler
   SELT2  = 0x10 ;PWM Clock Source Selection
PWM2TADC .EQU 0xffa3 ;PWM 2 Trigger ADC Count Word
PWM2TADCH .EQU 0xffa3 ;PWM 2 Trigger ADC Count High Byte
PWM2TADCL .EQU 0xffa4 ;PWM 2 Trigger ADC Count Low Byte
PWM2IF .EQU 0xffa5 ;PWM 2 Interrupt Flags
   C0IF = 0x01 ;Channel 0 Interrupt Flag
   C1IF = 0x02 ;Channel 1 Interrupt Flag
   C2IF = 0x04 ;Channel 2 Interrupt Flag
   C3IF = 0x08 ;Channel 3 Interrupt Flag
   C4IF = 0x10 ;Channel 4 Interrupt Flag
   C5IF = 0x20 ;Channel 5 Interrupt Flag
   C6IF = 0x40 ;Channel 6 Interrupt Flag
   C7IF = 0x80 ;Channel 7 Interrupt Flag
PWM2FDCR .EQU 0xffa6 ;PWM 2 Fault Detect Control Register
   FDIF    = 0x01 ;Fault Detect Interrupt Flag
   FDIO    = 0x02 ;IO Port Fault Detect
   FDCMP   = 0x04 ;Comparator Fault Detect
   EFDI    = 0x08 ;Enable Fault Detect Interrupt
   FLTFLIO = 0x10 ;Fault Detect IO Port Action
   ENFD    = 0x20 ;Enable Fault Detect
   INVIO   = 0x40 ;Invert IO Port Fault Detect Level
   INVCMP  = 0x80 ;Invert Comparator Fault Detect Level
PWM20T1 .EQU 0xffb0 ;PWM 2 Chanel 0 Timer 1 Word
PWM20T1H .EQU 0xffb0 ;PWM 2 Chanel 0 Timer 1 High Byte
PWM20T1L .EQU 0xffb1 ;PWM 2 Chanel 0 Timer 1 Low Byte
PWM20T2 .EQU 0xffb2 ;PWM 2 Chanel 0 Timer 2 Word
PWM20T2H .EQU 0xffb2 ;PWM 2 Chanel 0 Timer 2 High Byte
PWM20T2L .EQU 0xffb3 ;PWM 2 Chanel 0 Timer 2 Low Byte
PWM20CR .EQU 0xffb4 ;PWM 2 Chanel 0 Control Register
   PWM20_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM20_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM20_ENI   = 0x04 ;Enable Interrupt
   PWM20_INI   = 0x40 ;Initial Output Level
   PWM20_ENO   = 0x80 ;PWM Output Enable Bit
PWM20HLD .EQU 0xffb5 ;PWM 4 Chanel 0 Level Hold Control
   PWM20_HLDL = 0x01 ;Hold Low Override
   PWM20_HLDH = 0x02 ;Hold High Override
PWM21T1 .EQU 0xffb8 ;PWM 2 Chanel 1 Timer 1 Word
PWM21T1H .EQU 0xffb8 ;PWM 2 Chanel 1 Timer 1 High Byte
PWM21T1L .EQU 0xffb9 ;PWM 2 Chanel 1 Timer 1 Low Byte
PWM21T2 .EQU 0xffba ;PWM 2 Chanel 1 Timer 2 Word
PWM21T2H .EQU 0xffba ;PWM 2 Chanel 1 Timer 2 High Byte
PWM21T2L .EQU 0xffbb ;PWM 2 Chanel 1 Timer 2 Low Byte
PWM21CR .EQU 0xffbc ;PWM 2 Chanel 1 Control Register
   PWM21_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM21_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM21_ENI   = 0x04 ;Enable Interrupt
   PWM21_INI   = 0x40 ;Initial Output Level
   PWM21_ENO   = 0x80 ;PWM Output Enable Bit
PWM21HLD .EQU 0xffbd ;PWM 2 Chanel 1 Level Hold Control
   PWM21_HLDL = 0x01 ;Hold Low Override
   PWM21_HLDH = 0x02 ;Hold High Override
PWM22T1 .EQU 0xffc0 ;PWM 2 Chanel 2 Timer 1 Word
PWM22T1H .EQU 0xffc0 ;PWM 2 Chanel 2 Timer 1 High Byte
PWM22T1L .EQU 0xffc1 ;PWM 2 Chanel 2 Timer 1 Low Byte
PWM22T2 .EQU 0xffc2 ;PWM 2 Chanel 2 Timer 2 Word
PWM22T2H .EQU 0xffc2 ;PWM 2 Chanel 2 Timer 2 High Byte
PWM22T2L .EQU 0xffc3 ;PWM 2 Chanel 2 Timer 2 Low Byte
PWM22CR .EQU 0xffc4 ;PWM 2 Chanel 2 Control Register
   PWM22_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM22_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM22_ENI   = 0x04 ;Enable Interrupt
   PWM22_INI   = 0x40 ;Initial Output Level
   PWM22_ENO   = 0x80 ;PWM Output Enable Bit
PWM22HLD .EQU 0xffc5 ;PWM 2 Chanel 2 Level Hold Control
   PWM22_HLDL = 0x01 ;Hold Low Override
   PWM42_HLDH = 0x02 ;Hold High Override
PWM23T1 .EQU 0xffc8 ;PWM 2 Chanel 3 Timer 1 Word
PWM23T1H .EQU 0xffc8 ;PWM 2 Chanel 3 Timer 1 High Byte
PWM23T1L .EQU 0xffc9 ;PWM 2 Chanel 3 Timer 1 Low Byte
PWM23T2 .EQU 0xffca ;PWM 2 Chanel 3 Timer 2 Word
PWM23T2H .EQU 0xffca ;PWM 2 Chanel 3 Timer 2 High Byte
PWM23T2L .EQU 0xffcb ;PWM 2 Chanel 3 Timer 2 Low Byte
PWM23CR .EQU 0xffcc ;PWM 2 Chanel 3 Control Register
   PWM23_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM23_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM23_ENI   = 0x04 ;Enable Interrupt
   PWM23_INI   = 0x40 ;Initial Output Level
   PWM23_ENO   = 0x80 ;PWM Output Enable Bit
PWM23HLD .EQU 0xffcd ;PWM 2 Chanel 3 Level Hold Control
   PWM23_HLDL = 0x01 ;Hold Low Override
   PWM23_HLDH = 0x02 ;Hold High Override
PWM24T1 .EQU 0xffd0 ;PWM 2 Chanel 4 Timer 1 Word
PWM24T1H .EQU 0xffd0 ;PWM 2 Chanel 4 Timer 1 High Byte
PWM24T1L .EQU 0xffd1 ;PWM 2 Chanel 4 Timer 1 Low Byte
PWM24T2 .EQU 0xffd2 ;PWM 2 Chanel 4 Timer 2 Word
PWM24T2H .EQU 0xffd2 ;PWM 2 Chanel 4 Timer 2 High Byte
PWM24T2L .EQU 0xffd3 ;PWM 2 Chanel 4 Timer 2 Low Byte
PWM24CR .EQU 0xffd4 ;PWM 2 Chanel 4 Control Register
   PWM24_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM24_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM24_ENI   = 0x04 ;Enable Interrupt
   PWM24_INI   = 0x40 ;Initial Output Level
   PWM24_ENO   = 0x80 ;PWM Output Enable Bit
PWM24HLD .EQU 0xffd5 ;PWM 2 Chanel 4 Level Hold Control
   PWM24_HLDL = 0x01 ;Hold Low Override
   PWM24_HLDH = 0x02 ;Hold High Override
PWM25T1 .EQU 0xffd8 ;PWM 2 Chanel 5 Timer 1 Word
PWM25T1H .EQU 0xffd8 ;PWM 2 Chanel 5 Timer 1 High Byte
PWM25T1L .EQU 0xffd9 ;PWM 2 Chanel 5 Timer 1 Low Byte
PWM25T2 .EQU 0xffda ;PWM 2 Chanel 5 Timer 2 Word
PWM25T2H .EQU 0xffda ;PWM 2 Chanel 5 Timer 2 High Byte
PWM25T2L .EQU 0xffdb ;PWM 2 Chanel 5 Timer 2 Low Byte
PWM25CR .EQU 0xffdc ;PWM 2 Chanel 5 Control Register
   PWM25_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM25_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM25_ENI   = 0x04 ;Enable Interrupt
   PWM25_INI   = 0x40 ;Initial Output Level
   PWM25_ENO   = 0x80 ;PWM Output Enable Bit
PWM25HLD .EQU 0xffdd ;PWM 2 Chanel 5 Level Hold Control
   PWM25_HLDL = 0x01 ;Hold Low Override
   PWM25_HLDH = 0x02 ;Hold High Override
PWM26T1 .EQU 0xffe0 ;PWM 2 Chanel 6 Timer 1 Word
PWM26T1H .EQU 0xffe0 ;PWM 2 Chanel 6 Timer 1 High Byte
PWM26T1L .EQU 0xffe1 ;PWM 2 Chanel 6 Timer 1 Low Byte
PWM26T2 .EQU 0xffe2 ;PWM 2 Chanel 6 Timer 2 Word
PWM26T2H .EQU 0xffe2 ;PWM 2 Chanel 6 Timer 2 High Byte
PWM26T2L .EQU 0xffe3 ;PWM 2 Chanel 6 Timer 2 Low Byte
PWM26CR .EQU 0xffe4 ;PWM 2 Chanel 6 Control Register
   PWM26_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM26_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM26_ENI   = 0x04 ;Enable Interrupt
   PWM26_INI   = 0x40 ;Initial Output Level
   PWM26_ENO   = 0x80 ;PWM Output Enable Bit
PWM26HLD .EQU 0xffe5 ;PWM 2 Chanel 7 Level Hold Control
   PWM26_HLDL = 0x01 ;Hold Low Override
   PWM26_HLDH = 0x02 ;Hold High Override
PWM27T1 .EQU 0xffe8 ;PWM 2 Chanel 7 Timer 1 Word
PWM27T1H .EQU 0xffe8 ;PWM 2 Chanel 7 Timer 1 High Byte
PWM27T1L .EQU 0xffe9 ;PWM 2 Chanel 7 Timer 1 Low Byte
PWM27T2 .EQU 0xffea ;PWM 2 Chanel 7 Timer 2 Word
PWM27T2H .EQU 0xffea ;PWM 2 Chanel 7 Timer 2 High Byte
PWM27T2L .EQU 0xffeb ;PWM 2 Chanel 7 Timer 2 Low Byte
PWM27CR .EQU 0xffec ;PWM 2 Chanel 7 Control Register
   PWM27_ENT1I = 0x01 ;Enable Trigger Point 1 Interrupt
   PWM27_ENT2I = 0x02 ;Enable Trigger Point 2 Interrupt
   PWM27_ENI   = 0x04 ;Enable Interrupt
   PWM27_INI   = 0x40 ;Initial Output Level
   PWM27_ENO   = 0x80 ;PWM Output Enable Bit
PWM27HLD .EQU 0xffed ;PWM 2 Chanel 7 Level Hold Control
   PWM27_HLDL = 0x01 ;Hold Low Override
   PWM27_HLDH = 0x02 ;Hold High Override

;Interrupt_Address = ( Interrupt_Number * 8 ) + 3
;Vectors are named after their corresponding IE, IP or IR register bit so
;that we don't have to invent names and can be more consistent across MCUs.
   X0_VECTOR   = 0  ; 0x03  External Interrupt 0
   T0_VECTOR   = 1  ; 0x0B  Timer 0
   X1_VECTOR   = 2  ; 0x13  External Interrupt 1
   T1_VECTOR   = 3  ; 0x1B  Timer 1
   S_VECTOR    = 4  ; 0x23  Serial Port 1
   ADC_VECTOR  = 5  ; 0x2B  Analog to Digital Converter
   LVD_VECTOR  = 6  ; 0x33  Low Voltage Detect
   PCA_VECTOR  = 7  ; 0x3B  Programmable Counter Array (CCP)
   S2_VECTOR   = 8  ; 0x43  Serial Port 2
   SPI_VECTOR  = 9  ; 0x4B  Serial Peripheral Interface
   X2_VECTOR   = 10 ; 0x53  External Interrupt 2
   X3_VECTOR   = 11 ; 0x5B  External Interrupt 3
   T2_VECTOR   = 12 ; 0x63  Timer 2
   ;    -      = 13 ; 0x6B      -
   ;    -      = 14 ; 0x73  System Reserved
   ;    -      = 15 ; 0x7B  System Reserved
   X4_VECTOR   = 16 ; 0x83  External Interrupt 4
   S3_VECTOR   = 17 ; 0x8B  Serial Port 3
   S4_VECTOR   = 18 ; 0x93  Serial Port 4
   T3_VECTOR   = 19 ; 0x9B  Timer 3
   T4_VECTOR   = 20 ; 0xA3  Timer 4
   CMP_VECTOR  = 21 ; 0xAB  Comparator
   PWM0_VECTOR = 22 ; 0xB3  Pulse Width Modulator 0
   P0FD_VECTOR = 23 ; 0xBB  PWM 0 Fault Detect
   I2C_VECTOR  = 24 ; 0xC3  Inter-Integrated Circuit (IIC)
   ;    -      = 25 ; 0xCB      -
   ;    -      = 26 ; 0xD3      -
   ;    -      = 27 ; 0xDB      -
   PWM1_VECTOR = 28 ; 0xE3  Pulse Width Modulator 1
   PWM2_VECTOR = 29 ; 0xEB  Pulse Width Modulator 2
   PWM3_VECTOR = 30 ; 0xF3  Pulse Width Modulator 3
   PWM4_VECTOR = 31 ; 0xFB  Pulse Width Modulator 4
   PWM5_VECTOR = 32 ; 0x103 Pulse Width Modulator 5
   P2FD_VECTOR = 33 ; 0x10B PWM 2 Fault Detect
   P4FD_VECTOR = 34 ; 0x113 PWM 4 Fault Detect
   TK_VECTOR   = 35 ; 0x11B Touch Key

;.endif
