; PIO compatible header file STC8H.asm 20210829.
; For use with all STC8Hxx series.

;.ifndef STC8H_ASM
;.define STC8H_ASM

; SFR Definition               Description

P0 .EQU 0x80                  ;Port 0
;  ACH0 .EQU 0x80+0 ;ADC Channel 8
;  ACH1 .EQU 0x80+1 ;ADC Channel 9
;  ACH2 .EQU 0x80+2 ;ADC Channel 10
;  ACH3 .EQU 0x80+3 ;ADC Channel 11
;  ACH4 .EQU 0x80+4 ;ADC Channel 12
;  ACH5 .EQU 0x80+5 ;ADC Channel 13
;  ACH6 .EQU 0x80+6 ;ADC Channel 14
;  ADC0 .EQU 0x80+0 ;AtoD Channel 8
;  ADC1 .EQU 0x80+1 ;AtoD Channel 9
;  ADC2 .EQU 0x80+2 ;AtoD Channel 10
;  ADC3 .EQU 0x80+3 ;AtoD Channel 11
;  ADC4 .EQU 0x80+4 ;AtoD Channel 12
;  ADC5 .EQU 0x80+5 ;AtoD Channel 13
;  ADC6 .EQU 0x80+6 ;AtoD Channel 14
;  AIN0 .EQU 0x80+0 ;Analog Input 8
;  AIN1 .EQU 0x80+1 ;Analog Input 9
;  AIN2 .EQU 0x80+2 ;Analog Input 10
;  AIN3 .EQU 0x80+3 ;Analog Input 11
;  AIN4 .EQU 0x80+4 ;Analog Input 12
;  AIN5 .EQU 0x80+5 ;Analog Input 13
;  AIN6 .EQU 0x80+6 ;Analog Input 14
   P00 .EQU 0x80+0 ;Port 0 Bit 0
   P01 .EQU 0x80+1 ;Port 0 Bit 1
   P02 .EQU 0x80+2 ;Port 0 Bit 2
   P03 .EQU 0x80+3 ;Port 0 Bit 3
   P04 .EQU 0x80+4 ;Port 0 Bit 4
   P05 .EQU 0x80+5 ;Port 0 Bit 5
   P06 .EQU 0x80+6 ;Port 0 Bit 6
   P07 .EQU 0x80+7 ;Port 0 Bit 7
   P0_0 .EQU 0x80+0 ;Port 0 Bit 0
   P0_1 .EQU 0x80+1 ;Port 0 Bit 1
   P0_2 .EQU 0x80+2 ;Port 0 Bit 2
   P0_3 .EQU 0x80+3 ;Port 0 Bit 3
   P0_4 .EQU 0x80+4 ;Port 0 Bit 4
   P0_5 .EQU 0x80+5 ;Port 0 Bit 5
   P0_6 .EQU 0x80+6 ;Port 0 Bit 6
   P0_7 .EQU 0x80+7 ;Port 0 Bit 7
; See device specific data sheet for additional pin names.

SP .EQU 0x81                  ;Stack Pointer

;DPTR .EQU 0x82               ;Date Pointer Word
DPL .EQU 0x82                 ;Data Pointer Low Byte

DPH .EQU 0x83                 ;Data Pointer High Byte

S4CON .EQU 0x84               ;Serial Port 4 Control Register
   S4RI  = 0x01 ;Serial Port 4 Receive Interrupt Flag
   S4TI  = 0x02 ;Serial Port 4 Transmit Interrupt Flag
   S4RB8 = 0x04 ;Serial Port 4 Receive Bit 8 Data
   S4TB8 = 0x08 ;Serial Port 4 Transmit Bit 8 Data
   S4REN = 0x10 ;Serial Port 4 Receive Enable
   S4SM2 = 0x20 ;Serial Port 4 Select Mode Bit 2
   S4ST4 = 0x40 ;Serial Port 4 Select Timer 4
   S4SM0 = 0x80 ;Serial Port 4 Select Mode Bit 0

S4BUF .EQU 0x85               ;Serial Port 4 Data Register

PCON .EQU 0x87                ;Power Control Register
   IDL   = 0x01 ;Idle Mode Control
   PD    = 0x02 ;Power Down Mode Control
   GF0   = 0x04 ;User Defined Gereral Purpose Flag 0
   GF1   = 0x08 ;User Defined General Purpose Flag 1
   POF   = 0x10 ;Power On Flag
   LVDF  = 0x20 ;Low Voltage Detect Flag
   SMOD0 = 0x40 ;Frame Error Detection Control
   SMOD  = 0x80 ;Double Baudrate of Serial Port 1

TCON .EQU 0x88                ;Timer Control
   IT0 .EQU 0x88+0 ;Interrupt 0 Type
   IE0 .EQU 0x88+1 ;Interrupt 0 Edge
   IT1 .EQU 0x88+2 ;Interrupt 1 Type
   IE1 .EQU 0x88+3 ;Interrupt 1 Edge
   TR0 .EQU 0x88+4 ;Timer 0 Run
   TF0 .EQU 0x88+5 ;Timer 0 Flag
   TR1 .EQU 0x88+6 ;Timer 1 Run
   TF1 .EQU 0x88+7 ;Timer 1 Flag

TMOD .EQU 0x89                ;Timer Mode
   T0_M0   = 0x01 ;Timer 0 Mode 0
   T0_M1   = 0x02 ;Timer 0 Mode 1
   T0_M    = 0x03 ;Timer 0 Mode
   T0_CT   = 0x04 ;Timer 0 Counter Timer
   T0_GATE = 0x08 ;Timer 0 Gate
   T1_M0   = 0x10 ;Timer 1 Mode 0
   T1_M1   = 0x20 ;Timer 1 Mode 1
   T1_M    = 0x30 ;Timer 1 Mode
   T1_CT   = 0x40 ;Timer 1 Counter Timer
   T1_GATE = 0x80 ;Timer 1 Gate
   M00   = 0x01 ;Mode 0 Timer 0
   M10   = 0x02 ;Mode 1 Timer 0
   M0    = 0x03 ;Timer 0 Mode
   CT0   = 0x04 ;Counter Timer 0
   GATE0 = 0x08 ;Gate 0
   M01   = 0x10 ;Mode 1 Timer 1
   M11   = 0x20 ;Mode 1 Timer 1
   M1    = 0x30 ;Timer 1 Mode
   CT1   = 0x40 ;Counter Timer 1
   GATE1 = 0x80 ;Gate 1

TL0 .EQU 0x8A                 ;T0 Low Byte

TL1 .EQU 0x8B                 ;T1 Low Byte

TH0 .EQU 0x8C                 ;T0 High Byte

TH1 .EQU 0x8D                 ;T1 High Byte

AUXR .EQU 0x8E                ;Auxiliary Register
   S1ST2     = 0x01 ;Serial Port 1 Baud Rate Generator Select
   EXTRAM    = 0x02 ;Extended RAM Access Control
   T2x12     = 0x04 ;Timer 2 Clock x12 Prescaler Bypass
   T2_CT     = 0x08 ;Timer 2 Counter or Timer Mode Select
   T2R       = 0x10 ;Timer 2 Run Control
   UART_M0x6 = 0x20 ;UART 1 Mode 0 Baudrate Prescaler Select
   T1x12     = 0x40 ;Timer 1 Clock x12 Prescaler Bypass
   T0x12     = 0x80 ;Timer 0 Clock x12 Prescaler Bypass

INTCLKO .EQU 0x8F             ;Interrupt and Clock Output Control Register
   T0CLKO = 0x01 ;Timer 0 Clock Output Control
   T1CLKO = 0x02 ;Timer 1 Clock Output Control
   T2CLKO = 0x04 ;Timer 2 Clock Output Control
   EX2    = 0x10 ;External Interrupt 3 Enable
   EX3    = 0x20 ;External Interrupt 2 Enable
   EX4    = 0x40 ;External Interrupt 4 Enable

P1 .EQU 0x90                  ;Port 1
   ACH0 .EQU 0x90+0 ;ADC Channel 0
   ACH1 .EQU 0x90+1 ;ADC Channel 1
   ACH2 .EQU 0x90+2 ;ADC Channel 2
   ACH3 .EQU 0x90+3 ;ADC Channel 3
   ACH4 .EQU 0x90+4 ;ADC Channel 4
   ACH5 .EQU 0x90+5 ;ADC Channel 5
   ACH6 .EQU 0x90+6 ;ADC Channel 6
   ACH7 .EQU 0x90+7 ;ADC Channel 7
   ADC0 .EQU 0x90+0 ;AtoD Channel 0
   ADC1 .EQU 0x90+1 ;AtoD Channel 1
   ADC2 .EQU 0x90+2 ;AtoD Channel 2
   ADC3 .EQU 0x90+3 ;AtoD Channel 3
   ADC4 .EQU 0x90+4 ;AtoD Channel 4
   ADC5 .EQU 0x90+5 ;AtoD Channel 5
   ADC6 .EQU 0x90+6 ;AtoD Channel 6
   ADC7 .EQU 0x90+7 ;AtoD Channel 7
   AIN0 .EQU 0x90+0 ;Analog Input 0
   AIN1 .EQU 0x90+1 ;Analog Input 1
   AIN2 .EQU 0x90+2 ;Analog Input 2
   AIN3 .EQU 0x90+3 ;Analog Input 3
   AIN4 .EQU 0x90+4 ;Analog Input 4
   AIN5 .EQU 0x90+5 ;Analog Input 5
   AIN6 .EQU 0x90+6 ;Analog Input 6
   AIN7 .EQU 0x90+7 ;Analog Input 7
   P10 .EQU 0x90+0 ;Port 1 Bit 0
   P11 .EQU 0x90+1 ;Port 1 Bit 1
   P12 .EQU 0x90+2 ;Port 1 Bit 2
   P13 .EQU 0x90+3 ;Port 1 Bit 3
   P14 .EQU 0x90+4 ;Port 1 Bit 4
   P15 .EQU 0x90+5 ;Port 1 Bit 5
   P16 .EQU 0x90+6 ;Port 1 Bit 6
   P17 .EQU 0x90+7 ;Port 1 Bit 7
   P1_0 .EQU 0x90+0 ;Port 1 Bit 0
   P1_1 .EQU 0x90+1 ;Port 1 Bit 1
   P1_2 .EQU 0x90+2 ;Port 1 Bit 2
   P1_3 .EQU 0x90+3 ;Port 1 Bit 3
   P1_4 .EQU 0x90+4 ;Port 1 Bit 4
   P1_5 .EQU 0x90+5 ;Port 1 Bit 5
   P1_6 .EQU 0x90+6 ;Port 1 Bit 6
   P1_7 .EQU 0x90+7 ;Port 1 Bit 7
; See device specific data sheet for additional pin names.

P1M1 .EQU 0x91                ;Port 1 Mode Register 1
   P10M1 = 0x01 ;Port 1 bit 0 Mode 1
   P11M1 = 0x02 ;Port 1 bit 1 Mode 1
   P12M1 = 0x04 ;Port 1 bit 2 Mode 1
   P13M1 = 0x08 ;Port 1 bit 3 Mode 1
   P14M1 = 0x10 ;Port 1 bit 4 Mode 1
   P15M1 = 0x20 ;Port 1 bit 5 Mode 1
   P16M1 = 0x40 ;Port 1 bit 6 Mode 1
   P17M1 = 0x80 ;Port 1 bit 7 Mode 1

P1M0 .EQU 0x92                ;Port 1 Mode Register 0
   P10M0 = 0x01 ;Port 1 bit 0 Mode 0
   P11M0 = 0x02 ;Port 1 bit 1 Mode 0
   P12M0 = 0x04 ;Port 1 bit 2 Mode 0
   P13M0 = 0x08 ;Port 1 bit 3 Mode 0
   P14M0 = 0x10 ;Port 1 bit 4 Mode 0
   P15M0 = 0x20 ;Port 1 bit 5 Mode 0
   P16M0 = 0x40 ;Port 1 bit 6 Mode 0
   P17M0 = 0x80 ;Port 1 bit 7 Mode 0

P0M1 .EQU 0x93                ;Port 0 Mode Register 1
   P00M1 = 0x01 ;Port 0 bit 0 Mode 1
   P01M1 = 0x02 ;Port 0 bit 1 Mode 1
   P02M1 = 0x04 ;Port 0 bit 2 Mode 1
   P03M1 = 0x08 ;Port 0 bit 3 Mode 1
   P04M1 = 0x10 ;Port 0 bit 4 Mode 1
   P05M1 = 0x20 ;Port 0 bit 5 Mode 1
   P06M1 = 0x40 ;Port 0 bit 6 Mode 1
   P07M1 = 0x80 ;Port 0 bit 7 Mode 1

P0M0 .EQU 0x94                ;Port 0 Mode Register 0
   P00M0 = 0x01 ;Port 0 bit 0 Mode 0
   P01M0 = 0x02 ;Port 0 bit 1 Mode 0
   P02M0 = 0x04 ;Port 0 bit 2 Mode 0
   P03M0 = 0x08 ;Port 0 bit 3 Mode 0
   P04M0 = 0x10 ;Port 0 bit 4 Mode 0
   P05M0 = 0x20 ;Port 0 bit 5 Mode 0
   P06M0 = 0x40 ;Port 0 bit 6 Mode 0
   P07M0 = 0x80 ;Port 0 bit 7 Mode 0

P2M1 .EQU 0x95                ;Port 2 Mode Register 1
   P20M1 = 0x01 ;Port 2 bit 0 Mode 1
   P21M1 = 0x02 ;Port 2 bit 1 Mode 1
   P22M1 = 0x04 ;Port 2 bit 2 Mode 1
   P23M1 = 0x08 ;Port 2 bit 3 Mode 1
   P24M1 = 0x10 ;Port 2 bit 4 Mode 1
   P25M1 = 0x20 ;Port 2 bit 5 Mode 1
   P26M1 = 0x40 ;Port 2 bit 6 Mode 1
   P27M1 = 0x80 ;Port 2 bit 7 Mode 1

P2M0 .EQU 0x96                ;Port 2 Mode Register 0
   P20M0 = 0x01 ;Port 2 bit 0 Mode 0
   P21M0 = 0x02 ;Port 2 bit 1 Mode 0
   P22M0 = 0x04 ;Port 2 bit 2 Mode 0
   P23M0 = 0x08 ;Port 2 bit 3 Mode 0
   P24M0 = 0x10 ;Port 2 bit 4 Mode 0
   P25M0 = 0x20 ;Port 2 bit 5 Mode 0
   P26M0 = 0x40 ;Port 2 bit 6 Mode 0
   P27M0 = 0x80 ;Port 2 bit 7 Mode 0

SCON .EQU 0x98                ;Serial Control
   RI  .EQU 0x98+0 ;Receive Interrupt
   TI  .EQU 0x98+1 ;Transmit Interrupt
   RB8 .EQU 0x98+2 ;Receive Bit 8
   TB8 .EQU 0x98+3 ;Transmit Bit 8
   REN .EQU 0x98+4 ;Receive Enable
   SM2 .EQU 0x98+5 ;Serial Mode 2
   SM1 .EQU 0x98+6 ;Serial Mode 1
   SM0 .EQU 0x98+7 ;Serial Mode 0
   FE  .EQU 0x98+7 ;Framing Error

SBUF .EQU 0x99                ;Serial Port 1 Data Register

S2CON .EQU 0x9A               ;Serial Port 2 Control Register
   S2RI  = 0x01 ;Serial Port 2 Receive Interrupt Flag
   S2TI  = 0x02 ;Serial Port 2 Transmit Interrupt Flag
   S2RB8 = 0x04 ;Serial Port 2 Receive Bit 8 Data
   S2TB8 = 0x08 ;Serial Port 2 Transmit Bit 8 Data
   S2REN = 0x10 ;Serial Port 2 Receive Enable
   S2SM2 = 0x20 ;Serial Port 2 Select Mode Bit 2
   S2SM0 = 0x80 ;Serial Port 2 Select Mode Bit 0

S2BUF .EQU 0x9B               ;Serial Port 2 Data Register

IRCBAND .EQU 0x9D             ;Internal RC Clock Frequency Band Selection
   IRCBSEL = 0x01 ;Select RC Clock Frequency

LIRTRIM .EQU 0x9E             ;Internal RC Clock Frequency Trimming Register

IRTRIM .EQU 0x9F              ;Internal RC Clock Frequency Adjustment Register

P2 .EQU 0xA0                  ;Port 2
   P20 .EQU 0xA0+0 ;Port 2 Bit 0
   P21 .EQU 0xA0+1 ;Port 2 Bit 1
   P22 .EQU 0xA0+2 ;Port 2 Bit 2
   P23 .EQU 0xA0+3 ;Port 2 Bit 3
   P24 .EQU 0xA0+4 ;Port 2 Bit 4
   P25 .EQU 0xA0+5 ;Port 2 Bit 5
   P26 .EQU 0xA0+6 ;Port 2 Bit 6
   P27 .EQU 0xA0+7 ;Port 2 Bit 7
   P2_0 .EQU 0xA0+0 ;Port 2 Bit 0
   P2_1 .EQU 0xA0+1 ;Port 2 Bit 1
   P2_2 .EQU 0xA0+2 ;Port 2 Bit 2
   P2_3 .EQU 0xA0+3 ;Port 2 Bit 3
   P2_4 .EQU 0xA0+4 ;Port 2 Bit 4
   P2_5 .EQU 0xA0+5 ;Port 2 Bit 5
   P2_6 .EQU 0xA0+6 ;Port 2 Bit 6
   P2_7 .EQU 0xA0+7 ;Port 2 Bit 7
; See device specific data sheet for additional pin names.

BUS_SPEED .EQU 0xA1           ;Bus Speed Control Register
   BUSSPEED = 0x07 ;Bus Read-Write Speed Control
   RW_S     = 0xC0 ;Read-Write Control Pin Select

P_SW1 .EQU 0xA2               ;Peripheral Port Switching Register 1
   SPI_S = 0xC0 ;Serial Peripheral Interface Pin Select
   CCP_S = 0x30 ;PCA Pin Select
   S1_S  = 0xC0 ;Serial Port 1 Pin Select

IE .EQU 0xA8                  ;Interrupt Enable
   EX0  .EQU 0xA8+0 ;Enable External 0
   ET0  .EQU 0xA8+1 ;Enable Timer 0
   EX1  .EQU 0xA8+2 ;Enable External 1
   ET1  .EQU 0xA8+3 ;Enable Timer 1
   ES   .EQU 0xA8+4 ;Enable Serial
   EADC .EQU 0xA8+5 ;Enable ADC
   ELVD .EQU 0xA8+6 ;Enable Low Voltage Detect
   EA   .EQU 0xA8+7 ;Enable All

SADDR .EQU 0xA9               ;Slave Address Register

WKTCL .EQU 0xAA               ;Power Down Wakeup Timer Low Byte

WKTCH .EQU 0xAB               ;Power Down Wakeup Timer High Byte
   WKTEN = 0x80 ;Power Down Wakeup Timer Enable

S3CON .EQU 0xAC               ;Serial Port 3 Control Register
   S3RI  = 0x01 ;Serial Port 3 Receive Interrupt Flag
   S3TI  = 0x02 ;Serial Port 3 Transmit Interrupt Flag
   S3RB8 = 0x04 ;Serial Port 3 Receive Bit 8 Data
   S3TB8 = 0x08 ;Serial Port 3 Transmit Bit 8 Data
   S3REN = 0x10 ;Serial Port 3 Receive Enable
   S3SM2 = 0x20 ;Serial Port 3 Select Mode Bit 2
   S3ST3 = 0x40 ;Serial Port 3 Select Timer 3
   S3SM0 = 0x80 ;Serial Port 3 Select Mode Bit 0

S3BUF .EQU 0xAD               ;Serial Port 3 Data Register

TA .EQU 0xAE                  ;Data Pointer Control Register

IE2 .EQU 0xAF                 ;Interrupt Control Register 2
   ES2  = 0x01 ;Enable Serial Port 2 Interrupt
   ESPI = 0x02 ;Enable Serial Peripheral Interface Interrupt
   ET2  = 0x04 ;Enable Timer 2 Interrupt
   ES3  = 0x08 ;Enable Serial Port 3 Interrupt
   ES4  = 0x10 ;Enable Serial Port 4 Interrupt
   ET3  = 0x20 ;Enable Timer 3 Interrupt
   ET4  = 0x40 ;Enable Timer 4 Interrupt
   ECAN = 0x80 ;Enable CAN Interrupt

P3 .EQU 0xB0                  ;Port 3
;  ACH0 .EQU 0xB0+0 ;ADC Channel 8
;  ACH1 .EQU 0xB0+1 ;ADC Channel 9
;  ACH2 .EQU 0xB0+2 ;ADC Channel 10
;  ACH3 .EQU 0xB0+3 ;ADC Channel 11
;  ACH4 .EQU 0xB0+4 ;ADC Channel 12
;  ACH5 .EQU 0xB0+5 ;ADC Channel 13
;  ACH6 .EQU 0xB0+6 ;ADC Channel 14
;  ADC0 .EQU 0xB0+0 ;AtoD Channel 8
;  ADC1 .EQU 0xB0+1 ;AtoD Channel 9
;  ADC2 .EQU 0xB0+2 ;AtoD Channel 10
;  ADC3 .EQU 0xB0+3 ;AtoD Channel 11
;  ADC4 .EQU 0xB0+4 ;AtoD Channel 12
;  ADC5 .EQU 0xB0+5 ;AtoD Channel 13
;  ADC6 .EQU 0xB0+6 ;AtoD Channel 14
;  AIN0 .EQU 0xB0+0 ;Analog Input 8
;  AIN1 .EQU 0xB0+1 ;Analog Input 9
;  AIN2 .EQU 0xB0+2 ;Analog Input 10
;  AIN3 .EQU 0xB0+3 ;Analog Input 11
;  AIN4 .EQU 0xB0+4 ;Analog Input 12
;  AIN5 .EQU 0xB0+5 ;Analog Input 13
;  AIN6 .EQU 0xB0+6 ;Analog Input 14
   P30 .EQU 0xB0+0 ;Port 3 Bit 0
   P31 .EQU 0xB0+1 ;Port 3 Bit 1
   P32 .EQU 0xB0+2 ;Port 3 Bit 2
   P33 .EQU 0xB0+3 ;Port 3 Bit 3
   P34 .EQU 0xB0+4 ;Port 3 Bit 4
   P35 .EQU 0xB0+5 ;Port 3 Bit 5
   P36 .EQU 0xB0+6 ;Port 3 Bit 6
   P37 .EQU 0xB0+7 ;Port 3 Bit 7
   P3_0 .EQU 0xB0+0 ;Port 3 Bit 0
   P3_1 .EQU 0xB0+1 ;Port 3 Bit 1
   P3_2 .EQU 0xB0+2 ;Port 3 Bit 2
   P3_3 .EQU 0xB0+3 ;Port 3 Bit 3
   P3_4 .EQU 0xB0+4 ;Port 3 Bit 4
   P3_5 .EQU 0xB0+5 ;Port 3 Bit 5
   P3_6 .EQU 0xB0+6 ;Port 3 Bit 6
   P3_7 .EQU 0xB0+7 ;Port 3 Bit 7
; See device specific data sheet for additional pin names.

P3M1 .EQU 0xB1                ;Port 3 Mode Register 1
   P30M1 = 0x01 ;Port 3 bit 0 Mode 1
   P31M1 = 0x02 ;Port 3 bit 1 Mode 1
   P32M1 = 0x04 ;Port 3 bit 2 Mode 1
   P33M1 = 0x08 ;Port 3 bit 3 Mode 1
   P34M1 = 0x10 ;Port 3 bit 4 Mode 1
   P35M1 = 0x20 ;Port 3 bit 5 Mode 1
   P36M1 = 0x40 ;Port 3 bit 6 Mode 1
   P37M1 = 0x80 ;Port 3 bit 7 Mode 1

P3M0 .EQU 0xB2                ;Port 3 Mode Register 0
   P30M0 = 0x01 ;Port 3 bit 0 Mode 0
   P31M0 = 0x02 ;Port 3 bit 1 Mode 0
   P32M0 = 0x04 ;Port 3 bit 2 Mode 0
   P33M0 = 0x08 ;Port 3 bit 3 Mode 0
   P34M0 = 0x10 ;Port 3 bit 4 Mode 0
   P35M0 = 0x20 ;Port 3 bit 5 Mode 0
   P36M0 = 0x40 ;Port 3 bit 6 Mode 0
   P37M0 = 0x80 ;Port 3 bit 7 Mode 0

P4M1 .EQU 0xB3                ;Port 4 Mode Register 1
   P40M1 = 0x01 ;Port 4 bit 0 Mode 1
   P41M1 = 0x02 ;Port 4 bit 1 Mode 1
   P42M1 = 0x04 ;Port 4 bit 2 Mode 1
   P43M1 = 0x08 ;Port 4 bit 3 Mode 1
   P44M1 = 0x10 ;Port 4 bit 4 Mode 1
   P45M1 = 0x20 ;Port 4 bit 5 Mode 1
   P46M1 = 0x40 ;Port 4 bit 6 Mode 1
   P47M1 = 0x80 ;Port 4 bit 7 Mode 1

P4M0 .EQU 0xB4                ;Port 4 Mode Register 0
   P40M0 = 0x01 ;Port 4 bit 0 Mode 0
   P41M0 = 0x02 ;Port 4 bit 1 Mode 0
   P42M0 = 0x04 ;Port 4 bit 2 Mode 0
   P43M0 = 0x08 ;Port 4 bit 3 Mode 0
   P44M0 = 0x10 ;Port 4 bit 4 Mode 0
   P45M0 = 0x20 ;Port 4 bit 5 Mode 0
   P46M0 = 0x40 ;Port 4 bit 6 Mode 0
   P47M0 = 0x80 ;Port 4 bit 7 Mode 0

IP2 .EQU 0xB5                 ;Interrupt Priority Register 2
   PS2    = 0x01 ;Serial Port 2 Interrupt Priority
   PSPI   = 0x02 ;Serial Peripheral Interface Interrupt Priority
   PPWM   = 0x04 ;PWM Interrupt Priority
   PPWMFD = 0x08 ;PWM Fault Detect Interrupt Priority
   PX4    = 0x10 ;External Interrupt 4 Priority
   PCMP   = 0x20 ;Comparator Interrupt Priority
   PI2C   = 0x40 ;I2C Interrupt Priority
   PCAN   = 0x80 ;CAN Interrupt Priority
   PUSB   = 0x80 ;USB Interrupt Priority
   PTKSU  = 0x80 ;Touch Sensor Interrupt Priority

IP2H .EQU 0xB6                ;High Interrupt Priority Register 2
   PS2H    = 0x01 ;Serial Port 2 Interrupt Priority High
   PSPIH   = 0x02 ;Serial Peripheral Interface Interrupt Priority High
   PPWMH   = 0x04 ;PWM Interrupt Priority High
   PPWMFDH = 0x08 ;PWM Fault Detect Interrupt Priority High
   PX4H    = 0x10 ;External Interrupt 4 Priority High
   PCMPH   = 0x20 ;Comparator Interrupt Priority High
   PI2CH   = 0x40 ;I2C Interrupt Priority High
   PCANH   = 0x80 ;CAN Interrupt Priority High
   PUSBH   = 0x80 ;USB Interrupt Priority High
   PTKSUH  = 0x80 ;Touch Sensor Interrupt Priority High

IPH .EQU 0xB7                 ;High Interrupt Priority Register
   PX0H  = 0x01 ;External Interrupt 0 Priority High
   PT0H  = 0x02 ;Timer 0 Interrupt Priority High
   PX1H  = 0x04 ;External Interrupt 1 Priority High
   PT1H  = 0x08 ;Timer 1 Interrupt Priority High
   PSH   = 0x10 ;Serial Port 1 Interrupt Priority High
   PADCH = 0x20 ;ADC Interrupt Priority High
   PLVDH = 0x40 ;Low Voltage Detect Interrupt Priority High
   PPCAH = 0x80 ;CCP-PCA Interrupt Priority High

IP .EQU 0xB8                  ;Interrupt Priority
   PX0  .EQU 0xB8+0 ;Priority External 0
   PT0  .EQU 0xB8+1 ;Priority Timer 0
   PX1  .EQU 0xB8+2 ;Priority External 1
   PT1  .EQU 0xB8+3 ;Priority Timer 1
   PS   .EQU 0xB8+4 ;Priority Serial
   PADC .EQU 0xB8+5 ;Priority ADC
   PLVD .EQU 0xB8+6 ;Priority Low Voltage Detect
   PPCA .EQU 0xB8+7 ;Priority CCP-PCA

SADEN .EQU 0xB9               ;Slave Address Mask Register

P_SW2 .EQU 0xBA               ;Peripheral Port Switching Register 2
   S2_S   = 0x10 ;Serial Port 2 Pin Select
   S3_S   = 0x20 ;Serial Port 3 Pin Select
   S4_S   = 0x40 ;Serial Port 4 Pin Select
   CMPO_S = 0x80 ;Comparator Output Pin Select
   I2C_S  = 0x30 ;I2C Pin Select
   CAN_S  = 0x40 ;CAN Pin Select
   EAXFR  = 0x80 ;Extended RAM Area Transfer Enable

ADC_CONTR .EQU 0xBC           ;Analog to Digital Converter Control Register
   ADC_CHS   = 0x0F ;ADC Analog Channel Select
   ADC_EPWMT = 0x10 ;ADC Enable PWM Trigger
   ADC_FLAG  = 0x20 ;ADC Conversion Complete Flag
   ADC_START = 0x40 ;ADC Start Command
   ADC_POWER = 0x80 ;ADC Power Control

ADC_RES .EQU 0xBD             ;Analog to Digital Converter Result High 8 Bits

ADC_RESL .EQU 0xBE            ;Analog to Digital Converter Result Low 2 Bits

P4 .EQU 0xC0                  ;Port 4
   P40 .EQU 0xC0+0 ;Port 4 Bit 0
   P41 .EQU 0xC0+1 ;Port 4 Bit 1
   P42 .EQU 0xC0+2 ;Port 4 Bit 2
   P43 .EQU 0xC0+3 ;Port 4 Bit 3
   P44 .EQU 0xC0+4 ;Port 4 Bit 4
   P45 .EQU 0xC0+5 ;Port 4 Bit 5
   P46 .EQU 0xC0+6 ;Port 4 Bit 6
   P47 .EQU 0xC0+7 ;Port 4 Bit 7
   P4_0 .EQU 0xC0+0 ;Port 4 Bit 0
   P4_1 .EQU 0xC0+1 ;Port 4 Bit 1
   P4_2 .EQU 0xC0+2 ;Port 4 Bit 2
   P4_3 .EQU 0xC0+3 ;Port 4 Bit 3
   P4_4 .EQU 0xC0+4 ;Port 4 Bit 4
   P4_5 .EQU 0xC0+5 ;Port 4 Bit 5
   P4_6 .EQU 0xC0+6 ;Port 4 Bit 6
   P4_7 .EQU 0xC0+7 ;Port 4 Bit 7
; See device specific data sheet for additional pin names.

WDT_CONTR .EQU 0xC1           ;Watchdog Control Register
   WDTPS0   = 0x01 ;Watchdog Timer Prescaler 0
   WDTPS1   = 0x02 ;Watchdog Timer Prescaler 1
   WDTPS2   = 0x04 ;Watchdog Timer Prescaler 2
   WDT_PS   = 0x07 ;Watchdog Timer Prescaler
   IDL_WDT  = 0x08 ;Watchdog Timer Idle Mode Behavior
   CLR_WDT  = 0x10 ;Clear Watchdog Timer
   EN_WDT   = 0x20 ;Enable Watchdog Timer
   WDT_FLAG = 0x80 ;Watchdog Timer Overflow Flag

IAP_DATA .EQU 0xC2            ;In Application Programming Data
ISP_DATA .EQU 0xC2            ;In System Programming Data

IAP_ADDRH .EQU 0xC3           ;In Application Programming Address High
ISP_ADDRH .EQU 0xC3           ;In System Programming Address High

IAP_ADDRL .EQU 0xC4           ;In Application Programming Address Low
ISP_ADDRL .EQU 0xC4           ;In System Programming Address Low

IAP_CMD .EQU 0xC5             ;In Application Programming Command
ISP_CMD .EQU 0xC5             ;In System Programming Command
   MS0    = 0x01 ;Mode Select 0
   MS1    = 0x02 ;Mode Select 1
   IAPCMD = 0x03 ;In Application Programming Command
; Valid commands follow
   IAP_IDL   = 0x00
   IAP_READ  = 0x01
   IAP_WRITE = 0x02
   IAP_ERASE = 0x03
; End of valid commands

IAP_TRIG .EQU 0xC6            ;In Application Programming Trigger
ISP_TRIG .EQU 0xC6            ;In System Programming Trigger

IAP_CONTR .EQU 0xC7           ;In Application Programming Control
ISP_CONTR .EQU 0xC7           ;In System Programming Control
   WT0      = 0x01 ;Wait 0
   WT1      = 0x02 ;Wait 1
   WT2      = 0x04 ;Wait 2
   IAP_WT   = 0x07 ;In Application Programming Wait
   CMD_FAIL = 0x10 ;Command Fail
   SWRST    = 0x20 ;Software Reset Trigger
   SWBS     = 0x40 ;Software Boot Selection
   IAPEN    = 0x80 ;In Application Programming Enable

P5 .EQU 0xC8                  ;Port 5
   P50 .EQU 0xC8+0 ;Port 5 Bit 0
   P51 .EQU 0xC8+1 ;Port 5 Bit 1
   P52 .EQU 0xC8+2 ;Port 5 Bit 2
   P53 .EQU 0xC8+3 ;Port 5 Bit 3
   P54 .EQU 0xC8+4 ;Port 5 Bit 4
   P55 .EQU 0xC8+5 ;Port 5 Bit 5
   P5_0 .EQU 0xC8+0 ;Port 5 Bit 0
   P5_1 .EQU 0xC8+1 ;Port 5 Bit 1
   P5_2 .EQU 0xC8+2 ;Port 5 Bit 2
   P5_3 .EQU 0xC8+3 ;Port 5 Bit 3
   P5_4 .EQU 0xC8+4 ;Port 5 Bit 4
   P5_5 .EQU 0xC8+5 ;Port 5 Bit 5
; See device specific data sheet for additional pin names.

P5M1 .EQU 0xC9                ;Port 5 Mode Register 1
   P50M1 = 0x01 ;Port 5 bit 0 Mode 1
   P51M1 = 0x02 ;Port 5 bit 1 Mode 1
   P52M1 = 0x04 ;Port 5 bit 2 Mode 1
   P53M1 = 0x08 ;Port 5 bit 3 Mode 1
   P54M1 = 0x10 ;Port 5 bit 4 Mode 1
   P55M1 = 0x20 ;Port 5 bit 5 Mode 1

P5M0 .EQU 0xCA                ;Port 5 Mode Register 0
   P50M0 = 0x01 ;Port 5 bit 0 Mode 0
   P51M0 = 0x02 ;Port 5 bit 1 Mode 0
   P52M0 = 0x04 ;Port 5 bit 2 Mode 0
   P53M0 = 0x08 ;Port 5 bit 3 Mode 0
   P54M0 = 0x10 ;Port 5 bit 4 Mode 0
   P55M0 = 0x20 ;Port 5 bit 5 Mode 0

P6M1 .EQU 0xCB                ;Port 6 Mode Register 1
   P60M1 = 0x01 ;Port 6 bit 0 Mode 1
   P61M1 = 0x02 ;Port 6 bit 1 Mode 1
   P62M1 = 0x04 ;Port 6 bit 2 Mode 1
   P63M1 = 0x08 ;Port 6 bit 3 Mode 1
   P64M1 = 0x10 ;Port 6 bit 4 Mode 1
   P65M1 = 0x20 ;Port 6 bit 5 Mode 1
   P66M1 = 0x40 ;Port 6 bit 6 Mode 1
   P67M1 = 0x80 ;Port 6 bit 7 Mode 1

P6M0 .EQU 0xCC                ;Port 6 Mode Register 0
   P60M0 = 0x01 ;Port 6 bit 0 Mode 0
   P61M0 = 0x02 ;Port 6 bit 1 Mode 0
   P62M0 = 0x04 ;Port 6 bit 2 Mode 0
   P63M0 = 0x08 ;Port 6 bit 3 Mode 0
   P64M0 = 0x10 ;Port 6 bit 4 Mode 0
   P65M0 = 0x20 ;Port 6 bit 5 Mode 0
   P66M0 = 0x40 ;Port 6 bit 6 Mode 0
   P67M0 = 0x80 ;Port 6 bit 7 Mode 0

SPSTAT .EQU 0xCD              ;Serial Peripheral Status Register
   WCOL = 0x40 ;Write Collision
   SPIF = 0x80 ;Serial Peripheral Interface Flag

SPCTL .EQU 0xCE               ;Serial Peripheral Control Register
   SPR0 = 0x00 ;Serial Peripheral Rate 0
   SPR1 = 0x01 ;Serial Peripheral Rate 1
   SPR  = 0x03 ;Serial Peripheral Rate
   CPHA = 0x04 ;Clock Phase
   CPOL = 0x08 ;Clock Polarity
   MSTR = 0x10 ;Master
   DORD = 0x20 ;Data Order
   SPEN = 0x40 ;Serial Peripheral Enable
   SSIG = 0x80 ;Slave Select Signal

SPDAT .EQU 0xCF               ;Serial Peripheral Data

PSW .EQU 0xD0                 ;Program status word
   P   .EQU 0xD0+0 ;Parity
   F1  .EQU 0xD0+1 ;Flag 1
   OV  .EQU 0xD0+2 ;Overflow
   RS0 .EQU 0xD0+3 ;Register Select 0
   RS1 .EQU 0xD0+4 ;Register Select 1
   F0  .EQU 0xD0+5 ;Flag 0
   AC  .EQU 0xD0+6 ;Auxiliary Carry
   CY  .EQU 0xD0+7 ;Carry

T4T3M .EQU 0xD1               ;T4 and T3 Mode Register
   T3CLKO = 0x01 ;Timer 3 Clock Output Control
   T3x12  = 0x02 ;Timer 3 Clock x12 Prescaler Bypass
   T3_CT  = 0x04 ;Timer 3 Counter or Timer Mode Select
   T3R    = 0x08 ;Timer 3 Run Control
   T4CLKO = 0x10 ;Timer 4 Clock Output Control
   T4x12  = 0x20 ;Timer 4 Clock x12 Prescaler Bypass
   T4_CT  = 0x40 ;Timer 4 Counter or Timer Mode Select
   T4R    = 0x80 ;Timer 4 Run Control

T4H .EQU 0xD2                 ;T4 High Byte
TH4 .EQU 0xD2

T4L .EQU 0xD3                 ;T4 Low Byte
TL4 .EQU 0xD3

T3H .EQU 0xD4                 ;T3 High Byte
TH3 .EQU 0xD4

T3L .EQU 0xD5                 ;T3 Low Byte
TL3 .EQU 0xD5

T2H .EQU 0xD6                 ;T2 High Byte
TH2 .EQU 0xD6

T2L .EQU 0xD7                 ;T2 Low Byte
TL2 .EQU 0xD7

USBCLK .EQU 0xDC              ;USB Clock Control Register
   PHYTST  = 0x03 ;PHY Test Mode
   TST_PHY = 0x04 ;Test PHY Enable
   TST_USB = 0x08 ;Test USB Enable
   CRE     = 0x10 ;Clock Recovery Enable
   PCKI    = 0x60 ;PLL Clock Selection
   ENCKM   = 0x80 ;Enable Clock Multiplier

ADCCFG .EQU 0xDE              ;ADC Configuration Register
   ADCSPEED  = 0x0F ;Clock Speed Control
   RESFMT    = 0x20 ;Result Format Control

IP3 .EQU 0xDF                 ;Interrupt Priority Register 3
   PS3  = 0x01 ;Serial Port 3 Interrupt Priority
   PS4  = 0x02 ;Serial Port 4 Interrupt Priority
   PRTC = 0x04 ;RTC Interrupt Priority Control

ACC .EQU 0xE0                 ;Accumulator
   ACC0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC7 .EQU 0xE0+7 ;Accumulator Bit 7
   ACC_0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC_1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC_2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC_3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC_4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC_5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC_6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC_7 .EQU 0xE0+7 ;Accumulator Bit 7

P7M1 .EQU 0xE1                ;Port 7 Mode Register 1
   P70M1 = 0x01 ;Port 7 bit 0 Mode 1
   P71M1 = 0x02 ;Port 7 bit 1 Mode 1
   P72M1 = 0x04 ;Port 7 bit 2 Mode 1
   P73M1 = 0x08 ;Port 7 bit 3 Mode 1
   P74M1 = 0x10 ;Port 7 bit 4 Mode 1
   P75M1 = 0x20 ;Port 7 bit 5 Mode 1
   P76M1 = 0x40 ;Port 7 bit 6 Mode 1
   P77M1 = 0x80 ;Port 7 bit 7 Mode 1

P7M0 .EQU 0xE2                ;Port 7 Mode Register 0
   P70M0 = 0x01 ;Port 7 bit 0 Mode 0
   P71M0 = 0x02 ;Port 7 bit 1 Mode 0
   P72M0 = 0x04 ;Port 7 bit 2 Mode 0
   P73M0 = 0x08 ;Port 7 bit 3 Mode 0
   P74M0 = 0x10 ;Port 7 bit 4 Mode 0
   P75M0 = 0x20 ;Port 7 bit 5 Mode 0
   P76M0 = 0x40 ;Port 7 bit 6 Mode 0
   P77M0 = 0x80 ;Port 7 bit 7 Mode 0

DPS .EQU 0xE3                 ;DPTR Pointer Selector
   SEL = 0x01 ;Data Pointer Select
   AU0 = 0x08 ;Auto Increment-Decrement Data Pointer 0
   AU1 = 0x10 ;Auto Increment-Decrement Data Pointer 1
   TSL = 0x20 ;Auto Toggle Data Pointer Select
   ID0 = 0x40 ;Increment or Decrement Data Pointer 0
   ID1 = 0x80 ;Increment or Decrement Data Pointer 1

DPL1 .EQU 0xE4                ;Second Data Pointer Low Byte
DPTR1 .EQU 0xE4               ;Second Data Pointer Word

DPH1 .EQU 0xE5                ;Second Data Pointer High Byte

CMPCR1 .EQU 0xE6              ;Comparator Control Register 1
   CMPRES = 0x01 ;Comparator Result
   CMPOE  = 0x02 ;Comparator Output Enable
   NIS    = 0x04 ;Negative Input Source Selection
   PIS    = 0x08 ;Positive Input Source Selection
   NIE    = 0x10 ;Falling Edge Interrupt Enable
   PIE    = 0x20 ;Rising Edge Interrupt Enable
   CMPIF  = 0x40 ;Comparator Interrupt Flag
   CMPEN  = 0x80 ;Comparator Enable

CMPCR2 .EQU 0xE7              ;Comparator Control Register 2
   LCDTY   = 0x3F ;Digital Filter Control
   DISFLT  = 0x40 ;Analog Filter Control
   INVCMPO = 0x80 ;Comparator Output Control

P6 .EQU 0xE8                  ;Port 6
   P60 .EQU 0xE8+0 ;Port 6 Bit 0
   P61 .EQU 0xE8+1 ;Port 6 Bit 1
   P62 .EQU 0xE8+2 ;Port 6 Bit 2
   P63 .EQU 0xE8+3 ;Port 6 Bit 3
   P64 .EQU 0xE8+4 ;Port 6 Bit 4
   P65 .EQU 0xE8+5 ;Port 6 Bit 5
   P66 .EQU 0xE8+6 ;Port 6 Bit 6
   P67 .EQU 0xE8+7 ;Port 6 Bit 7
   P6_0 .EQU 0xE8+0 ;Port 6 Bit 0
   P6_1 .EQU 0xE8+1 ;Port 6 Bit 1
   P6_2 .EQU 0xE8+2 ;Port 6 Bit 2
   P6_3 .EQU 0xE8+3 ;Port 6 Bit 3
   P6_4 .EQU 0xE8+4 ;Port 6 Bit 4
   P6_5 .EQU 0xE8+5 ;Port 6 Bit 5
   P6_6 .EQU 0xE8+6 ;Port 6 Bit 6
   P6_7 .EQU 0xE8+7 ;Port 6 Bit 7
; See device specific data sheet for additional pin names.

USBDATA .EQU 0xEC             ;USB Data Register
USBDAT .EQU 0xEC
   UDAT  = 0xFF ;USB Indirect Register Data

IP3H .EQU 0xEE                ;High Interrupt Priority Register 3
   PS3H  = 0x01 ;Serial Port 3 Interrupt Priority
   PS4H  = 0x02 ;Serial Port 4 Interrupt Priority
   PRTCH = 0x04 ;RTC Interrupt Priority Control

AUXINTIF .EQU 0xEF            ;Auxiliary Interrupt Flag Register
   T2IF   = 0x01 ;Timer 2 Overflow Interrupt
   T3IF   = 0x02 ;Timer 1 Overflow Interrupt
   T4IF   = 0x04 ;Timer 0 Overflow Interrupt
   INT2IF = 0x10 ;External Interrupt 2 Request Flag
   INT3IF = 0x20 ;External Interrupt 3 Request Flag
   INT4IF = 0x40 ;External Interrupt 4 Request Flag

B .EQU 0xF0                   ;B
   B0 .EQU 0xF0+0 ;B Bit 0
   B1 .EQU 0xF0+1 ;B Bit 1
   B2 .EQU 0xF0+2 ;B Bit 2
   B3 .EQU 0xF0+3 ;B Bit 3
   B4 .EQU 0xF0+4 ;B Bit 4
   B5 .EQU 0xF0+5 ;B Bit 5
   B6 .EQU 0xF0+6 ;B Bit 6
   B7 .EQU 0xF0+7 ;B Bit 7
   B_0 .EQU 0xF0+0 ;B Bit 0
   B_1 .EQU 0xF0+1 ;B Bit 1
   B_2 .EQU 0xF0+2 ;B Bit 2
   B_3 .EQU 0xF0+3 ;B Bit 3
   B_4 .EQU 0xF0+4 ;B Bit 4
   B_5 .EQU 0xF0+5 ;B Bit 5
   B_6 .EQU 0xF0+6 ;B Bit 6
   B_7 .EQU 0xF0+7 ;B Bit 7

USBCON .EQU 0xF4              ;USB Control Register
   DM     = 0x01 ;D- Logic Level Indicator
   DP     = 0x02 ;D+ Logic Level Indicator
   DFREC  = 0x04 ;Differential Receive Status
   PDEN   = 0x08 ;Pull Down Resistor Enable
   PUEN   = 0x10 ;Pull Up Resistor Enable
   PS2M   = 0x20 ;PS2 Mode Enable
   ENRST  = 0x40 ;USB Reset Enable
   ENUSB  = 0x80 ;Enable USB and Clock

IAP_TPS .EQU 0xF5             ;IAP Wait Time Control Register
   IAPTPS = 0x3F ;Set Wait Time Per Operating Frequency

P7 .EQU 0xF8                  ;Port 7
   P70 .EQU 0xF8+0 ;Port 7 Bit 0
   P71 .EQU 0xF8+1 ;Port 7 Bit 1
   P72 .EQU 0xF8+2 ;Port 7 Bit 2
   P73 .EQU 0xF8+3 ;Port 7 Bit 3
   P74 .EQU 0xF8+4 ;Port 7 Bit 4
   P75 .EQU 0xF8+5 ;Port 7 Bit 5
   P76 .EQU 0xF8+6 ;Port 7 Bit 6
   P77 .EQU 0xF8+7 ;Port 7 Bit 7
   P7_0 .EQU 0xF8+0 ;Port 7 Bit 0
   P7_1 .EQU 0xF8+1 ;Port 7 Bit 1
   P7_2 .EQU 0xF8+2 ;Port 7 Bit 2
   P7_3 .EQU 0xF8+3 ;Port 7 Bit 3
   P7_4 .EQU 0xF8+4 ;Port 7 Bit 4
   P7_5 .EQU 0xF8+5 ;Port 7 Bit 5
   P7_6 .EQU 0xF8+6 ;Port 7 Bit 6
   P7_7 .EQU 0xF8+7 ;Port 7 Bit 7
; See device specific data sheet for additional pin names.

USBADDR .EQU 0xFC             ;USB Address Register
USBADR .EQU 0xFC
   UADR   = 0x3F ; USB Indirect Register Address
   AUTORD = 0x04 ; USB Register Automatic Read Flag
   BUSY   = 0x08 ; USB Register Busy Flag

RSTCFG .EQU 0xFF              ;Reset Configuration Register
   LVDS   = 0x03 ;Low Voltage Detection Threshold
   P54RST = 0x10 ;Port 5 Pin 4 Reset Pin Enable
   ENLVR  = 0x40 ;Enable Low Voltage Reset

; The following SB Controller Registers SIE support USB functionality.
; They are accessed indirectly via the USBDATA and USBADDR registers.
   FADDR = 0x00              ;Function Address Register
   UADDR  = 0x7F ;USB 7 Bit Function Address
   UPDATE = 0x80 ;Function Address Update Flag
   POWER = 0x01              ;Power Management Register
   ENSUS   = 0x01 ;Enable Suspend Detection
   USBSUS  = 0x02 ;USB Suspend Control
   USBRSU  = 0x04 ;USB Resume Control
   USBRST = 0x08 ;USB Asynchronous Reset Control
   ISOUD   = 0x80 ;ISO Update Control
   INTRIN1 = 0x02            ;Endpoint In1 Interrupt Flags
   EP0IF   = 0x01 ;Endpoint 0 In1-Out1 Interrupt Flag
   EP1INIF = 0x02 ;Endpoint 1 In1 Interrupt Flag
   EP2INIF = 0x04 ;Endpoint 2 In1 Interrupt Flag
   EP3INIF = 0x08 ;Endpoint 3 In1 Interrupt Flag
   EP4INIF = 0x10 ;Endpoint 4 In1 Interrupt Flag
   EP5INIF = 0x20 ;Endpoint 5 In1 Interrupt Flag
   INTROUT1 = 0x04           ;Endpoint Out1 Interrupt Flags
   EP1OUTIF = 0x02 ;Endpoint 1 Out1 Interrupt Flag
   EP2OUTIF = 0x04 ;Endpoint 2 Out1 Interrupt Flag
   EP3OUTIF = 0x08 ;Endpoint 3 Out1 Interrupt Flag
   EP4OUTIF = 0x10 ;Endpoint 4 Out1 Interrupt Flag
   EP5OUTIF = 0x20 ;Endpoint 5 Out1 Interrupt Flag
   INTRUSB = 0x06            ;USB Power Interrupt Flag
   SUSIF = 0x01 ;Suspend Signal Interrupt Flag
   RSUIF = 0x02 ;Recovery Signal Interrupt Flag
   RSTIF = 0x04 ;Reset Signal Interrupt Flag
   SOFIF = 0x08 ;Start Of Frame Interrupt Flag
   INTRIN1E = 0x07           ;Endpoint In1 Interrupt Enable
   EP0IE   = 0x01 ;Endpoint 0 In1-Out1 Interrupt Enable
   EP1INIE = 0x02 ;Endpoint 1 In1 Interrupt Enable
   EP2INIE = 0x04 ;Endpoint 2 In1 Interrupt Enable
   EP3INIE = 0x08 ;Endpoint 3 In1 Interrupt Enable
   EP4INIE = 0x10 ;Endpoint 4 In1 Interrupt Enable
   EP5INIE = 0x20 ;Endpoint 5 In1 Interrupt Enable
   INTROUT1E = 0x09          ;Endpoint Out1 Interrupt Enable
   EP1OUTIE = 0x02 ;Endpoint 1 Out1 Interrupt Enable
   EP2OUTIE = 0x04 ;Endpoint 2 Out1 Interrupt Enable
   EP3OUTIE = 0x08 ;Endpoint 3 Out1 Interrupt Enable
   EP4OUTIE = 0x10 ;Endpoint 4 Out1 Interrupt Enable
   EP5OUTIE = 0x20 ;Endpoint 5 Out1 Interrupt Enable
   INTRUSBE = 0x0B           ;USB Power Interrupt Enable
   SUSIE = 0x01 ;Suspend Signal Interrupt Enable
   RSUIE = 0x02 ;Recovery Signal Interrupt Enable
   RSTIE = 0x04 ;Reset Signal Interrupt Enable
   SOFIE = 0x08 ;Start Of Frame Interrupt Enable
   FRAME1 = 0x0C             ;Data Frame Number Register Low Byte
   FRAME2 = 0x0D             ;Data Frame Number Register High Bits
   INDEX = 0x0E              ;Target Endpoint Index Register
   INMAXP = 0x10             ;Maximum In-Endpoint Packet Size
   CSR0 = 0x11               ;Endpoint 0 Control Status Register
   OPRDY  = 0x01 ;OUT Packet Ready
   IPRDY  = 0x02 ;IN Packet Ready
   STSTLF = 0x04 ;Sent Stall Signal
   DATEND = 0x08 ;Data End Signal
   SUEND  = 0x10 ;Setup End Signal
   SDSTL  = 0x20 ;Send Stall Signal
   SOPRDY = 0x40 ;OPRDY Serviced Flag
   SSUEND = 0x80 ;Setup End Event Serviced Flag
   INCSR1 = 0x11             ;In-Endpoint Control Status Register 1
   IPRDYF = 0x01 ;In Packet Ready Flag
   FIFONE = 0x02 ;In-Endpoint FIFO Not Empty
   UNDRUN = 0x04 ;Data-In Underrun Flag
   FLUSH  = 0x10 ;Purge Next Input FIFO Packet
   SDSTL  = 0x20 ;Send Stall Signal Trigger
   STSTL  = 0x40 ;Stall Signal Sent Completion Flag
   CLRDT  = 0x80 ;Clear In-Data Toggle
   INCSR2 = 0x12             ;In-Endpoint Control Status Register 2
   FCDT    = 0x08 ;Force Data0-Data1 Switch Settings
   ENDMAI  = 0x10 ;Enable In-Endpoint DMA
   MODE    = 0x20 ;Mode (Endpoint Direction) Setting
   ISO     = 0x40 ;Synchronous Transmission Enable
   AUTOSET = 0x80 ;Automatically Set IPRDY Flag
   OUTMAXP = 0x13            ;Maximum Out-Endpoint Packet Size
   OUTCSR1 = 0x14            ;Out-Endpoint Control Status Register 1
   OPRDY   = 0x01 ;Out Packet Ready Flag
   FIFOFUL = 0x02 ;Out-Endpoint FIFO is Full
   OVRRUN  = 0x04 ;Data-Out Overrun Flag
   DATERR  = 0x08 ;Data Error Detected Flag
   FLUSH   = 0x10 ;Purge Next Output FIFO Packet
   SDSTL   = 0x20 ;Send Stall Signal Trigger
   STSTL   = 0x40 ;Stall Signal Sent Completion Flag
   CLRDT   = 0x80 ;Clear Out-Data Toggle
   OUTCSR2 = 0x15            ;Out-Endpoint Control Status Register 2
   DMAMD   = 0x10 ;DMA Mode Control
   ENDMAO  = 0x20 ;Enable Out-Endpoint DMA
   ISO     = 0x40 ;Synchronous Transmission Enable
   AUTOCLR = 0x80 ;Automatically Clears OPRDY Flag
   COUNT0 = 0x16             ;Endpoint 0 Out Length
   OUTCNT0 = 0x7F ;Endpoint 0 Out Byte Count
   OUTCOUNT1 = 0x16          ;Out Length of Endpoints Low Byte
   OUTCOUNT2 = 0x17          ;Out Length of Endpoints High Bits
   FIFO0 = 0x20              ;Endpoint Data FIFO 0
   FIFO1 = 0x21              ;Endpoint Data FIFO 1
   FIFO2 = 0x22              ;Endpoint Data FIFO 2
   FIFO3 = 0x23              ;Endpoint Data FIFO 3
   FIFO4 = 0x24              ;Endpoint Data FIFO 4
   FIFO5 = 0x25              ;Endpoint Data FIFO 5
   UTRKCTL = 0x30            ;USB Tracking Control
   RES   = 0x07 ;Utrack Adjustment Resolution
   ENST5 = 0x08 ;Calibration Limit Select
   INTV  = 0x30 ;Utrack Update Cycle Time
   FTM0  = 0x40 ;Fine Tuning Mode Selection 0
   FTM1  = 0x80 ;Fine Tuning Mode Selection 1
   UTRKSTS = 0x31            ;USB Track Status Register
   UTRK_RDY = 0x01 ;USB Track Calibrated & Ready
   TST_UTRK = 0x02 ;USB Track Test Mode Control
   STS      = 0x0C ;USB Track Status
   INTVCNT  = 0xF0 ;Internal Count Status

; The following special function registers are in the extended RAM area.
; You need to set bit7 of P_SW2 EAXFR to 1 to read and write them normally.
BMM_M2M_CFG .EQU 0xfa00 ;Bulk Mem Move Mem 2 Mem Config Register
   M2MPTY = 0x03 ;Mem 2 Mem Data Bus Access Priority
   M2MIP  = 0x0C ;Mem 2 Mem Interrupt Priority
   RXACO  = 0x01 ;Destination Address Direction
   TXACO  = 0x02 ;Source Address Direction
   M2MIE  = 0x80 ;Mem 2 Mem Interrupt Enable
BMM_M2M_CR .EQU 0xfa01 ;Bulk Mem Move Mem 2 Mem Control Register
   TRIGM2M = 0x40 ;Trigger Mem 2 Mem DMA Task
   ENM2M   = 0x80 ;Enable Mem 2 Mem DMA Function
BMM_M2M_STA .EQU 0xfa02 ;Bulk Mem Move Mem 2 Mem Status Register
   M2MIF = 0x01 ;Mem 2 Mem DMA Interrupt Request Flag
BMM_M2M_AMT .EQU 0xfa03 ;Bulk Mem Move Mem 2 Mem Amount to Move
BMM_M2M_DONE .EQU 0xfa04 ;Bulk Mem Move Mem 2 Mem Done Byte Count
BMM_M2M_TXAH .EQU 0xfa05 ;Bulk Mem Move Mem 2 Mem Read Address High
BMM_M2M_TXAL .EQU 0xfa06 ;Bulk Mem Move Mem 2 Mem Read Address Low
BMM_M2M_RXAH .EQU 0xfa07 ;Bulk Mem Move Mem 2 Mem Write Address High
BMM_M2M_RXAL .EQU 0xfa08 ;Bulk Mem Move Mem 2 Mem Write Address Low
BMM_ADC_CFG .EQU 0xfa10 ;Bulk Mem Move ADC Config Register
   ADCPTY = 0x03 ;ADC Data Bus Access Priority
   ADCMIP = 0x0C ;ADC Interrupt Priority
   ADCIE  = 0x80 ;ADC Interrupt Enable
BMM_ADC_CR .EQU 0xfa11 ;Bulk Mem Move ADC Control Register
   TRIGADC = 0x40 ;Trigger ADC DMA Task
   ENADC   = 0x80 ;Enable ADC DMA Function
BMM_ADC_STA .EQU 0xfa12 ;Bulk Mem Move ADC Status Register
   ADCIF = 0x01 ;ADC DMA Interrupt Request Flag
BMM_ADC_RXAH .EQU 0xfa17 ;Bulk Mem Move ADC Write Address High
BMM_ADC_RXAL .EQU 0xfa18 ;Bulk Mem Move ADC Write Address Low
BMM_ADC_CFG2 .EQU 0xfa19 ;Bulk Mem Move ADC Config Register 2
BMM_ADC_CHSW0 .EQU 0xfa1a ;Bulk Mem Move ADC Channel Enable Register 0
   CH8  = 0x01 ;
   CH9  = 0x02 ;
   CH10 = 0x04 ;
   CH11 = 0x08 ;
   CH12 = 0x10 ;
   CH13 = 0x20 ;
   CH14 = 0x40 ;
   CH15 = 0x80 ;
BMM_ADC_CHSW1 .EQU 0xfa1b ;Bulk Mem Move ADC Channel Enable Register 0
   CH0 = 0x01 ;
   CH1 = 0x02 ;
   CH2 = 0x04 ;
   CH3 = 0x08 ;
   CH4 = 0x10 ;
   CH5 = 0x20 ;
   CH6 = 0x40 ;
   CH7 = 0x80 ;
BMM_SPI_CFG .EQU 0xfa20 ;Bulk Mem Move Serial Peripheral Interface Config Register
   SPIPTY = 0x03 ;Serial Peripheral Interface Data Bus Access Priority
   SPIIP  = 0x0C ;Serial Peripheral Interface Interrupt Priority
   ACT_RX = 0x20 ;Activate SPI Reception via Bulk Memory Move
   ACT_TX = 0x40 ;Activate SPI Transmission via Bulk Memory Move
   SPIIE  = 0x80 ;Serial Peripheral Interface Interrupt Enable
BMM_SPI_CR .EQU 0xfa21 ;Bulk Mem Move Serial Peripheral Interface Control Register
   CLRFIFO = 0x01 ;Clear SPI Recieve FIFO
   TRIG_S  = 0x20 ;Trigger SPI DMA Slave Task
   TRIG_M  = 0x40 ;Trigger SPI DMA Master Task
   ENSPI   = 0x80 ;Enable Serial Peripheral Interface DMA Function
BMM_SPI_STA .EQU 0xfa22 ;Bulk Mem Move Serial Peripheral Interface Status Register
   SPIIF  = 0x01 ;Serial Peripheral Interface DMA Interrupt Request Flag
   RXLOSS = 0x02 ;Received Data Lost Flag
   TXOVW  = 0x04 ;Transmit Data Overwritten Flag
BMM_SPI_AMT .EQU 0xfa23 ;Bulk Mem Move Serial Peripheral Interface Amount to Move
BMM_SPI_DONE .EQU 0xfa24 ;Bulk Mem Move Serial Peripheral Interface Done Byte Count
BMM_SPI_TXAH .EQU 0xfa25 ;Bulk Mem Move Serial Peripheral Interface Read Address High
BMM_SPI_TXAL .EQU 0xfa26 ;Bulk Mem Move Serial Peripheral Interface Read Address Low
BMM_SPI_RXAH .EQU 0xfa27 ;Bulk Mem Move Serial Peripheral Interface Write Address High
BMM_SPI_RXAL .EQU 0xfa28 ;Bulk Mem Move Serial Peripheral Interface Write Address Low
BMM_SPI_CFG2 .EQU 0xfa29 ;Bulk Mem Move Serial Peripheral Interface Config Register 2
   SSS   = 0x03 ;SS Pin Select
   WRPSS = 0x04 ;SS Pin Pulldown After Write
BMM_UR1T_CFG .EQU 0xfa30 ;Bulk Mem Move UR1T Config Register
   UR1TPTY = 0x03 ;UR1T Data Bus Access Priority
   UR1TIP  = 0x0C ;UR1T Interrupt Priority
   UR1TIE  = 0x80 ;UR1T Interrupt Enable
BMM_UR1T_CR .EQU 0xfa31 ;Bulk Mem Move UR1T Control Register
   TRIGUR1T = 0x40 ;Trigger UR1T DMA Task
   ENUR1T   = 0x80 ;Enable UR1T DMA Function
BMM_UR1T_STA .EQU 0xfa32 ;Bulk Mem Move UR1T Status Register
   UR1TIF = 0x01 ;UR1T DMA Interrupt Request Flag
   TXOVW  = 0x04 ;Transmit Data Overwritten Flag
BMM_UR1T_AMT .EQU 0xfa33 ;Bulk Mem Move UR1T Amount to Move
BMM_UR1T_DONE .EQU 0xfa34 ;Bulk Mem Move UR1T Done Byte Count
BMM_UR1T_TXAH .EQU 0xfa35 ;Bulk Mem Move UR1T Read Address High
BMM_UR1T_TXAL .EQU 0xfa36 ;Bulk Mem Move UR1T Read Address Low
BMM_UR1R_CFG .EQU 0xfa38 ;Bulk Mem Move UR1R Config Register
   UR1RPTY = 0x03 ;UR1R Data Bus Access Priority
   UR1RIP  = 0x0C ;UR1R Interrupt Priority
   UR1RIE  = 0x80 ;UR1R Interrupt Enable
BMM_UR1R_CR .EQU 0xfa39 ;Bulk Mem Move UR1R Control Register
   CLRFIFO  = 0x01 ;Clear UR1R Receive FIFO
   TRIGUR1R = 0x20 ;Trigger UR1R DMA Task
   ENUR1R   = 0x80 ;UR1R Interrupt Enable
BMM_UR1R_STA .EQU 0xfa3a ;Bulk Mem Move UR1R Status Register
   UR1RIF = 0x01 ;UR1R DMA Interrupt Request Flag
   RXLOSS = 0x02 ;Received Data Lost Flag
BMM_UR1R_AMT .EQU 0xfa3b ;Bulk Mem Move UR1R Amount to Move
BMM_UR1R_DONE .EQU 0xfa3c ;Bulk Mem Move UR1R Done Byte Count
BMM_UR1R_RXAH .EQU 0xfa3d ;Bulk Mem Move UR1R Write Address High
BMM_UR1R_RXAL .EQU 0xfa3e ;Bulk Mem Move UR1R Write Address Low
BMM_UR2T_CFG .EQU 0xfa40 ;Bulk Mem Move UR2T Config Register
   UR2TPTY = 0x03 ;UR2T Data Bus Access Priority
   UR2TIP  = 0x0C ;UR2T Interrupt Priority
   UR2TIE  = 0x80 ;UR2T Interrupt Enable
BMM_UR2T_CR .EQU 0xfa41 ;Bulk Mem Move UR2T Control Register
   TRIGUR2T = 0x40 ;Trigger UR2T DMA Task
   ENUR2T   = 0x80 ;Enable UR2T DMA Function
BMM_UR2T_STA .EQU 0xfa42 ;Bulk Mem Move UR2T Status Register
   UR2TIF = 0x01 ;UR2T DMA Interrupt Request Flag
   TXOVW  = 0x04 ;Transmit Data Overwritten Flag
BMM_UR2T_AMT .EQU 0xfa43 ;Bulk Mem Move UR2T Amount to Move
BMM_UR2T_DONE .EQU 0xfa44 ;Bulk Mem Move UR2T Done Byte Count
BMM_UR2T_TXAH .EQU 0xfa45 ;Bulk Mem Move UR2T Read Address High
BMM_UR2T_TXAL .EQU 0xfa46 ;Bulk Mem Move UR2T Read Address Low
BMM_UR2R_CFG .EQU 0xfa48 ;Bulk Mem Move UR2R Config Register
   UR2RPTY = 0x03 ;UR2R Data Bus Access Priority
   UR2RIP  = 0x0C ;UR2R Interrupt Priority
   UR2RIE  = 0x80 ;UR2R Interrupt Enable
BMM_UR2R_CR .EQU 0xfa49 ;Bulk Mem Move UR2R Control Register
   CLRFIFO  = 0x01 ;Clear UR2R Receive FIFO
   TRIGUR2R = 0x20 ;Trigger UR2R DMA Task
   ENUR2R   = 0x80 ;UR2R Interrupt Enable
BMM_UR2R_STA .EQU 0xfa4a ;Bulk Mem Move UR2R Status Register
   UR2RIF = 0x01 ;UR2R DMA Interrupt Request Flag
   RXLOSS = 0x02 ;Received Data Lost Flag
BMM_UR2R_AMT .EQU 0xfa4b ;Bulk Mem Move UR2R Amount to Move
BMM_UR2R_DONE .EQU 0xfa4c ;Bulk Mem Move UR2R Done Byte Count
BMM_UR2R_RXAH .EQU 0xfa4d ;Bulk Mem Move UR2R Write Address High
BMM_UR2R_RXAL .EQU 0xfa4e ;Bulk Mem Move UR2R Write Address Low
BMM_UR3T_CFG .EQU 0xfa50 ;Bulk Mem Move UR3T Config Register
   UR3TPTY = 0x03 ;UR3T Data Bus Access Priority
   UR3TIP  = 0x0C ;UR3T Interrupt Priority
   UR3TIE  = 0x80 ;UR3T Interrupt Enable
BMM_UR3T_CR .EQU 0xfa51 ;Bulk Mem Move UR3T Control Register
   TRIGUR3T = 0x40 ;Trigger UR3T DMA Task
   ENUR3T   = 0x80 ;Enable UR3T DMA Function
BMM_UR3T_STA .EQU 0xfa52 ;Bulk Mem Move UR3T Status Register
   UR3TIF = 0x01 ;UR3T DMA Interrupt Request Flag
   TXOVW  = 0x04 ;Transmit Data Overwritten Flag
BMM_UR3T_AMT .EQU 0xfa53 ;Bulk Mem Move UR3T Amount to Move
BMM_UR3T_DONE .EQU 0xfa54 ;Bulk Mem Move UR3T Done Byte Count
BMM_UR3T_TXAH .EQU 0xfa55 ;Bulk Mem Move UR3T Read Address High
BMM_UR3T_TXAL .EQU 0xfa56 ;Bulk Mem Move UR3T Read Address Low
BMM_UR3R_CFG .EQU 0xfa58 ;Bulk Mem Move UR3R Config Register
   UR3RPTY = 0x03 ;UR3R Data Bus Access Priority
   UR3RIP  = 0x0C ;UR3R Interrupt Priority
   UR3RIE  = 0x80 ;UR3R Interrupt Enable
BMM_UR3R_CR .EQU 0xfa59 ;Bulk Mem Move UR3R Control Register
   CLRFIFO  = 0x01 ;Clear UR3R Receive FIFO
   TRIGUR3R = 0x20 ;Trigger UR3R DMA Task
   ENUR3R   = 0x80 ;UR3R Interrupt Enable
BMM_UR3R_STA .EQU 0xfa5a ;Bulk Mem Move UR3R Status Register
   UR3RIF = 0x01 ;UR3R DMA Interrupt Request Flag
   RXLOSS = 0x02 ;Received Data Lost Flag
BMM_UR3R_AMT .EQU 0xfa5b ;Bulk Mem Move UR3R Amount to Move
BMM_UR3R_DONE .EQU 0xfa5c ;Bulk Mem Move UR3R Done Byte Count
BMM_UR3R_RXAH .EQU 0xfa5d ;Bulk Mem Move UR3R Write Address High
BMM_UR3R_RXAL .EQU 0xfa5e ;Bulk Mem Move UR3R Write Address Low
BMM_UR4T_CFG .EQU 0xfa60 ;Bulk Mem Move UR4T Config Register
   UR4TPTY = 0x03 ;UR4T Data Bus Access Priority
   UR4TIP  = 0x0C ;UR4T Interrupt Priority
   UR4TIE  = 0x80 ;UR4T Interrupt Enable
BMM_UR4T_CR .EQU 0xfa61 ;Bulk Mem Move UR4T Control Register
   TRIGUR4T = 0x40 ;Trigger UR4T DMA Task
   ENUR4T   = 0x80 ;Enable UR4T DMA Function
BMM_UR4T_STA .EQU 0xfa62 ;Bulk Mem Move UR4T Status Register
   UR4TIF = 0x01 ;UR4T DMA Interrupt Request Flag
   TXOVW  = 0x04 ;Transmit Data Overwritten Flag
BMM_UR4T_AMT .EQU 0xfa63 ;Bulk Mem Move UR4T Amount to Move
BMM_UR4T_DONE .EQU 0xfa64 ;Bulk Mem Move UR4T Done Byte Count
BMM_UR4T_TXAH .EQU 0xfa65 ;Bulk Mem Move UR4T Read Address High
BMM_UR4T_TXAL .EQU 0xfa66 ;Bulk Mem Move UR4T Read Address Low
BMM_UR4R_CFG .EQU 0xfa68 ;Bulk Mem Move UR4R Config Register
   UR4RPTY = 0x03 ;UR4R Data Bus Access Priority
   UR4RIP  = 0x0C ;UR4R Interrupt Priority
   UR4RIE  = 0x80 ;UR4R Interrupt Enable
BMM_UR4R_CR .EQU 0xfa69 ;Bulk Mem Move UR4R Control Register
   CLRFIFO  = 0x01 ;Clear UR4R Receive FIFO
   TRIGUR4R = 0x20 ;Trigger UR4R DMA Task
   ENUR4R = 0x80 ;UR4R Interrupt Enable
BMM_UR4R_STA .EQU 0xfa6a ;Bulk Mem Move UR4R Status Register
   UR4RIF = 0x01 ;UR4R DMA Interrupt Request Flag
   RXLOSS = 0x02 ;Received Data Lost Flag
BMM_UR4R_AMT .EQU 0xfa6b ;Bulk Mem Move UR4R Amount to Move
BMM_UR4R_DONE .EQU 0xfa6c ;Bulk Mem Move UR4R Done Byte Count
BMM_UR4R_RXAH .EQU 0xfa6d ;Bulk Mem Move UR4R Write Address High
BMM_UR4R_RXAL .EQU 0xfa6e ;Bulk Mem Move UR4R Write Address Low
BMM_LCM_CFG .EQU 0xfa70 ;Bulk Mem Move LC Module Config Register
   LCMPTY = 0x03 ;LC Module Data Bus Access Priority
   LCMIP  = 0x0C ;LC Module Interrupt Priority
   ACT_RX_LCM = 0x80 ;Activate LC Module Reception via Bulk Memory Move
   ACT_TX_LCM = 0x80 ;Activate LC Module Transmission via Bulk Memory Move
   LCMIE  = 0x80 ;LC Module Interrupt Enable
BMM_LCM_CR .EQU 0xfa71 ;Bulk Mem Move LC Module Control Register
   CLRFIFO = 0x01 ;Clear LC Module Receive FIFO
   TRIGRD  = 0x08 ;Trigger Read Data Mode DMA Task
   TRIGRC  = 0x10 ;Trigger Read Command Mode DMA Task
   TRIGWD  = 0x20 ;Trigger Write Data Mode DMA Task
   TRIGWC  = 0x40 ;Trigger Write Command Mode DMA Task
   ENLCM   = 0x80 ;Enable LC Module DMA Function
BMM_LCM_STA .EQU 0xfa72 ;Bulk Mem Move LC Module Status Register
   LCMIF    = 0x01 ;LC Module DMA Interrupt Request Flag
   LCMTXOVW = 0x02 ;LCMIFDAT Overwritten Flag
BMM_LCM_AMT .EQU 0xfa73 ;Bulk Mem Move LC Module Amount to Move
BMM_LCM_DONE .EQU 0xfa74 ;Bulk Mem Move LC Module Done Byte Count
BMM_LCM_TXAH .EQU 0xfa75 ;Bulk Mem Move LC Module Read Address High
BMM_LCM_TXAL .EQU 0xfa76 ;Bulk Mem Move LC Module Read Address Low
BMM_LCM_RXAH .EQU 0xfa77 ;Bulk Mem Move LC Module Write Address High
BMM_LCM_RXAL .EQU 0xfa78 ;Bulk Mem Move LC Module Write Address Low
COMEN .EQU 0xfb00 ;LED Common Enable
   C0EN = 0x01 ;
   C1EN = 0x02 ;
   C2EN = 0x04 ;
   C3EN = 0x08 ;
   C4EN = 0x10 ;
   C5EN = 0x20 ;
   C6EN = 0x40 ;
   C7EN = 0x80 ;
SEGENL .EQU 0xfb01 ;Segment Enable Low Byte
   S0EN = 0x01 ;
   S1EN = 0x02 ;
   S2EN = 0x04 ;
   S3EN = 0x08 ;
   S4EN = 0x10 ;
   S5EN = 0x20 ;
   S6EN = 0x40 ;
   S7EN = 0x80 ;
SEGENH .EQU 0xfb02 ;Segment Enable High Byte
   S8EN  = 0x01 ;
   S9EN  = 0x02 ;
   S10EN = 0x04 ;
   S11EN = 0x08 ;
   S12EN = 0x10 ;
   S13EN = 0x20 ;
   S14EN = 0x40 ;
   S15EN = 0x80 ;
LEDCTRL .EQU 0xfb03 ;LED Control
   LEDDUTY = 0x07 ;LED Duty Cycle Adjustment
   LEDMODE = 0x30 ;LED Driver Mode
   LEDON   = 0x80 ;LED Driver Enable
LEDCKS .EQU 0xfb04 ;LED Clock Division
COM0_DA_L .EQU 0xfb10 ;Common Anode阳 Display Data 0
COM1_DA_L .EQU 0xfb11 ;Common Anode阳 Display Data 1
COM2_DA_L .EQU 0xfb12 ;Common Anode阳 Display Data 2
COM3_DA_L .EQU 0xfb13 ;Common Anode阳 Display Data 3
COM4_DA_L .EQU 0xfb14 ;Common Anode阳 Display Data 4
COM5_DA_L .EQU 0xfb15 ;Common Anode阳 Display Data 5
COM6_DA_L .EQU 0xfb16 ;Common Anode阳 Display Data 6
COM7_DA_L .EQU 0xfb17 ;Common Anode阳 Display Data 7
COM0_DA_H .EQU 0xfb18 ;Common Anode阳 Display Data 8
COM1_DA_H .EQU 0xfb19 ;Common Anode阳 Display Data 9
COM2_DA_H .EQU 0xfb1a ;Common Anode阳 Display Data 10
COM3_DA_H .EQU 0xfb1b ;Common Anode阳 Display Data 11
COM4_DA_H .EQU 0xfb1c ;Common Anode阳 Display Data 12
COM5_DA_H .EQU 0xfb1d ;Common Anode阳 Display Data 13
COM6_DA_H .EQU 0xfb1e ;Common Anode阳 Display Data 14
COM7_DA_H .EQU 0xfb1f ;Common Anode阳 Display Data 15
COM0_DC_L .EQU 0xfb20 ;Common Cathode阴 Display Data 0
COM1_DC_L .EQU 0xfb21 ;Common Cathode阴 Display Data 1
COM2_DC_L .EQU 0xfb22 ;Common Cathode阴 Display Data 2
COM3_DC_L .EQU 0xfb23 ;Common Cathode阴 Display Data 3
COM4_DC_L .EQU 0xfb24 ;Common Cathode阴 Display Data 4
COM5_DC_L .EQU 0xfb25 ;Common Cathode阴 Display Data 5
COM6_DC_L .EQU 0xfb26 ;Common Cathode阴 Display Data 6
COM7_DC_L .EQU 0xfb27 ;Common Cathode阴 Display Data 7
COM0_DC_H .EQU 0xfb28 ;Common Cathode阴 Display Data 8
COM1_DC_H .EQU 0xfb29 ;Common Cathode阴 Display Data 9
COM2_DC_H .EQU 0xfb2a ;Common Cathode阴 Display Data 10
COM3_DC_H .EQU 0xfb2b ;Common Cathode阴 Display Data 11
COM4_DC_H .EQU 0xfb2c ;Common Cathode阴 Display Data 12
COM5_DC_H .EQU 0xfb2d ;Common Cathode阴 Display Data 13
COM6_DC_H .EQU 0xfb2e ;Common Cathode阴 Display Data 14
COM7_DC_H .EQU 0xfb2f ;Common Cathode阴 Display Data 15
TSCHEN1 .EQU 0xfb40 ;Touch Sensor Enable Register 1
   TKEN0 = 0x01 ;
   TKEN1 = 0x02 ;
   TKEN2 = 0x04 ;
   TKEN3 = 0x08 ;
   TKEN4 = 0x10 ;
   TKEN5 = 0x20 ;
   TKEN6 = 0x40 ;
   TKEN7 = 0x80 ;
TSCHEN2 .EQU 0xfb41 ;Touch Sensor Enable Register 2
   TKEN8  = 0x01 ;
   TKEN9  = 0x02 ;
   TKEN10 = 0x04 ;
   TKEN11 = 0x08 ;
   TKEN12 = 0x10 ;
   TKEN13 = 0x20 ;
   TKEN14 = 0x40 ;
   TKEN15 = 0x80 ;
TSCFG1 .EQU 0xfb42 ;Touch Sensor Config Register 1
   DT  = 0x07 ;Discharge Time
   SCR = 0x70 ;Switched Capacitor Rate
TSCFG2 .EQU 0xfb43 ;Touch Sensor Config Register 2
   TSVR = 0x03 ;Touch Sensor Voltage Reference
TSWUTC .EQU 0xfb44 ;Touch Sensor Wakeup Control
TSCTRL .EQU 0xfb45 ;Touch Sensor Control
   TSSAMP = 0x03 ;Touch Sensor Multiple Scan Averaging
   TSWUEN = 0x04 ;Touch Sensor Wakeup Enable
   TSDCEN = 0x08 ;Touch Sensor Digital Comparator Enable
   TSWUCS = 0x10 ;Touch Sensor Wakeup Clock Select
   TSWAIT = 0x20 ;Touch Sensor WAIT Control
   SINGLE = 0x40 ;Single Scan Mode Control
   TSGO   = 0x80 ;Touch Sensor Enable
TSSTA1 .EQU 0xfb46 ;Touch Sensor Status Register 1
   TSWKCHN = 0x0F ;Touch Sensor Scan Status Flags
   LEDWK   = 0x80 ;LED Working Status
TSSTA2 .EQU 0xfb47 ;Touch Sensor Status Register 2
   TSDNCHN = 0x0F ;Touch Sensor Channel Completion Status
   TSDOV   = 0x40 ;Touch Sensor Data Overflow Flag
   TSIF    = 0x80 ;Touch Sensor Interrup Flag
TSRT .EQU 0xfb48 ;Touch Sensor Time Control
TSDAT .EQU 0xfb49 ;Touch Sensor Data Word
TSDATH .EQU 0xfb49 ;Touch Sensor Data High Byte
TSDATL .EQU 0xfb4a ;Touch Sensor Data Low Byte
TSTH00 .EQU 0xfb50 ;Touch Sensor 0 Threshold Word
TSTH00H .EQU 0xfb50 ;Touch Sensor 0 Threshold High Byte
TSTH00L .EQU 0xfb51 ;Touch Sensor 0 Threshold Low Byte
TSTH01 .EQU 0xfb52 ;Touch Sensor 1 Threshold Word
TSTH01H .EQU 0xfb52 ;Touch Sensor 1 Threshold High Byte
TSTH01L .EQU 0xfb53 ;Touch Sensor 1 Threshold Low Byte
TSTH02 .EQU 0xfb54 ;Touch Sensor 2 Threshold Word
TSTH02H .EQU 0xfb54 ;Touch Sensor 2 Threshold High Byte
TSTH02L .EQU 0xfb55 ;Touch Sensor 2 Threshold Low Byte
TSTH03 .EQU 0xfb56 ;Touch Sensor 3 Threshold Word
TSTH03H .EQU 0xfb56 ;Touch Sensor 3 Threshold High Byte
TSTH03L .EQU 0xfb57 ;Touch Sensor 3 Threshold Low Byte
TSTH04 .EQU 0xfb58 ;Touch Sensor 4 Threshold Word
TSTH04H .EQU 0xfb58 ;Touch Sensor 4 Threshold High Byte
TSTH04L .EQU 0xfb59 ;Touch Sensor 4 Threshold Low Byte
TSTH05 .EQU 0xfb5a ;Touch Sensor 5 Threshold Word
TSTH05H .EQU 0xfb5a ;Touch Sensor 5 Threshold High Byte
TSTH05L .EQU 0xfb5b ;Touch Sensor 5 Threshold Low Byte
TSTH06 .EQU 0xfb5c ;Touch Sensor 6 Threshold Word
TSTH06H .EQU 0xfb5c ;Touch Sensor 6 Threshold High Byte
TSTH06L .EQU 0xfb5d ;Touch Sensor 6 Threshold Low Byte
TSTH07 .EQU 0xfb5e ;Touch Sensor 7 Threshold Word
TSTH07H .EQU 0xfb5e ;Touch Sensor 7 Threshold High Byte
TSTH07L .EQU 0xfb5f ;Touch Sensor 7 Threshold Low Byte
TSTH08 .EQU 0xfb60 ;Touch Sensor 8 Threshold Word
TSTH08H .EQU 0xfb60 ;Touch Sensor 8 Threshold High Byte
TSTH08L .EQU 0xfb61 ;Touch Sensor 8 Threshold Low Byte
TSTH09 .EQU 0xfb62 ;Touch Sensor 9 Threshold Word
TSTH09H .EQU 0xfb62 ;Touch Sensor 9 Threshold High Byte
TSTH09L .EQU 0xfb63 ;Touch Sensor 9 Threshold Low Byte
TSTH10 .EQU 0xfb64 ;Touch Sensor 10 Threshold Word
TSTH10H .EQU 0xfb64 ;Touch Sensor 10 Threshold High Byte
TSTH10L .EQU 0xfb65 ;Touch Sensor 10 Threshold Low Byte
TSTH11 .EQU 0xfb66 ;Touch Sensor 11 Threshold Word
TSTH11H .EQU 0xfb66 ;Touch Sensor 11 Threshold High Byte
TSTH11L .EQU 0xfb67 ;Touch Sensor 11 Threshold Low Byte
TSTH12 .EQU 0xfb68 ;Touch Sensor 12 Threshold Word
TSTH12H .EQU 0xfb68 ;Touch Sensor 12 Threshold High Byte
TSTH12L .EQU 0xfb69 ;Touch Sensor 12 Threshold Low Byte
TSTH13 .EQU 0xfb6a ;Touch Sensor 13 Threshold Word
TSTH13H .EQU 0xfb6a ;Touch Sensor 13 Threshold High Byte
TSTH13L .EQU 0xfb6b ;Touch Sensor 13 Threshold Low Byte
TSTH14 .EQU 0xfb6c ;Touch Sensor 14 Threshold Word
TSTH14H .EQU 0xfb6c ;Touch Sensor 14 Threshold High Byte
TSTH14L .EQU 0xfb6d ;Touch Sensor 14 Threshold Low Byte
TSTH15 .EQU 0xfb6e ;Touch Sensor 15 Threshold Word
TSTH15H .EQU 0xfb6e ;Touch Sensor 15 Threshold High Byte
TSTH15L .EQU 0xfb6f ;Touch Sensor 15 Threshold Low Byte
LCDCFG .EQU 0xfb80 ;LCD Configuration Register
   VLCDSEL  = 0x07 ;LCD Voltage Select
   VRLPSEL  = 0x08 ;Undefined
   LCDCKSEL = 0x80 ;LCD Clock Source Select
LCDCFG2 .EQU 0xfb81 ;LCD Configuration Register 2
   SEG0PS = 0x01 ;Enable Port 0 for LCD Segments
   SEG1PS = 0x02 ;Enable Port 1 for LCD Segments
   SEG2PS = 0x04 ;Enable Port 2 for LCD Segments
   SEG3PS = 0x08 ;Enable Port 3 for LCD Segments
DBLEN .EQU 0xfb82 ;LCD Deadtime Length
COMLENL .EQU 0xfb83 ;COM Time Lenght Low Byte
COMLENM .EQU 0xfb84 ;COM Time Lenght Middle Byte
COMLENH .EQU 0xfb85 ;COM Time Lenght High Bits
   COMLEN = 0x0F ;COM Time Lenght High Bits
BLINKRATE .EQU 0xfb86 ;Blink Rate Register
LCDCR .EQU 0xfb87 ;LCD Control Register
   ENLCD   = 0x01 ;Enable LCD Function
   ACTMODE = 0x06 ;LCD Display Mode
COMON .EQU 0xfb88 ;Common Line Enable
   COM0 = 0x01 ;Enable Port 0 for LCD Common Line
   COM1 = 0x02 ;Enable Port 1 for LCD Common Line
   COM2 = 0x04 ;Enable Port 2 for LCD Common Line
   COM3 = 0x08 ;Enable Port 3 for LCD Common Line
SEGON1 .EQU 0xfb8a ;Enable Segment On 1
   SEG0 = 0x01 ;
   SEG1 = 0x02 ;
   SEG2 = 0x04 ;
   SEG3 = 0x08 ;
   SEG4 = 0x10 ;
   SEG5 = 0x20 ;
   SEG6 = 0x40 ;
   SEG7 = 0x80 ;
SEGON2 .EQU 0xfb8b ;Enable Segment On 2
   SEG8  = 0x01 ;
   SEG9  = 0x02 ;
   SEG10 = 0x04 ;
   SEG11 = 0x08 ;
   SEG12 = 0x10 ;
   SEG13 = 0x20 ;
   SEG14 = 0x40 ;
   SEG15 = 0x80 ;
SEGON3 .EQU 0xfb8c ;Enable Segment On 3
   SEG16 = 0x01 ;
   SEG17 = 0x02 ;
   SEG18 = 0x04 ;
   SEG19 = 0x08 ;
   SEG20 = 0x10 ;
   SEG21 = 0x20 ;
   SEG22 = 0x40 ;
   SEG23 = 0x80 ;
SEGON4 .EQU 0xfb8d ;Enable Segment On 4
   SEG24 = 0x01 ;
   SEG25 = 0x02 ;
   SEG26 = 0x04 ;
   SEG27 = 0x08 ;
   SEG28 = 0x10 ;
   SEG29 = 0x20 ;
   SEG30 = 0x40 ;
   SEG31 = 0x80 ;
SEGON5 .EQU 0xfb8e ;Enable Segment On 5
   SEG32 = 0x01 ;
   SEG33 = 0x02 ;
   SEG34 = 0x04 ;
   SEG35 = 0x08 ;
   SEG36 = 0x10 ;
   SEG37 = 0x20 ;
   SEG38 = 0x40 ;
   SEG39 = 0x80 ;
C0SEGV0 .EQU 0xfb90 ;LCD C0 Data Register 0
   C0S0 = 0x01 ;
   C0S1 = 0x02 ;
   C0S2 = 0x04 ;
   C0S3 = 0x08 ;
   C0S4 = 0x10 ;
   C0S5 = 0x20 ;
   C0S6 = 0x40 ;
   C0S7 = 0x80 ;
C0SEGV1 .EQU 0xfb91 ;LCD C0 Data Register 1
   C0S8  = 0x01 ;
   C0S9  = 0x02 ;
   C0S10 = 0x04 ;
   C0S11 = 0x08 ;
   C0S12 = 0x10 ;
   C0S13 = 0x20 ;
   C0S14 = 0x40 ;
   C0S15 = 0x80 ;
C0SEGV2 .EQU 0xfb92 ;LCD C0 Data Register 2
   C0S16 = 0x01 ;
   C0S17 = 0x02 ;
   C0S18 = 0x04 ;
   C0S19 = 0x08 ;
   C0S20 = 0x10 ;
   C0S21 = 0x20 ;
   C0S22 = 0x40 ;
   C0S23 = 0x80 ;
C0SEGV3 .EQU 0xfb93 ;LCD C0 Data Register 3
   C0S24 = 0x01 ;
   C0S25 = 0x02 ;
   C0S26 = 0x04 ;
   C0S27 = 0x08 ;
   C0S28 = 0x10 ;
   C0S29 = 0x20 ;
   C0S30 = 0x40 ;
   C0S31 = 0x80 ;
C0SEGV4 .EQU 0xfb94 ;LCD C0 Data Register 4
   C0S32 = 0x01 ;
   C0S33 = 0x02 ;
   C0S34 = 0x04 ;
   C0S35 = 0x08 ;
   C0S36 = 0x10 ;
   C0S37 = 0x20 ;
   C0S38 = 0x40 ;
   C0S39 = 0x80 ;
C1SEGV0 .EQU 0xfb98 ;LCD C1 Data Register 0
   C1S0 = 0x01 ;
   C1S1 = 0x02 ;
   C1S2 = 0x04 ;
   C1S3 = 0x08 ;
   C1S4 = 0x10 ;
   C1S5 = 0x20 ;
   C1S6 = 0x40 ;
   C1S7 = 0x80 ;
C1SEGV1 .EQU 0xfb99 ;LCD C1 Data Register 1
   C1S8  = 0x01 ;
   C1S9  = 0x02 ;
   C1S10 = 0x04 ;
   C1S11 = 0x08 ;
   C1S12 = 0x10 ;
   C1S13 = 0x20 ;
   C1S14 = 0x40 ;
   C1S15 = 0x80 ;
C1SEGV2 .EQU 0xfb9a ;LCD C1 Data Register 2
   C1S16 = 0x01 ;
   C1S17 = 0x02 ;
   C1S18 = 0x04 ;
   C1S19 = 0x08 ;
   C1S20 = 0x10 ;
   C1S21 = 0x20 ;
   C1S22 = 0x40 ;
   C1S23 = 0x80 ;
C1SEGV3 .EQU 0xfb9b ;LCD C1 Data Register 3
   C1S24 = 0x01 ;
   C1S25 = 0x02 ;
   C1S26 = 0x04 ;
   C1S27 = 0x08 ;
   C1S28 = 0x10 ;
   C1S29 = 0x20 ;
   C1S30 = 0x40 ;
   C1S31 = 0x80 ;
C1SEGV4 .EQU 0xfb9c ;LCD C1 Data Register 4
   C1S32 = 0x01 ;
   C1S33 = 0x02 ;
   C1S34 = 0x04 ;
   C1S35 = 0x08 ;
   C1S36 = 0x10 ;
   C1S37 = 0x20 ;
   C1S38 = 0x40 ;
   C1S39 = 0x80 ;
C2SEGV0 .EQU 0xfba0 ;LCD C2 Data Register 0
   C2S0   = 0x01 ;
   C2S1   = 0x02 ;
   C2S2   = 0x04 ;
   C2S3   = 0x08 ;
   C2S4   = 0x10 ;
   C2SC25 = 0x20 ;
   C2S6   = 0x40 ;
   C2S7   = 0x80 ;
C2SEGV1 .EQU 0xfba1 ;LCD C2 Data Register 1
   C2S8  = 0x01 ;
   C2S9  = 0x02 ;
   C2S10 = 0x04 ;
   C2S11 = 0x08 ;
   C2S12 = 0x10 ;
   C2S13 = 0x20 ;
   C2S14 = 0x40 ;
   C2S15 = 0x80 ;
C2SEGV2 .EQU 0xfba2 ;LCD C2 Data Register 2
   C2S16 = 0x01 ;
   C2S17 = 0x02 ;
   C2S18 = 0x04 ;
   C2S19 = 0x08 ;
   C2S20 = 0x10 ;
   C2S21 = 0x20 ;
   C2S22 = 0x40 ;
   C2S23 = 0x80 ;
C2SEGV3 .EQU 0xfba3 ;LCD C2 Data Register 3
   C2S24 = 0x01 ;
   C2S25 = 0x02 ;
   C2S26 = 0x04 ;
   C2S27 = 0x08 ;
   C2S28 = 0x10 ;
   C2S29 = 0x20 ;
   C2S30 = 0x40 ;
   C2S31 = 0x80 ;
C2SEGV4 .EQU 0xfba4 ;LCD C2 Data Register 4
   C2S32 = 0x01 ;
   C2S33 = 0x02 ;
   C2S34 = 0x04 ;
   C2S35 = 0x08 ;
   C2S36 = 0x10 ;
   C2S37 = 0x20 ;
   C2S38 = 0x40 ;
   C2S39 = 0x80 ;
C3SEGV0 .EQU 0xfba8 ;LCD C3 Data Register 0
   C3S0 = 0x01 ;
   C3S1 = 0x02 ;
   C3S2 = 0x04 ;
   C3S3 = 0x08 ;
   C3S4 = 0x10 ;
   C3S5 = 0x20 ;
   C3S6 = 0x40 ;
   C3S7 = 0x80 ;
C3SEGV1 .EQU 0xfba9 ;LCD C3 Data Register 1
   C3S8  = 0x01 ;
   C3S9  = 0x02 ;
   C3S10 = 0x04 ;
   C3S11 = 0x08 ;
   C3S12 = 0x10 ;
   C3S13 = 0x20 ;
   C3S14 = 0x40 ;
   C3S15 = 0x80 ;
C3SEGV2 .EQU 0xfbaa ;LCD C3 Data Register 2
   C3S16 = 0x01 ;
   C3S17 = 0x02 ;
   C3S18 = 0x04 ;
   C3S19 = 0x08 ;
   C3S20 = 0x10 ;
   C3S21 = 0x20 ;
   C3S22 = 0x40 ;
   C3S23 = 0x80 ;
C3SEGV3 .EQU 0xfbab ;LCD C3 Data Register 3
   C3S24 = 0x01 ;
   C3S25 = 0x02 ;
   C3S26 = 0x04 ;
   C3S27 = 0x08 ;
   C3S28 = 0x10 ;
   C3S29 = 0x20 ;
   C3S30 = 0x40 ;
   C3S31 = 0x80 ;
C3SEGV4 .EQU 0xfbac ;LCD C3 Data Register 4
   C3S32 = 0x01 ;
   C3S33 = 0x02 ;
   C3S34 = 0x04 ;
   C3S35 = 0x08 ;
   C3S36 = 0x10 ;
   C3S37 = 0x20 ;
   C3S38 = 0x40 ;
   C3S39 = 0x80 ;
MD3 .EQU 0xfcf0 ;Operand 3 Data Register
MD2 .EQU 0xfcf1 ;Operand 2 Data Register
MD1 .EQU 0xfcf2 ;Operand 1 Data Register
MD0 .EQU 0xfcf3 ;Operand 0 Data Register
MD5 .EQU 0xfcf4 ;Operand 5 Data Register
MD4 .EQU 0xfcf5 ;Operand 4 Data Register
ARCON .EQU 0xfcf6 ;Multiply Divide Unit Array Control
   SC     = 0x1F ;Shift Count
   ARMODE = 0xE0 ;Mode Select
OPCON .EQU 0xfcf7 ;Multiply Divide Unit Operation Control
   ENOP = 0x01 ;Enable Operation
   RST  = 0x02 ;Software Reset
   MDOV = 0x40 ;Overflow Flag
P0INTE .EQU 0xfd00 ;Port 0 Interrupt Enable Register
   P00INTE = 0x01 ;
   P01INTE = 0x02 ;
   P02INTE = 0x04 ;
   P03INTE = 0x08 ;
   P04INTE = 0x10 ;
   P05INTE = 0x20 ;
   P06INTE = 0x40 ;
   P07INTE = 0x80 ;
P1INTE .EQU 0xfd01 ;Port 1 Interrupt Enable Register
   P10INTE = 0x01 ;
   P11INTE = 0x02 ;
   P12INTE = 0x04 ;
   P13INTE = 0x08 ;
   P14INTE = 0x10 ;
   P15INTE = 0x20 ;
   P16INTE = 0x40 ;
   P17INTE = 0x80 ;
P2INTE .EQU 0xfd02 ;Port 2 Interrupt Enable Register
   P20INTE = 0x01 ;
   P21INTE = 0x02 ;
   P22INTE = 0x04 ;
   P23INTE = 0x08 ;
   P24INTE = 0x10 ;
   P25INTE = 0x20 ;
   P26INTE = 0x40 ;
   P27INTE = 0x80 ;
P3INTE .EQU 0xfd03 ;Port 3 Interrupt Enable Register
   P30INTE = 0x01 ;
   P31INTE = 0x02 ;
   P32INTE = 0x04 ;
   P33INTE = 0x08 ;
   P34INTE = 0x10 ;
   P35INTE = 0x20 ;
   P36INTE = 0x40 ;
   P37INTE = 0x80 ;
P4INTE .EQU 0xfd04 ;Port 4 Interrupt Enable Register
   P40INTE = 0x01 ;
   P41INTE = 0x02 ;
   P42INTE = 0x04 ;
   P43INTE = 0x08 ;
   P44INTE = 0x10 ;
   P45INTE = 0x20 ;
   P46INTE = 0x40 ;
   P47INTE = 0x80 ;
P5INTE .EQU 0xfd05 ;Port 5 Interrupt Enable Register
   P50INTE = 0x01 ;
   P51INTE = 0x02 ;
   P52INTE = 0x04 ;
   P53INTE = 0x08 ;
   P54INTE = 0x10 ;
   P55INTE = 0x20 ;
P6INTE .EQU 0xfd06 ;Port 6 Interrupt Enable Register
   P60INTE = 0x01 ;
   P61INTE = 0x02 ;
   P62INTE = 0x04 ;
   P63INTE = 0x08 ;
   P64INTE = 0x10 ;
   P65INTE = 0x20 ;
   P66INTE = 0x40 ;
   P67INTE = 0x80 ;
P7INTE .EQU 0xfd07 ;Port 7 Interrupt Enable Register
   P70INTE = 0x01 ;
   P71INTE = 0x02 ;
   P72INTE = 0x04 ;
   P73INTE = 0x08 ;
   P74INTE = 0x10 ;
   P75INTE = 0x20 ;
   P76INTE = 0x40 ;
   P77INTE = 0x80 ;
P0INTF .EQU 0xfd10 ;Port 0 Interrupt Flag Register
   P00INTF = 0x01 ;
   P01INTF = 0x02 ;
   P02INTF = 0x04 ;
   P03INTF = 0x08 ;
   P04INTF = 0x10 ;
   P05INTF = 0x20 ;
   P06INTF = 0x40 ;
   P07INTF = 0x80 ;
P1INTF .EQU 0xfd11 ;Port 1 Interrupt Flag Register
   P10INTF = 0x01 ;
   P11INTF = 0x02 ;
   P12INTF = 0x04 ;
   P13INTF = 0x08 ;
   P14INTF = 0x10 ;
   P15INTF = 0x20 ;
   P16INTF = 0x40 ;
   P17INTF = 0x80 ;
P2INTF .EQU 0xfd12 ;Port 2 Interrupt Flag Register
   P20INTF = 0x01 ;
   P21INTF = 0x02 ;
   P22INTF = 0x04 ;
   P23INTF = 0x08 ;
   P24INTF = 0x10 ;
   P25INTF = 0x20 ;
   P26INTF = 0x40 ;
   P27INTF = 0x80 ;
P3INTF .EQU 0xfd13 ;Port 3 Interrupt Flag Register
   P30INTF = 0x01 ;
   P31INTF = 0x02 ;
   P32INTF = 0x04 ;
   P33INTF = 0x08 ;
   P34INTF = 0x10 ;
   P35INTF = 0x20 ;
   P36INTF = 0x40 ;
   P37INTF = 0x80 ;
P4INTF .EQU 0xfd14 ;Port 4 Interrupt Flag Register
   P40INTF = 0x01 ;
   P41INTF = 0x02 ;
   P42INTF = 0x04 ;
   P43INTF = 0x08 ;
   P44INTF = 0x10 ;
   P45INTF = 0x20 ;
   P46INTF = 0x40 ;
   P47INTF = 0x80 ;
P5INTF .EQU 0xfd15 ;Port 5 Interrupt Flag Register
   P50INTF = 0x01 ;
   P51INTF = 0x02 ;
   P52INTF = 0x04 ;
   P53INTF = 0x08 ;
   P54INTF = 0x10 ;
   P55INTF = 0x20 ;
P6INTF .EQU 0xfd16 ;Port 6 Interrupt Flag Register
   P60INTF = 0x01 ;
   P61INTF = 0x02 ;
   P62INTF = 0x04 ;
   P63INTF = 0x08 ;
   P64INTF = 0x10 ;
   P65INTF = 0x20 ;
   P66INTF = 0x40 ;
   P67INTF = 0x80 ;
P7INTF .EQU 0xfd17 ;Port 7 Interrupt Flag Register
   P70INTF = 0x01 ;
   P71INTF = 0x02 ;
   P72INTF = 0x04 ;
   P73INTF = 0x08 ;
   P74INTF = 0x10 ;
   P75INTF = 0x20 ;
   P76INTF = 0x40 ;
   P77INTF = 0x80 ;
P0IM0 .EQU 0xfd20 ;Port 0 Interrupt Mode Register 0
   P00IM0 = 0x01 ;
   P01IM0 = 0x02 ;
   P02IM0 = 0x04 ;
   P03IM0 = 0x08 ;
   P04IM0 = 0x10 ;
   P05IM0 = 0x20 ;
   P06IM0 = 0x40 ;
   P07IM0 = 0x80 ;
P1IM0 .EQU 0xfd21 ;Port 1 Interrupt Mode Register 0
   P10IM0 = 0x01 ;
   P11IM0 = 0x02 ;
   P12IM0 = 0x04 ;
   P13IM0 = 0x08 ;
   P14IM0 = 0x10 ;
   P15IM0 = 0x20 ;
   P16IM0 = 0x40 ;
   P17IM0 = 0x80 ;
P2IM0 .EQU 0xfd22 ;Port 2 Interrupt Mode Register 0
   P20IM0 = 0x01 ;
   P21IM0 = 0x02 ;
   P22IM0 = 0x04 ;
   P23IM0 = 0x08 ;
   P24IM0 = 0x10 ;
   P25IM0 = 0x20 ;
   P26IM0 = 0x40 ;
   P27IM0 = 0x80 ;
P3IM0 .EQU 0xfd23 ;Port 3 Interrupt Mode Register 0
   P30IM0 = 0x01 ;
   P31IM0 = 0x02 ;
   P32IM0 = 0x04 ;
   P33IM0 = 0x08 ;
   P34IM0 = 0x10 ;
   P35IM0 = 0x20 ;
   P36IM0 = 0x40 ;
   P37IM0 = 0x80 ;
P4IM0 .EQU 0xfd24 ;Port 4 Interrupt Mode Register 0
   P40IM0 = 0x01 ;
   P41IM0 = 0x02 ;
   P42IM0 = 0x04 ;
   P43IM0 = 0x08 ;
   P44IM0 = 0x10 ;
   P45IM0 = 0x20 ;
   P46IM0 = 0x40 ;
   P47IM0 = 0x80 ;
P5IM0 .EQU 0xfd25 ;Port 5 Interrupt Mode Register 0
   P50IM0 = 0x01 ;
   P51IM0 = 0x02 ;
   P52IM0 = 0x04 ;
   P53IM0 = 0x08 ;
   P54IM0 = 0x10 ;
   P55IM0 = 0x20 ;
P6IM0 .EQU 0xfd26 ;Port 6 Interrupt Mode Register 0
   P60IM0 = 0x01 ;
   P61IM0 = 0x02 ;
   P62IM0 = 0x04 ;
   P63IM0 = 0x08 ;
   P64IM0 = 0x10 ;
   P65IM0 = 0x20 ;
   P66IM0 = 0x40 ;
   P67IM0 = 0x80 ;
P7IM0 .EQU 0xfd27 ;Port 7 Interrupt Mode Register 0
   P70IM0 = 0x01 ;
   P71IM0 = 0x02 ;
   P72IM0 = 0x04 ;
   P73IM0 = 0x08 ;
   P74IM0 = 0x10 ;
   P75IM0 = 0x20 ;
   P76IM0 = 0x40 ;
   P77IM0 = 0x80 ;
P0IM1 .EQU 0xfd30 ;Port 0 Interrupt Mode Register 1
   P00IM1 = 0x01 ;
   P01IM1 = 0x02 ;
   P02IM1 = 0x04 ;
   P03IM1 = 0x08 ;
   P04IM1 = 0x10 ;
   P05IM1 = 0x20 ;
   P06IM1 = 0x40 ;
   P07IM1 = 0x80 ;
P1IM1 .EQU 0xfd31 ;Port 1 Interrupt Mode Register 1
   P10IM1 = 0x01 ;
   P11IM1 = 0x02 ;
   P12IM1 = 0x04 ;
   P13IM1 = 0x08 ;
   P14IM1 = 0x10 ;
   P15IM1 = 0x20 ;
   P16IM1 = 0x40 ;
   P17IM1 = 0x80 ;
P2IM1 .EQU 0xfd32 ;Port 2 Interrupt Mode Register 1
   P20IM1 = 0x01 ;
   P21IM1 = 0x02 ;
   P22IM1 = 0x04 ;
   P23IM1 = 0x08 ;
   P24IM1 = 0x10 ;
   P25IM1 = 0x20 ;
   P26IM1 = 0x40 ;
   P27IM1 = 0x80 ;
P3IM1 .EQU 0xfd33 ;Port 3 Interrupt Mode Register 1
   P30IM1 = 0x01 ;
   P31IM1 = 0x02 ;
   P32IM1 = 0x04 ;
   P33IM1 = 0x08 ;
   P34IM1 = 0x10 ;
   P35IM1 = 0x20 ;
   P36IM1 = 0x40 ;
   P37IM1 = 0x80 ;
P4IM1 .EQU 0xfd34 ;Port 4 Interrupt Mode Register 1
   P40IM1 = 0x01 ;
   P41IM1 = 0x02 ;
   P42IM1 = 0x04 ;
   P43IM1 = 0x08 ;
   P44IM1 = 0x10 ;
   P45IM1 = 0x20 ;
   P46IM1 = 0x40 ;
   P47IM1 = 0x80 ;
P5IM1 .EQU 0xfd35 ;Port 5 Interrupt Mode Register 1
   P50IM1 = 0x01 ;
   P51IM1 = 0x02 ;
   P52IM1 = 0x04 ;
   P53IM1 = 0x08 ;
   P54IM1 = 0x10 ;
   P55IM1 = 0x20 ;
P6IM1 .EQU 0xfd36 ;Port 6 Interrupt Mode Register 1
   P60IM1 = 0x01 ;
   P61IM1 = 0x02 ;
   P62IM1 = 0x04 ;
   P63IM1 = 0x08 ;
   P64IM1 = 0x10 ;
   P65IM1 = 0x20 ;
   P66IM1 = 0x40 ;
   P67IM1 = 0x80 ;
P7IM1 .EQU 0xfd37 ;Port 7 Interrupt Mode Register 1
   P70IM1 = 0x01 ;
   P71IM1 = 0x02 ;
   P72IM1 = 0x04 ;
   P73IM1 = 0x08 ;
   P74IM1 = 0x10 ;
   P75IM1 = 0x20 ;
   P76IM1 = 0x40 ;
   P77IM1 = 0x80 ;
P0WKUE .EQU 0xfd40 ;Port 0 Wake-up Enable Register
   P00WKUE = 0x01 ;
   P01WKUE = 0x02 ;
   P02WKUE = 0x04 ;
   P03WKUE = 0x08 ;
   P04WKUE = 0x10 ;
   P05WKUE = 0x20 ;
   P06WKUE = 0x40 ;
   P07WKUE = 0x80 ;
P1WKUE .EQU 0xfd41 ;Port 1 Wake-up Enable Register
   P10WKUE = 0x01 ;
   P11WKUE = 0x02 ;
   P12WKUE = 0x04 ;
   P13WKUE = 0x08 ;
   P14WKUE = 0x10 ;
   P15WKUE = 0x20 ;
   P16WKUE = 0x40 ;
   P17WKUE = 0x80 ;
P2WKUE .EQU 0xfd42 ;Port 2 Wake-up Enable Register
   P20WKUE = 0x01 ;
   P21WKUE = 0x02 ;
   P22WKUE = 0x04 ;
   P23WKUE = 0x08 ;
   P24WKUE = 0x10 ;
   P25WKUE = 0x20 ;
   P26WKUE = 0x40 ;
   P27WKUE = 0x80 ;
P3WKUE .EQU 0xfd43 ;Port 3 Wake-up Enable Register
   P30WKUE = 0x01 ;
   P31WKUE = 0x02 ;
   P32WKUE = 0x04 ;
   P33WKUE = 0x08 ;
   P34WKUE = 0x10 ;
   P35WKUE = 0x20 ;
   P36WKUE = 0x40 ;
   P37WKUE = 0x80 ;
P4WKUE .EQU 0xfd44 ;Port 4 Wake-up Enable Register
   P40WKUE = 0x01 ;
   P41WKUE = 0x02 ;
   P42WKUE = 0x04 ;
   P43WKUE = 0x08 ;
   P44WKUE = 0x10 ;
   P45WKUE = 0x20 ;
   P46WKUE = 0x40 ;
   P47WKUE = 0x80 ;
P5WKUE .EQU 0xfd45 ;Port 5 Wake-up Enable Register
   P50WKUE = 0x01 ;
   P51WKUE = 0x02 ;
   P52WKUE = 0x04 ;
   P53WKUE = 0x08 ;
   P54WKUE = 0x10 ;
   P55WKUE = 0x20 ;
P6WKUE .EQU 0xfd46 ;Port 6 Wake-up Enable Register
   P60WKUE = 0x01 ;
   P61WKUE = 0x02 ;
   P62WKUE = 0x04 ;
   P63WKUE = 0x08 ;
   P64WKUE = 0x10 ;
   P65WKUE = 0x20 ;
   P66WKUE = 0x40 ;
   P67WKUE = 0x80 ;
P7WKUE .EQU 0xfd47 ;Port 7 Wake-up Enable Register
   P70WKUE = 0x01 ;
   P71WKUE = 0x02 ;
   P72WKUE = 0x04 ;
   P73WKUE = 0x08 ;
   P74WKUE = 0x10 ;
   P75WKUE = 0x20 ;
   P76WKUE = 0x40 ;
   P77WKUE = 0x80 ;
PINIPL .EQU 0xfd60 ;IO Port Interrupt Priority Low
   P0IP = 0x01 ;
   P1IP = 0x02 ;
   P2IP = 0x04 ;
   P3IP = 0x08 ;
   P4IP = 0x10 ;
   P5IP = 0x20 ;
   P6IP = 0x40 ;
   P7IP = 0x80 ;
PINIPH .EQU 0xfd61 ;IO Port Interrupt Priority High
   P0IPH = 0x01 ;
   P1IPH = 0x02 ;
   P2IPH = 0x04 ;
   P3IPH = 0x08 ;
   P4IPH = 0x10 ;
   P5IPH = 0x20 ;
   P6IPH = 0x40 ;
   P7IPH = 0x80 ;
CKSEL .EQU 0xfe00 ;Clock Select Register
   MCKSEL = 0x03 ;Main Clock Source Selection
CLKDIV .EQU 0xfe01 ;Clock Frequency Division Register
HIRCCR .EQU 0xfe02 ;High Accuracy Internal RC Control Register
   HIRCST = 0x01 ;Internal High Speed/Precision Oscillator Stability Indicator
   ENHIRC = 0x80 ;Enable Internal High Speed/Precision Clock Source
XOSCCR .EQU 0xfe03 ;External Oscillator Control Register
   XOSCST   = 0x01 ;External Crystal Oscillator Stability Indicator
   XITYPE   = 0x40 ;External Clock Source Type
   GAIN     = 0x80 ;External Crystal Oscillator Gain Control
   XCFILTER = 0x30 ;External Crystal Oscillator Filter Control
   XITYPE   = 0x40 ;External Clock Source Type Select
   ENXOSC   = 0x80 ;Enable External Crystal Clock Source
IRC32KCR .EQU 0xfe04 ;Internal 32K Oscillator Control Register
   IRC32KST = 0x01 ;Internal RC 32 KHz Oscillator Stability Indicator
   ENIRC32K = 0x80 ;Enable Internal RC 32 KHz Clock Source
MCLKOCR .EQU 0xfe05 ;Main Clock Output Control Register
   MCLKODIV = 0x7F ;Main Clock Output Division Coefficient
   MCLKO_S    = 0x80 ;Main Clock Output Pin Selection
IRCDB .EQU 0xfe06 ;Internal RC High Speed Oscillator
   IRCDB_PAR = 0xFF ;
IRC48MCR .EQU 0xfe07 ;Internal 48M Oscillator Control Register
   IRC48MST = 0x01 ;Internal RC 48 MHz Oscillator Stability Indicator
   ENIRC48M = 0x80 ;Enable Internal RC 48 MHz Clock Source
X32KCR .EQU 0xfe08 ;External 32 KHz Oscillator Control Register
   X32KST  = 0x01 ;External 32 KHz Crystal Oscillator Stability Indicator
   GAIN32K = 0x40 ;External 32 KHz Crystal Oscillator Gain Control
   ENX32K  = 0x80 ;Enable External 32 KHz Crystal Oscillator
SPFUNC .EQU 0xfe08 ;Special Function Control Register
   BKSWR = 0x01 ;Undefined
RSTFLAG .EQU 0xfe09 ;Reset Flag Register
   EXRST = 0x01 ;Undefined
   ROMOV = 0x02 ;Undefined
   SWR   = 0x04 ;Undefined
P0PU .EQU 0xfe10 ;Port 0 Pull-up Resistor Control Register
   P00PU = 0x01 ;
   P01PU = 0x02 ;
   P02PU = 0x04 ;
   P03PU = 0x08 ;
   P04PU = 0x10 ;
   P05PU = 0x20 ;
   P06PU = 0x40 ;
   P07PU = 0x80 ;
P1PU .EQU 0xfe11 ;Port 1 Pull-up Resistor Control Register
   P10PU = 0x01 ;
   P11PU = 0x02 ;
   P12PU = 0x04 ;
   P13PU = 0x08 ;
   P14PU = 0x10 ;
   P15PU = 0x20 ;
   P16PU = 0x40 ;
   P17PU = 0x80 ;
P2PU .EQU 0xfe12 ;Port 2 Pull-up Resistor Control Register
   P20PU = 0x01 ;
   P21PU = 0x02 ;
   P22PU = 0x04 ;
   P23PU = 0x08 ;
   P24PU = 0x10 ;
   P25PU = 0x20 ;
   P26PU = 0x40 ;
   P27PU = 0x80 ;
P3PU .EQU 0xfe13 ;Port 3 Pull-up Resistor Control Register
   P30PU = 0x01 ;
   P31PU = 0x02 ;
   P32PU = 0x04 ;
   P33PU = 0x08 ;
   P34PU = 0x10 ;
   P35PU = 0x20 ;
   P36PU = 0x40 ;
   P37PU = 0x80 ;
P4PU .EQU 0xfe14 ;Port 4 Pull-up Resistor Control Register
   P40PU = 0x01 ;
   P41PU = 0x02 ;
   P42PU = 0x04 ;
   P43PU = 0x08 ;
   P44PU = 0x10 ;
   P45PU = 0x20 ;
   P46PU = 0x40 ;
   P47PU = 0x80 ;
P5PU .EQU 0xfe15 ;Port 5 Pull-up Resistor Control Register
   P50PU = 0x01 ;
   P51PU = 0x02 ;
   P52PU = 0x04 ;
   P53PU = 0x08 ;
   P54PU = 0x10 ;
   P55PU = 0x20 ;
P6PU .EQU 0xfe16 ;Port 6 Pull-up Resistor Control Register
   P60PU = 0x01 ;
   P61PU = 0x02 ;
   P62PU = 0x04 ;
   P63PU = 0x08 ;
   P64PU = 0x10 ;
   P65PU = 0x20 ;
   P66PU = 0x40 ;
   P67PU = 0x80 ;
P7PU .EQU 0xfe17 ;Port 7 Pull-up Resistor Control Register
   P70PU = 0x01 ;
   P71PU = 0x02 ;
   P72PU = 0x04 ;
   P73PU = 0x08 ;
   P74PU = 0x10 ;
   P75PU = 0x20 ;
   P76PU = 0x40 ;
   P77PU = 0x80 ;
P0NCS .EQU 0xfe18 ;Port 0 Schmidt Trigger Control Register
   P00NCS = 0x01 ;
   P01NCS = 0x02 ;
   P02NCS = 0x04 ;
   P03NCS = 0x08 ;
   P04NCS = 0x10 ;
   P05NCS = 0x20 ;
   P06NCS = 0x40 ;
   P07NCS = 0x80 ;
P1NCS .EQU 0xfe19 ;Port 1 Schmidt Trigger Control Register
   P10NCS = 0x01 ;
   P11NCS = 0x02 ;
   P12NCS = 0x04 ;
   P13NCS = 0x08 ;
   P14NCS = 0x10 ;
   P15NCS = 0x20 ;
   P16NCS = 0x40 ;
   P17NCS = 0x80 ;
P2NCS .EQU 0xfe1a ;Port 2 Schmidt Trigger Control Register
   P20NCS = 0x01 ;
   P21NCS = 0x02 ;
   P22NCS = 0x04 ;
   P23NCS = 0x08 ;
   P24NCS = 0x10 ;
   P25NCS = 0x20 ;
   P26NCS = 0x40 ;
   P27NCS = 0x80 ;
P3NCS .EQU 0xfe1b ;Port 3 Schmidt Trigger Control Register
   P30NCS = 0x01 ;
   P31NCS = 0x02 ;
   P32NCS = 0x04 ;
   P33NCS = 0x08 ;
   P34NCS = 0x10 ;
   P35NCS = 0x20 ;
   P36NCS = 0x40 ;
   P37NCS = 0x80 ;
P4NCS .EQU 0xfe1c ;Port 4 Schmidt Trigger Control Register
   P40NCS = 0x01 ;
   P41NCS = 0x02 ;
   P42NCS = 0x04 ;
   P43NCS = 0x08 ;
   P44NCS = 0x10 ;
   P45NCS = 0x20 ;
   P46NCS = 0x40 ;
   P47NCS = 0x80 ;
P5NCS .EQU 0xfe1d ;Port 5 Schmidt Trigger Control Register
   P50NCS = 0x01 ;
   P51NCS = 0x02 ;
   P52NCS = 0x04 ;
   P53NCS = 0x08 ;
   P54NCS = 0x10 ;
   P55NCS = 0x20 ;
P6NCS .EQU 0xfe1e ;Port 6 Schmidt Trigger Control Register
   P60NCS = 0x01 ;
   P61NCS = 0x02 ;
   P62NCS = 0x04 ;
   P63NCS = 0x08 ;
   P64NCS = 0x10 ;
   P65NCS = 0x20 ;
   P66NCS = 0x40 ;
   P67NCS = 0x80 ;
P7NCS .EQU 0xfe1f ;Port 7 Schmidt Trigger Control Register
   P70NCS = 0x01 ;
   P71NCS = 0x02 ;
   P72NCS = 0x04 ;
   P73NCS = 0x08 ;
   P74NCS = 0x10 ;
   P75NCS = 0x20 ;
   P76NCS = 0x40 ;
   P77NCS = 0x80 ;
P0SR .EQU 0xfe20 ;Port 0 Slew Rate Control Register
   P00SR = 0x01 ;
   P01SR = 0x02 ;
   P02SR = 0x04 ;
   P03SR = 0x08 ;
   P04SR = 0x10 ;
   P05SR = 0x20 ;
   P06SR = 0x40 ;
   P07SR = 0x80 ;
P1SR .EQU 0xfe21 ;Port 1 Slew Rate Control Register
   P10SR = 0x01 ;
   P11SR = 0x02 ;
   P12SR = 0x04 ;
   P13SR = 0x08 ;
   P14SR = 0x10 ;
   P15SR = 0x20 ;
   P16SR = 0x40 ;
   P17SR = 0x80 ;
P2SR .EQU 0xfe22 ;Port 2 Slew Rate Control Register
   P20SR = 0x01 ;
   P21SR = 0x02 ;
   P22SR = 0x04 ;
   P23SR = 0x08 ;
   P24SR = 0x10 ;
   P25SR = 0x20 ;
   P26SR = 0x40 ;
   P27SR = 0x80 ;
P3SR .EQU 0xfe23 ;Port 3 Slew Rate Control Register
   P30SR = 0x01 ;
   P31SR = 0x02 ;
   P32SR = 0x04 ;
   P33SR = 0x08 ;
   P34SR = 0x10 ;
   P35SR = 0x20 ;
   P36SR = 0x40 ;
   P37SR = 0x80 ;
P4SR .EQU 0xfe24 ;Port 4 Slew Rate Control Register
   P40SR = 0x01 ;
   P41SR = 0x02 ;
   P42SR = 0x04 ;
   P43SR = 0x08 ;
   P44SR = 0x10 ;
   P45SR = 0x20 ;
   P46SR = 0x40 ;
   P47SR = 0x80 ;
P5SR .EQU 0xfe25 ;Port 5 Slew Rate Control Register
   P50SR = 0x01 ;
   P51SR = 0x02 ;
   P52SR = 0x04 ;
   P53SR = 0x08 ;
   P54SR = 0x10 ;
   P55SR = 0x20 ;
P6SR .EQU 0xfe26 ;Port 6 Slew Rate Control Register
   P60SR = 0x01 ;
   P61SR = 0x02 ;
   P62SR = 0x04 ;
   P63SR = 0x08 ;
   P64SR = 0x10 ;
   P65SR = 0x20 ;
   P66SR = 0x40 ;
   P67SR = 0x80 ;
P7SR .EQU 0xfe27 ;Port 7 Slew Rate Control Register
   P70SR = 0x01 ;
   P71SR = 0x02 ;
   P72SR = 0x04 ;
   P73SR = 0x08 ;
   P74SR = 0x10 ;
   P75SR = 0x20 ;
   P76SR = 0x40 ;
   P77SR = 0x80 ;
P0DR .EQU 0xfe28 ;Port 0 Drive Current Control Register
   P00DR = 0x01 ;
   P01DR = 0x02 ;
   P02DR = 0x04 ;
   P03DR = 0x08 ;
   P04DR = 0x10 ;
   P05DR = 0x20 ;
   P06DR = 0x40 ;
   P07DR = 0x80 ;
P1DR .EQU 0xfe29 ;Port 1 Drive Current Control Register
   P10DR = 0x01 ;
   P11DR = 0x02 ;
   P12DR = 0x04 ;
   P13DR = 0x08 ;
   P14DR = 0x10 ;
   P15DR = 0x20 ;
   P16DR = 0x40 ;
   P17DR = 0x80 ;
P2DR .EQU 0xfe2a ;Port 2 Drive Current Control Register
   P20DR = 0x01 ;
   P21DR = 0x02 ;
   P22DR = 0x04 ;
   P23DR = 0x08 ;
   P24DR = 0x10 ;
   P25DR = 0x20 ;
   P26DR = 0x40 ;
   P27DR = 0x80 ;
P3DR .EQU 0xfe2b ;Port 3 Drive Current Control Register
   P30DR = 0x01 ;
   P31DR = 0x02 ;
   P32DR = 0x04 ;
   P33DR = 0x08 ;
   P34DR = 0x10 ;
   P35DR = 0x20 ;
   P36DR = 0x40 ;
   P37DR = 0x80 ;
P4DR .EQU 0xfe2c ;Port 4 Drive Current Control Register
   P40DR = 0x01 ;
   P41DR = 0x02 ;
   P42DR = 0x04 ;
   P43DR = 0x08 ;
   P44DR = 0x10 ;
   P45DR = 0x20 ;
   P46DR = 0x40 ;
   P47DR = 0x80 ;
P5DR .EQU 0xfe2d ;Port 5 Drive Current Control Register
   P50DR = 0x01 ;
   P51DR = 0x02 ;
   P52DR = 0x04 ;
   P53DR = 0x08 ;
   P54DR = 0x10 ;
   P55DR = 0x20 ;
P6DR .EQU 0xfe2e ;Port 6 Drive Current Control Register
   P60DR = 0x01 ;
   P61DR = 0x02 ;
   P62DR = 0x04 ;
   P63DR = 0x08 ;
   P64DR = 0x10 ;
   P65DR = 0x20 ;
   P66DR = 0x40 ;
   P67DR = 0x80 ;
P7DR .EQU 0xfe2f ;Port 7 Drive Current Control Register
   P70DR = 0x01 ;
   P71DR = 0x02 ;
   P72DR = 0x04 ;
   P73DR = 0x08 ;
   P74DR = 0x10 ;
   P75DR = 0x20 ;
   P76DR = 0x40 ;
   P77DR = 0x80 ;
P0IE .EQU 0xfe30 ;Port 0 Digital Input Enable Register
   P00IE = 0x01 ;
   P01IE = 0x02 ;
   P02IE = 0x04 ;
   P03IE = 0x08 ;
   P04IE = 0x10 ;
   P05IE = 0x20 ;
   P06IE = 0x40 ;
   P07IE = 0x80 ;
P1IE .EQU 0xfe31 ;Port 1 Digital Input Enable Register
   P10IE = 0x01 ;
   P11IE = 0x02 ;
   P12IE = 0x04 ;
   P13IE = 0x08 ;
   P14IE = 0x10 ;
   P15IE = 0x20 ;
   P16IE = 0x40 ;
   P17IE = 0x80 ;
P2IE .EQU 0xfe32 ;Port 2 Digital Input Enable Register
   P20IE = 0x01 ;
   P21IE = 0x02 ;
   P22IE = 0x04 ;
   P23IE = 0x08 ;
   P24IE = 0x10 ;
   P25IE = 0x20 ;
   P26IE = 0x40 ;
   P27IE = 0x80 ;
P3IE .EQU 0xfe33 ;Port 3 Digital Input Enable Register
   P30IE = 0x01 ;
   P31IE = 0x02 ;
   P32IE = 0x04 ;
   P33IE = 0x08 ;
   P34IE = 0x10 ;
   P35IE = 0x20 ;
   P36IE = 0x40 ;
   P37IE = 0x80 ;
P4IE .EQU 0xfe34 ;Port 4 Digital Input Enable Register
   P40IE = 0x01 ;
   P41IE = 0x02 ;
   P42IE = 0x04 ;
   P43IE = 0x08 ;
   P44IE = 0x10 ;
   P45IE = 0x20 ;
   P46IE = 0x40 ;
   P47IE = 0x80 ;
P5IE .EQU 0xfe35 ;Port 5 Digital Input Enable Register
   P50IE = 0x01 ;
   P51IE = 0x02 ;
   P52IE = 0x04 ;
   P53IE = 0x08 ;
   P54IE = 0x10 ;
   P55IE = 0x20 ;
P6IE .EQU 0xfe36 ;Port 6 Digital Input Enable Register
   P60IE = 0x01 ;
   P61IE = 0x02 ;
   P62IE = 0x04 ;
   P63IE = 0x08 ;
   P64IE = 0x10 ;
   P65IE = 0x20 ;
   P66IE = 0x40 ;
   P67IE = 0x80 ;
P7IE .EQU 0xfe37 ;Port 7 Digital Input Enable Register
   P70IE = 0x01 ;
   P71IE = 0x02 ;
   P72IE = 0x04 ;
   P73IE = 0x08 ;
   P74IE = 0x10 ;
   P75IE = 0x20 ;
   P76IE = 0x40 ;
   P77IE = 0x80 ;
LCMIFCFG .EQU 0xfe50 ;LC Module Interface Config Register
   M68_I80  = 0x01 ;Mode Select Motorola-6800 or Intel-8080
   D16_D8   = 0x02 ;Data Width Select 16 or 8 bits
   LCMIFDPS = 0x0C ;LC Module Interface Data Pin Select
   LCMIFIP  = 0x30 ;LC Module Interface Interrupt Priority
   LCMIFIE  = 0x80 ;LC Module Interface Interrupt Enable
LCMIFCFG2 .EQU 0xfe51 ;LC Module Interface Config Register 2
   HOLDT    = 0x03 ;Data Hold Time Control
   SETUPT   = 0x1C ;Data Setup Time Control
   LCMIFCPS = 0x60 ;LC Module Interface Control Pin Select
LCMIFCR .EQU 0xfe52 ;LC Module Interface Control Register
   LCMIFCMD = 0x07 ;LC Module Interface Trigger Command
   ENLCMIF  = 0x80 ;Enable LC Module Interface
LCMIFSTA .EQU 0xfe53 ;LC Module Interface Status Register
   LCMIFIF = 0x01 ;LC Module Interface
LCMIDDATL .EQU 0xfe54 ;LC Module Interface Low Byte Data
LCMIDDATH .EQU 0xfe55 ;LC Module Interface High Byte Data
RTCCR .EQU 0xfe60 ;Real Time Clock Control Register
   RUNRTC = 0x01 ;Real Time Clock Run-Stop
RTCCFG .EQU 0xfe61 ;Real Time Clock Config Register
   SETRTC = 0x01 ;Set Real Time Clock
   RTCCKS = 0x02 ;Real Time Clock Clock-Source Select
RTCIEN .EQU 0xfe62 ;Real Time Clock Interrupt Enable
   ESEC32I = 0x01 ;Enable 1/32s Interrupt
   ESEC8I  = 0x02 ;Enable 1/8s Interrupt
   ESEC2I  = 0x04 ;Enable 1/2s Interrupt
   ESECI   = 0x08 ;Enable Seconds Interrupt
   EMINI   = 0x10 ;Enable Minutes Interrupt
   EHOURI  = 0x20 ;Enable Hourly Interrupt
   EDAYI   = 0x40 ;Enable Daily Interrupt
   EALAI   = 0x80 ;Enable Alarm Interrupt
RTCIF .EQU 0xfe63 ;Real Time Clock Interrupt Flag
   SEC32IF = 0x01 ;1/32s Interrupt Flag
   SEC8IF  = 0x02 ;1/8s Interrupt Flag
   SEC2IF  = 0x04 ;1/2s Interrupt Flag
   SECIF   = 0x08 ;Seconds Interrupt Flag
   MINIF   = 0x10 ;Minutes Interrupt Flag
   HOURIF  = 0x20 ;Hourly Interrupt Flag
   DAYIF   = 0x40 ;Daily Interrupt Flag
   ALAIF   = 0x80 ;Alarm Interrupt Flag
ALAHOUR .EQU 0xfe64 ;Alarm Hour Value
ALAMIN .EQU 0xfe65 ;Alarm Minute Value
ALASEC .EQU 0xfe66 ;Alarm Second Value
ALASSEC .EQU 0xfe67 ;Alarm Subsecond 1/127s Value
INIYEAR .EQU 0xfe68 ;Initialize Year
INIMONTH .EQU 0xfe69 ;Initialize Month
INIDAY .EQU 0xfe6a ;Initialize Day
INIHOUR .EQU 0xfe6b ;Initialize Hour
INIMIN .EQU 0xfe6c ;Initialize Minute
INISEC .EQU 0xfe6d ;Initialize Second
INISSEC .EQU 0xfe6e ;Initialize Subsecond 1/127s
YEAR .EQU 0xfe70 ;Current Year
MONTH .EQU 0xfe71 ;Current Month
DAY .EQU 0xfe72 ;Current Day
HOUR .EQU 0xfe73 ;Current Hour
MIN .EQU 0xfe74 ;Current Minute
SEC .EQU 0xfe75 ;Current Second
SSEC .EQU 0xfe76 ;Current Subsecond 1/127s
I2CCFG .EQU 0xfe80 ;I2C configuration
   MSSPEED = 0x3F ;I2C Bus Speed Selection
   MSSL    = 0x40 ;Master or Slave Mode Select
   ENI2C   = 0x80 ;Enable I2C Functionality
I2CMSCR .EQU 0xfe81 ;I2C Master Control
   MSCMD = 0x0F ;Master Command Execution
   EMSI  = 0x80 ;Enable Master Interrupt
I2CMSST .EQU 0xfe82 ;I2C Master Status
   MSACKO = 0x01 ;Master Mode Output ACK
   MSACKI = 0x02 ;Master Mode Input ACK
   MSIF   = 0x40 ;Master Mode Interrupt Flag
   MSBUSY = 0x80 ;Master Busy Flag
I2CSLCR .EQU 0xfe83 ;I2C Slave Control
   SLRST = 0x01 ;Slave Reset Mode
   ESTOI = 0x08 ;Enable Interrupt after STOP is received in Slave Mode
   ETXI  = 0x10 ;Enable Interrupt after data is sent in Slave Mode
   ERXI  = 0x20 ;Enable Interrupt after data is received in Slave Mode
   ESTAI = 0x40 ;Enable Interrupt after START is received in Slave Mode
I2CSLST .EQU 0xfe84 ;I2C Slave Status
   SLACKO = 0x01 ;Slave ACK Output Flag
   SLACKI = 0x02 ;Slave ACK Input Flag
   TXING  = 0x04 ;Undocumented
   STOIF  = 0x08 ;STOP signal Interrupt Flag
   TXIF   = 0x10 ;Transmit Data Interrupt Flag
   RXIF   = 0x20 ;Received Data Interrupt Flag
   STAIF  = 0x40 ;START Interrupt Flag in Slave Mode
   SLBUSY = 0x80 ;Slave Busy Flag
I2CSLADR .EQU 0xfe85 ;I2C Slave Address
   MA    = 0x01 ;Slave Device Address Matching
   SLADR = 0xFE ;Slave Device Address
I2CTXD .EQU 0xfe86 ;I2C Data Transmit Register
I2CRXD .EQU 0xfe87 ;I2C Data Receive Register
I2CMSAUX .EQU 0xfe88 ;I2C Master Auxiliary Control
   WDTA = 0x01 ;I2C Write Data Automatic Send Enable in Master Module
TM2PS .EQU 0xfea2 ;Timer 2 Prescaler
TM3PS .EQU 0xfea3 ;Timer 3 Prescaler
TM4PS .EQU 0xfea4 ;Timer 4 Prescaler
ADCTIM .EQU 0xfea8 ;ADC Timing Control
   SMPDUTY = 0x1F ;Analog Signal Sampling Time Control
   CSHOLD  = 0x60 ;Channel Selection Hold Time Control
   CSSETUP = 0x80 ;Channel Selection Setup Time Control
T3T4PIN .EQU 0xfeac ;T3 and T4 Pin Select
   T3T4SEL = 0x01 ;T3 and T4 Pin Select
ADCEXCFG .EQU 0xfead ;ADC Extension Config Register
   CVTIMESEL = 0x07 ;Number of Conversions per Channel
   ADCETRS   = 0x30 ;ADC External Trigger Pin Select
CMPEXCFG .EQU 0xfeae ;Comparator Extension Config Register
   CMPPS = 0x03 ;Comparator Positive Input Pin Select
   CMPNS = 0x04 ;Comparator Negative Input Pin Select
   CHYS  = 0xC0 ;Comparator Input Hysterisis Select
PWMA_ETRPS .EQU 0xfeb0 ;PWM A External Trigger Select
PWM1_ETRPS .EQU 0xfeb0 ;(alias)
   ETRAPS = 0x03 ;External Trigger PWM A Pin Select
   BRKAPS = 0x04 ;Fault Brake PWM A Input Pin or Comparator Select
PWMA_ENO .EQU 0xfeb1 ;PWM A Enable Output
PWM1_ENO .EQU 0xfeb1 ;(alias)
   ENO1P = 0x01 ;Output 1P Enable
   ENO1N = 0x02 ;Output 1N Enable
   ENO2P = 0x04 ;Output 2P Enable
   ENO2N = 0x08 ;Output 2N Enable
   ENO3P = 0x10 ;Output 3P Enable
   ENO3N = 0x20 ;Output 3N Enable
   ENO4P = 0x40 ;Output 4P Enable
   ENO4N = 0x80 ;Output 4N Enable
PWMA_PS .EQU 0xfeb2 ;PWM A Output Pin Select
PWM1_PS .EQU 0xfeb2 ;(alias)
   C1PS = 0x03 ;Pin 1N and 1P Select
   C2PS = 0x0C ;Pin 2N and 2P Select
   C3PS = 0x30 ;Pin 3N and 3P Select
   C4PS = 0xC0 ;Pin 4N and 4P Select
PWMA_IOAUX .EQU 0xfeb3 ;PWM A Auxiliary IO Register
PWM1_IOAUX .EQU 0xfeb3 ;(alias)
   AUX1P = 0x01 ;Output 1P Auxiliary Output Control Select
   AUX1N = 0x02 ;Output 1N Auxiliary Output Control Select
   AUX2P = 0x04 ;Output 2P Auxiliary Output Control Select
   AUX2N = 0x08 ;Output 2N Auxiliary Output Control Select
   AUX3P = 0x10 ;Output 3P Auxiliary Output Control Select
   AUX3N = 0x20 ;Output 3N Auxiliary Output Control Select
   AUX4P = 0x40 ;Output 4P Auxiliary Output Control Select
   AUX4N = 0x80 ;Output 4N Auxiliary Output Control Select
PWMB_ETRPS .EQU 0xfeb4 ;PWM B External Trigger Select
PWM2_ETRPS .EQU 0xfeb4 ;(alias)
   ETRBPS = 0x03 ;External Trigger PWM B Pin Select
   BRKBPS = 0x04 ;Fault Brake PWM B Input Pin or Comparator Select
PWMB_ENO .EQU 0xfeb5 ;PWM B Enable Output
PWM2_ENO .EQU 0xfeb5 ;(alias)
   ENO5P = 0x01 ;Output 5P Enable
   ENO6P = 0x04 ;Output 6P Enable
   ENO7P = 0x10 ;Output 7P Enable
   ENO8P = 0x40 ;Output 8P Enable
PWMB_PS .EQU 0xfeb6 ;PWM B Output Pin Select
PWM2_PS .EQU 0xfeb6 ;(alias)
   C5PS = 0x03 ;Pin 5P Select
   C6PS = 0x0C ;Pin 6P Select
   C7PS = 0x30 ;Pin 7P Select
   C8PS = 0xC0 ;Pin 8P Select
PWMB_IOAUX .EQU 0xfeb7 ;PWM B Auxiliary Register
PWM2_IOAUX .EQU 0xfeb7 ;(alias)
   AUX5P = 0x01 ;Output 5P Auxiliary Output Control Select
   AUX6P = 0x04 ;Output 6P Auxiliary Output Control Select
   AUX7P = 0x10 ;Output 7P Auxiliary Output Control Select
   AUX8P = 0x40 ;Output 8P Auxiliary Output Control Select
PWMA_CR1 .EQU 0xfec0 ;PWM A Control Register 1
PWM1_CR1 .EQU 0xfec0 ;(alias)
   CENA  = 0x01 ;Enable the PWM A Counters
   UDISA = 0x02 ;PWM A Update Event Generation Disable
   URSA  = 0x04 ;PWM A Update Interrupt Request Source
   OPMA  = 0x08 ;PWM A One Pulse Mode Counter Control
   DIRA  = 0x10 ;Counting Direction of PWM A Counters
   CMSA  = 0x60 ;PWM A Central Alignemt Mode Selection
   ARPEA = 0x80 ;PWM A ARR Register Preload Buffer Enable
PWMA_CR2 .EQU 0xfec1 ;PWM A Control Register 2
PWM1_CR2 .EQU 0xfec1 ;(alias)
   CCPCA = 0x01 ;PWM A Capture-Compare Preload Control Selection
   COMSA = 0x04 ;PWM A Capture-Compare Control Selection
   MMSA  = 0x70 ;PWM A Main Mode Select
   TI1S  = 0x80 ;PWM A TI 1 Pin Selection
PWMA_SMCR .EQU 0xfec2 ;PWM A Input Mode Control Register
PWM1_SMCR .EQU 0xfec2 ;(alias)
   SMSA = 0x07 ;PWM B Clock and Trigger Mode Selection
   TSA  = 0x70 ;PWM A Trigger Source Selection
   MSMA = 0x80 ;PWM A Master Mode
PWMA_ETR .EQU 0xfec3 ;PWM A External Trigger Register
PWM1_ETR .EQU 0xfec3 ;(alias)
   ETFA  = 0x0F ;PWM A External Trigger Filter
   ETPSA = 0x30 ;PWM A External Trigger Prescaler
   ECEA  = 0x40 ;PWM A External Clock Enable
   ETP1  = 0x80 ;PWM A External Trigger Polarity
PWMA_IER .EQU 0xfec4 ;PWM A Interrupt Enable Register
PWM1_IER .EQU 0xfec4 ;(alias)
   UIEA   = 0x01 ;PWM A Update Interrupt Enable
   CC1IE  = 0x02 ;Capture-Compare 1 Enable
   CC2IE  = 0x04 ;Capture-Compare 2 Enable
   CC3IE  = 0x08 ;Capture-Compare 3 Enable
   CC4IE  = 0x10 ;Capture-Compare 4 Enable
   COMIEA = 0x20 ;PWM A Compare Interrupt Enable
   TIEA   = 0x40 ;PWM A Trigger Interrupt Enable
   BIEA   = 0x80 ;PWM A Brake Interrupt Enable
PWMA_SR1 .EQU 0xfec5 ;PWM A Status Register 1
PWM1_SR1 .EQU 0xfec5 ;(alias)
   UIFA   = 0x01 ;PWM A Update Interrupt Flag
   CC1IF  = 0x02 ;Capture-Compare 1 Interrupt Flag
   CC2IF  = 0x04 ;Capture-Compare 2 Interrupt Flag
   CC3IF  = 0x08 ;Capture-Compare 3 Interrupt Flag
   CC4IF  = 0x10 ;Capture-Compare 4 Interrupt Flag
   COMIFA = 0x20 ;PWM A Compare Interrupt Flag
   TIFA   = 0x40 ;PWM A Trigger Interrupt Flag
   BIFA   = 0x80 ;PWM A Brake Interrupt Flag
PWMA_SR2 .EQU 0xfec6 ;PWM A Status Register 2
PWM1_SR2 .EQU 0xfec6 ;(alias)
   CC1OF = 0x02 ;Captue-Compare 1 Duplicate Flag
   CC2OF = 0x04 ;Captue-Compare 2 Duplicate Flag
   CC3OF = 0x08 ;Captue-Compare 3 Duplicate Flag
   CC4OF = 0x10 ;Captue-Compare 4 Duplicate Flag
PWMA_EGR .EQU 0xfec7 ;PWM A Event Generation Register
PWM1_EGR .EQU 0xfec7 ;(alias)
   UGA   = 0x01 ;PWM A Update Event Generation
   CC1G  = 0x02 ;Capture-Compare Event 1 Generation
   CC2G  = 0x04 ;Capture-Compare Event 2 Generation
   CC3G  = 0x08 ;Capture-Compare Event 3 Generation
   CC4G  = 0x10 ;Capture-Compare Event 4 Generation
   COMGA = 0x20 ;PWM A Capture-Compare Event Generation
   TGA   = 0x40 ;PWM A Trigger Event Generation
   BGA   = 0x80 ;PWM A Brake Event Generation
PWMA_CCMR1 .EQU 0xfec8 ;PWM A Capture-Compare Mode Register 1
PWM1_CCMR1 .EQU 0xfec8 ;(alias)
   CC1S   = 0x03 ;Capture-Compare 1 Configuration
   OC1FE  = 0x04 ;Output Compare 1 Fast Mode Enable
   OC1PE  = 0x08 ;Output Compare 1 Preload Enable
   IC1PSC = 0x0C ;Input Capture 1 Prescaler
   OC1M   = 0x70 ;Output Compare 1 Mode
   OC1CE  = 0x80 ;Output Compare 1 Clear Enable
   IC1F   = 0xF0 ;Input Capture 1 Filter
PWMA_CCMR2 .EQU 0xfec9 ;PWM A Capture-Compare Mode Register 2
PWM1_CCMR2 .EQU 0xfec9 ;(alias)
   CC2S   = 0x03 ;Capture-Compare 2 Configuration
   OC2FE  = 0x04 ;Output Compare 2 Fast Mode Enable
   OC2PE  = 0x08 ;Output Compare 2 Preload Enable
   IC2PSC = 0x0C ;Input Capture 2 Prescaler
   OC2M   = 0x70 ;Output Compare 2 Mode
   OC2CE  = 0x80 ;Output Compare 2 Clear Enable
   IC2F   = 0xF0 ;Input Capture 2 Filter
PWMA_CCMR3 .EQU 0xfeca ;PWM A Capture-Compare Mode Register 3
PWM1_CCMR3 .EQU 0xfeca ;(alias)
   CC3S   = 0x03 ;Capture-Compare 3 Configuration
   OC3FE  = 0x04 ;Output Compare 3 Fast Mode Enable
   OC3PE  = 0x08 ;Output Compare 3 Preload Enable
   IC3PSC = 0x0C ;Input Capture 3 Prescaler
   OC3M   = 0x70 ;Output Compare 3 Mode
   OC3CE  = 0x80 ;Output Compare 3 Clear Enable
   IC3F   = 0xF0 ;Input Capture 3 Filter
PWMA_CCMR4 .EQU 0xfecb ;PWM A Capture-Compare Mode Register 4
PWM1_CCMR4 .EQU 0xfecb ;(alias)
   CC4S   = 0x03 ;Capture-Compare 4 Configuration
   OC4FE  = 0x04 ;Output Compare 4 Fast Mode Enable
   OC4PE  = 0x08 ;Output Compare 4 Preload Enable
   IC4PSC = 0x0C ;Input Capture 4 Prescaler
   OC4M   = 0x70 ;Output Compare 4 Mode
   OC4CE  = 0x80 ;Output Compare 4 Clear Enable
   IC4F   = 0xF0 ;Input Capture 4 Filter
PWMA_CCER1 .EQU 0xfecc ;PWM A Capture-Compare Enable Register 1
PWM1_CCER1 .EQU 0xfecc ;(alias)
   CC1E  = 0x01 ;Input Capture-Compare 1 Ouput Enable
   CC1P  = 0x02 ;Input Capture-Compare 1 Output Polarity
   CC1NE = 0x04 ;Input Capture-Compare 1 Negated Output Enable
   CC1NP = 0x08 ;Input Capture-Compare 1 Negated Output Polarity
   CC2E  = 0x10 ;Input Capture-Compare 2 Ouput Enable
   CC2P  = 0x20 ;Input Capture-Compare 2 Output Polarity
   CC2NE = 0x40 ;Input Capture-Compare 2 Negated Output Enable
   CC2NP = 0x80 ;Input Capture-Compare 2 Negated Polarity
PWMA_CCER2 .EQU 0xfecd ;PWM A Capture-Compare Enable Register 2
PWM1_CCER2 .EQU 0xfecd ;(alias)
   CC3E  = 0x01 ;Input Capture-Compare 3 Output Enable
   CC3P  = 0x02 ;Input Capture-Compare 3 Output Polarity
   CC3NE = 0x04 ;Input Capture-Compare 3 Negated Output Enable
   CC3NP = 0x08 ;Input Capture-Compare 3 Negated Output Polarity
   CC4E  = 0x10 ;Input Capture-Compare 4 Output Enable
   CC4P  = 0x20 ;Input Capture-Compare 4 Output Polarity
   CC4NE = 0x40 ;Input Capture-Compare 4 Negated Output Enable
   CC4NP = 0x80 ;Input Capture-Compare 4 Negated Output Polarity
PWMA_CNTR .EQU 0xfece ;PWM A Counter Word
PWM1_CNTR .EQU 0xfece ;(alias)
PWMA_CNTRH .EQU 0xfece ;PWM A Counter High Byte
PWM1_CNTRH .EQU 0xfece ;(alias)
PWMA_CNTRL .EQU 0xfecf ;PWM A Counter Low Byte
PWM1_CNTRL .EQU 0xfecf ;(alias)
PWMA_PSCR .EQU 0xfed0 ;PWM A Prescaler Word
PWM1_PSCR .EQU 0xfed0 ;(alias)
PWMA_PSCRH .EQU 0xfed0 ;PWM A Prescaler High Byte
PWM1_PSCRH .EQU 0xfed0 ;(alias)
PWMA_PSCRL .EQU 0xfed1 ;PWM A Prescaler Low Byte
PWM1_PSCRL .EQU 0xfed1 ;(alias)
PWMA_ARR .EQU 0xfed2 ;Automatic Reload Register Word
PWM1_ARR .EQU 0xfed2 ;(alias)
PWMA_ARRH .EQU 0xfed2 ;Automatic Reload Register High Byte
PWM1_ARRH .EQU 0xfed2 ;(alias)
PWMA_ARRL .EQU 0xfed3 ;Automatic Reload Register Low Byte
PWM1_ARRL .EQU 0xfed3 ;(alias)
PWMA_RCR .EQU 0xfed4 ;Repeat Counter Register
PWM1_RCR .EQU 0xfed4 ;(alias)
PWMA_CCR1 .EQU 0xfed5 ;Capture Compare Register 1 Word
PWM1_CCR1 .EQU 0xfed5 ;(alias)
PWMA_CCR1H .EQU 0xfed5 ;Capture Compare Register 1 High Byte
PWM1_CCR1H .EQU 0xfed5 ;(alias)
PWMA_CCR1L .EQU 0xfed6 ;Capture Compare Register 1 Low Byte
PWM1_CCR1L .EQU 0xfed6 ;(alias)
PWMA_CCR2 .EQU 0xfed7 ;Capture Compare Register 2 Word
PWM1_CCR2 .EQU 0xfed7 ;(alias)
PWMA_CCR2H .EQU 0xfed7 ;Capture Compare Register 2 High Byte
PWM1_CCR2H .EQU 0xfed7 ;(alias)
PWMA_CCR2L .EQU 0xfed8 ;Capture Compare Register 2 Low Byte
PWM1_CCR2L .EQU 0xfed8 ;(alias)
PWMA_CCR3 .EQU 0xfed9 ;Capture Compare Register 3 Word
PWM1_CCR3 .EQU 0xfed9 ;(alias)
PWMA_CCR3H .EQU 0xfed9 ;Capture Compare Register 3 High Byte
PWM1_CCR3H .EQU 0xfed9 ;(alias)
PWMA_CCR3L .EQU 0xfeda ;Capture Compare Register 3 Low Byte
PWM1_CCR3L .EQU 0xfeda ;(alias)
PWMA_CCR4 .EQU 0xfedb ;Capture Compare Register 4 Word
PWM1_CCR4 .EQU 0xfedb ;(alias)
PWMA_CCR4H .EQU 0xfedb ;Capture Compare Register 4 High Byte
PWM1_CCR4H .EQU 0xfedb ;(alias)
PWMA_CCR4L .EQU 0xfedc ;Capture Compare Register 4 Low Byte
PWM1_CCR4L .EQU 0xfedc ;(alias)
PWMA_BKR .EQU 0xfedd ;PWM A Brake Register
PWM1_BKR .EQU 0xfedd ;(alias)
   LOCK = 0x03 ;Register Write Protect Lock Setting
   OSSI = 0x04 ;Off Status Select in Idle Mode
   OSSR = 0x08 ;Off Status Select in Run Mode
   BKE  = 0x10 ;Brake Function Enable
   BKP  = 0x20 ;Brake Input Polarity
   AOE  = 0x40 ;Automatic Output Enable
   MOE  = 0x80 ;Main Output Enable
PWMA_DTR .EQU 0xfede ;PWM A Dead Time Control
PWM1_DTR .EQU 0xfede ;(alias)
   DTGA = 0xFF ;Dead Time Generator A Setting
PWMA_OISR .EQU 0xfedf ;PWM A Output Idle State Register
PWM1_OISR .EQU 0xfedf ;(alias)
   OIS1  = 0x01 ;OC1 Output Level in Idle State
   OIS1N = 0x02 ;OC1N Output Leve in Idle State
   OIS2  = 0x04 ;OC2 Output Level in Idle State
   OIS2N = 0x08 ;OC2N Output Leve in Idle State
   OIS3  = 0x10 ;OC3 Output Level in Idle State
   OIS3N = 0x20 ;OC3N Output Leve in Idle State
   OIS4  = 0x40 ;OC4 Output Level in Idle State
   OIS4N = 0x80 ;OC4N Output Leve in Idle State
PWMB_CR1 .EQU 0xfee0 ;PWM B Control Register 1
PWM2_CR1 .EQU 0xfee0 ;(alias)
   CENB  = 0x01 ;Enable the PWM B Counters
   UDISB = 0x02 ;PWM B Update Event Generation Disable
   URSB  = 0x04 ;PWM B Update Interrupt Request Source
   OPMB  = 0x08 ;PWM B One Pulse Mode Counter Control
   DIRB  = 0x10 ;Counting Direction of PWM B Counters
   CMSB  = 0x60 ;PWM B Central Alignemt Mode Selection
   ARPEB = 0x80 ;PWM B ARR Register Preload Buffer Enable
PWMB_CR2 .EQU 0xfee1 ;PWM B Control Register 2
PWM2_CR2 .EQU 0xfee1 ;(alias)
   CCPCB = 0x01 ;PWM B Capture-Compare Preload Control Selection
   COMSB = 0x04 ;PWM B Capture-Compare Control Selection
   MMSB  = 0x70 ;PWM B Main Mode Select
   TI5S  = 0x80 ;PWM B TI 5 Pin Selection
PWMB_SMCR .EQU 0xfee2 ;PWM B Input Mode Control Register
PWM2_SMCR .EQU 0xfee2 ;(alias)
   SMSB = 0x07 ;PWM B Clock and Trigger Mode Selection
   TSB  = 0x70 ;PWM B Trigger Source Selection
   MSMB = 0x80 ;PWM B Master Mode
PWMB_ETR .EQU 0xfee3 ;PWM B External Trigger Register
PWM2_ETR .EQU 0xfee3 ;(alias)
   ETFB  = 0x0F ;PWM B External Trigger Filter
   ETPSB = 0x30 ;PWM B External Trigger Prescaler
   ECEB  = 0x40 ;PWM B External Clock Enable
   ETP2  = 0x80 ;PWM B External Trigger Polarity
PWMB_IER .EQU 0xfee4 ;PWM B Interrupt Enable Register
PWM2_IER .EQU 0xfee4 ;(alias)
   UIEB   = 0x01 ;PWM B Update Interrupt Enable
   CC5IE  = 0x02 ;Capture-Compare 5 Enable
   CC6IE  = 0x04 ;Capture-Compare 6 Enable
   CC7IE  = 0x08 ;Capture-Compare 7 Enable
   CC8IE  = 0x10 ;Capture-Compare 8 Enable
   COMIEB = 0x20 ;PWM B Compare Interrupt Enable
   TIEB   = 0x40 ;PWM B Trigger Interrupt Enable
   BIEB   = 0x80 ;PWM B Brake Interrupt Enable
PWMB_SR1 .EQU 0xfee5 ;PWM B Status Register 1
PWM2_SR1 .EQU 0xfee5 ;(alias)
   UIFB   = 0x01 ;PWM B Update Interrupt Flag
   CC5IF  = 0x02 ;Capture-Compare 5 Interrupt Flag
   CC6IF  = 0x04 ;Capture-Compare 6 Interrupt Flag
   CC7IF  = 0x08 ;Capture-Compare 7 Interrupt Flag
   CC8IF  = 0x10 ;Capture-Compare 8 Interrupt Flag
   COMIFB = 0x20 ;PWM B Compare Interrupt Flag
   TIFB   = 0x40 ;PWM B Trigger Interrupt Flag
   BIFB   = 0x80 ;PWM B Brake Interrupt Flag
PWMB_SR2 .EQU 0xfee6 ;PWM B Status Register 2
PWM2_SR2 .EQU 0xfee6 ;(alias)
   CC5OF = 0x02 ;Captue-Compare 1 Duplicate Flag
   CC6OF = 0x04 ;Captue-Compare 2 Duplicate Flag
   CC7OF = 0x08 ;Captue-Compare 3 Duplicate Flag
   CC8OF = 0x10 ;Captue-Compare 4 Duplicate Flag
PWMB_EGR .EQU 0xfee7 ;PWM B Event Generation Register
PWM2_EGR .EQU 0xfee7 ;(alias)
   UGB   = 0x01 ;PWM B Update Event Generation
   CC1G  = 0x02 ;Capture-Compare Event 5 Generation
   CC2G  = 0x04 ;Capture-Compare Event 6 Generation
   CC3G  = 0x08 ;Capture-Compare Event 7 Generation
   CC4G  = 0x10 ;Capture-Compare Event 8 Generation
   COMGB = 0x20 ;PWM B Capture-Compare Event Generation
   TGB   = 0x40 ;PWM B  Trigger Event Generation
   BGB   = 0x80 ;PWM B Brake Event Generation
PWMB_CCMR1 .EQU 0xfee8 ;PWM B Capture-Compare Mode Register 1
PWM2_CCMR1 .EQU 0xfee8 ;(alias)
   CC5S   = 0x03 ;Capture-Compare Channel 5 Configuration
   OC5FE  = 0x04 ;Output Compare Channel 5 Fast Mode Enable
   OC5PE  = 0x08 ;Output Compare Channel 5 Preload Enable
   IC5PSC = 0x0C ;Input Capture Channel 5 Prescaler
   OC5M   = 0x70 ;Output Compare Channel 5 Mode
   OC5CE  = 0x80 ;Output Compare Channel 5 Clear Enable
   IC5F   = 0xF0 ;Input Capture Channel 5 Filter
PWMB_CCMR2 .EQU 0xfee9 ;PWM B Capture-Compare Mode Register 2
PWM2_CCMR2 .EQU 0xfee9 ;(alias)
   CC6S   = 0x03 ;Capture-Compare Channel 6 Configuration
   OC6FE  = 0x04 ;Output Compare Channel 6 Fast Mode Enable
   OC6PE  = 0x08 ;Output Compare Channel 6 Preload Enable
   IC6PSC = 0x0C ;Input Capture Channel 6 Prescaler
   OC6M   = 0x70 ;Output Compare Channel 6 Mode
   OC6CE  = 0x80 ;Output Compare Channel 6 Clear Enable
   IC6F   = 0xF0 ;Input Capture Channel 6 Filter
PWMB_CCMR3 .EQU 0xfeea ;PWM B Capture-Compare Mode Register 3
PWM2_CCMR3 .EQU 0xfeea ;(alias)
   CC7S   = 0x03 ;Capture-Compare Channel 7 Configuration
   OC7FE  = 0x04 ;Output Compare Channel 7 Fast Mode Enable
   OC7PE  = 0x08 ;Output Compare Channel 7 Preload Enable
   IC7PSC = 0x0C ;Input Capture Channel 7 Prescaler
   OC7M   = 0x70 ;Output Compare Channel 7 Mode
   OC7CE  = 0x80 ;Output Compare Channel 7 Clear Enable
   IC7F   = 0xF0 ;Input Capture Channel 7 Filter
PWMB_CCMR4 .EQU 0xfeeb ;PWM B Capture-Compare Mode Register 4
PWM2_CCMR4 .EQU 0xfeeb ;(alias)
   CC8S   = 0x03 ;Capture-Compare Channel 8 Configuration
   OC8FE  = 0x04 ;Output Compare Channel 8 Fast Mode Enable
   OC8PE  = 0x08 ;Output Compare Channel 8 Preload Enable
   IC8PSC = 0x0C ;Input Capture Channel 8 Prescaler
   OC8M   = 0x70 ;Output Compare Channel 8 Mode
   OC8CE  = 0x80 ;Output Compare Channel 8 Clear Enable
   IC8F   = 0xF0 ;Input Capture Channel 8 Filter
PWMB_CCER1 .EQU 0xfeec ;PWM B Capture-Compare Enable Register 1
PWM2_CCER1 .EQU 0xfeec ;(alias)
   CC5E  = 0x01 ;Input Capture-Compare 5 Ouput Enable
   CC5P  = 0x02 ;Input Capture-Compare 5 Output Polarity
   CC6E  = 0x10 ;Input Capture-Compare 6 Ouput Enable
   CC6P  = 0x20 ;Input Capture-Compare 6 Output Polarity
PWMB_CCER2 .EQU 0xfeed ;PWM B Capture-Compare Enable Register 2
PWM2_CCER2 .EQU 0xfeed ;(alias)
   CC7E  = 0x01 ;Input Capture-Compare 7 Output Enable
   CC7P  = 0x02 ;Input Capture-Compare 7 Output Polarity
   CC8E  = 0x10 ;Input Capture-Compare 8 Output Enable
   CC8P  = 0x20 ;Input Capture-Compare 8 Output Polarity
PWMB_CNTR .EQU 0xfeee ;PWM B Counter Word
PWM2_CNTR .EQU 0xfeee ;(alias)
PWMB_CNTRH .EQU 0xfeee ;PWM B Counter High Byte
PWM2_CNTRH .EQU 0xfeee ;(alias)
PWMB_CNTRL .EQU 0xfeef ;PWM B Counter Low Byte
PWM2_CNTRL .EQU 0xfeef ;(alias)
PWMB_PSCR .EQU 0xfef0 ;PWM B Prescaler Word
PWM2_PSCR .EQU 0xfef0 ;(alias)
PWMB_PSCRH .EQU 0xfef0 ;PWM B Prescaler High Byte
PWM2_PSCRH .EQU 0xfef0 ;(alias)
PWMB_PSCRL .EQU 0xfef1 ;PWM B Prescaler Low Byte
PWM2_PSCRL .EQU 0xfef1 ;(alias)
PWMB_ARR .EQU 0xfef2 ;Automatic Reload Register Word
PWM2_ARR .EQU 0xfef2 ;(alias)
PWMB_ARRH .EQU 0xfef2 ;Automatic Reload Register High Byte
PWM2_ARRH .EQU 0xfef2 ;(alias)
PWMB_ARRL .EQU 0xfef3 ;Automatic Reload Register Low Byte
PWM2_ARRL .EQU 0xfef3 ;(alias)
PWMB_RCR .EQU 0xfef4 ;Repeat Counter Register
PWM2_RCR .EQU 0xfef4 ;(alias)
PWMB_CCR5 .EQU 0xfef5 ;Capture Compare Register 5 Word
PWM2_CCR5 .EQU 0xfef5 ;(alias)
PWMB_CCR5H .EQU 0xfef5 ;Capture Compare Register 5 High Byte
PWM2_CCR5H .EQU 0xfef5 ;(alias)
PWMB_CCR5L .EQU 0xfef6 ;Capture Compare Register 5 Low Byte
PWM2_CCR1L .EQU 0xfef6 ;(alias)
PWMB_CCR6 .EQU 0xfef7 ;Capture Compare Register 6 Word
PWM2_CCR6 .EQU 0xfef7 ;(alias)
PWMB_CCR6H .EQU 0xfef7 ;Capture Compare Register 6 High Byte
PWM2_CCR6H .EQU 0xfef7 ;(alias)
PWMB_CCR6L .EQU 0xfef8 ;Capture Compare Register 6 Low Byte
PWM2_CCR6L .EQU 0xfef8 ;(alias)
PWMB_CCR7 .EQU 0xfef9 ;Capture Compare Register 7 Word
PWM2_CCR7 .EQU 0xfef9 ;(alias)
PWMB_CCR7H .EQU 0xfef9 ;Capture Compare Register 7 High Byte
PWM2_CCR7H .EQU 0xfef9 ;(alias)
PWMB_CCR7L .EQU 0xfefa ;Capture Compare Register 7 Low Byte
PWM2_CCR7L .EQU 0xfefa ;(alias)
PWMB_CCR8 .EQU 0xfefb ;Capture Compare Register 8 Word
PWM2_CCR8 .EQU 0xfefb ;(alias)
PWMB_CCR8H .EQU 0xfefb ;Capture Compare Register 8 High Byte
PWM2_CCR8H .EQU 0xfefb ;(alias)
PWMB_CCR8L .EQU 0xfefc ;Capture Compare Register 8 Low Byte
PWM2_CCR8L .EQU 0xfefc ;(alias)
PWMB_BKR .EQU 0xfefd ;PWM A Brake Register
PWM2_BKR .EQU 0xfefd ;(alias)
   LOCK = 0x03 ;Register Write Protect Lock Setting
   OSSI = 0x04 ;Off Status Select in Idle Mode
   OSSR = 0x08 ;Off Status Select in Run Mode
   BKE  = 0x10 ;Brake Function Enable
   BKP  = 0x20 ;Brake Input Polarity
   AOE  = 0x40 ;Automatic Output Enable
   MOE  = 0x80 ;Main Output Enable
PWMB_DTR .EQU 0xfefe ;PWM B Dead Time Control
PWM2_DTR .EQU 0xfefe ;(alias)
   DTGB = 0xFF ;Dead Time Generator B Setting
PWMB_OISR .EQU 0xfeff ;PWM B Output Idle State Register
PWM2_OISR .EQU 0xfeff ;(alias)
   OIS5  = 0x01 ;OC5 Output Level in Idle State
   OIS6  = 0x04 ;OC6 Output Level in Idle State
   OIS7  = 0x10 ;OC7 Output Level in Idle State
   OIS8  = 0x40 ;OC8 Output Level in Idle State

;Interrupt_Address = ( Interrupt_Number * 8 ) + 3
;Vectors are named after their corresponding IE, IP or IR register bit so
;that we don't have to invent names and can be more consistent across MCUs.
   X0_VECTOR   = 0  ; 0x03  External Interrupt 0
   T0_VECTOR   = 1  ; 0x0B  Timer 0
   X1_VECTOR   = 2  ; 0x13  External Interrupt 1
   T1_VECTOR   = 3  ; 0x1B  Timer 1
   S_VECTOR    = 4  ; 0x23  Serial Port 1
   ADC_VECTOR  = 5  ; 0x2B  Analog to Digital Converter
   LVD_VECTOR  = 6  ; 0x33  Low Voltage Detect
   PCA_VECTOR  = 7  ; 0x3B  Programmable Counter Array (CCP)
   S2_VECTOR   = 8  ; 0x43  Serial Port 2
   SPI_VECTOR  = 9  ; 0x4B  Serial Peripheral Interface
   X2_VECTOR   = 10 ; 0x53  External Interrupt 2
   X3_VECTOR   = 11 ; 0x5B  External Interrupt 3
   T2_VECTOR   = 12 ; 0x63  Timer 2
   ;   -       = 13 ; 0x6B      -
   ;   -       = 14 ; 0x73  System Reserved
   ;   -       = 15 ; 0x7B  System Reserved
   X4_VECTOR   = 16 ; 0x83  External Interrupt 4
   S3_VECTOR   = 17 ; 0x8B  Serial Port 3
   S4_VECTOR   = 18 ; 0x93  Serial Port 4
   T3_VECTOR   = 19 ; 0x9B  Timer 3
   T4_VECTOR   = 20 ; 0xA3  Timer 4
   CMP_VECTOR  = 21 ; 0xAB  Comparator
   ;    -      = 22 ; 0xB3      -
   ;    -      = 23 ; 0xBB      -
   I2C_VECTOR  = 24 ; 0xC3  Inter-Integrated Circuit (IIC)
   USB_VECTOR  = 25 ; 0xCB  Universal Serial Bus Events
   PWMA_VECTOR = 26 ; 0xD3  Pulse Width Modulator A
   PWMB_VECTOR = 27 ; 0xDB  Pulse Width Modulator B
   ;    -      = 28 ; 0xE3      -
   ;    -      = 29 ; 0xEB      -
   ;    -      = 30 ; 0xF3      -
   ;    -      = 31 ; 0xFB      -
   ;    -      = 32 ; 0x103     -
   ;    -      = 33 ; 0x10B     -
   ;    -      = 34 ; 0x113     -
   TK_VECTOR   = 35 ; 0x11B Touch Key
   RTC_VECTOR  = 36 ; 0x123 Real Time Clock
   P0_VECTOR   = 37 ; 0x12B Port P0
   P1_VECTOR   = 38 ; 0x133 Port P1
   P2_VECTOR   = 39 ; 0x13B Port P2
   P3_VECTOR   = 40 ; 0x143 Port P3
   P4_VECTOR   = 41 ; 0x14B Port P4
   P5_VECTOR   = 42 ; 0x153 Port P5
   P6_VECTOR   = 43 ; 0x15B Port P6
   P7_VECTOR   = 44 ; 0x163 Port P7

;.endif
