; PIO compatible header file STC90-STC89.asm 20210829.
; For use with all STC89xx and STC90xx series except siffix AD.

;.ifndef STC90_STC89_ASM
;.define STC90_STC89_ASM

P0 .EQU 0x80                  ;Port 0
   P00 .EQU 0x80+0 ;Port 0 Bit 0
   P01 .EQU 0x80+1 ;Port 0 Bit 1
   P02 .EQU 0x80+2 ;Port 0 Bit 2
   P03 .EQU 0x80+3 ;Port 0 Bit 3
   P04 .EQU 0x80+4 ;Port 0 Bit 4
   P05 .EQU 0x80+5 ;Port 0 Bit 5
   P06 .EQU 0x80+6 ;Port 0 Bit 6
   P07 .EQU 0x80+7 ;Port 0 Bit 7
   P0_0 .EQU 0x80+0 ;Port 0 Bit 0
   P0_1 .EQU 0x80+1 ;Port 0 Bit 1
   P0_2 .EQU 0x80+2 ;Port 0 Bit 2
   P0_3 .EQU 0x80+3 ;Port 0 Bit 3
   P0_4 .EQU 0x80+4 ;Port 0 Bit 4
   P0_5 .EQU 0x80+5 ;Port 0 Bit 5
   P0_6 .EQU 0x80+6 ;Port 0 Bit 6
   P0_7 .EQU 0x80+7 ;Port 0 Bit 7
SP .EQU 0x81                  ;Stack Pointer
;DPTR .EQU 0x82                ;Data Pointer
DPL .EQU 0x82                ;Data Pointer Low
DPH .EQU 0x83                 ;Data Pointer High
PCON .EQU 0x87                ;Power Control
   IDL   = 0x01 ;Idle
   PD    = 0x02 ;Power Down
   STOP  = 0x02 ;Stop
   GF0   = 0x04 ;General Flag 0
   GF1   = 0x08 ;General Flag 1
   POF   = 0x10 ;Power On Flag
   SMOD0 = 0x40 ;Serial Mode 0
   SMOD  = 0x80 ;Serial Mode
TCON .EQU 0x88                ;Timer Control
   IT0 .EQU 0x88+0 ;Interrupt 0 Type
   IE0 .EQU 0x88+1 ;Interrupt 0 Edge
   IT1 .EQU 0x88+2 ;Interrupt 1 Type
   IE1 .EQU 0x88+3 ;Interrupt 1 Edge
   TR0 .EQU 0x88+4 ;Timer 0 Run
   TF0 .EQU 0x88+5 ;Timer 0 Flag
   TR1 .EQU 0x88+6 ;Timer 1 Run
   TF1 .EQU 0x88+7 ;Timer 1 Flag
TMOD .EQU 0x89                ;Timer Mode
   T0_M0   = 0x01 ;Timer 0 Mode 0
   T0_M1   = 0x02 ;Timer 0 Mode 1
   T0_M    = 0x03 ;Timer 0 Mode
   T0_CT   = 0x04 ;Timer 0 Counter Timer
   T0_GATE = 0x08 ;Timer 0 Gate
   T1_M0   = 0x10 ;Timer 1 Mode 0
   T1_M1   = 0x20 ;Timer 1 Mode 1
   T1_M    = 0x30 ;Timer 1 Mode
   T1_CT   = 0x40 ;Timer 1 Counter Timer
   T1_GATE = 0x80 ;Timer 1 Gate
   M00   = 0x01 ;Mode 0 Timer 0
   M10   = 0x02 ;Mode 1 Timer 0
   M0    = 0x03 ;Timer 0 Mode
   CT0   = 0x04 ;Counter Timer 0
   GATE0 = 0x08 ;Gate 0
   M01   = 0x10 ;Mode 1 Timer 1
   M11   = 0x20 ;Mode 1 Timer 1
   M1    = 0x30 ;Timer 1 Mode
   CT1   = 0x40 ;Counter Timer 1
   GATE1 = 0x80 ;Gate 1
TL0 .EQU 0x8A                 ;Timer 0 Low
TL1 .EQU 0x8B                 ;Timer 1 Low
TH0 .EQU 0x8C                 ;Timer 0 High
TH1 .EQU 0x8D                 ;Timer 1 High
AUXR .EQU 0x8E                ;Auxiliary Register
   ALEOFF = 0x01 ;Address Latch Enable Off
   EXTRAM = 0x02 ;External RAM
P1 .EQU 0x90                  ;Port 1
   T2   .EQU 0x90+0 ;Timer 2
   T2EX .EQU 0x90+1 ;Timer 2 Extra
   P10 .EQU 0x90+0 ;Port 1 Bit 0
   P11 .EQU 0x90+1 ;Port 1 Bit 1
   P12 .EQU 0x90+2 ;Port 1 Bit 2
   P13 .EQU 0x90+3 ;Port 1 Bit 3
   P14 .EQU 0x90+4 ;Port 1 Bit 4
   P15 .EQU 0x90+5 ;Port 1 Bit 5
   P16 .EQU 0x90+6 ;Port 1 Bit 6
   P17 .EQU 0x90+7 ;Port 1 Bit 7
   P1_0 .EQU 0x90+0 ;Port 1 Bit 0
   P1_1 .EQU 0x90+1 ;Port 1 Bit 1
   P1_2 .EQU 0x90+2 ;Port 1 Bit 2
   P1_3 .EQU 0x90+3 ;Port 1 Bit 3
   P1_4 .EQU 0x90+4 ;Port 1 Bit 4
   P1_5 .EQU 0x90+5 ;Port 1 Bit 5
   P1_6 .EQU 0x90+6 ;Port 1 Bit 6
   P1_7 .EQU 0x90+7 ;Port 1 Bit 7
SCON .EQU 0x98              ;Serial Control
   RI  .EQU 0x98+0 ;Receive Interrupt
   TI  .EQU 0x98+1 ;Transmit Interrupt
   RB8 .EQU 0x98+2 ;Receive Bit 8
   TB8 .EQU 0x98+3 ;Transmit Bit 8
   REN .EQU 0x98+4 ;Receive Enable
   SM2 .EQU 0x98+5 ;Serial Mode 2
   SM1 .EQU 0x98+6 ;Serial Mode 1
   SM0 .EQU 0x98+7 ;Serial Mode 0
   FE  .EQU 0x98+7 ;Framing Error
SBUF .EQU 0x99                ;Serial Buffer
P2 .EQU 0xA0                  ;Port 2
   P20 .EQU 0xA0+0 ;Port 2 Bit 0
   P21 .EQU 0xA0+1 ;Port 2 Bit 1
   P22 .EQU 0xA0+2 ;Port 2 Bit 2
   P23 .EQU 0xA0+3 ;Port 2 Bit 3
   P24 .EQU 0xA0+4 ;Port 2 Bit 4
   P25 .EQU 0xA0+5 ;Port 2 Bit 5
   P26 .EQU 0xA0+6 ;Port 2 Bit 6
   P27 .EQU 0xA0+7 ;Port 2 Bit 7
   P2_0 .EQU 0xA0+0 ;Port 2 Bit 0
   P2_1 .EQU 0xA0+1 ;Port 2 Bit 1
   P2_2 .EQU 0xA0+2 ;Port 2 Bit 2
   P2_3 .EQU 0xA0+3 ;Port 2 Bit 3
   P2_4 .EQU 0xA0+4 ;Port 2 Bit 4
   P2_5 .EQU 0xA0+5 ;Port 2 Bit 5
   P2_6 .EQU 0xA0+6 ;Port 2 Bit 6
   P2_7 .EQU 0xA0+7 ;Port 2 Bit 7
AUXR1 .EQU 0xA2               ;Auxiliary Register 1
   DPS = 0x01 ;Data Pointer Select
   GF2 = 0x08 ;General Flag 2
IE .EQU 0xA8                  ;Interrupt Enable
   EX0 .EQU 0xA8+0 ;Enable External 0
   ET0 .EQU 0xA8+1 ;Enable Timer 0
   EX1 .EQU 0xA8+2 ;Enable External 1
   ET1 .EQU 0xA8+3 ;Enable Timer 1
   ES  .EQU 0xA8+4 ;Enable Serial
   ET2 .EQU 0xA8+5 ;Enable Timer 2
   EA  .EQU 0xA8+7 ;Enable All
SADDR .EQU 0xA9               ;Slave Address
P3 .EQU 0xB0                  ;Port 3
   RXD  .EQU 0xB0+0 ;Receive Data
   TXD  .EQU 0xB0+1 ;Transmit Data
   INT0 .EQU 0xB0+2 ;Interrupt 0
   INT1 .EQU 0xB0+3 ;Interrupt 1
   T0   .EQU 0xB0+4 ;Timer 0
   T1   .EQU 0xB0+5 ;Timer 1
   WR   .EQU 0xB0+6 ;Write
   RD   .EQU 0xB0+7 ;Read
   P30 .EQU 0xB0+0 ;Port 3 Bit 0
   P31 .EQU 0xB0+1 ;Port 3 Bit 1
   P32 .EQU 0xB0+2 ;Port 3 Bit 2
   P33 .EQU 0xB0+3 ;Port 3 Bit 3
   P34 .EQU 0xB0+4 ;Port 3 Bit 4
   P35 .EQU 0xB0+5 ;Port 3 Bit 5
   P36 .EQU 0xB0+6 ;Port 3 Bit 6
   P37 .EQU 0xB0+7 ;Port 3 Bit 7
   P3_0 .EQU 0xB0+0 ;Port 3 Bit 0
   P3_1 .EQU 0xB0+1 ;Port 3 Bit 1
   P3_2 .EQU 0xB0+2 ;Port 3 Bit 2
   P3_3 .EQU 0xB0+3 ;Port 3 Bit 3
   P3_4 .EQU 0xB0+4 ;Port 3 Bit 4
   P3_5 .EQU 0xB0+5 ;Port 3 Bit 5
   P3_6 .EQU 0xB0+6 ;Port 3 Bit 6
   P3_7 .EQU 0xB0+7 ;Port 3 Bit 7
IPH .EQU 0xB7                 ;Interrupt Priority High
   PX0H = 0x01 ;Priority EXternal 0 High
   PT0H = 0x02 ;Priority Timer 0 High
   PX1H = 0x04 ;Priority External 1 High
   PT1H = 0x08 ;Priority Timer 1 High
   PSH  = 0x10 ;Priority Serial High
   PT2H = 0x20 ;Priority Timer 2 High
   PX2H = 0x40 ;Priority External 2 High
   PX3H = 0x80 ;Priority External 3 High
IP .EQU 0xB8                  ;Interrupt Priority
   PX0 .EQU 0xB8+0 ;Priority External 0
   PT0 .EQU 0xB8+1 ;Priority Timer 0
   PX1 .EQU 0xB8+2 ;Priority External 1
   PT1 .EQU 0xB8+3 ;Priority Timer 1
   PS  .EQU 0xB8+4 ;Priority Serial
   PT2 .EQU 0xB8+5 ;Priority Timer 2
SADEN .EQU 0xB9               ;Slave Address Enable
XICON .EQU 0xC0               ;Auxiliary Interrupt Control
   IT2 = 0x01 ;Interrupt 2 Type
   IE2 = 0x02 ;Interrupt 2 Edge
   EX2 = 0x04 ;Enable External 2
   PX2 = 0x08 ;Priority External 2
   IT3 = 0x10 ;Interrupt 3 Type
   IE3 = 0x20 ;Interrupt 3 Edge
   EX3 = 0x40 ;Enable External 3
   PX3 = 0x80 ;Priority External 3
T2CON .EQU 0xC8               ;Timer 2 Control
   CP_RL2 .EQU 0xC8+0 ;Capture Reload 2
   C_T2   .EQU 0xC8+1 ;Counter Timer 2
   TR2    .EQU 0xC8+2 ;Timer 2 Run
   EXEN2  .EQU 0xC8+3 ;External Enable 2
   TCLK   .EQU 0xC8+4 ;Transmit Clock
   RCLK   .EQU 0xC8+5 ;Receive Clock
   EXF2   .EQU 0xC8+6 ;External Flag 2
   TF2    .EQU 0xC8+7 ;Timer 2 Flag
T2MOD .EQU 0xC9               ;Timer 2 Mode
   DCEN = 0x01 ;Down Count Enable
   T2OE = 0x02 ;Timer 2 Output Enable
RCAP2L .EQU 0xCA              ;Reload Capture 2 Low
RCAP2H .EQU 0xCB              ;Reload Capture 2 High
TL2 .EQU 0xCC                 ;Timer 2 Low
TH2 .EQU 0xCD                 ;Timer 2 High
PSW .EQU 0xD0                 ;Program status word
   P   .EQU 0xD0+0 ;Parity
   F1  .EQU 0xD0+1 ;Flag 1
   OV  .EQU 0xD0+2 ;Overflow
   RS0 .EQU 0xD0+3 ;Register Select 0
   RS1 .EQU 0xD0+4 ;Register Select 1
   F0  .EQU 0xD0+5 ;Flag 0
   AC  .EQU 0xD0+6 ;Auxiliary Carry
   CY  .EQU 0xD0+7 ;Carry
ACC .EQU 0xE0                 ;Accumulator
   ACC0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC7 .EQU 0xE0+7 ;Accumulator Bit 7
   ACC_0 .EQU 0xE0+0 ;Accumulator Bit 0
   ACC_1 .EQU 0xE0+1 ;Accumulator Bit 1
   ACC_2 .EQU 0xE0+2 ;Accumulator Bit 2
   ACC_3 .EQU 0xE0+3 ;Accumulator Bit 3
   ACC_4 .EQU 0xE0+4 ;Accumulator Bit 4
   ACC_5 .EQU 0xE0+5 ;Accumulator Bit 5
   ACC_6 .EQU 0xE0+6 ;Accumulator Bit 6
   ACC_7 .EQU 0xE0+7 ;Accumulator Bit 7
WDT_CONTR .EQU 0xE1           ;Watch-Dog-Timer Control
   PS0      = 0x01 ;Prescale 0
   PS1      = 0x02 ;Prescale 1
   PS2      = 0x04 ;Prescale 2
   IDLE_WDT = 0x08 ;Idle Watchdog Timer
   CLR_WDT  = 0x10 ;Clear Watchdog Timer
   EN_WDT   = 0x20 ;Enable Watchdog Timer
IAP_DATA .EQU 0xE2            ;IAP Data
ISP_DATA .EQU 0xE2            ;ISP Data
IAP_ADDRH .EQU 0xE3           ;IAP Address High
ISP_ADDRH .EQU 0xE3           ;ISP Address High
IAP_ADDRL .EQU 0xE4           ;IAP Address Low
ISP_ADDRL .EQU 0xE4           ;ISP Address Low
IAP_CMD .EQU 0xE5             ;IAP Command
ISP_CMD .EQU 0xE5             ;ISP Command
   MS0 = 0x01 ;Mode Select 0
   MS1 = 0x02 ;Mode Select 1
   MS2 = 0x04 ;Mode Select 2
IAP_TRIG .EQU 0xE6            ;IAP Trigger
ISP_TRIG .EQU 0xE6            ;ISP Trigger
IAP_CONTR .EQU 0xE7           ;IAP Control
ISP_CONTR .EQU 0xE7           ;ISP Control
   WT0      = 0x01 ;Wait Time 0
   WT1      = 0x02 ;Wait Time 1
   WT2      = 0x04 ;Wait Time 2
   SWRST    = 0x20 ;Software Reset Trigger
   SWBS     = 0x40 ;Software Boot Select
   ISPEN    = 0x80 ;ISP Enable
   IAPEN    = 0x80 ;IAP Enable
P4 .EQU 0xE8                  ;Port 4
   INT3 .EQU 0xE8+2 ;Interrupt 3
   INT2 .EQU 0xE8+3 ;Interrupt 4
   PSEN .EQU 0xE8+4 ;Program Store Enable
   ALE  .EQU 0xE8+5 ;Address Latch Enable
   XA   .EQU 0xE8+6 ;External Access
   P40  .EQU 0xE8+0 ;Port 4 Bit 0
   P41  .EQU 0xE8+1 ;Port 4 Bit 1
   P42  .EQU 0xE8+2 ;Port 4 Bit 2
   P43  .EQU 0xE8+3 ;Port 4 Bit 3
   P44  .EQU 0xE8+4 ;Port 4 Bit 4
   P45  .EQU 0xE8+5 ;Port 4 Bit 5(ISP下载需勾选"ALE脚用作P4.5口")
   P46  .EQU 0xE8+6 ;Port 4 Bit 6
   P4_0  .EQU 0xE8+0 ;Port 4 Bit 0
   P4_1  .EQU 0xE8+1 ;Port 4 Bit 1
   P4_2  .EQU 0xE8+2 ;Port 4 Bit 2
   P4_3  .EQU 0xE8+3 ;Port 4 Bit 3
   P4_4  .EQU 0xE8+4 ;Port 4 Bit 4
   P4_5  .EQU 0xE8+5 ;Port 4 Bit 5
   P4_6  .EQU 0xE8+6 ;Port 4 Bit 6
B .EQU 0xF0                   ;B
   B0 .EQU 0xF0+0 ;B Bit 0
   B1 .EQU 0xF0+1 ;B Bit 1
   B2 .EQU 0xF0+2 ;B Bit 2
   B3 .EQU 0xF0+3 ;B Bit 3
   B4 .EQU 0xF0+4 ;B Bit 4
   B5 .EQU 0xF0+5 ;B Bit 5
   B6 .EQU 0xF0+6 ;B Bit 6
   B7 .EQU 0xF0+7 ;B Bit 7
   B_0 .EQU 0xF0+0 ;B Bit 0
   B_1 .EQU 0xF0+1 ;B Bit 1
   B_2 .EQU 0xF0+2 ;B Bit 2
   B_3 .EQU 0xF0+3 ;B Bit 3
   B_4 .EQU 0xF0+4 ;B Bit 4
   B_5 .EQU 0xF0+5 ;B Bit 5
   B_6 .EQU 0xF0+6 ;B Bit 6
   B_7 .EQU 0xF0+7 ;B Bit 7

;Interrupt numbers: Address = ( Number * 8 ) + 3
;Vectors are named after their corresponding interrupt
;enable register bit, so that we don't have to make up
;names and can be consisten across different 8051 MCUs
   X0_VECTOR = 0 ; 0x0003 External Interrupt 0
   T0_VECTOR = 1 ; 0x000B Timer 0
   X1_VECTOR = 2 ; 0x0013 External Interrupt 1
   T1_VECTOR = 3 ; 0x001B Timer 1
   S_VECTOR  = 4 ; 0x0023 Serial Port 0
   T2_VECTOR = 5 ; 0x002B Timer 2
   X2_VECTOR = 6 ; 0x0033 External Interrupt 2
   X3_VECTOR = 7 ; 0x003B External Interrupt 3

;.endif